/**
 * @author Grahor
 * 基础js
 */
;(function(){
	var VERSION = '1.0';
	
	var require, define;

	(function () {
	    var modules = {},
	    // Stack of moduleIds currently being built.
	        requireStack = [],
	    // Map of module ID -> index into requireStack of modules currently being built.
	        inProgressModules = {},
	        SEPARATOR = ".";

	    function build(module) {
	        var factory = module.factory,
	            localRequire = function (id) {
	                var resultantId = id;
	                //Its a relative path, so lop off the last portion and add the id (minus "./")
	                if (id.charAt(0) === ".") {
	                    resultantId = module.id.slice(0, module.id.lastIndexOf(SEPARATOR)) + SEPARATOR + id.slice(2);
	                }
	                return require(resultantId);
	            };
	        module.exports = {};
	        delete module.factory;
	        factory(localRequire, module.exports, module);
	        return module.exports;
	    }

	    require = function (id) {
	        if (!modules[id]) {
	            throw "module " + id + " not found";
	        } else if (id in inProgressModules) {
	            var cycle = requireStack.slice(inProgressModules[id]).join('->') + '->' + id;
	            throw "Cycle in require graph: " + cycle;
	        }
	        if (modules[id].factory) {
	            try {
	                inProgressModules[id] = requireStack.length;
	                requireStack.push(id);
	                return build(modules[id]);
	            } finally {
	                delete inProgressModules[id];
	                requireStack.pop();
	            }
	        }
	        return modules[id].exports;
	    };

	    define = function (id, factory) {
	        if (modules[id]) {
	            throw "module " + id + " already defined";
	        }

	        modules[id] = {
	            id: id,
	            factory: factory
	        };
	    };

	    define.remove = function (id) {
	        delete modules[id];
	    };

	    define.moduleMap = modules;
	})();

	//Export for use in node
	if (typeof module === "object" && typeof require === "function") {
	    module.exports.require = require;
	    module.exports.define = define;
	}

	define('base',function(require, exports, module){
		var app = {
		    define:define,
		    require:require,
		    version:VERSION
		};
		module.exports = app;
	});

	window.APPBASE = require('base');
})();

/**
 * 修复jquery移除改方法
 */
/*$.fn.live = function(event,func){
};*/

function initSideNav(page,reset){
	page.css({height:'100%'});
	page.find('[domId=st-container]').css({height:window.innerHeight});
	/*window.addEventListener("resize", function () {  
        // 得到屏幕尺寸 (内部/外部宽度，内部/外部高度)
        var page = APP.main.activePage;
        if(page && APP.framework.scroll && APP.framework.scroll.scrollMap && APP.framework.scroll.scrollMap[page.attr('id')]){
        	//APP.framework.scroll.scrollMap[page.attr('id')] = null;
        	page.find('[domId=st-container]').css({height:window.innerHeight});
        	page.find('div.app-wrapper:first').data('scrollId',null);
        	page.trigger('pageshow');
        	
        	//APP.framework.scroll.scrollMap[page.attr('id')].refresh(true);
        }
    }, false);  */
	var sideNavListDom = page.find('[domId=sideNavList]');
	if(APP && APP.main){
		APP.main.showOrUpdateMineUnReadMsg();
	}
	if(page.data('initSilde') == 'true'){
		return;
	}
	page.data('initSilde','true');
	if(sideNavListDom.data('init') != 'true'){
		sideNavListDom.data('init','true');
		var main = APP.main;
		var sideList = main.initIndexSideNavList();
		var tool = APP.tool;
		var domJQ = tool.dom.create();
		var liData;
		var len = sideList.length;
		if(len>0){
			for(var i = 0; i < len; i++){
				liData = sideList[i];
				if(i == 0){
					domJQ.append('<div class="whiteFont" sideNavType="').append(liData.id).append('">');
				}else{
					domJQ.append('<div class="whiteFont d3" sideNavType="').append(liData.id).append('">');
				}
				domJQ.append('<span class="').append(liData.icon).append(' i9"></span>');
				domJQ.append('<p class="f3">').append(liData.name).append('</p>');
				//domJQ.append('<span class="rightTopDot">99</span>');
				domJQ.append('</div>').end(liData);
				if(i != len - 1){
					domJQ.append('<div class="j5 k4 c4 f6"></div>').end();
				}
			}
		}
		sideNavListDom.empty().append(domJQ.getDom());
		main.onListClick(sideNavListDom,function(target,tagName){
			var data = target.data('liData');
			if(data){
				
				data.click && data.click(data);
				resetSide();
				//setTimeout(function(){
					//$("div.ui-page-active").trigger('pageshow');
				//},200);
			}
		},'div.whiteFont');
		
		if(APP && APP.main){
			APP.main.showOrUpdateMineUnReadMsg();
		}
		
		initSideForThree(page.find('[domId=st-container]'),page.find('[domId=sideNavBtn]'));
		
		function resetSide(){
			initSideForThree(page.find('[domId=st-container]'),page.find('[domId=sideNavBtn]'),true);
		}
	}
}

function initSideForThree(container,btn,reset){
	if(!container || !btn){
		return;
	}
	var container = container[0],
	buttons = btn ,
	eventtype = mobilecheck() ? 'touchstart' : 'click',
	resetMenu = function(){
		classie.remove(container, 'st-menu-open');
	},
	bodyClickFn = function(evt) {
		evt.stopPropagation();
		evt.preventDefault();
		if(!hasParentClass(evt.target, 'st-menu')) {
			resetMenu();
			window.showSlideNav = false;
			document.removeEventListener( eventtype, bodyClickFn );
		}
	};
	if(reset){
		if(!hasParentClass(container, 'st-menu')) {
			resetMenu();
			document.removeEventListener(eventtype, bodyClickFn );
		}
		return;
	}
	buttons.each(function(i) {
		var el = this;
		var effect = el.getAttribute('data-effect');
		el.addEventListener(eventtype, function(ev) {
			window.showSlideNav = true;
			ev.stopPropagation();
			ev.preventDefault();
			container.className = 'st-container'; // clear
			classie.add(container, effect);
			setTimeout( function() {
				classie.add(container, 'st-menu-open');
				//window.slideMenuContentWidth = $('#tyshIndexPage').find('div.st-pusher').width();
				$('#tyshIndexPage').find('div.header').css({borderBottom:'1px solid #0165c0'});
				$('#tyshIndexPage').find('div[domId=sideNavList]').parent().css({width:window.innerWidth*0.3});
			}, 25 );
			document.addEventListener( eventtype, bodyClickFn );
		});
	} );
	
	function hasParentClass( e, classname ) {
		if(e === document) return false;
		if( classie.has( e, classname ) ) {
			return true;
		}
		return e.parentNode && hasParentClass( e.parentNode, classname );
	}
	function mobilecheck() {
		var check = false;
		(function(a){if(/(android|ipad|playbook|silk|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows (ce|phone)|xda|xiino/i.test(a)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(a.substr(0,4)))check = true})(navigator.userAgent||navigator.vendor||window.opera);
		return check;
	}
}
