/**
 * @author Grahor
 * app初始化 
 */

var APP = {}; //应用对象
var TOOL,    //工具对象
	CONFIG, //配置对象
	MODULE,  //模块对象
	INTERFACE, //接口对象
	FRAMEWORK, //框架对象
	PAGE,  //页面对象
	MAIN,  //公用对象
	UNDERLY,//底层对象
	UI,  //页面UI对象
	WIDGETS;//插件管理对象

APP.init = function(){
	TOOL = APPBASE.require('tool');//获取工具对象
	CONFIG = APPBASE.require('config'); //获取配置对象
	MODULE = APPBASE.require('module');//获取模块对象
	FRAMEWORK = APPBASE.require('framework');//获取框架对象
	INTERFACE = APPBASE.require('interface');//获取接口对象
	PAGE = APPBASE.require('page'); //获取页面对象
	MAIN = APPBASE.require('main'); //获取核心对象
	UI = APPBASE.require('ui');//获取ui对象
	UNDERLY = APPBASE.require('underly');//获取底层对象
	WIDGETS = APPBASE.require('widgets');//获取插件管理对象
	var widgetMall = APPBASE.require('widgetMall');//获取卖场控件
	var defaultUi = APPBASE.require('uiDefault');
	var thirdParty = APPBASE.require('thirdParty');
	
	var tool = TOOL;
	var config = CONFIG;
	var page = PAGE;
	var framework = FRAMEWORK;
	var interf = INTERFACE;
	var ui = UI;
	var main = MAIN;
	var module = MODULE;
	var underly = UNDERLY;
	
	tool.init();//工具对象初始化
	
	config.init();//配置对象初始化
	
	underly.init();//底层对象初始化
	
	module.init();//模块对象初始化
	
	framework.init();//框架对象初始化
	
	interf.init();//接口对象初始化
	
	thirdParty.init();//第三方初始化
	page.init({
		contextPath:'../',
		pageContainer:'loadBodyPage'
	});//页面对象初始化
	ui.init();//ui对象初始化
	
	defaultUi.init();//初始化默认主题
	main.init();//主对象初始化
	
	widgetMall.init();
	APP.tool = tool;
	APP.config = config;
	APP.page = page;
	APP.framework = framework;
	APP.interf = interf;
	APP.ui = ui;
	APP.main = main;
	APP.module = module;
	APP.underly = underly;
	APP.thirdParty = thirdParty;
	APP.widgets = WIDGETS;
	
	var validate = tool.validate;
	var data = config.data;
	var localData = config.localData;//本地存储对象
	//localData.loginNumber = '';//本地存储 登录号码
	//localData.userName = '';//本地存储 登录名称
	//localData.areaCode = '025';//本地存储 地市信息
	//添加公共模块
	module.addModule({
		id:'commonModule',
		init:function(){
			this.loadServerResources();
			//this.loadServerData();
			config.data.flowTypes = [
			    {"rowId": "","typeName": "包月型","typeDes": ""},
			    {"rowId": "","typeName": "加餐型","typeDes": ""},
			    {"rowId": "","typeName": "跨月包","typeDes": ""},
			    {"rowId": "","typeName": "夜间包","typeDes": ""},
			    {"rowId": "","typeName": "定向包","typeDes": ""}
			];
		},
		loadServerResources:function(){//加载远程资源
			var THIS = this;
			if(data.loadServerResourceStatus == 1){
				return;
			}
			var random = 100000*Math.random();
						
			if(!!APP.main.getLocalData('simplerAPP') && APP.main.getLocalData('simplerAPP') != 'false'){
                APP.config.serverJsUrl = handleDomainContent('http://wapjs.189.cn/serverJS/android_simple.js');
            }
			appLoader.addJsFile({url:APP.config.serverJsUrl + '?callback=' + random,loaded:function(){
				// console.warn('@@@@serverJS_callback')
				try{
					var tyshIndexPage = MODULE.getModule('tyshIndexPage')
					//2019-3-18 统计首页刷新次数以判断热修复是否需要刷新首页 0次不需要 1次未登录需要 1次自动登录，自动识别不需要 2次未登录不需要 2次正常登录不需要 2次自动登录，自动识别需要 3次及以上任何情况都不需要不需要
					if(tyshIndexPage){
						// console.warn('@@@@tyshIndexPage.refreshTimes',tyshIndexPage.data.refreshTimes)

						var needRefresh = false;
						switch (tyshIndexPage.data.refreshTimes) {
							case 1:
								if(!(window.hotfixLoginType === 'autoLogin'||window.hotfixLoginType === 'autoRecognition'|| window.hotfixLoginType === 'autoLoginNew' )&& APP.main.getData('loginStatus')=='0'){
									//console.warn('@@@@首页热修复刷新1',window.hotfixLoginType,APP.main.getData('loginStatus'))
									needRefresh = true;
								}
								break;
							case 2:
								if(window.hotfixLoginType === 'autoLogin'||window.hotfixLoginType === 'autoRecognition'|| window.hotfixLoginType === 'autoLoginNew' ){
									//console.warn('@@@@首页热修复刷新2',window.hotfixLoginType)
									needRefresh = true;
								}
						}

						if(needRefresh){
							// console.warn('@@@@首页热修复刷新')
							tyshIndexPage.refresh();
						}
					}else{
						// console.warn('@@@@首页还未加载，热修复无需刷新')
					}
				}catch(e){
					// console.warn(e)
				}

				THIS.loadedServerResources();
			}},$('head:first'));
            appLoader.addJsFile({url:APP.config.wxbindJsUrl + '?callback=' + random,loaded:function(){
                THIS.loadedServerResources();
            }});

            appLoader.addJsFile({url:APP.config.serverHttpsConfig + '?callback=' + random,loaded:function(){
                THIS.loadedServerResources();
            }},$('head:first'));

			data.loadServerResourceStatus = 1;
		},
		loadedServerResources:function(){//加载远程资源完成
			data.loadServerResourceStatus = 1;
			//this.init();
		},
		loadServerData:function(){//加载远程服务器数据
			//推荐模块1
			var serverDataFunc = this.serverData;
			var modules = serverDataFunc.modules;
			modules('1',function(data){
				//UI.ui('index.recomendModule1',{nodeId:'ztIndexRecomends1',data:data});
			},function(){
				
			});
			//推荐模块2
			modules('2',function(data){
				
			},function(){
				
			});
			//焦点图
			serverDataFunc.focus(function(data){
				
			},function(){
				
			});
			//产品区焦点图
			serverDataFunc.productFocus(function(){
				
			},function(){
				
			});
		},
		serverData:{
			modules:function(type,succ,fail){//模块接口调用
				if(validate.isNull(type)){
					return;
				}
				interf.invoke({
					url:'/module/recomendModules',
					param:TOOL.param.get().add('areaCode',data.cityCode).add('recomendType',type).add('ztCustomerVersion',data.appVersion).value(),
					actionCode:'module001',
					showLoading:false,
					showDailog:false,
					success:function(data){
						succ && succ(data);
					},
					fail:function(data){
						fail && fail(data);
					}
				});
			},
			focus:function(succ,fail){//焦点图接口调用
				interf.invoke({
					url:'/promotion/mpie',
					param:TOOL.param.get().add('status','1').add('areaCode',data.cityCode).add('ztCustomerVersion',data.appVersion).value(),
					actionCode:'mpie001',
					showLoading:false,
					showDailog:false,
					success:function(data){
						succ && succ(data);
					},
					fail:function(data){
						fail && fail(data);
					}
				});
			},
			productFocus:function(succ,fail){//产品焦点图
				interf.invoke({
					url:'/promotion/queryZtMainPageInfoList',
					param:TOOL.param.get().add('areaCode',data.cityCode).add('ztCustomerVersion',data.appVersion).value(),
					actionCode:'mpie002',
					showLoading:false,
					showDailog:false,
					success:function(data){
						succ && succ(data);
					},
					fail:function(data){
						fail && fail(data);
					}
				});
			}
		}
	}).init();
	//navigator.loadStartAd.notifToShowBut(function(){}, function(){}, {});
	APP.init = null;  //释放内存
	
	APP.module.rewriteMethod('ePhoneList', 'initPageInfo', function(module,common) {
    var app = common.app;
    var scroll = common.scroll;
    var param = common.param;
    //如果带参请求
    if (param) {
        var brand = param.brand;
        var cityCode = param.cityCode;
        var price = param.price;
        var brandCode = param.brandCode;
        var priceCode = param.priceCode;
        if (brandCode) {
            module.data.brandCode = brandCode;
        }else{
            module.data.brandCode = '';
        }
        if (priceCode) {
            module.data.priceCode = priceCode;
        }else{
            module.data.priceCode = '';
        }
        if (price) {
            module.data.price = price;
        }else{
            module.data.price = '';
        }
        if (brand) {
            module.data.brand = brand;
        }else{
            module.data.brand = '';
        }
        if (cityCode) {
            module.data.cityCode = cityCode;
        } else {
            module.data.cityCode = app.main.getData('shopCityCode');
        }
        common.scroll.scrollToTop();
        module.dom.phoneList.empty();
        module.getList(module, app, scroll);
    }else {

        if (!module.data.phoneList) {
            module.data.cityCode = app.main.getData('shopCityCode');
            module.getList(module, app, scroll);
        }
    }
});
	
};


window.jpushNotiClicked = function(url){
	if(url != null && "" != url){
		APP.page.changePage(url);
	}
}
