/**
 * @author Grahor
 * 接口调用
 */
;APPBASE.define('interface',function(require, exports, module){
	var tools = require('tool');
	var methods = require('module');
	var underly = require('underly');
	var config = require('config');
	var ui = require('ui');

	/**
	 * 接口对象定义
	 */
	var INTERFACE = function(){
		this.urlPrefix = '';
		this.wapUrlPrefix = '';
		this.wapPath = '';
		this.queue = {};
		this.commonParam = '';//';channelCode_common=010001;pubAreaCode=025;pushUserId=jszt_8412439843;coachUser=;actionCode=module001;userLogAccNbr=2;userLogAccNbrType=2;ztInterSource=android;pubToken=;userTokenAccNbrType=2;ztVersion=3.0.3';
		this.interfaceFlag = {}; //接口调用标记
		this.interfaceInvokeInterval = 5 * 60;//接口调用间隔时间5分钟
		this.interfaceEncrptyKey = '';
		this.errorRecordList= [
		    //'base-00003',//首页-APP更新接口
		    //'query-00002',//首页-触点接口站内信
		    // 'otherlogin-00008',//首页-查询微信绑定用户
		    //'config-00001',//首页-触点配置接口
		    //'query-00001',//首页-电信优选自有业务
		    //'numberNew-00001',//首页-获取精选靓号
		    //'user-00012',//首页-查询用户是否限速接口
		    //'tempScore-00001',//首页-积分信息获取
		    //'user-00012',//首页-流量与语音掉新接口
		    //'user-00003',//首页-余额查询接口
		    'login-00003',//登录-短信验证码
		    'otherlogin-00018',
		    // 'login-00008',//登录-获得图形码
		    // 'login-00001',//登录-账号信息
		]
	};

	/**
	 * 接口方法定义
	 */
	INTERFACE.prototype = {
		init:function(option){
			this.urlPrefix = config.server.NORMAL;
			this.wapUrlPrefix = config.server.NORMAL_WAP;
			var strBuilder = tools.stringBuilder.newInstance();
			var params = tools.param;
			var param = params.get();
			var app = config.app;
			var data = config.data;
			this.interfaceEncrptyKey = config.interfaceEncryptKey;
			if(data.token == null || $.trim(data.token) == ''){
				data.token = 'undefined';
			}
			if(data.userLogAccNbr == null || $.trim(data.userLogAccNbr) == ''){
				data.userLogAccNbr = '';
			}
			if(option){
				var old = option.old;
				var type = option.type;
				if(old){
					this.urlPrefix = config.server.NORMAL_OLD;
					this.wapUrlPrefix = config.server.NORMAL_OLD_WAP;
				}
				if(type){
					if(type == 'mall'){//卖场
						this.urlPrefix = config.server.MALL;
						this.wapUrlPrefix = config.server.MALL_WAP;
					}else if(type == 'flow'){//流量
						this.urlPrefix = config.server.FLOW;
						this.wapUrlPrefix = config.server.FLOW_WAP;
					}else if(type == 'query'){//查询
						this.urlPrefix = config.server.QUERY;
						this.wapUrlPrefix = config.server.QUERY_WAP;
					}else if(type == 'old'){//老接口
						this.urlPrefix = config.server.NORMAL_OLD;
						this.wapUrlPrefix = config.server.NORMAL_OLD_WAP;
					}else if(type == 'login'){
						this.urlPrefix = config.server.LOGIN;
						this.wapUrlPrefix = config.server.LOGIN_WAP;
					}else if(type == 'channel'){
						this.urlPrefix = config.server.CHANNEL;
						this.wapUrlPrefix = config.server.CHANNEL_WAP;
					}else if(type == 'market'){
						this.urlPrefix = config.server.MARKET;
						this.wapUrlPrefix = config.server.MARKET_WAP;
					}else if(type == 'pay'){
						this.urlPrefix = config.server.PAY;
						this.wapUrlPrefix = config.server.PAY_WAP;
					}else if(type == 'ztservice'){//zt开头的是千万级接口服务
	                    this.urlPrefix = config.server.ztService;
	                    this.wapUrlPrefix = config.server.ztService_WAP; 
	                }else if(type == 'ztscore'){
	                    this.urlPrefix = config.server.ztScore;
	                    this.wapUrlPrefix = config.server.ztScore_WAP; 
	                }else if(type == 'ztpay'){
	                    this.urlPrefix = config.server.ztPay;
	                    this.wapUrlPrefix = config.server.ztPay_WAP;
	                }else if(type == 'ztmall'){
	                    this.urlPrefix = config.server.ztMall;
	                    this.wapUrlPrefix = config.server.ztMall_WAP;
	                }else if(type == 'ztlogin'){
	                    this.urlPrefix = config.server.ztLogin;
	                    this.wapUrlPrefix = config.server.ztLogin_WAP;
	                }else if(type == 'ztconfig'){
	                    this.urlPrefix = config.server.ztConfig;
	                    this.wapUrlPrefix = config.server.ztConfig_WAP;
	                }else if(type == 'ztbusiness'){
	                    this.urlPrefix = config.server.ztBusiness;
	                    this.wapUrlPrefix = config.server.ztBusiness_WAP;
	                }else if(type == 'ztapp'){
	                    this.urlPrefix = config.server.ztApp;
	                    this.wapUrlPrefix = config.server.ztApp_WAP;
	                }else if(type == 'activity'){
                        this.urlPrefix = config.server.ACTIVITY;
                        this.wapUrlPrefix = config.server.ACTIVITY_WAP;
                    } 
				}
			}
			if(config.platform == 'WAP'){
				this.wapPath = config.server.WAP_PATH;
			}
			try{
			var channelcode = device.channelCode == undefined ? "" : device.channelCode;
			}catch(e){}
			param.add('channelCode_common',channelcode).add('pubAreaCode',data.cityCode);
			param.add('pushUserId',data.pushUserId).add('coachUser',"");
			if(APP && APP.main){
				param.add('userLogAccNbrType',APP.main.getFamily());
				if(APP.main.getFamily() && APP.main.getFamily() == '0'){
					if(data.loginNumber.indexOf(data.cityCode) == 0){
						param.add('userLogAccNbr',data.loginNumber.substring(data.cityCode.length));
					}else{
						param.add('userLogAccNbr',data.loginNumber);
					}
					
				}else{
					param.add('userLogAccNbr',data.loginNumber);
				}
				param.add('userTokenAccNbrType','2').add('ztVersion',app.version);
			}else{
				param.add('userLogAccNbrType','2');
				param.add('userTokenAccNbrType','2');
				param.add('userLogAccNbr',data.loginNumber);
				param.add('ztVersion',app.version);
			}
			param.add('ztInterSource',app.ztInterSource).add('pubToken',data.token);
			
			this.commonParam = param.value();
		},
		log:function(str){
			var log = tools.log;
			log.log(str);
		},
		_validate:function(option){
			var logStr = 'system exception';if(option.server == 'http://61.160.137.199:10002/ztChannel-main'){option.server = null;}var validate = APP.tool.validate;if(validate.isNull(option)){logStr = 'option is null';this.log('interface invoke: ' + logStr);return false;}
        	if(validate.isNull(option.url)){logStr = 'url of param is null';this.log('interface invoke: ' + logStr);return false;}if(validate.isNull(option.param)){logStr = 'param of option is null';this.log('interface invoke: ' + logStr);return false;}if(validate.isNull(option.type)){option.type = 'post';}if(validate.isNull(option.dataType)){option.dataType = 'text';}
        	if(validate.isNotNull(option.parentInterface)){var parent = this.queue[option.parentInterface];if(validate.isNull(parent)){parent = this.queue[option.parentInterface] = [];}parent.push(option);return false;}return true;
		},
		_parseResponse:function(option,data){
			data = APP.main.getFixUrl(data);
		    var THIS = this;
		    var tools = APP.tool;
		    var validate = tools.validate;
		    var interfUrl = THIS.urlPrefix + option.url;
		    if(option.server){
		        interfUrl = option.server + option.url;
		    }
		    if(validate.isNull(data)){
		        this.log('interface invoke: request:(url=' + interfUrl + ';param=' + option.param + this.commonParam + ');response=' + data);
		        return;
		    }
		    if(option.dataType != 'html'){
		        var json = null;
		        var index = data.indexOf("({");
		        if(index == "-1"){
		            if(data.indexOf('{') == -1){
		                data = JSON.stringify(data);
		                data = handleDomainContent(data);
		                data = JSON.parse(data);
		                json = {TSR_RESULT:'0',TSR_CODE:'0',data:data};
		            }
		            else{
		                data = handleDomainContent(data);
		                json = JSON.parse(data);
		                if(json.TSR_RESULT=='110001'){//鉴权不通过
		                   APP.ui.ui('default.tip',{content:'登录信息已失效，请重新登录',
		                        callback:function(){
		                            APP.main.updateData('loginStatus', '0');//退出为0,被踢下线属于异常，设为-1
		                            APP.main.updateData('loginType', 'mobile');
		                            APP.main.updateData('loginNumber', '');
		                            APP.main.updateLocalData('loginNumber', '');
		                            APP.main.updateLocalData('loginType', 'mobile');
		                            APP.main.updateLocalData('autoLogin', 'null');
		                            APP.main.updateData('curUserAccouts','');
		                            //微信信息清空
		                            APP.main.updateData('wx_name', '');//微信昵称
		                            APP.main.updateData('wx_headImg', '');//微信头像
		                            APP.main.updateData('wx_openId', '');//微信昵称
		                            APP.main.updateData('wx_unionId', '');//微信头像
		                            APP.main.updateData('wx_isBind',0);//微信绑定(2-绑定)
		                            APP.main.updateData('wx_domain',0);//微信第三方登录为主，可解绑号码；反之可解绑微信

		                            window.loginType = '';
		                            window.loginNumber = '';
		                            window.localStorage.mobile = '';
		                            var login_areaCode = "025";
		                            window.localStorage.areaCode = login_areaCode;
		                            window.tymcCityCode = login_areaCode;
		                            window.cityCode = login_areaCode;
		                            window.loginCity = login_areaCode;
		                            window.mainCityCode = login_areaCode;
		                            window.localStorage.cityCode = '';
		                            window.loginStatus = 0;
		                            window.token = 'undefined';  //lxc 20150917 未登录统计地市 000的修复
		                            APP.main.updateData('token', '');//lxc 20150917                                 
		                            setTimeout(function () {
		                                if(APP.module.getModule('packageTheRemaining')){
		                                    APP.module.getModule('packageTheRemaining').data.queryAccNbr = null;
		                                }
		                                if(APP.module.getModule('billQueryIndexPage')){
		                                    APP.module.getModule('billQueryIndexPage').data.userInfo = null;
		                                }
		                                APP.page.changePage('main/index');
		                                MODULE.getModule('tyshIndexPage') && MODULE.getModule('tyshIndexPage').refresh();
		                            }, 10);
		                            if (APP.main.getFamily() == '2'||APP.main.getData('loginStatus')=='-1' || APP.main.getData('loginStatus')=='0') {
		                                APP.main.handleFlowNoti('close');//关闭流量通知栏
		                                APP.underly.util.floatDesktop.destory();//关闭桌面悬浮窗
		                            }
		                                                            
		                        }
		                    });
		                    
		                }
		            }
		        }else{
		            var temp = data.substring(index+1,data.lastIndexOf("})") + 1);
		            temp = handleDomainContent(temp);
		            json = JSON.parse(temp);
		        }
		        this.log('interface invoke: request:(url=' + interfUrl + ';param=' + option.param + this.commonParam +');response(' + data + ')');
		        return json;
		    }
		    else{
		        
		        this.log('interface invoke: request:(url=' + interfUrl + ';param=' + option.param + this.commonParam +');response(' + data + ')');
		        return data;
		    }			
	    },
	    // 统一修改提示语
	    changeTipText: function(tip,callback) {
		    var arr = [
		        {
		            key : "欠费",
		            tip : "不好，您名下有欠费产品了，快去缴费吧～"
		        },
		        {
		            key : "欠停",
		            tip : "呀，您的手机停机了，快拨打10000号或去营业厅求助吧～"
		        },
		        {
		            key : "不能合账付费",
		            tip : "啊哦，您现在还无法办理该业务，去看看其他活动吧～"
		        },
		        {
		            key : "军工用户",
		            tip : "啊哦，您现在还无法办理该业务，去看看其他活动吧～"
		        },
		        {
		            key : "缺少主套餐",
		            tip : "啊哦，您现在还无法办理该业务，去看看其他活动吧～"
		        },
		        {
		            key : "一卡双号-虚号",
		            tip : "啊哦，您现在还无法办理该业务，去看看其他活动吧～"
		        },
		        {
		            key : "依赖于",
		            tip : "啊哦，您现在还无法办理该业务，去看看其他活动吧～"
		        },
		        {
		            key : "不支持",
		            tip : "啊哦，您现在还无法办理该业务，去看看其他活动吧～"
		        },
		        {
		            key : "不允许",
		            tip : "啊哦，您现在还无法办理该业务，去看看其他活动吧～"
		        },
		        {
		            key : "已办理",
		            tip : "啊哦，您已经办理过该业务啦，去看看其他活动吧～"
		        },
		        {
		            key : "开通中",
		            tip : "呀，您的申请已成功提交，系统正为您加紧处理，无需重复操作哦～"
		        },
		        {
		            key : "在途单",
		            tip : "呀，您的申请已成功提交，系统正为您加紧处理，无需重复操作哦～"
		        },
		        {
		            key : "操作不满2分钟",
		            tip : "呀，您的申请已成功提交，系统正为您加紧处理，无需重复操作哦～"
		        },
		        {
		            key : "未归档",
		            tip : "呀，您的申请已成功提交，系统正为您加紧处理，无需重复操作哦～"
		        },
		        {
		            key : "系统异常",
		            tip : "太不巧了，系统正在开小差，稍后再来哦～"
		        },
		        {
		            key : "算法异常",
		            tip : "太不巧了，系统正在开小差，稍后再来哦～"
		        },
		        {
		            key : "动作链异常",
		            tip : "太不巧了，系统正在开小差，稍后再来哦～"
		        },
		        {
		            key : "其他无法分类错误",
		            tip : "太不巧了，系统正在开小差，稍后再来哦～"
		        },
		        {
		            key : "未激活",
		            tip : "太不巧了，系统正在开小差，稍后再来哦～"
		        }
		    ];
		    var flag = false;
		    var status = false;
		    var url = window.location.href;
		    if(!!APP.main.getLocalData('simplerAPP') && APP.main.getLocalData('simplerAPP') != 'false'){ 
		    	var urlArr = ["main/simpleIndex","newBusinessHall/index","HJYD/smartFamily","lifePage/index","six_userCent/simpleUserCenter"];
		    }else{
		    	var urlArr = ["main/index","newBusinessHall/index","HJYD/smartFamily","lifePage/index","six_userCent/userCenterIndexS"];
		    }
		    
		    for(var j=0;j<urlArr.length;j++){
		        if(url.indexOf(urlArr[j])>-1){
		            status = true;
		            break;
		        }
		    }
		    if(!status){
		        if(typeof(tip) == "string"){
		            for (var i = 0,len = arr.length; i < len; i++) {
		                if (tip.indexOf(arr[i].key) > -1) {
		                    flag = true;
		                    break;
		                }
		            }
		        }
		    }
		    
		    if (flag) {
		        APP.ui.ui('default.alert', {
		            content: arr[i].tip,
		            callback: function(op) {
		                // APP.page.changePage("main/index");
		            }
		        });
		    } else {
		        callback();
		    }
		},
		_invokeBefore:function(option){
			option.before && option.before();
		    if(option.showLoading == null){
		        option.showLoading = true;
		    }
		    if(option.showLoading == null){
		        option.showLoading = true;
		    }
		    if(option.showError == null){
		        // showError=true,先使用公用fail处理方法
		        // showError=false,不使用公用fail处理方法，直接用页面级方法
		        option.showError = false;
		    }
		    if(option.showLoading){
		        APP.ui.ui('default.loading');
		    }
		    if(!option.actionCode){
		        option.actionCode = 'jsztActionCode_' + option.url.replace(/\//g,'');
		    }
		    if(option.pathCode){
		        option.param = option.param + 'PathCode=' + option.pathCode + ";";
		    }
		    this.init(option);
		    option.param = option.param + 'actionCode=' + option.actionCode + ';';
		    var interfUrl = this.urlPrefix + option.url;
		    if(option.server){
		        interfUrl = option.server + option.url;
		    }
		    this.log('interface invoke:before request:(url=' + interfUrl + ';param=' + option.param + ';' + this.commonParam + ')');
		},
		_invokeComplete:function(option){
			if(option.showLoading){
				hideLoginWaitCurr();
				ui.hide('default.loading');
			}
			option.complete && option.complete();
		},
		_invokeSuccess:function(option,data){
			var THIS = this;
			if(data.TSR_MSG){
		        if (data.TSR_RESULT == '0') { //调用成功
		            if (option.success) {
		                option.success(data);
		            }
		        } else {
		            // 调用失败
		            if (data.TSR_MSG && option.showError == true) {
		                THIS.changeTipText(data.TSR_MSG,function() {
		                    THIS._invokeFail(option, data);
		                });
		            } else {
		                THIS._invokeFail(option, data);
		            }
		        }
		    }else{
		        if (data.TSR_RESULT == '0') { //调用成功
		            if (option.success) {
		                option.success(data);
		            }
		        } else { //调用失败
		            THIS._invokeFail(option, data);
		        }
		    }
		},
		_invokeFail:function(option,data){
		   var validate = APP.tool.validate;
		     if (validate.isNull(data)) {
		         if (option.error) {
		             if (!data || !data.TSR_MSG) {
		                 data = {"TSR_MSG": '亲，您的网络不给力喔！'};
		             }
		             option.error(data);
		         }
		     } else {
		         if (option.fail) {
		            //  if (option.showLoading) { }
		             option.fail(data);
		         } 
		        //  else { }
		     }
		     APP.interf._errorRecord(option,data)
		},
		_logInterfaceInvoke:function(option){//接口调用记录
			var validate = tools.validate;
			var key = tools.util.encrypt(option.url + '=' + option.param);
			option.logKey = key;
			var interfaceObj;
			if(validate.isNull(key)){
				return true;
			}
			if(validate.isNull(this.interfaceFlag[key])){
				interfaceObj = this.interfaceFlag[key] = {};
				if(validate.isNull(option.interval)){
					interfaceObj.time = (new Date()).getTime();
				}
				else{
					try{
						interfaceObj.time = parseInt(option.interval) * 1000;
					}catch(e){
						interfaceObj.time = (new Date()).getTime();
					}
				}
				interfaceObj.param = option.param;
				interfaceObj.invoke = 0;
				interfaceObj.invokeCount = 0;
				interfaceObj.invokeFail = 0;
				interfaceObj.invokeSucc = 0;
			}
			else{
				interfaceObj = this.interfaceFlag[key];
			}

			if(interfaceObj.invoke == 1){
				if((new Date()).getTime() - interfaceObj.time > this.interfaceInvokeInterval * 1000){
					return false;
				}
			}
			interfaceObj.time = (new Date()).getTime();
			return true;
		},
		_errorRecord:function(option,data){
			var app = APP;
		    var tool =  app.tool;
		    var main = app.main;
		    var params = tool.param;
		    var paramInit = params.get();
		    try {
		        if(!option.pathCode  || APP.interf.errorRecordList.indexOf(option.pathCode)<0){//避免陷入死循环
		            return;
		        }
		        //接口限流，1分钟最多上传1次
		        if(APP.interf.recentRecorded){
		            return;
		        }
		        APP.interf.recentRecorded = true;
		        setTimeout(function(){
		            APP.interf.recentRecorded = false;
		        },60000)
		
		        paramInit.add("accNbr",main.getData('loginNumber'));
		        paramInit.add("areaCode",main.getData('cityCode'));
		        paramInit.add("family",main.getFamily());
		        paramInit.add("code",option.pathCode);
		        paramInit.add("modularName",option.url);
		        paramInit.add("operationInParameter",ztEncrptyUtil.encode(option.param));
		        paramInit.add("operationOutParameter",JSON.stringify(data))
		        APP.interf.invoke({
		            url:'/welcome',
		            type:'ztbusiness',
		            pathCode:'boardProblem-00011',
		            param:paramInit.value(),
		            showLoading:true,
		            success:function(result){
		                console.log('errorRecorded',option.pathCode,data,result)
		            },
		            fail:function(result){},
		            error:function(result){}
		        })
		    } catch(e) {
		        console.log(e)
		    }
		},
		invoke:function(option){
	        var THIS = this;
            if(THIS._validate(option)){
                //option.data.url = option.url;
                THIS._logInterfaceInvoke(option);
                THIS._invokeBefore(option);
                if(APP.config.platform == 'APP'){
                    var interfUrl = THIS.urlPrefix + option.url;
                    if(option.server){
                        interfUrl = option.server + option.url;
                    }
                    var paramOption = {
                        url:interfUrl,
                        data:{para:option.param + this.commonParam},
                        success:function(data){
                            var data = data.data;
                            THIS.interfaceFlag[option.logKey].invoke = 1;
                            THIS.interfaceFlag[option.logKey].invokeCount++;
                            THIS._invokeComplete(option);
                            THIS.commonComplete(option);
                            THIS.interfaceFlag[option.logKey].invokeSucc++;
                            var json = THIS._parseResponse(option,data);
                            THIS._invokeSuccess(option,json);
                        },
                        error:function(data){
                            THIS.interfaceFlag[option.logKey].invoke = 1;
                            THIS.interfaceFlag[option.logKey].invokeCount++;
                            THIS._invokeComplete(option);
                            THIS.commonComplete(option);
                            THIS.interfaceFlag[option.logKey].invokeFail++;
                            THIS._invokeFail(option);
                        },
                        complete:function(data){
                        }
                    };
                    if(option.pathCode){//新加密
                        paramOption.charset = 0;
                        paramOption.newDes = 1;
                    }else{
                        paramOption.charset = 1;
                        paramOption.des = 1;
                    }
                    navigator.http.post(paramOption);
                }
                else{
                    var interfUrl = THIS.wapUrlPrefix + option.url;
                    if(option.server){
                        interfUrl = option.server + option.url;
                    }
                    if(!option.methodType){
                        option.methodType = 'POST';
                    }
                    $.ajax({
                        url:THIS.wapPath + '/interface/doAjax.do',
                        type:option.methodType,
                        async:true,
                        data:{url:interfUrl,para:option.param + this.commonParam},
                        dataType:option.dataType,
                        beforeSend:function(){
                        }
                    })
                        .done(function(data){
                            THIS.interfaceFlag[option.logKey].invokeSucc++;
                            var json = THIS._parseResponse(option,data);
                            THIS._invokeSuccess(option,json);
                        })
                        .fail(function(data){
                            THIS.interfaceFlag[option.logKey].invokeFail++;
                            THIS._invokeFail(option);
                        })
                        .always(function(data){
                            THIS.interfaceFlag[option.logKey].invoke = 1;
                            THIS.interfaceFlag[option.logKey].invokeCount++;
                            THIS._invokeComplete(option);
                            THIS.commonComplete(option);
                        });
                }
            }
		},
		commonComplete:function(option){
			var parent = this.queue[option.url];
			if(tools.validate.isNotNull(parent)){
				for(var i = 0; i < parent.length; i++){
					this.invoke(parent[i]);
				}
				this.queue[option.url] = null;
			}
		}
	};
	
	var interfaceTool = new INTERFACE();
	
	module.exports = interfaceTool;
});