﻿/**
 * @author Grahor
 * 应用主js文件，引导文件
 */
;
APPBASE.define('main', function(require, exports, module) {
	var tools = require('tool'),
		modules = require('module'),
		framework = require('framework'),
		config = require('config');
	var widgets = require('widgets');
	//应用对象
	var MAIN = function() {

		this.firstBackClickTime = 0; //第一次点击的时间
		this.backFilter = {}; //返回筛选
		this.activePage = null; //当前显示页面
		this.param = null; //参数传递
		this.products = [];
		this.refreshStack = []; //刷新栈
		this.noRefresh = false; //是否要刷新页面
		this.currentTyshMainNav = 0; //默认首页
		this.getUserInfoErrorCounts = 0; //出错次数
		this.loadWelcomeTime = (window.localStorage.loadWelcomeTime == undefined ? 100 : parseInt(window.localStorage.loadWelcomeTime));
		this.pageNeedLogin = false; //是否需要
	};

	MAIN.prototype = {
		init: function() {
			/**
			 * 初始化公共功能
			 */
			/**
			 * 自动刷新
			 */
			this.products = [{
					name: '手机', //产品名称
					productType: '2', //产品类型描述
					numberType: '2000004', //产品类型值
					value: 'mobile', //bss code
					login: true //是否是可登录产品
				},
				{
					name: '固话',
					productType: '0',
					numberType: '2000001',
					value: 'phone',
					login: true
				},
				{
					name: '宽带',
					productType: '3',
					numberType: '2000002',
					value: 'broadband',
					login: true
				},
				{
					name: '流量',
					productType: '9',
					numberType: '000000',
					value: 'flow',
					login: false
				}, {
					name: '微信第三方登录',
					productType: '',
					numberType: '',
					value: 'weixin',
					login: true
				}
			];
			this.cityList = [{
					code: '025',
					adminCode: '320100',
					name: '南京',
					areaId: '3',
					areas: [{
						id: '9',
						name: "市区"
					}, {
						id: "10",
						name: "江宁"
					}, {
						id: "11",
						name: "溧水"
					}, {
						id: "12",
						name: "高淳"
					}, {
						id: "13",
						name: "六合"
					}, {
						id: "14",
						name: "江浦"
					}]
				},
				{
					code: '0510',
					adminCode: '320200',
					name: '无锡',
					areaId: '15',
					areas: [{
						id: "16",
						name: "市区"
					}, {
						id: "18",
						name: "宜兴"
					}, {
						id: "19",
						name: "江阴"
					}]
				},
				{
					code: '0511',
					adminCode: '321100',
					name: '镇江',
					areaId: '4',
					areas: [{
						id: "8",
						name: "市区"
					}, {
						id: "5",
						name: "丹阳"
					}, {
						id: "6",
						name: "句容"
					}, {
						id: "7",
						name: "扬中"
					}]
				},
				{
					code: '0512',
					adminCode: '320500',
					name: '苏州',
					areaId: '20',
					areas: [{
						id: "21",
						name: "市区"
					}, {
						id: "74",
						name: "昆山"
					}, {
						id: "23",
						name: "吴江"
					}, {
						id: "77",
						name: "张家港"
					}, {
						id: "76",
						name: "常熟"
					}, {
						id: "75",
						name: "太仓"
					}]
				},
				{
					code: '0513',
					adminCode: '320600',
					name: '南通',
					areaId: '26',
					areas: [{
						id: "28",
						name: "市区"
					}, {
						id: "24",
						name: "海门"
					}, {
						id: "25",
						name: "启东"
					}, {
						id: "27",
						name: "通州"
					}, {
						id: "29",
						name: "如东"
					}, {
						id: "30",
						name: "如皋"
					}, {
						id: "31",
						name: "海安"
					}]
				},
				{
					code: '0514',
					adminCode: '321000',
					name: '扬州',
					areaId: '33',
					areas: [{
						id: "34",
						name: "市区"
					}, {
						id: "32",
						name: "仪征"
					}, {
						id: "36",
						name: "江都"
					}, {
						id: "37",
						name: "高邮"
					}, {
						id: "38",
						name: "宝应"
					}]
				},
				{
					code: '0515',
					adminCode: '320900',
					name: '盐城',
					areaId: '39',
					areas: [{
						id: "40",
						name: "市区"
					}, {
						id: "17",
						name: "盐都"
					}, {
						id: "41",
						name: "大丰"
					}, {
						id: "42",
						name: "东台"
					}, {
						id: "43",
						name: "射阳"
					}, {
						id: "44",
						name: "阜宁"
					}, {
						id: "45",
						name: "滨海"
					}, {
						id: "46",
						name: "响水"
					}, {
						id: "47",
						name: "建湖"
					}]
				},
				{
					code: '0516',
					adminCode: '320300',
					name: '徐州',
					areaId: '48',
					areas: [{
						id: "49",
						name: "市区"
					}, {
						id: "50",
						name: "铜山"
					}, {
						id: "51",
						name: "睢宁"
					}, {
						id: "52",
						name: "邳县"
					}, {
						id: "53",
						name: "新沂"
					}, {
						id: "54",
						name: "沛县"
					}, {
						id: "55",
						name: "丰县"
					}]
				},
				{
					code: '0517',
					adminCode: '320800',
					name: '淮安',
					areaId: '60',
					areas: [{
						id: "61",
						name: "市区"
					}, {
						id: "62",
						name: "涟水"
					}, {
						id: "89",
						name: "楚州"
					}, {
						id: "56",
						name: "金湖"
					}, {
						id: "57",
						name: "盱眙"
					}, {
						id: "58",
						name: "淮阴"
					}, {
						id: "59",
						name: "洪泽"
					}]
				},
				{
					code: '0518',
					adminCode: '320700',
					name: '连云港',
					areaId: '63',
					areas: [{
						id: "64",
						name: "市区"
					}, {
						id: "65",
						name: "赣榆"
					}, {
						id: "66",
						name: "灌云"
					}, {
						id: "67",
						name: "东海"
					}, {
						id: "68",
						name: "灌南"
					}]
				},
				{
					code: '0519',
					adminCode: '320400',
					name: '常州',
					areaId: '69',
					areas: [{
						id: "70",
						name: "市区"
					}, {
						id: "72",
						name: "金坛"
					}, {
						id: "73",
						name: "溧阳"
					}]
				},
				{
					code: '0523',
					adminCode: '321200',
					name: '泰州',
					areaId: '79',
					areas: [{
						id: "80",
						name: "市区"
					}, {
						id: "78",
						name: "靖江"
					}, {
						id: "81",
						name: "泰兴"
					}, {
						id: "82",
						name: "姜堰"
					}, {
						id: "83",
						name: "兴化"
					}]
				},
				{
					code: '0527',
					adminCode: '321300',
					name: '宿迁',
					areaId: '84',
					areas: [{
						id: "85",
						name: "市区"
					}, {
						id: "71",
						name: "宿豫"
					}, {
						id: "86",
						name: "泗洪"
					}, {
						id: "87",
						name: "沭阳"
					}, {
						id: "88",
						name: "泗阳"
					}]
				}
			];
			this.mainNavgatorList = [ //app导航
				'main/index', //我的电信
				'six_serviceHall/six_serviceHallIndex', //业务大厅
				'http://wapjs.189.cn/mall/pages/HJYD/smartFamily.html', //智慧家庭
				'http://wapjs.189.cn/mall//pages/lifePage/index.html', //生活
				'six_userCent/userCenterIndexS' //我的
			];

			this.family = {
				mobile: '2',
				phone: '0',
				broadband: '3',
				'c+w': '55',
				weixin: ''
			};
			this.familyWeiXin = {
				mobile: '101',
				phone: '102',
				broadband: '103',
			};
			if (this.getLocalData('tyshPackageMainType')) { //可通过远程js进行重写：例如 main.updateLocalData('tyshPackageMainType',{});
				this.packageMainType = JSON.parse(this.getLocalData('tyshPackageMainType'));
			} else {
				this.packageMainType = { //主套餐标识
					'3111': '4G',
					'2262': '3G',
					'3304': '4GPhone' //4G分享计划/固话分享版/乐享999/100M-JS2015
				};
			}
			this.cityCode = null; //{'025':'南京','0510':'无锡','0511':'镇江','0512':'苏州','0513':'南通','0514':'扬州','0515':'盐城','0516':'徐州','0517':'淮安','0518':'连云港','0519':'常州','0523':'泰州','0527':'宿迁'};
			this.cityName = null; //{'南京':'025','无锡':'0510','镇江':'0511','苏州':'0512','南通':'0513','扬州':'0514','盐城':'0515','徐州':'0516','淮安':'0517','连云港':'0518','常州':'0519','泰州':'0523','宿迁':'0527'};
		},
		commonPagecreate: function(event, ui) {
			$('.headRight01[style="display: none"]').css({
				display: 'table-cell',
				visibility: 'hidden'
			}); //头部样式偏右修复
			var me = this;
			var validate = APP.tool.validate,
				toPage = ui.toPage,
				pageId = toPage.attr('id');
			if (validate.isNull(pageId)) {
				return;
			}
			var page = toPage,
				autoInputFocus = page.attr('autoInputFocus');
			if (validate.isNotNull(autoInputFocus) && autoInputFocus == 'false') { //不处理自动弹出键盘
			} else {
				page.find('input').attr('disabled', 'disabled');
			}
			if (page.attr('navPage') == 'true') { //是导航页面
				me.onListClick(page.find('div.tyshFooter'), function(target, tagName) {
					if (tagName == 'a') { //注册事件 
						try {
							var index = target.index();
							var domId = APP.config.platform + '_tyshMainNavgatorBar';
							var underly = APP.underly;
							if (validate.isNotNull(target.attr('inserCodeId'))) {
								underly.insertCode(domId, target.attr('inserCodeId'));
							} else {
								underly.insertCode(domId, 'subIndex' + index);
							}
						} catch (e) {}
						me.currentTyshMainNav = index;
						var btnNameObj = {
							'0': "首页",
							'1': "业务", //
							'2': "智慧家庭", //
							'3': "生活", //
							'4': "我的" //
						}
						
						if(!!APP.main.getLocalData('simplerAPP') && APP.main.getLocalData('simplerAPP') != 'false'){ //老人版
						    me.mainNavgatorList = [ //app导航
                                'main/simpleIndex', //我的电信
                                'http://wapjs.189.cn/mall/pages/newBusinessHall/index.html', //业务大厅
                                'http://wapjs.189.cn/mall/pages/HJYD/smartFamily.html', //智慧家庭
                                'http://wapjs.189.cn/mall/pages/lifePage/index.html', //生活
                                'six_userCent/simpleUserCenter' //我的
                            ];
						}else{
						    me.mainNavgatorList = [ //app导航
                                'main/index', //我的电信
                                'http://wapjs.189.cn/mall/pages/newBusinessHall/index.html', //业务大厅
                                'http://wapjs.189.cn/mall/pages/HJYD/smartFamily.html', //智慧家庭
                                'http://wapjs.189.cn/mall/pages/lifePage/index.html', //生活
                                'six_userCent/userCenterIndexS' //我的
                            ];
						}

						var trkObj = {
							"eVar4": btnNameObj[index]
						};
						insertCodeNew(trkObj);
						APP.page.changePage(me.mainNavgatorList[index]);
					}
				}, 'a');
				//处理公共的换肤
				var needChange = me.getLocalData('skinChanged');
				if (needChange != '0') {
					me.updateLocalData('skinChanged', '1');
					page.find('div.header').addClass('ty-sale-bj'); //修改标题头
				}
				if (needChange == '1') { //需换肤
					page.find('div.header').addClass('ty-sale-bj'); //修改标题头
				}

				//第一次打开首页时业务大厅重定向
				if (page.attr('id') == 'six_serviceHallIndex') { //第一次打开首页点击业务大厅
					APP.page.changePage('http://wapjs.189.cn/mall/pages/newBusinessHall/index.html');
				}

			}
			page.find('div.header.h5-bar').find('div.ty-k5:first').addClass('ty-l48');
			page.find('input').attr('data-role', 'none');
		},
		pagecreate: function(event, ui) {
			var toPage = ui.toPage,
				pageId = toPage.attr('id');
			if (tools.validate.isNull(pageId)) {
				return;
			}
			var module = modules.getModule(pageId);
			this.commonPagecreate(event, ui);
			module && module.pagecreate(module, {
				page: toPage,
				app: APP,
				param: this.param,
				noRefresh: this.noRefresh
			}, event);
		},
		commonPageShow: function(module, scroll, page, ui) {
			var THIS = APP.main, tools = APP.tool, validate = tools.validate, config = APP.config;
			//push页面长时间等待修复
			if(window.pageFromJPush){
				window.pageFromJPush = false;
				if(config.app.platform == 'iphone'){
					setTimeout(function(){
						navigator.splashscreen.hide();
					}, 100);
				}else{
					setTimeout(function(){
						navigator.app.hideFlash();
					}, 100);
				}
			}
			//需要刷新操作，2015.10.30，杨飞宇
			if (module.id == 'flowResult' || module.id == 'integralArea1' || module.id == 'businessResult' ||
				module.id == 'rcPayResultPage' || module.id == 'rcFlowSuc') {
				THIS.updateData("indexPageRefresh", "1");
			}
			THIS.onClick(page.find('div.header>.icon-back'), function (e) {
				THIS.back();
				try {
					e.stopPropagation();
					return false;
				} catch (e) { }
			});
			var nod = document.createElement("style"),
				str = ".headLeft01 {padding: 0.5% 0;margin-left: 1%;}" +
					".header .iconTy0-left_btn:active {background-color: rgba(95,100,110,0.2)}" +
					".header .iconTy0-left_btn {width: 2.1em !important;height: 2.1em;box-sizing: border-box;text-align: center !important;margin: 0 0 0 1% !important;padding: 0 !important;line-height: 2.1em;border-radius: 50%;display: inline-block;}" +
					".header .icon-back:active {background-color: rgba(95,100,110,0.2)}" +
					".header .icon-back {width: 2.1em !important;height: 2.1em;box-sizing: border-box;text-align: center !important;margin: 0 0 0 1% !important;padding: 0 !important;line-height: 2.1em;border-radius: 50%;display: inline-block;}";
			nod.type="text/css";
			if(nod.styleSheet){         //ie下
				nod.styleSheet.cssText = str;
			} else {
				nod.innerHTML = str;       // nod.appendChild(document.createTextNode(str))
			}
			document.getElementsByTagName("head")[0].appendChild(nod);
		
			if (page.find('div> span.icon-back')[0] && page.find('div> span.icon-back').hasClass("headLeft01")) {
				page.find('div> span.icon-back').wrapAll('<div class="headLeft01"></div>');
				page.find('div> span.icon-back').removeClass("headLeft01");
			}
			if(page.find('div> i.iconTy0-left_btn')[0]){
				THIS.onClick(page.find('div > i.iconTy0-left_btn').parent(), function (e) {
					THIS.back();
					try {
						e.stopPropagation();
						return false;
					} catch (e) { }
				});
			}
			var param = tools.param.urlParam();
			if (param) {
				if (!THIS.param) {
					THIS.param = {};
				}
				for (var key in param) {
					if (key != 'callback') {
						THIS.param[key] = param[key];
					}
					// if (key == 'ztInterSource') {
					//     config.app[key] = param[key];
					// }
				}
			}
			if (page.find('[domId]').length > 0) {
				var dom = {}, me;
				page.find('[domId]').each(function () {
					me = $(this);
					dom[me.attr('domId')] = me;
				});
				module.dom = dom;
			}
		
			if (validate.isNotNull(page.attr('scrollV'))) {
				scroll.initVScroll({
					page: page, module: module, scrollV: true
				});
			} else if (validate.isNotNull(page.attr('scrollVPage'))) {
				scroll.initVPageScroll({
					page: page, module: module, scrollVPage: true
				});
			}// else if (validate.isNotNull(page.attr('scrollHPage'))) {}
			var format = tools.format;
			if (validate.isNotNull(page.find('input[format]')[0])) {
				var input = page.find('input[format]');
				input.unbind('keyup');
				input.unbind('change');
				input.bind('keyup', function (e) {
					this.value = format.formatNumber(null, this.value, $(this).attr('format'));
				});
				input.bind('change', function (e) {
					this.value = format.formatNumber(null, this.value, $(this).attr('format'));
				});
			}
			THIS.initCommonUI(page);
			if (page.attr('imgCache') == 'false') {//不缓存img图片
				setTimeout(function () {
					page.find('img').each(function () {
						$(this).attr('src', $(this).attr('src') + '?_t=' + appLoader.currentTime);
					});
				}, 200);
			}
			if (typeof _paq != 'undefined') {//wap插码初始化渠道统计
				if (param && param.ztInterSource) {
					_paq.push(["setCustomVariable", 1, "channelid", param.ztInterSource, "visit"]);
				}
			}
			setTimeout(function () {
				page.find('input').removeAttr('disabled');
			}, 300);
		
			if(page.attr('navPage') == 'true'){//是导航页面
				var counts = THIS.getData('headUserMsgCounts');
				if(counts && counts > 0){
					page.find('div.header').find('span.ty-dot-red-big').show();
				}else{
					page.find('div.header').find('span.ty-dot-red-big').hide();
				}
			}
		},
		//新版刷新 2019-08 chr
		pullDownRefreshNew: function(module, common, callback, option) {
			/* style:'dot' or 'circle' */
            var scroll = common.scroll;

            var default_option = {
                style: 'dot',
                color: '#949494',
				pullDownShow: 10, //提示展示阈值
                pullDownOrUpSnap: 60, //刷新阈值
                pullDownToOpen: 100
            }
            option = option || {};
            for (var i in default_option) {
                if (!option[i]) {
                    option[i] = default_option[i];
                }
            }

            if (!scroll) {
                return;
            }
            if (!module.pullDownRefreshDivInited) {
                module.pullDownRefreshDivInited = true;
                var color = option.color;
                if (option.style === 'circle') {
                    common.page.find('div.app-wrapper>div:first').prepend(
                        '<div class="o2 pullDownNew1 pullDownNew circleRefresh" style="top:-30px;z-index:1;left:0;right:0;display:none;justify-content:center;align-items:center;">' +
                        '<svg style="transform: rotate(-90deg);width:20px;margin-right:0.5rem" viewBox="0,0,72,72">' +
                        '<circle cx="36"  cy="36" r="34" stroke="' + color + '" style="stroke-dasharray: 205;stroke-dashoffset: 210;transform: rotate(15deg);transform-origin: center center;" stroke-width="2"  fill="transparent"></circle>' +
                        '</svg>' +
                        '<span style="color:' + color + ';font-size: 0.85rem">下拉刷新</span>' +
                        '</div>' +
                        '<div class="o2 pullDownNew2 pullDownNew circleRefresh" style="top:-30px;z-index:1;left:0;right:0;display:none;justify-content:center;align-items:center;">' +
                        '<svg style="transform: rotate(-90deg);width:20px;margin-right:0.5rem" viewBox="0,0,72,72">' +
                        '<circle cx="36"  cy="36" r="34" stroke="' + color + '" style="stroke-dasharray: 205;stroke-dashoffset: 10;transform: rotate(15deg);transform-origin: center center;" stroke-width="2"  fill="transparent"></circle>' +
                        '<path class="" fill="transparent" stroke-linecap="round" stroke="' + color + '" stroke-width="2" d="M48 35 L24 35 M35 24 L24 35 L35 46"  class="__path"></path>' +
                        '</svg>' +
                        '<span style="color:' + color + ';font-size: 0.85rem">松开刷新</span>' +
                        '</div>' +
                        '<div class="o2 pullDownNew3 pullDownNew circleRefresh" style="top:-30px;z-index:1;left:0;right:0;display:none;justify-content:center;align-items:center;">' +
                        '<svg style="width:20px;margin-right:0.5rem" viewBox="0,0,72,72">' +
                        '<circle cx="36"  cy="36" r="34" stroke="' + color + '" style="stroke-dasharray: 205;stroke-dashoffset: 10;transform: rotate(15deg);transform-origin: center center;" stroke-width="2"  fill="transparent"></circle>' +
                        '</svg>' +
                        '<style>' +
                        '.pullDownNew3.circleRefresh svg circle:nth-child(1) {animation: svg-load 1s linear infinite;-webkit-animation: svg-load 1s linear infinite;}' +
                        '</style>' +
                        '<style>' +
                        '@keyframes svg-load {from {transform:rotate(-90deg);transform-origin: 36px 36px;} to {transform:rotate(270deg);transform-origin: 36px 36px;}}' +
                        '</style>' +
                        '<span style="color:' + color + ';font-size: 0.85rem">正在刷新</span>' +
                        '</div>'
                    );
                } else {
                    common.page.find('div.app-wrapper>div:first').prepend(
                        '<div class="o2 pullDownNew1 pullDownNew" style="top:-30px;left:0;right:0;display:none;justify-content:center;align-items:center;">' +
                        '<svg style="width:17px;margin-right:0.5rem;overflow: initial;" viewBox="0,0,42,46">' +
                        '<circle cx="21"  cy="5" r="5" fill="' + color + '"></circle>' +
                        '<circle cx="21"  cy="22" r="5" fill="' + color + '"></circle>' +
                        '<path class="" fill="transparent" stroke-linecap="round" stroke="' + color + '" stroke-width="6" d="M1 24 L21 43 L40 24"  class="__path"></path>' +
                        '</svg>' +
                        '<span style="color:' + color + ';font-size: 0.85rem">下拉刷新</span>' +
                        '</div>' +
                        '<div class="o2 pullDownNew2 pullDownNew" style="top:-30px;left:0;right:0;display:none;justify-content:center;align-items:center;">' +
                        '<svg style="width:17px;margin-right:0.5rem" viewBox="0,0,42,46">' +
                        '<circle cx="21"  cy="5" r="5" fill="' + color + '"></circle>' +
                        '<circle cx="21"  cy="22" r="5" fill="' + color + '"></circle>' +
                        '<circle cx="21"  cy="39" r="5" fill="' + color + '"></circle>' +
                        '</svg>' +
                        '<span style="color:' + color + ';font-size: 0.85rem">松开刷新</span>' +
                        '</div>' +

                        '<div class="o2 pullDownNew3 pullDownNew" style="top:-30px;left:0;right:0;display:none;justify-content:center;align-items:center;">' +
                        '<svg style="width:17px;margin-right:0.5rem" viewBox="0,0,42,46">' +
                        '<circle cx="21"  cy="5" r="5" fill="' + color + '"><animate attributeName="opacity" values="1;0.2;1" from="1" to="0.2" begin="0s" dur="600ms" repeatCount="indefinite"  fill="freeze"/></circle>' +
                        '<circle cx="21"  cy="22" r="5" fill="' + color + '"><animate attributeName="opacity" values="1;0.2;1" from="1" to="0.2" begin="150ms" dur="600ms" repeatCount="indefinite"  fill="freeze"/></circle>' +
                        '<circle cx="21"  cy="39" r="5" fill="' + color + '"><animate attributeName="opacity" values="1;0.2;1" from="1" to="0.2" begin="300ms" dur="600ms" repeatCount="indefinite"  fill="freeze"/></circle>' +
                        '</svg>' +
                        '<span style="color:' + color + ';font-size: 0.85rem">正在刷新</span>' +
                        '</div>'
                    );
                }
            } else {
                return;
            }
            scroll.pullDownShow = option.pullDownShow; //提示展示阈值
            scroll.pullDownOrUpSnap = option.pullDownOrUpSnap //刷新阈值
            scroll.pullDownToOpen = option.pullDownToOpen;


            scroll.on('scrollMove', function (e) {
                if (module.data.pullDownCanOpen) {
                    if (scroll.y >= scroll.pullDownToOpen) {
                        if (!scroll.needOpen) {
                            scroll.needOpen = true;
                            common.page.find('div.app-wrapper:first').find('div.pulldown-text').html('松开得惊喜')
                        }
                    }
                    if (scroll.y >= scroll.pullDownOrUpSnap) {
                        if (!scroll.needShowText) {
                            scroll.needShowText = true;
                            common.page.find('div.app-wrapper:first').find('div.pulldown-text').html('继续下拉有惊喜')
                        }
                    }
                }
                if (scroll.y < scroll.pullDownShow) {
                    common.page.find('.pullDownNew').hide();
                } else if (scroll.y >= scroll.pullDownShow && scroll.y < scroll.pullDownOrUpSnap) {
                    common.page.find('.pullDownNew').hide();
                    common.page.find('.pullDownNew1').css('display', 'flex');
                    if (option.style === 'circle') {
                        // 设x为scroll位移，y为stroke-dashoffset
                        // Ax-y = b 有方程组
                        // 考虑一般情况，增广矩阵为
                        // [scroll.pullDownOrUpSnap , -1,-10];
                        // [scroll.pullDownShow , -1,-210]
                        var A = -200 / (scroll.pullDownOrUpSnap - scroll.pullDownShow)
                        var b = A * scroll.pullDownShow - 210;
                        common.page.find('.pullDownNew1').find('circle').css('stroke-dashoffset', A * scroll.y - b);
                    }
                } else {
                    if (option.style === 'circle') {
                        common.page.find('.pullDownNew1').find('circle').css('stroke-dashoffset', 210);
                    }
                }
                if (scroll.y >= scroll.pullDownOrUpSnap) {
                    if (scroll.needRefreshStatus) {
                        return;
                    }
                    common.page.find('.pullDownNew').hide();
                    common.page.find('.pullDownNew2').css('display', 'flex');
                    scroll.needRefreshStatus = true;
                } else if (scroll.y >= scroll.pullDownShow) {
                    scroll.needRefreshStatus = false;
                    common.page.find('.pullDownNew').hide();
                    common.page.find('.pullDownNew1').css('display', 'flex');
                }
            });
            common.page.find('div.app-wrapper:first')[0].addEventListener('touchend', _end);
            common.page.find('div.app-wrapper:first')[0].addEventListener('touchcancel', _end);

            function _end(e) {
                common.page.find('.pullDownNew').hide();
                if (scroll.needShowText) {
                    scroll.needShowText = null;
                    common.page.find('div.app-wrapper:first').find('div.pulldown-text').html('')
                }
                if (scroll.needOpen) {
                    scroll.needOpen = null;
                    scroll.needOpenToPreventFromRefresh = true;
                    try {
                        setTimeout(function(){
                            if (module.data && module.data.pullDownUrl) {
                                var pos = module.data.pageName || "首页"
                                pos = pos + "下拉频道";
                                var trkObj = {
                                    "eVar4": "" + module.data.pageName + ":" + pos,
                                    "eVar5": "" + module.data.pageName + ":" + pos
                                };
                                insertCodeNew(trkObj);
                                APP.main.executeJsCode(module.data.pullDownUrl);
                            }
                        },900)
                      
                    } catch (e) {}
                }
                if (scroll.needRefreshStatus) {
                    scroll.disable();
                    scroll.needRefreshStatus = null;
                    // scroll._transitionTime(500);
                    scroll._translate(0, scroll.pullDownOrUpSnap, 500);

                    var pulldown_bg = common.page.find('div.pulldown-bg');
                    var pulldown_bgimg = common.page.find('div.pulldown-bgimg');
                    var pulldown_effect = common.page.find('div.pulldown-effect');
                    // var pulldown_text = common.page.find('div.pulldown-text');

                    common.page.find('.pullDownNew').hide();
                    common.page.find('.pullDownNew3').css('display', 'flex');

                    setTimeout(function () {
                        pulldown_effect.removeClass('show');
                    }, 550);
                    setTimeout(function () {
                        pulldown_effect.addClass('show');
                    }, 600);

                    if (module.data) {
                        pos = module.data.pageName || "首页"
                        pos = pos + "下拉刷新";
                        trkObj = {
                            "eVar4": "" + module.data.pageName + ":" + pos,
                            "eVar5": "" + module.data.pageName + ":" + pos
                        };
                        insertCodeNew(trkObj);
                    }
                    callback && callback(function () {
                        try {
                            //检查是否配置了下拉广告图
                            if (module.data.pullDownOpenImg) {
                                setTimeout(function () {
                                    common.page.find('.pullDownNew').hide();
                                    scroll.enable();
                                    scroll.scrollTo(0, 0, 0);
                                    scroll.needRefreshStatus = null;
                                    pulldown_bg.fadeOut(300);
                                }, 250)
                                setTimeout(function () {
                                    common.page.find('.header1').css('visibility', 'initial');
                                    pulldown_bg.css('display', 'none');
                                    pulldown_bgimg.css('display', 'none');
                                    pulldown_effect.css('display', 'none');
                                }, 600)
                                setTimeout(function () {
                                    pulldown_effect.removeClass('show').css('display', 'block');
                                }, 650)
                            } else {
                                setTimeout(function () {
                                    common.page.find('.pullDownNew').hide();
                                    scroll.enable();
                                    scroll.scrollTo(0, 0, 0);
                                    scroll.needRefreshStatus = null;
                                }, 500);
                            }
                        } catch (e) {}
                    });
                }
            }
		},
		/*
		 * 下拉刷新方法 杨飞宇 2015.10.30 
		 * 修改样式 蔡浩然 2017.8.3 
		 * 下拉频道 蔡浩然 2018.5.23 
		 */
		pullDownRefresh: function(module, common, callback) {
			var scroll = common.scroll;
			if (!scroll) {
				return;
			}
			if (!module.pullDownRefreshDivInited) {
				module.pullDownRefreshDivInited = true;
				common.page.find('div.app-wrapper>div:first').prepend('<div class="m-down-body-new"><div class="m-down-city"><img src="' + handleDomainContent("http://wapjs.189.cn/tysh/resources/images/common/city.png") + '" style="width:100%;vertical-align: bottom;"></div><div class="m-down-bird" style="display:none;"><img src="' + handleDomainContent("http://wapjs.189.cn/tysh/resources/images/common/bird.png") + '" style="width:55%;"></div><div class="m-down-shan" style=""><img src="' + handleDomainContent("http://wapjs.189.cn/tysh/resources/images/common/shan1.png") + '" style="width:100%;"></div><div class="m-down-shan2" style=""><img src="' + handleDomainContent("http://wapjs.189.cn/tysh/resources/images/common/shan2.png") + '" style="width:100%;"></div><div class="m-down-shan3" style=""><img src="' + handleDomainContent("http://wapjs.189.cn/tysh/resources/images/common/shan3.png") + '" style="width:100%;"></div></div>');
			}else{
				return;
			}
			var bird = common.page.find('div.app-wrapper:first').find('div.m-down-bird');
			// var city = common.page.find('div.app-wrapper:first').find('div.m-down-city');
			var shan = common.page.find('div.app-wrapper:first').find('div.m-down-shan');
			var shan2 = common.page.find('div.app-wrapper:first').find('div.m-down-shan2');
			var shan3 = common.page.find('div.app-wrapper:first').find('div.m-down-shan3');
			shan.hide();
			scroll.pullDownOrUpSnap = 75;
			scroll.pullDownToOpen = 105;
			scroll.on('scrollMove', function (e) {
				if (module.data.pullDownCanOpen) {
					if (scroll.y >= scroll.pullDownToOpen) {
						if (!scroll.needOpen) {
							scroll.needOpen = true;
							common.page.find('div.app-wrapper:first').find('div.pulldown-text').html('松开得惊喜')
						}
					}
					if (scroll.y >= scroll.pullDownOrUpSnap) {
						if (!scroll.needShowText) {
							scroll.needShowText = true;
							common.page.find('div.app-wrapper:first').find('div.pulldown-text').html('继续下拉有惊喜')
						}
					}
				}

				if (scroll.y >= scroll.pullDownOrUpSnap) {
					if (scroll.needRefreshStatus) {
						return;
					}
					scroll.needRefreshStatus = true;
					bird.show();
					bird.addClass('m-up-in-b');
					shan.show();
					shan2.show();
					shan3.show();
				} else {
					if (scroll.needRefreshStatus != null && !scroll.needRefreshStatus) {
						return;
					}
					scroll.needRefreshStatus = false;
					bird.removeClass('m-up-in-b m-up-out-b m-up-wait-b');
					bird.hide();
				}

			});
			common.page.find('div.app-wrapper:first')[0].addEventListener('touchend', function (e) {
				common.page.find('div.header4').css('visibility', 'visible');
				if (scroll.needShowText) {
					scroll.needShowText = null;
					common.page.find('div.app-wrapper:first').find('div.pulldown-text').html('')
				}
				if (scroll.needOpen) {
					scroll.needOpen = null;
					scroll.needOpenToPreventFromRefresh = true;
					try {
						if (module.data && module.data.pullDownUrl) {
							var pos = "首页下拉频道";
							var trkObj = { "eVar4": "" + module.data.pageName + ":" + pos, "eVar5": "" + module.data.pageName + ":" + pos };
							insertCodeNew(trkObj);
							APP.main.executeJsCode(module.data.pullDownUrl);
						}
					} catch (e) {
						//console.log(e)
					}
				}
				if (scroll.needRefreshStatus) {
					scroll.disable();
					scroll.needRefreshStatus = null;
					bird.removeClass('m-up-in-b m-up-out-b').addClass('m-up-wait-b');
					// scroll._transitionTime(500);
					scroll._translate(0, scroll.pullDownOrUpSnap, 500);

					var pulldown_bg = common.page.find('div.pulldown-bg');
					var pulldown_bgimg = common.page.find('div.pulldown-bgimg');
					var pulldown_effect = common.page.find('div.pulldown-effect');

					setTimeout(function () {
						pulldown_effect.addClass('show');
					}, 600);

					if (module.data) {
						pos = "首页下拉刷新";
						trkObj = { "eVar4": "" + module.data.pageName + ":" + pos, "eVar5": "" + module.data.pageName + ":" + pos };
						insertCodeNew(trkObj);
					}

					callback && callback(function () {
						try {
							bird.removeClass('m-up-wait-b').addClass('m-up-out-b');
							//检查是否配置了下拉广告图
							if (module.data.pullDownOpenImg) {
								setTimeout(function () {
									scroll.enable();
									scroll.scrollTo(0, 0, 0);
									scroll.needRefreshStatus = null;
									pulldown_bg.fadeOut(300);
								}, 250)
								setTimeout(function () {
									pulldown_bg.css('display', 'none');
									pulldown_bgimg.css('display', 'none');
									pulldown_effect.css('display', 'none');
								}, 600)
								setTimeout(function () {
									pulldown_effect.removeClass('show').css('display', 'block');
								}, 650)
							} else {
								setTimeout(function () {
									shan.hide();
									shan2.hide();
									shan3.hide();
									scroll.enable();
									scroll.scrollTo(0, 0, 0);
									scroll.needRefreshStatus = null;
								}, 500);
							}

						} catch (e) {}
					});
				}
			});
		},
		/*
		 * 个人中心下拉刷新方法
		 */
		UCPullDownRefresh: function(module, common, callback) {
			//请使用新的乐翼小形象下拉刷新
			var scroll = module.data.scroll;
			if (!scroll) {
				return;
			}
			if (!module.pullDownRefreshDivInited) {
				module.pullDownRefreshDivInited = true;
				if (common.page.find('header').css('top') == '75px') {
					common.page.find('header').css('top', '0');
				}
				common.page.find('div.app-wrapper>div:first').prepend('<div class="m-down-body-new"><div class="m-down-city"><img src="' + handleDomainContent("http://wapjs.189.cn/tysh/resources/images/common/city.png") + '" style="width:100%;vertical-align: bottom;"></div><div class="m-down-bird" style="display:none;"><img src="' + handleDomainContent("http://wapjs.189.cn/tysh/resources/images/common/bird.png") + '" style="width:55%;"></div><div class="m-down-shan" style="top:-65px;"><img src="' + handleDomainContent("http://wapjs.189.cn/tysh/resources/images/common/shan1.png") + '" style="width:100%;"></div><div class="m-down-shan2" style="top:-65px;"><img src="' + handleDomainContent("http://wapjs.189.cn/tysh/resources/images/common/shan2.png") + '" style="width:100%;"></div><div class="m-down-shan3" style=""><img src="' + handleDomainContent("http://wapjs.189.cn/tysh/resources/images/common/shan3.png") + '" style="width:100%;"></div></div>');
			}else{
				return
			}
			var bird = common.page.find('div.app-wrapper:first').find('div.m-down-bird');
			// var city = common.page.find('div.app-wrapper:first').find('div.m-down-city');
			var shan = common.page.find('div.app-wrapper:first').find('div.m-down-shan');
			var shan2 = common.page.find('div.app-wrapper:first').find('div.m-down-shan2');
			var shan3 = common.page.find('div.app-wrapper:first').find('div.m-down-shan3');
			shan.hide();
			scroll.pullDownOrUpSnap = 95;
			scroll.on('scrollMove', function (e) {
				if (scroll.y >= scroll.pullDownOrUpSnap) {
					if (scroll.needRefreshStatus) {
						return;
					}
					scroll.needRefreshStatus = true;
					bird.show();
					bird.addClass('m-up-in-b');
					shan.show();
					shan2.show();
					shan3.show();
				} else {
					if (scroll.needRefreshStatus != null && !scroll.needRefreshStatus) {
						return;
					}
					scroll.needRefreshStatus = false;
					bird.removeClass('m-up-in-b m-up-out-b m-up-wait-b');
					bird.hide();
				}
		
			});
			common.page.find('div.app-wrapper:first')[0].addEventListener('touchend', function (e) {
				if (scroll.needRefreshStatus) {
					scroll.disable();
					scroll.needRefreshStatus = null;
					bird.removeClass('m-up-in-b m-up-out-b').addClass('m-up-wait-b');
					// scroll._transitionTime(500);
					scroll._translate(0, scroll.pullDownOrUpSnap,500);
					common.page.find('.m-down-body-new').css({
						height: 'auto',
						marginTop: module.data.scroll.pullDownOrUpSnap,
						top: 0,
						position: 'relative'
					});
					//                setTimeout(function () {
					callback && callback(function () {
						try {
							bird.removeClass('m-up-wait-b').addClass('m-up-out-b');
							setTimeout(function () {
								shan.hide();
								shan2.hide();
								shan3.hide();
								scroll.enable();
								common.page.find('.m-down-body-new').css('margin-top', 0);
								scroll.scrollTo(0, 0, 600);
								scroll.needRefreshStatus = null;
							}, 500);
						} catch (e) {}
					});
					//                }, 2000);
				}
			});
		},
		pageshow: function(event, ui) { //页面显示初始化加adobe pv uv 統計修復
			try {
				var scroll = APP.framework.scroll,
					validate = APP.tool.validate,
					toPage = ui.toPage,
					pageId = toPage.attr('id');
				if (validate.isNull(pageId)) {
					return;
				}
				APP.ui.hide('default.loading');
				var modules = APP.module;
				var module = modules.getModule(pageId);
				var widgets = APP.widgets;
				try {
					if (pageId != 'annualBillIndex_video') {
						if ($('#annualBillIndex_video').size() > 0) {
							$('#annualBillIndex_video').remove();
						}
					}
					if (APP.module.videomodules) {
						var videoattr = APP.module.videomodules;

						for (var i = 0; i < videoattr.length; i++) {
							var moduleVideo = APP.module.getModule(videoattr[i]);
							if (moduleVideo) {
								var domVideo = moduleVideo.dom;
								$("#" + videoattr[i]).find("video").each(function() {
									this.pause();
								});
								$("#" + videoattr[i]).find("audio").each(function() {
									this.pause();
								});
								if (domVideo.hjydPanoramaContainer) {
									$("#hjydPanorama_wr").remove();
								}
							}
						}

					}

				} catch (e) {
					// console.log(e);
				}
				if (!window.hasUploadTrkFlatName) {
					window.trkPageName = pageId + ":" + toPage.find('div.header').find('p:first').html();
					window.trkFlatName = "android";
					if (typeof trkAppState != 'undefined') {
						try {
							trkAppState();
							window.hasUploadTrkFlatName = true;
							window.trkPageName = null;
							window.trkFlatName = null;
						} catch (e) {}
					}
				}
				if (typeof trkAppState != 'undefined') { //方便abode 統計pv uv
					trkAppState();
				}
				try {
					if (typeof(wr_dm) != 'undefined' && typeof(wr_dm.t) != 'undefined') { //方便abode 統計pv uv
						// var trkPages = ['broadbandApril1','fuli','stockBd517Index','fourUPfiveIndex','fourUPfiveEntry','fourUPfiveEntryUp','fourUPfiveRules','fourUPfiveRules2','fourUPfiveRulesUp','addHighCardN','addHighCardNUP','success','mapios_5GPage','map_5GPage','landlords5G']
						if (wr_tPagesId && wr_tPagesId.indexOf(pageId) > -1) {
							wr_dm.t()
						}
					}
				} catch (e) {}
				if (module.login != null && module.login) { //需要授权登录
					var loginStatus = this.getData('loginStatus');
					if (loginStatus == 0) {
						if (this.pageNeedLogin) {
							this.pageNeedLogin = false;
							window.history.back();
							return;
						} else {
							this.pageNeedLogin = true;
							APP.page.changePage('common/login');
							return;
						}
					}
				}
				var pageshow = modules.getPageShow(pageId);
				if (validate.isNotNull(pageshow)) {
					var item = this.refreshStack.pop();
					if (validate.isNotNull(item) && item == toPage.attr('id')) {
						this.noRefresh = true;
					}
					module.beforepageshow && module.beforepageshow(module, toPage, ui);

					this.commonPageShow(module, scroll, toPage, ui);
					var scrollList = scroll.getScrollList(pageId);
					if (validate.isNull(scrollList)) {
						scrollList = [];
					}
					if (scrollList.length <= 1 && validate.isNotNull(scrollList) && !validate.isArray(scrollList)) {
						scrollList.enable();
						scrollList.refresh();
					}
					this.activePage = toPage;
					if (!widgets.noRefresh) {
						if (this.param && this.param.widgetCallback) {
							this.addBack(function(func) {
								return function() {
									widgets.setNoRefresh(true);
									window.history.back();
								}
							}(this.param.widgetCallback));
						}
						pageshow(module, {
							page: toPage,
							scroll: scrollList,
							app: APP,
							param: this.param,
							noRefresh: this.noRefresh
						}, event);
					} else {
						if (wr_tProPagesId && wr_tProPagesId.indexOf(pageId) > -1) {
							try {
								if (typeof(wr_dm) != 'undefined' && typeof(wr_trkProduct) != 'undefined') { //方便abode 統計pv uv
									wr_trkProduct()
								}
							} catch (e) {}
						}
						widgets.setNoRefresh(false);
					}
					if (module.parent) {
						this.refreshStack.push(module.parent);
					} else {
						this.noRefresh = false;
					}
				}
			} catch (e) {}
		},
		initIndexSideNavList: function() { //初始化侧边栏列表
			var me = this;
			if (me.sideNavList) {
				return me.sideNavList;
			}
			var list = [];
			list.push({
				id: 'msg',
				icon: 'icon-message',
				name: '消息',
				status: 1,
				click: function(liData) {
					me.login(function() {
						APP.page.changePage('mineMessage/messageList');
					});
				}
			});
			list.push({
				id: 'scanner',
				icon: 'icon-scan',
				name: '扫码',
				status: 1,
				click: function(liData) {
					APP.underly.appScan();
				}
			});
			list.push({
				id: 'share',
				icon: 'icon-share',
				name: '分享',
				status: 1,
				click: function(liData) {
					me.share(); //initShareConfirmListFunc();
				}
			});
			list.push({
				id: 'mall',
				icon: 'icon-tmailSide',
				name: '网上商城',
				status: 1,
				click: function(liData) {
					ztChangePage('http://wapjs.189.cn/tysh/pages/phoneArea/phoneIndex.html');
				}
			});
			if (config.app.platform != 'iphone') {
				list.push({
					id: 'downloadRecomend',
					icon: 'icon-downloadRecommend',
					name: '下载推荐',
					status: 1,
					click: function(liData) {
						ztChangePage('http://61.160.137.140:8082/tpzq/downloadCenter/index.html');
					}
				});
			}
			me.sideNavList = list;
			return list;
		},
		share: function(option, success, fail) { //分享
			var page = APP.page;
			if (option) {
				var jsonStr = handleDomainContent(JSON.stringify(option));
				option = JSON.parse(jsonStr);
				page.changePage('common/share', {
					param: {
						shareData: option,
						success: success,
						fail: fail
					}
				});
			} else {
				page.changePage('common/share');
			}
		},
		_getKey: function() {
			var validate = tools.validate;
			if (validate.isNull(this.activePage)) {
				return "";
			}
			return this.activePage.attr('id').replace(/[\s|\_]/g, "");
		},
		addBack: function(backFunc) { //自定义返回处理回调
			var validate = tools.validate,
				key = this._getKey();
			if (validate.isNull(key)) {
				return;
			}
			this.backFilter[key] = backFunc;
		},
		commonBack: function() { //公共返回


			var ui = APP.ui,
				me = APP.main,
				tools = APP.tool,
				validate = tools.validate,
				config = APP.config;
			if (window.pushFlag) {
				window.pushFlag = false;
				APP.page.changePage('main/index');
				return false;
			}

			if (validate.isNotNull(ui.currentUIShow) && ui.currentUIShow != 'default.loading' && ui.currentUIShow != 'default.tip2' && validate.isVisible($('#' + ui.getUID(ui.currentUIShow)))) { //返回关闭所有弹框


				ui.hide(ui.currentUIShow);
				return false;
			}

			if (me.selfDefinedToIndex) { //自定义返回出来
				me.selfDefinedToIndex = false;
				APP.page.changePage('main/index');
				return false;
			}


			if (me.activePage) {
				if (me.activePage.attr('orderPage') == 'true' && !me.confirmCancelOrder) { //订单页面取消页面
					ui.ui('default.confirm', {
						title: '订单取消确认',
						content: '您是否要取消当前订单？',
						confirmBtn: '是',
						cancelBtn: '否',
						confirm: function() {
							me.confirmCancelOrder = true;
							ui.hide('default.confirm');
							me.back();
						},
						cancel: function() {
							ui.hide('default.confirm');
						}
					});
					return false;
				} else {
					me.confirmCancelOrder = false;
				}
			}
			var href = me.getLocationHref();


			if (href.match('main/index') || href.match('main/simpleIndex') || href.match('main/guide') || href.match('zt/main') || !href.match('main/load.html#')) {
				if (window.showSlideNav) {
					window.showSlideNav = false;
					initSideForThree($('#tyshIndexPage').find('[domId=st-container]'), $('#tyshIndexPage').find('[domId=sideNavBtn]'), true);
					return false;
				}
				if (config.platform == 'APP' && config.app.platform == 'android') {

					var secondClickBackTime = new Date().getTime();


					if (secondClickBackTime - this.firstBackClickTime < 2000) {
						APP.underly.exitApp();
					} else {
						APP.ui.ui('default.tip2', {
							content: '再按一次返回键退出天翼生活'
						});
						this.firstBackClickTime = new Date().getTime();

					}


					/* ui.ui('default.confirm', {
					     fromIndex: true, align: 'center', title: '提示',
					     content: '确认退出天翼生活？', confirmBtn: '确认', cancelBtn: '取消',
					     confirm: function () {
					         ui.hide('default.confirm');
					         //updateAppData(2);
					         APP.underly.exitApp();
					     },
					     cancel: function () {
					         ui.hide('default.confirm');
					     }
					 });*/
					return false;
				}

			}
			/**
			 * 兼容以前的，最终版将删除这些
			 */
			if (validate.isVisible($("#selectorView"))) {
				$("#selectorView").hide();
				return false;
			}
			if (href.match("orderResult")) {
				APP.page.changePage('mall/index');
				return false;
			}
			return true;
		},
		back: function() { //返回
			var validate = tools.validate;
			if (!this.commonBack()) {
				return;
			}
			var key = this._getKey();
			if (validate.isNull(key)) {
				return;
			}
			if (this.backFilter[key]) {
				this.backFilter[key].apply(this, []);
			} else {
				window.history.back();
				return;
			}
		},
		onClick: function(obj, func, option) { //注册事件
			var insertCodeData = obj.attr('insertCodeData'),
				validate = tools.validate;
			obj.removeEventListener('quickClick');
			obj.addEventListener('quickClick', function(e) {
				var domId = obj.attr('domId');
				if (validate.isNotNull(domId)) {
					var isActivity = false;
					var page = obj.closest('div[data-role=page]');
					if ($.trim(page.attr('activity')) != '') {
						isActivity = true;
					}
					if (isActivity) {
						domId = config.platform + 'Activity_' + page.attr('id') + '_' + domId;
					} else {
						domId = config.platform + '_' + page.attr('id') + '_' + domId;
					}
					var underly = APP.underly;
					underly.insertCode(domId);
				}
				func && func(e);
			}, null, function(currentTarget, target) {
				$('div.ui-page-active').find('input').blur();
				$(currentTarget).addClass("pressed");
			}, function(currentTarget, target) {
				$(currentTarget).removeClass("pressed");
			});
		},
		onListClick: function(obj, func, children) { //注册列表事件
			var tools = APP.tool,
				config = APP.config,
				validate = tools.validate;
			obj.removeEventListener('quickClick');
			obj.addEventListener('quickClick', function(e) {
				$('div.ui-page-active').find('input').blur();
				var target = $(e.target).closest(children),
					tagName = '';
				if (target[0]) {
					tagName = target[0].tagName;
				}
				if (tagName) {
					tagName = tagName.toLowerCase();
				} else {
					tagName = '';
				}
				var domId = obj.attr('domId'),
					index = obj.find(children).index(target[0]);
				if (validate.isNotNull(domId)) {
					var isActivity = false,
						page = obj.closest('div[data-role=page]');
					if ($.trim(page.attr('activity')) != '') {
						isActivity = true;
					}
					if (isActivity) {
						domId = config.platform + 'Activity_' + page.attr('id') + '_' + domId;
					} else {
						domId = config.platform + '_' + page.attr('id') + '_' + domId;
					}
					var underly = APP.underly;
					if (validate.isNotNull(target.attr('inserCodeId'))) {
						underly.insertCode(domId, target.attr('inserCodeId'));
					} else {
						underly.insertCode(domId, 'subIndex' + index);
					}
				}
				func && func(target, tagName, e);
			}, null, function(currentTarget, target) {
				$(target).closest(children).addClass("pressed");
			}, function(currentTarget, target) {
				$(target).closest(children).removeClass("pressed");
			});
		},
		getLocationHref: function() { //获取当前地址url
			return window.location.href;
		},
		_initCityName: function() {
			var list = this.cityList;
			if (!list) {
				this.cityName = {};
				return;
			}
			var len = list.length;
			this.cityName = {};
			for (var i = 0; i < len; i++) {
				this.cityName[list[i].name] = list[i].code;
			}
		},
		getCityCodeByName: function(name) { //获取地市区号
			if (!this.cityName) {
				this._initCityName();
			}
			return this.cityName[name];
		},
		getCityNameByCode: function(code) { //获取地市名称
			if (!this.cityAreaInfoMap) {
				this._initCityAreaInfoMap();
			}
			if (this.cityAreaInfoMap[code]) {
				return this.cityAreaInfoMap[code].name;
			} else {
				return "";
			}
		},
		getAdminCode: function(code) { //获取行政编码
			if (!this.cityAreaInfoMap) {
				this._initCityAreaInfoMap();
			}
			return this.cityAreaInfoMap[code].adminCode;
		},
		_initCityAreaInfoMap: function() {
			var list = this.cityList;
			if (!list) {
				this.cityAreaInfoMap = {};
				return;
			}
			var len = list.length;
			this.cityAreaInfoMap = {};
			for (var i = 0; i < len; i++) {
				this.cityAreaInfoMap[list[i].code] = list[i];
			}
		},
		getCityListAreaByCode: function(code) { //获取区域列表
			if (!this.cityAreaInfoMap) {
				this._initCityAreaInfoMap();
			}
			return this.cityAreaInfoMap[code].areas;
		},
		getCityAreaByCode: function(code, name) { //根据区号
			if (!this.cityAreaInfoMap) {
				this._initCityAreaInfoMap();
			}
			if (!name) {
				var list = this.cityAreaInfoMap[code].areas;
				var len = list.length;
				for (var i = 0; i < len; i++) {
					if (list[i].name == $.trim(name)) {
						return list[i];
					}
				}
			}
			return this.cityAreaInfoMap[code].areas[0];
		},
		getData: function(key) { //获取公共数据
			var validate = tools.validate;
			if (validate.isNull(key)) {
				return '';
			}
			return config.data[key];
		},
		updateData: function(key, value) { //更新公共数据
			var validate = tools.validate;
			if (validate.isNull(key)) {
				return;
			}
			config.data[key] = value;
		},
		getLocalData: function(key, isObj) { //获取本地存储数据
			var validate = tools.validate,
				localData = tools.localData;
			if (validate.isNull(key)) {
				return '';
			}
			var value = localData.get(key);
			if (isObj) {
				value = JSON.parse(value);
			}
			return value;
		},
		updateLocalData: function(key, value, expireSeconds) { //更新本地存储数据
			var validate = tools.validate,
				localData = tools.localData;
			if (validate.isNull(key)) {
				return;
			}
			localData.put(key, value, expireSeconds);
		},
		getLoginNumberByType: function(type) { //根据用户类型获取当前登录号码
			if (config.data.loginType == type) {
				if (config.data.loginStatus != 0 && config.data.loginType == 'phone') {
					config.data.loginNumber = config.data.loginNumber.replace(config.data.cityCode, '');
				}
				return config.data.loginNumber;
			} else {
				return "";
			}
		},
		initCommonUI: function(page) {
			var me = this;
			if (this.noRefresh) {
				return;
			}
			page.find('[domType]').each(function() {
				me.commonTypeInit($(this), $(this).attr('domType'));
			});
		},
		commonTypeInit: function(dom, type) { //新城市选择器列表 杨飞宇0628
			var me = APP.main;
			var ui = APP.ui;
			if (type == 'cityAreaNew') {
				me.cityList = [{
						code: '025',
						adminCode: '320100',
						name: '南京市',
						areaId: '3',
						areas: [{
							id: "9",
							name: "玄武区"
						}, {
							id: "9",
							name: "白下区"
						}, {
							id: "9",
							name: "秦淮区"
						}, {
							id: "9",
							name: "建邺区"
						}, {
							id: "9",
							name: "鼓楼区"
						}, {
							id: "9",
							name: "下关区"
						}, {
							id: "9",
							name: "栖霞区"
						}, {
							id: "9",
							name: "雨花台区"
						}, {
							id: "10",
							name: "江宁区"
						}, {
							id: "11",
							name: "溧水县"
						}, {
							id: "12",
							name: "高淳县"
						}, {
							id: "13",
							name: "六合区"
						}, {
							id: "14",
							name: "浦口区"
						}]
					},
					{
						code: '0510',
						adminCode: '320200',
						name: '无锡市',
						areaId: '15',
						areas: [{
							id: "16",
							name: "崇安区"
						}, {
							id: "16",
							name: "南长区"
						}, {
							id: "16",
							name: "北塘区"
						}, {
							id: "19",
							name: "江阴市"
						}, {
							id: "18",
							name: "宜兴市"
						}, {
							id: "16",
							name: "锡山区"
						}, {
							id: "16",
							name: "滨湖区"
						}, {
							id: "16",
							name: "惠山区"
						}]
					},
					{
						code: '0511',
						adminCode: '321100',
						name: '镇江市',
						areaId: '4',
						areas: [{
							id: "8",
							name: "京口区"
						}, {
							id: "8",
							name: "润州区"
						}, {
							id: "8",
							name: "丹徒区"
						}, {
							id: "5",
							name: "丹阳市"
						}, {
							id: "7",
							name: "扬中市"
						}, {
							id: "6",
							name: "句容市"
						}, {
							id: "8",
							name: "镇江新区"
						}]
					},
					{
						code: '0512',
						adminCode: '320500',
						name: '苏州市',
						areaId: '20',
						areas: [{
							id: "21",
							name: "沧浪区"
						}, {
							id: "21",
							name: "平江区"
						}, {
							id: "21",
							name: "金阊区"
						}, {
							id: "21",
							name: "高新区"
						}, {
							id: "76",
							name: "常熟市"
						}, {
							id: "77",
							name: "张家港市"
						}, {
							id: "74",
							name: "昆山市"
						}, {
							id: "23",
							name: "吴江市"
						}, {
							id: "75",
							name: "太仓市"
						}, {
							id: "21",
							name: "吴中区"
						}, {
							id: "21",
							name: "相城区"
						}, {
							id: "21",
							name: "工业园区"
						}]
					},
					{
						code: '0513',
						adminCode: '320600',
						name: '南通市',
						areaId: '26',
						areas: [{
							id: "28",
							name: "崇川区"
						}, {
							id: "28",
							name: "港闸区"
						}, {
							id: "31",
							name: "海安县"
						}, {
							id: "29",
							name: "如东县"
						}, {
							id: "25",
							name: "启东市"
						}, {
							id: "30",
							name: "如皋市"
						}, {
							id: "27",
							name: "通州市"
						}, {
							id: "24",
							name: "海门市"
						}]
					},
					{
						code: '0514',
						adminCode: '321000',
						name: '扬州市',
						areaId: '33',
						areas: [{
							id: "34",
							name: "广陵区"
						}, {
							id: "38",
							name: "宝应县"
						}, {
							id: "34",
							name: "邗江区"
						}, {
							id: "32",
							name: "仪征市"
						}, {
							id: "37",
							name: "高邮市"
						}, {
							id: "36",
							name: "江都市"
						}]
					},
					{
						code: '0515',
						adminCode: '320900',
						name: '盐城市',
						areaId: '39',
						areas: [{
							id: "46",
							name: "响水县"
						}, {
							id: "45",
							name: "滨海县"
						}, {
							id: "44",
							name: "阜宁县"
						}, {
							id: "43",
							name: "射阳县"
						}, {
							id: "47",
							name: "建湖县"
						}, {
							id: "40",
							name: "盐都区"
						}, {
							id: "42",
							name: "东台市"
						}, {
							id: "41",
							name: "大丰市"
						}, {
							id: "40",
							name: "亭湖区"
						}]
					},
					{
						code: '0516',
						adminCode: '320300',
						name: '徐州市',
						areaId: '48',
						areas: [{
							id: "49",
							name: "鼓楼区"
						}, {
							id: "49",
							name: "云龙区"
						}, {
							id: "49",
							name: "九里区"
						}, {
							id: "90",
							name: "贾汪区"
						}, {
							id: "49",
							name: "泉山区"
						}, {
							id: "55",
							name: "丰县"
						}, {
							id: "54",
							name: "沛县"
						}, {
							id: "50",
							name: "铜山县"
						}, {
							id: "51",
							name: "睢宁县"
						}, {
							id: "53",
							name: "新沂市"
						}, {
							id: "52",
							name: "邳州市"
						}]
					},
					{
						code: '0517',
						adminCode: '320800',
						name: '淮安市',
						areaId: '60',
						areas: [{
							id: "61",
							name: "清河区"
						}, {
							id: "61",
							name: "清浦区"
						}, {
							id: "58",
							name: "淮阴区"
						}, {
							id: "62",
							name: "涟水县"
						}, {
							id: "59",
							name: "洪泽县"
						}, {
							id: "57",
							name: "盱眙县"
						}, {
							id: "56",
							name: "金湖县"
						}, {
							id: "61",
							name: "开发区"
						}, {
							id: "89",
							name: "楚州区"
						}]
					},
					{
						code: '0518',
						adminCode: '320700',
						name: '连云港市',
						areaId: '63',
						areas: [{
							id: "64",
							name: "连云区"
						}, {
							id: "64",
							name: "新浦区"
						}, {
							id: "65",
							name: "赣榆县"
						}, {
							id: "67",
							name: "东海县"
						}, {
							id: "66",
							name: "灌云县"
						}, {
							id: "68",
							name: "灌南县"
						}, {
							id: "64",
							name: "开发区"
						}]
					},
					{
						code: '0519',
						adminCode: '320400',
						name: '常州市',
						areaId: '69',
						areas: [{
							id: "70",
							name: "天宁区"
						}, {
							id: "70",
							name: "钟楼区"
						}, {
							id: "70",
							name: "戚墅堰区"
						}, {
							id: "73",
							name: "溧阳市"
						}, {
							id: "72",
							name: "金坛市"
						}, {
							id: "70",
							name: "武进区"
						}, {
							id: "70",
							name: "新北区"
						}]
					},
					{
						code: '0523',
						adminCode: '321200',
						name: '泰州市',
						areaId: '79',
						areas: [{
							id: "80",
							name: "海陵区"
						}, {
							id: "80",
							name: "高港区"
						}, {
							id: "83",
							name: "兴化市"
						}, {
							id: "78",
							name: "靖江市"
						}, {
							id: "81",
							name: "泰兴市"
						}, {
							id: "82",
							name: "姜堰市"
						}]
					},
					{
						code: '0527',
						adminCode: '321300',
						name: '宿迁市',
						areaId: '84',
						areas: [{
							id: "85",
							name: "宿城区"
						}, {
							id: "85",
							name: "宿豫区"
						}, {
							id: "87",
							name: "沭阳县"
						}, {
							id: "88",
							name: "泗阳县"
						}, {
							id: "86",
							name: "泗洪县"
						}]
					}
				];
			} else {

				me.cityList = [{
						code: '025',
						adminCode: '320100',
						name: '南京',
						areaId: '3',
						areas: [{
							id: '9',
							name: "市区"
						}, {
							id: "10",
							name: "江宁"
						}, {
							id: "11",
							name: "溧水"
						}, {
							id: "12",
							name: "高淳"
						}, {
							id: "13",
							name: "六合"
						}, {
							id: "14",
							name: "江浦"
						}]
					},
					{
						code: '0510',
						adminCode: '320200',
						name: '无锡',
						areaId: '15',
						areas: [{
							id: "16",
							name: "市区"
						}, {
							id: "18",
							name: "宜兴"
						}, {
							id: "19",
							name: "江阴"
						}]
					},
					{
						code: '0511',
						adminCode: '321100',
						name: '镇江',
						areaId: '4',
						areas: [{
							id: "8",
							name: "市区"
						}, {
							id: "5",
							name: "丹阳"
						}, {
							id: "6",
							name: "句容"
						}, {
							id: "7",
							name: "扬中"
						}]
					},
					{
						code: '0512',
						adminCode: '320500',
						name: '苏州',
						areaId: '20',
						areas: [{
							id: "21",
							name: "市区"
						}, {
							id: "74",
							name: "昆山"
						}, {
							id: "23",
							name: "吴江"
						}, {
							id: "77",
							name: "张家港"
						}, {
							id: "76",
							name: "常熟"
						}, {
							id: "75",
							name: "太仓"
						}]
					},
					{
						code: '0513',
						adminCode: '320600',
						name: '南通',
						areaId: '26',
						areas: [{
							id: "28",
							name: "市区"
						}, {
							id: "24",
							name: "海门"
						}, {
							id: "25",
							name: "启东"
						}, {
							id: "27",
							name: "通州"
						}, {
							id: "29",
							name: "如东"
						}, {
							id: "30",
							name: "如皋"
						}, {
							id: "31",
							name: "海安"
						}]
					},
					{
						code: '0514',
						adminCode: '321000',
						name: '扬州',
						areaId: '33',
						areas: [{
							id: "34",
							name: "市区"
						}, {
							id: "32",
							name: "仪征"
						}, {
							id: "36",
							name: "江都"
						}, {
							id: "37",
							name: "高邮"
						}, {
							id: "38",
							name: "宝应"
						}]
					},
					{
						code: '0515',
						adminCode: '320900',
						name: '盐城',
						areaId: '39',
						areas: [{
							id: "40",
							name: "市区"
						}, {
							id: "17",
							name: "盐都"
						}, {
							id: "41",
							name: "大丰"
						}, {
							id: "42",
							name: "东台"
						}, {
							id: "43",
							name: "射阳"
						}, {
							id: "44",
							name: "阜宁"
						}, {
							id: "45",
							name: "滨海"
						}, {
							id: "46",
							name: "响水"
						}, {
							id: "47",
							name: "建湖"
						}]
					},
					{
						code: '0516',
						adminCode: '320300',
						name: '徐州',
						areaId: '48',
						areas: [{
							id: "49",
							name: "市区"
						}, {
							id: "50",
							name: "铜山"
						}, {
							id: "51",
							name: "睢宁"
						}, {
							id: "52",
							name: "邳县"
						}, {
							id: "53",
							name: "新沂"
						}, {
							id: "54",
							name: "沛县"
						}, {
							id: "55",
							name: "丰县"
						}]
					},
					{
						code: '0517',
						adminCode: '320800',
						name: '淮安',
						areaId: '60',
						areas: [{
							id: "61",
							name: "市区"
						}, {
							id: "62",
							name: "涟水"
						}, {
							id: "89",
							name: "楚州"
						}, {
							id: "56",
							name: "金湖"
						}, {
							id: "57",
							name: "盱眙"
						}, {
							id: "58",
							name: "淮阴"
						}, {
							id: "59",
							name: "洪泽"
						}]
					},
					{
						code: '0518',
						adminCode: '320700',
						name: '连云港',
						areaId: '63',
						areas: [{
							id: "64",
							name: "市区"
						}, {
							id: "65",
							name: "赣榆"
						}, {
							id: "66",
							name: "灌云"
						}, {
							id: "67",
							name: "东海"
						}, {
							id: "68",
							name: "灌南"
						}]
					},
					{
						code: '0519',
						adminCode: '320400',
						name: '常州',
						areaId: '69',
						areas: [{
							id: "70",
							name: "市区"
						}, {
							id: "72",
							name: "金坛"
						}, {
							id: "73",
							name: "溧阳"
						}]
					},
					{
						code: '0523',
						adminCode: '321200',
						name: '泰州',
						areaId: '79',
						areas: [{
							id: "80",
							name: "市区"
						}, {
							id: "78",
							name: "靖江"
						}, {
							id: "81",
							name: "泰兴"
						}, {
							id: "82",
							name: "姜堰"
						}, {
							id: "83",
							name: "兴化"
						}]
					},
					{
						code: '0527',
						adminCode: '321300',
						name: '宿迁',
						areaId: '84',
						areas: [{
							id: "85",
							name: "市区"
						}, {
							id: "71",
							name: "宿豫"
						}, {
							id: "86",
							name: "泗洪"
						}, {
							id: "87",
							name: "沭阳"
						}, {
							id: "88",
							name: "泗阳"
						}]
					}
				];
			}
			me._initCityAreaInfoMap();
			switch (type) {
				case 'city': //城市选择器
					var shopCityCode = me.getData('shopCityCode');
					if (!shopCityCode || "" == $.trim(shopCityCode)) {
						shopCityCode = me.getData('cityCode');
					}
					var name = me.getCityNameByCode(shopCityCode);
					ui.ui('common.city', {
						dom: dom,
						code: shopCityCode,
						name: name
					});
					break;
				case 'cityNew': //新城市选择器
					var shopCityCode = me.getData('shopCityCode');
					if (!shopCityCode || "" == $.trim(shopCityCode)) {
						shopCityCode = me.getData('cityCode');
					}
					var name = me.getCityNameByCode(shopCityCode);
					ui.ui('common.cityNew', {
						dom: dom,
						code: shopCityCode,
						name: name
					});
					break;
				case 'product': //产品选择器
					var loginType = me.getData("loginType");
					ui.ui('common.product', {
						dom: dom,
						loginType: loginType
					});
					break;
				case 'cityArea': //地区选择器
					ui.ui('common.cityArea', {
						dom: dom
					});
					break;
				case 'cityAreaNew': //地区选择器
					ui.ui('common.cityArea', {
						dom: dom
					});
					break;
			}
		},
		getProductId: function() {
			var me = this,
				loginNumber = me.getData('loginNumber'),
				userInfo = me.getData('userInfo');
			if (!userInfo || !loginNumber) {
				return "";
			}
			var loginType = me.getData('loginType');
			if (!loginType) {
				return "";
			}
			var productInfo = userInfo[loginType + 'Info'],
				numberInfo = loginType + 'Num'
			if (!productInfo) {
				return "";
			}
			var len = productInfo.length,
				liData;
			for (var i = 0; i < len; i++) {
				liData = productInfo[i];
				if (loginType == 'phone') {
					if ($.trim(liData[numberInfo]) == $.trim(loginNumber) || (window.cityCode + '' + $.trim(liData[numberInfo])) == $.trim(loginNumber)) {
						return liData.prodId;
					}
				} else {
					if ($.trim(liData[numberInfo]) == $.trim(loginNumber)) {
						return liData.prodId;
					}

				}
			}
			return "";
		},
		getFamily: function() {
			var loginType = this.getData('loginType');
			if (!loginType) {
				loginType = "mobile";
			}
			return this.family[loginType];
		},
		getfamilyWeiXin: function(type) {
			if (!type) {
				type = "mobile";
			}
			return this.familyWeiXin[type];
		},
		_initNumberType: function() {
			var me = this;
			if (me.numberTypeMap) {
				return;
			}
			var numberTypeMap = {},
				list = me.products;
			for (var i = 0; i < list.length; i++) {
				numberTypeMap[list[i].value] = list[i].numberType;
			}
			me.numberTypeMap = numberTypeMap;
		},
		getNumberType: function() {
			var me = this;
			me._initNumberType();
			if (me.getData('loginStatus') != 0) {
				return me.numberTypeMap[me.getData('loginType')];
			} else {
				return "";
			}

		},
		login: function(loginCallback, noLoginCallback, succCallback, errorCallback, gotoPage) { //需要登录授权才可访问
			var loginStatus = this.getData('loginStatus');
			if (loginStatus == 0 || loginStatus == '-1') { //未登录
				if (succCallback) {
					loginCallback = succCallback;
				}
				APP.page.changePage('common/login', {
					param: {
						succCallback: loginCallback,
						errorCallback: errorCallback
					}
				});
			} else {
				loginCallback && loginCallback();
			}
		},
		logout: function() { //注销    去掉清除是否更新个人中心的缓存
			var me = APP.main;
            function clearStatus(){
                try {
                    var trkObj = {
                        "events": "event2"
                    };
                    insertCodeNew(trkObj);
                } catch (e) {}
                me.updateData('loginStatus', 0);
                me.updateData('loginType', 'mobile');
                me.updateData('loginNumber', '');
                me.updateData('userMainPackage', '');
                me.updateLocalData('loginNumber', '');
                me.updateLocalData('loginType', 'mobile');
                me.updateLocalData('autoLogin', '');
				/*清除微信数据start*/
                me.updateData('wx_name', ''); //微信昵称
                me.updateData('wx_headImg', ''); //微信头像
                me.updateData('wx_openId', ''); //微信昵称
                me.updateData('wx_unionId', ''); //微信头像
                me.updateData('wx_isBind', 0); //微信绑定(2-绑定)
                me.updateData('wx_domain', 0); //微信第三方登录为主，可解绑号码；反之可解绑微信
				/*清除微信数据end*/

                window.loginType = '';
                window.loginNumber = '';
                window.localStorage.mobile = '';
                var login_areaCode = "025";
                window.localStorage.areaCode = login_areaCode;
                window.tymcCityCode = login_areaCode;
                window.cityCode = login_areaCode;
                window.loginCity = login_areaCode;
                window.mainCityCode = login_areaCode;
                window.localStorage.cityCode = '';
                window.loginStatus = 0;
                window.token = 'undefined'; //lxc 20150917 未登录统计地市 000的修复
                me.updateData('token', ''); //lxc 20150917
                navigator.TyAccountPlugin.signOut({
                    success: null,
                    error: null
                });
                setTimeout(function() {
                    APP.ui.hide('default.confirm');
                    APP.page.changePage('main/index');
                }, 10);
                if (me.getFamily() == '2') {
                    me.handleFlowNoti('close'); //关闭流量通知栏
                    APP.underly.util.floatDesktop.destory(); //关闭桌面悬浮窗
                }
			}
			APP.ui.ui('default.confirmNew', {
				title: '提示',
				//align: 'center',
				content: '确认要退出当前帐号？',
				confirm: function() {
                    me.loginOffline({
                        success: clearStatus,
                        fail: clearStatus,
                        error: clearStatus,
                    });
				},
				cancel: function() {
					APP.ui.hide('default.confirmNew');
				}
			});
		},
		buyFlow: function(serviceId, serviceName, productServiceType, serviceSpecialType, callback, fail) { //订购流量
			var me = this;
			this.login(function() {
				var number = me.getData('loginNumber'),
					areaCode = me.getData('cityCode'),
					family = me.getFamily();
				var bssInnerAreaId = me.getData('childAreaCode'),
					productId = me.getProductId(),
					paramTool = tools.param.get();
				paramTool.add('accNbr', number);
				paramTool.add('areaCode', areaCode);
				paramTool.add('bssInnerAreaId', bssInnerAreaId);
				paramTool.add('productServiceType', productServiceType);
				paramTool.add('specialType', serviceSpecialType);
				paramTool.add('prodId', productId);
				paramTool.add('family', family);
				paramTool.add('goodName', serviceName);
				paramTool.add('offerSpecl', serviceId);
				APP.interf.invoke({
					url: "/rest/orderpackage",
					param: paramTool.value(),
					actionCode: 'yw000',
					type: 'old',
					//server:'http://61.160.137.141/jszt',
					success: function(data) {
						callback && callback(data);
						//window.orderNum = data.olId;
					},
					fail: function(data) {
						fail && fail(data);
					},
					error: function() {
						error && error(data);
					}
				});
			});
		},
		getFlowData: function(key) { //获取公共流量数据
			var flow = this.getData('flowData'),
				data, formatData = this.getData('flowFormatData');
			if (!flow) {
				data = {
					used: [0, 'M'],
					total: [0, 'M'],
					percent: 0,
					left: [0, 'M']
				};
				this.updateData('flowFormatData', null);
				formatData = data;
				return formatData[key];
			}
			if (!formatData) {
				data = {};
				var used = flow.used,
					total = flow.total,
					left = flow.remain,
					percent = flow.percent;

				if (used != null) {
					if (used >= 1024) {
						used = used / 1024;
						used = Math.round(used * 100) / 100;
						data.used = [used, 'G'];
					} else {
						data.used = [used, 'M'];
					}
				}
				if (left != null) {
					if (left >= 1024) {
						left = left / 1024;
						left = Math.round(left * 100) / 100;
						data.left = [left, 'G'];
					} else {
						data.left = [left, 'M'];
					}
				}
				if (total != null) {
					if (total >= 1024) {
						total = total / 1024;
						total = Math.round(total * 100) / 100;
						data.total = [total, 'G'];
					} else {
						data.total = [total, 'M'];
					}
				}
				if (percent != null) {
					data.percent = flow.percent;
				} else {
					data.percent = 0;
				}
				this.updateData('flowFormatData', data);
				formatData = data;
			}
			return formatData[key];
		},
		goLogin: function(succ, error) {

		},
		showOrUpdateMineUnReadMsg: function(counts) { //显示未读消息
			var me = this,
				page = me.activePage;
			if (page == null) {
				return;
			}
			if (counts != null) {
				me.updateData('mineUnReadMsgCounts', counts);
			} else {
				var unReadCounts = me.getData('mineUnReadMsgCounts');
				var sideNavListDom = page.find('[domId=sideNavList]');
				if (!unReadCounts || unReadCounts == 0 || unReadCounts == '0') {
					page.find('div[domId=sideNavBtn]').find('span[domId=rotHasCounts]').hide();
					sideNavListDom.find('div[sideNavType=msg]').find('span.rightTopDot').remove();
					sideNavListDom.find('div[sideNavType=msg]').removeClass('o1').addClass('d3');
				} else if (unReadCounts > 0) {
					page.find('div[domId=sideNavBtn]').find('span[domId=rotHasCounts]').show();
					sideNavListDom.find('div[sideNavType=msg]').find('span.rightTopDot').remove();
					sideNavListDom.find('div[sideNavType=msg]').removeClass('o1').addClass('d3');
					if (unReadCounts > 99) {
						unReadCounts = 99;
					}
					page.find('div[domId=sideNavBtn]').find('span[domId=rotHasCounts]').empty().append(unReadCounts);
					sideNavListDom.find('div[sideNavType=msg]').append('<span class="rightTopDot">' + unReadCounts + '</span>');
					sideNavListDom.find('div[sideNavType=msg]').removeClass('d3').addClass('o1');
				}
			}
		},
		executeJsCode: function(urlStr, isLogin) {
			var validate = tools.validate;
			if (validate.isNotNull(urlStr)) {
				try {
					urlStr = urlStr.replaceAll("‘", "'");
					urlStr = urlStr.replaceAll("’", "'");
					if (validate.isNotNull(isLogin) && (isLogin == '1' || isLogin == 1)) {
						var loginStatus = this.getData('loginStatus');
						if (loginStatus == 0) {
							APP.page.changePage('common/login');
							return;
						}
					}
					urlStr = urlStr.replaceAll("MAIN.", 'APP.main.');
					eval(handleDomainContent(urlStr));
				} catch (e) {

				}
			}
		},
		//短信验证码登录
		dynamicUserLogin: function(loginType, accNbr, password, accLoginType, areaCode, verificationCode, isAutomatic, equipmentId, success, fail, notShowLoading) { //新版短信验证码登录addby lqy 2016/11/17
			var me = this,
				ui = APP.ui,
				tools = APP.tool,
				paramInit = tools.param.get(),
				main = me;
			paramInit.add("accNbr", accNbr).add("password", password).add("accNbrType", accLoginType).add("PWDType", "-1").add("areaCode", areaCode);
			paramInit.add('verificationCode', verificationCode).add('isAutomatic', isAutomatic).add('equipmentId', equipmentId);
			paramInit.add('PathCode', 'login-00009');
			notShowLoading = !notShowLoading;
			var productp = {
				'2000001': '固话',
				'2000002': '宽带',
				'2000004': '手机',
				'000000': '流量'
			}
			// var trkObj = {"eVar1":accNbr, "eVar2":productp[accLoginType], "eVar3":areaCode, "events":"event1"};
			// insertCodeNew(trkObj);

			APP.interf.invoke({
				url: "/login/loginByDynamicPwd",
				pathCode: 'login-00009',
				type: 'ztlogin',
				param: paramInit.value(),
				showLoading: notShowLoading,
				showError: notShowLoading,
				actionCode: 'login037',
				success: function(data) {
					main.updateData('loginStatus', 2);
					main.updateData('token', data.token);
					main.updateData('cityCode', data.areaCode);
					main.updateData('shopCityCode', data.areaCode);
					main.updateData('autoIdentitySuccess', true);
					main.updateData('loginNumber', data.accNbr);
					main.updateData('loginType', loginType);
					main.updateData('loginNumberType', accLoginType);
					main.updateData('userInfo', {});
					main.updateLocalData('mobile', data.accNbr);
					main.updateLocalData('areaCode', data.areaCode ? data.areaCode : "025");
					main.updateLocalData('cityCode', data.areaCode ? data.areaCode : "025");
					main.lowCompatible();

					if (APP.config.app.platform == 'android') {
						if (main.getFamily() == '2') { //流量通知栏 悬浮窗
							main.handleFlowNoti();
						} else {
							main.handleFlowNoti('close');
						}
					}
					main.getUserInfo(data.accNbr, main.getNumberType(), function(data) {
						MODULE.getModule('tyshIndexPage') && MODULE.getModule('tyshIndexPage').refresh();
					}, function(data) {}, false, "manual");

					success && success(data);

				},
				fail: function(data) {
					if (fail) {
						fail(data);
					} else {
						ui.ui('default.tip', {
							content: data.TSR_MSG
						});
					}
				},
				error: function(data) {
					if (fail) {
						fail(data);
					}
					ui.ui('default.tip', {
						content: '网络连接失败，请检查网络设置'
					});
				}
			});
		},
		//免密登陆 
		noPwdlogin: function(accessToken, notShowLoading, succ, fail, autoNumber, isAutomatic, lastLoginID, refreshToken) {
			var main = APP.main,
				me = this,
				ui = APP.ui,
				tools = APP.tool,
				paramInit = tools.param.get(),
				autoLogin = me.getLocalData('autoLogin');
			var equipmentId = isNull(window.localStorage.userPushid) ? "" : window.localStorage.userPushid;
			if (APP.config.app.platform == 'iphone') {
				equipmentId = device.uuid
			}
			var pushUserId = main.getData("pushUserId");
			var appVersion = APP.config.app.version;
			var ztInterSource = APP.config.app.ztInterSource;
			var param = "accessToken=" + accessToken + ";clientType=10010;equipmentId=" + equipmentId + ";lastLoginID=" + lastLoginID + ";pushUserId=" + pushUserId + ";appVersion=" + appVersion + ";ztInterSource=" + ztInterSource + ";PathCode=login-00007;";

			if (!isNull(autoNumber) && isAutomatic == 'Y') {
				param = "accessToken=" + accessToken + ";clientType=10010;equipmentId=" + equipmentId + ";keepLoginAccNbr=" + autoNumber + ";isAutomatic=" + isAutomatic + ";refreshToken=" + refreshToken + ";lastLoginID=" + lastLoginID + ";pushUserId=" + pushUserId + ";appVersion=" + appVersion + ";ztInterSource=" + ztInterSource + ";PathCode=login-00007;";
			}
			APP.interf.invoke({
				//url: "/login/mianmiLogin", 
				url: "/welcome",
				type: 'ztlogin',
				param: param,
				showLoading: notShowLoading,
				showError: notShowLoading,
				pathCode: 'login-00007',
				actionCode: 'nopasswordlogin',
				success: function(data) {
					var main = APP.main;
					if (data.TSR_RESULT == '0') {
						main.updateData('loginStatus', 2);
						main.updateData('token', data.token);
						main.updateData('cityCode', data.areaCode);
						main.updateData('shopCityCode', data.areaCode);
						main.updateData('autoIdentitySuccess', true);
						main.updateData('loginNumber', data.accNbr);
						main.updateData('loginType', 'mobile');
						main.updateData('loginNumberType', main.getNumberType());
						main.updateLocalData('mobile', data.accNbr);
						main.updateLocalData('areaCode', data.areaCode ? data.areaCode : "025");
						main.lowCompatible();
						if (!isNull(autoNumber) && isAutomatic == 'Y') {
							var logins = autoLogin.split(',');
							logins[2] = data.accessToken;
							logins = logins.join(',');
							me.updateLocalData("autoLogin", logins);
						}

						if (APP.config.app.platform == 'android') {
							if (main.getFamily() == '2') { //流量通知栏 悬浮窗
								main.handleFlowNoti();
							} else {
								main.handleFlowNoti('close');
							}
						}
						main.getUserInfo(data.accNbr, main.getNumberType(), function(data) {
							MODULE.getModule('tyshIndexPage') && MODULE.getModule('tyshIndexPage').refresh();
						}, function(data) {}, false, "manual");
					}

					succ && succ(data);
				},
				fail: function(data) {
					main.updateLocalData('autoLogin', null);
					fail && fail();

				},
				error: function(data) {
					main.updateLocalData('autoLogin', null);
					fail && fail();

				}
			});

		},
		//登录时发现areacode时undefined，修复该bug，2017-5-17后可删除，因为接口统一扎口修复
		userLogin: function(loginType, accNbr, password, accLoginType, areaCode, isAutomatic, success, fail, notShowLoading) { //登录
			if (areaCode == 'undefined') {
				areaCode = '';
			}
			var me = APP.main,
				ui = APP.ui,
				tools = APP.tool,
				paramInit = tools.param.get();
			paramInit.add("accNbr", accNbr).add("password", password).add("accNbrType", accLoginType).add("PWDType", "-1").add("areaCode", areaCode);
			paramInit.add('isAutomatic', isAutomatic);
			var productp = {
				'2000001': '固话',
				'2000002': '宽带',
				'2000004': '手机',
				'000000': '流量'
			}
			// var trkObj = {"eVar1":accNbr, "eVar2":productp[accLoginType], "eVar3":areaCode, "events":"event1"};
			// insertCodeNew(trkObj);
			notShowLoading = !notShowLoading;
			APP.interf.invoke({
				//server:"http://221.228.39.58:12000/jszt",
				server: "http://wapjs.189.cn/zt-login",
				url: "/login/innerAccount",
				param: paramInit.value(),
				//url: "/rest/login2User", param: paramInit.value(),
				//type: 'old',
				showLoading: notShowLoading,
				showError: notShowLoading,
				actionCode: 'login037',
				success: function(data) {
					me.updateData('loginStatus', 2);
					me.updateData('loginType', loginType);
					me.updateData('cityCode', data.areaCode);
					me.updateData('shopCityCode', data.areaCode);
					me.updateData('loginNumber', data.accNbr);
					me.updateData('loginNumberType', accLoginType);
					me.updateData('token', data.token);
					me.updateData('customerName', "");
					me.updateData('childAreaCode', "");
					me.updateData('userInfo', {});
					window.token = data.token;
					//添加例外
					if (isNull(window.token)) {
						window.token = "1234";
					}
					window.loginType = loginType;
					if (loginType == 'phone') {
						window.loginNumber = data.accNbr.substring(data.areaCode.length);
					} else {
						window.loginNumber = data.accNbr;
					}
					window.localStorage.mobile = data.accNbr;
					// 记录登录的地区码
					var login_areaCode = data.areaCode ? data.areaCode : "025";
					window.localStorage.areaCode = login_areaCode;
					window.tymcCityCode = login_areaCode;
					window.cityCode = login_areaCode;
					window.loginCity = login_areaCode;
					window.mainCityCode = login_areaCode; //added by chm焦点图变换
					window.localStorage.cityCode = window.cityCode;
					window.loginStatus = 2; // 已登录
					me.uploadUseInfoToUms();
					me.uploadUserInfo();
					me.lowCompatible();
					success && success(data);
				},
				fail: function(data) {
					if (fail) {
						fail(data);
					} else {
						ui.ui('default.tip', {
							content: data.TSR_MSG
						});
					}
				},
				error: function(data) {
					if (fail) {
						fail(data);
					}
					ui.ui('default.tip', {
						content: '网络连接失败，请检查网络设置'
					});

				}
			});
		},
		userLoginNew: function(loginType, accNbr, password, accLoginType, areaCode, isAutomatic, success, fail, notShowLoading, times) {
			/*登录增加滑动*/
			if (areaCode == 'undefined') {
				areaCode = '';
			}
			var me = APP.main,
				ui = APP.ui,
				tools = APP.tool,
				paramInit = tools.param.get();
			paramInit.add("accNbr", accNbr).add("password", password).add("accNbrType", accLoginType).add("PWDType", "-1").add("areaCode", areaCode);
			paramInit.add('isAutomatic', isAutomatic);
			paramInit.add('pushUserId', me.getData("pushUserId"));
			paramInit.add('PathCode', 'login-000012');
			paramInit.add('times', times);
			/* var trkObj = {"eVar1":accNbr, "eVar2":productp[accLoginType], "eVar3":areaCode, "events":"event1"};
			 insertCodeNew(trkObj);*/
			notShowLoading = !notShowLoading;
			APP.interf.invoke({
				//url: "/rest/login2User",
				url: "/welcome",
				param: paramInit.value(),
				pathCode: "login-000012",
				type: 'ztlogin',
				showLoading: notShowLoading,
				showError: notShowLoading,
				actionCode: 'zt-login_login-000012',
				success: function(data) {
					me.updateData('loginStatus', 2);
					me.updateData('loginType', loginType);
					me.updateData('cityCode', data.areaCode);
					me.updateData('shopCityCode', data.areaCode);
					me.updateData('loginNumber', data.accNbr);
					me.updateData('loginNumberType', accLoginType);
					me.updateData('token', data.token);
					me.updateData('customerName', "");
					me.updateData('childAreaCode', "");
					me.updateData('userInfo', {});
					window.token = data.token;
					//添加例外
					if (isNull(window.token)) {
						window.token = "1234";
					}
					window.loginType = loginType;
					if (loginType == 'phone') {
						window.loginNumber = data.accNbr.substring(data.areaCode.length);
					} else {
						window.loginNumber = data.accNbr;
					}
					window.localStorage.mobile = data.accNbr;
					// 记录登录的地区码
					var login_areaCode = data.areaCode ? data.areaCode : "025";
					window.localStorage.areaCode = login_areaCode;
					window.tymcCityCode = login_areaCode;
					window.cityCode = login_areaCode;
					window.loginCity = login_areaCode;
					window.mainCityCode = login_areaCode; //added by chm焦点图变换
					window.localStorage.cityCode = window.cityCode;
					window.loginStatus = 2; // 已登录
					me.uploadUseInfoToUms();
					me.uploadUserInfo();
					me.lowCompatible();
					success && success(data);
				},
				fail: function(data) {
					if (fail) {
						fail(data);
					} else {
						ui.ui('default.tip', {
							content: data.TSR_MSG
						});
					}
				},
				error: function(data) {
					if (fail) {
						fail(data);
					}
					ui.ui('default.tip', {
						content: '网络连接失败，请检查网络设置'
					});

				}
			});
		},
		lowCompatible: function() {
			var main = this;
			window.loginStatus = main.getData('loginStatus');
			window.token = main.getData('token');
			window.cityCode = main.getData('cityCode');
			window.shopCityCode = main.getData('shopCityCode');
			window.autoIdentitySuccess = main.getData('autoIdentitySuccess');
			window.loginNumber = main.getData('loginNumber');
			window.loginType = main.getData('loginType');
			window.loginNumberType = main.getData('loginNumberType');
			window.mobile = main.getData('mobile');
			window.areaCode = main.getData('areaCode');
		},
		getUserInfo: function(accNbr, accLoginType, success, fail, notShowLoading, isAuto) { //获取用户信息
			var me = APP.main;
			var tools = APP.tool;
			var interf = APP.interf;
			var paramInit = tools.param.get();
			var ui = APP.ui;
			if (accLoginType == "weixin") //纯微信登录未绑定不用查信息，防止鉴权不通过
				return;
			paramInit.add("accNbr", accNbr);
			//paramInit.add("password",pwd);
			paramInit.add("accNbrType", accLoginType);
			paramInit.add("PWDType", "-1");
			paramInit.add("areaCode", me.getData("cityCode"));

			if (notShowLoading) {
				notShowLoading = true;
			} else {
				notShowLoading = false;
			}
			if (window.info2DoOne) { //正在执行时，只执行一次，不重复执行
				return;
			}
			window.info2DoOne = true;
			if (typeof(wr_dm) != 'undefined' && typeof(wr_dm.t) != 'undefined') { //方便abode 統計pv uv
				if (wr_tPagesId && wr_tPagesId.indexOf(this.activePage.attr("id")) > -1) {
					wr_dm.t()
				}
			}
			interf.invoke({
				url: "/rest/login2UserInfo",
				param: paramInit.value(),
				type: 'old',
				actionCode: 'yw013',
				showLoading: notShowLoading,
				//showError:notShowLoading,
				success: function(data) { //保存登陆信息
					var trkObj;
					try {
						var touchParams = {};
						var app2 = APP.config.app;
						var data2 = APP.config.data;
						var areaCode = me.getData('cityCode');
						var loginNumber = me.getData('loginNumber');
						var family = me.getFamily();
						var loginStatus = me.getData('loginStatus');
						// if (APP.config.platform == 'APP' && loginStatus && loginStatus != '0' && loginStatus != 0 && loginStatus != '-1') {
						var family = me.getFamily();

						function isJS(areaCode) {
							var cityList = me.cityList;
							for (var i = 0; i < cityList.length; i++) {
								if (cityList[i].code == areaCode) {
									return "江苏";
								}

							}
							return false;
						}
						if (!isJS(areaCode)) {
							areaCode = '025';
						}
						me.updateData('cityCode', areaCode);
						touchParams.channelCode_common = app2.channelCode;
						touchParams.pubAreaCode = data2.cityCode;
						if (data2.pushUserId) { //防止safari浏览器获取不到这个参数
							touchParams.pushUserId = data2.pushUserId;
						} else {
							touchParams.pushUserId = 'jszt_9876543210';
						}
						touchParams.userLogAccNbrType = family;
						touchParams.userLogAccNbr = data2.loginNumber;
						touchParams.userTokenAccNbrType = '2';
						touchParams.ztVersion = app2.version;
						touchParams.ztInterSource = app2.ztInterSource;
						touchParams.pubToken = data2.token;
						touchParams.accNbr = loginNumber;
						touchParams.areaCode = areaCode;
						touchParams.family = family;
						touchParams.PathCode = 'uniformity-0009';
						touchParams.actionCode = 'uniformitysearchUseInfo';
						navigator.TyAccountPlugin.setAccountInfo({
							success: null,
							error: null,
							para: touchParams
						})
					} catch (e) {}
					if (me.getData('wx_domain')) {
						trkObj = {
							"event1": "event1",
							"vid": window.vvid,
							"trkFlatName": window.trkFlatName,
							"account": accNbr,
							"loginType": "weixin",
							"city": me.getData("cityCode")
						}
					} else {
						trkObj = {
							"event1": "event1",
							"vid": window.vvid,
							"trkFlatName": window.trkFlatName,
							"account": accNbr,
							"loginType": accLoginType,
							"city": me.getData("cityCode")
						}
					}
					insertCodeLogin(trkObj);
					window.info2DoOne = false;
					window.info2IsSucc = true; //login2UserInfo正确返回
					me.updateData('realNameStatus', data.smState); //0 实名   1 非实名
					me.updateData("zqState", data.zqState); //0政企  1非政企
					me.updateData('state34G', data.state34G); //0 3G   1 4G
					me.updateData('customerName', data.customerName);
					me.updateData('childAreaCode', data.childAreaCode);
					me.updateData('userInfo', data);
					me.updateData('adminAccount', data.managerAccount == "0");
					me.updateData('customerID', data.indentNbr);
					me.updateData('payMethod', data.payMethod ? data.payMethod : '2'); //1：预付费  2：后付费
					me.lowCompatible();
					window.idCard = data.indentNbr;
					window.presentAccountInfo = new PresentAccountInfo();
					window.presentAccountInfo.num = me.getData('loginNumber');
					window.presentAccountInfo.numType = parseInt(me.getFamily()); ////me.getData('loginNumberType');
					window.localStorage.userName = data.customerName;
					// 记录登录的地区码
					window.bssAreaCode3 = data.childAreaCode ? data.childAreaCode : "";
					window.isAdminLogin = (data.managerAccount == "0");
					window.userAccountInfo = data;
					success && success(data);
					try {
						doInitStartAdTbl();
					} catch (eexcep) {}

					if (me.getFamily() == '2') { //流量通知栏 悬浮窗

						me.handleFlowNoti();
						//me.initFlowWidget();//20170908去除调用，减少首页调用接口数量
					} else {
						me.handleFlowNoti('close');
					}
				},
				fail: function(data) {
					window.info2DoOne = false;
					window.info2IsSucc = false;
					/*if (me.getUserInfoErrorCounts < 2) {//20170919 屏蔽
					 me.getUserInfoErrorCounts++;
					 me.getUserInfo(accNbr, accLoginType, success, fail, notShowLoading);
					 }*/
					if (fail) {
						fail(data);
					} else {
						// ui.ui('default.alert', {content: data.TSR_MSG});
					}
				},
				error: function(data) {
					window.info2DoOne = false;
					window.info2IsSucc = false;
					if (fail) {
						fail(data);
					} else {
						//ui.ui('default.alert', {content: data.TSR_MSG});
					}
				}
			});
			if (!APP.main.getData('wx_domain')) { //非微信第三方登录查询绑定消息
				inquiryBindInfo();
			}

			function inquiryBindInfo() {
				var main = APP.main;
				var interf = APP.interf;
				var params = tools.param;
				var paramInit = params.get();

				paramInit.add('accNbr', main.getData("loginNumber"));
				paramInit.add('areaCode', main.getData("cityCode"));
				var type = main.getfamilyWeiXin(main.getData("loginType"));
				paramInit.add('loginType', type); //账号类型 101 江苏电信手机号账号 102 江苏电信固话账号  103 江苏电信宽带账号
				paramInit.add('PathCode', "otherlogin-00008");

				interf.invoke({
					url: "/welcome",
					param: paramInit.value(),
					pathCode: "otherlogin-00008",
					type: 'ztlogin',
					success: function(data) {
						if (data.TSR_RESULT == 0) {
							data = data.body;
							main.updateData("wx_isFirstBind", 0);
							if (data.isCancelBind == 1) { //已经解绑，之前有过绑定
								main.updateData('wx_isBind', 0);
								main.updateData('wx_name', ''); //微信昵称
								main.updateData('wx_headImg', ''); //微信头像
								main.updateData('wx_openId', '');
								main.updateData('wx_unionId', ''); //微信昵称
								return;
							}
							//有绑定情况，获取token更新登录信息状态
							main.updateData('wx_isBind', 2);
							main.updateData('wx_name', data.nickName); //微信昵称
							//                          main.updateData('wx_headImg', data.headPortrait);//微信头像
							main.updateData('wx_openId', data.thirdAccountName);
							main.updateData('wx_unionId', data.unionId); //微信昵称
						}

					},
					fail: function(data) {
						main.updateData("wx_isFirstBind", 2);
						main.updateData('wx_isBind', 0);
						main.updateData('wx_name', ''); //微信昵称
						main.updateData('wx_headImg', ''); //微信头像
						main.updateData('wx_openId', '');
						main.updateData('wx_unionId', ''); //微信昵称
					},
					error: function(data) {
						main.updateData('wx_isBind', 0);
						main.updateData('wx_name', ''); //微信昵称
						main.updateData('wx_headImg', ''); //微信头像
						main.updateData('wx_openId', '');
						main.updateData('wx_unionId', ''); //微信昵称
					}
				});
			}

			if (window.location.href.indexOf('common/login') >= 0 || window.location.href.indexOf('common/wxbindAccount') >= 0) {
				var main = APP.main;
				var page = APP.page;
				if (main.getData('wx_domain')) { //微信登录有绑定跳转回主页，并清空输入框
					page.changePage("main/index");
				}
			}
		},
		getMainPackage: function(accNbr, success, fail) { //获取主套餐
			var me = APP.main;
			var tools = APP.tool;
			var interf = APP.interf;
			var paramInit = tools.param.get();
			var ui = APP.ui;
			var PathCode = 'business-00006';
			paramInit.add("PathCode", PathCode);
			paramInit.add("accNbr", accNbr);
			paramInit.add("nbrType", me.getFamily());
			paramInit.add("areaCode", me.getData("cityCode"));
			if (window.getMainPackage) {
				fail && fail();
				return;
			}
			window.getMainPackage = true;
			interf.invoke({
				url: '/business/offerId',
				param: paramInit.value(),
				type: 'ztservice',
				pathCode: PathCode,
				showLoading: false,
				showError: false,
				success: function(data) {
					window.getMainPackage = false;
					me.updateData('userMainPackage', data.body);
					success && success(data.body);
				},
				fail: function(data) {
					window.getMainPackage = false;
					// console.error(data)
					if (fail) {
						fail && fail(data);
					} else {
						ui.ui('default.alert', {
							content: data.TSR_MSG
						});
					}
				},
				error: function(data) {
					window.getMainPackage = false;
					// console.error(data)
					if (fail) {
						fail && fail(data);
					} else {
						ui.ui('default.alert', {
							content: data.TSR_MSG
						});
					}
				}
			});
		},

		isAutoLogin: function() { //是否自动登录
			var me = this,
				autoLogin = me.getLocalData('autoLogin'),
				validate = tools.validate;
			if (validate.isNull(autoLogin)) {
				return false;
			} else {
				autoLogin = autoLogin.split(',');
				if (validate.isNull(autoLogin[0])) {
					return false;
				} else if (validate.isNull(autoLogin[1])) {
					return false;
				}
			}
			return true;
		},
		autoLogin: function(isSwitch) { //自动登录
			var me = APP.main,
				autoLogin = me.getLocalData('autoLogin'),
				validate = APP.tool.validate;
			if (validate.isNotNull(autoLogin)) {
				var logins = autoLogin.split(',');

				try {
					//新增Y为isAutomatic的值
					if (logins[0] == 'mobile' && logins.length >= 6 && logins[5] == 'message') {
						var equipmentId = isNull(window.localStorage.userPushid) ? "" : window.localStorage.userPushid;
						if (APP.config.app.platform == 'iphone') {
							equipmentId = device.uuid
						}
						me.dynamicUserLogin(logins[0], logins[1], logins[2], logins[3], logins[4], logins[2], 'Y', equipmentId, function() {
							try {
								if (APP.config.app.platform == 'android') {
									if (logins[0] && logins[0] == 'mobile' && navigator && navigator.jpush && navigator.jpush.setAliasAndTags) {
										navigator.jpush.setAliasAndTags(function() {}, function() {}, logins[1], [logins[4]]);
									}
								} else {
									if (logins[0] && logins[0] == 'mobile' && navigator && navigator.jpushmanager && navigator.jpushmanager.jpushSetTagAlias) {
										var option = {
											tags: logins[4],
											alias: logins[1]
										};
										navigator.jpushmanager.jpushSetTagAlias(function(arg) {}, function(err) {}, option);
									}
								}
							} catch (e) {}
							me.getUserInfo(logins[1], logins[3], function() {
								MODULE.getModule('tyshIndexPage') && MODULE.getModule('tyshIndexPage').refresh();
                                if(isSwitch){APP.page.changePage('main/index')};
							}, function() {
								MODULE.getModule('tyshIndexPage') && MODULE.getModule('tyshIndexPage').refresh();
                                if(isSwitch){APP.page.changePage('main/index')};
							}, true, "manual");
						}, function(data) {
							if (data.TSR_MSG.indexOf('短信自动登录验证码已失效') > -1) {
								var loginInfo = {
									type: 'message',
									account: logins[1]
								}
								updateLoginHistory(loginInfo, 'Y');
								me.updateLocalData('autoLogin', null);
							}
							APP.ui.ui('default.tip', {
								content: data.TSR_MSG,
								callback: function() {
									APP.page.changePage('common/login', {
										loginType: 'message'
									});
								}
							});
						}, true);

					} else {
						var account = logins[1];
						if (logins[0] == 'phone') {
							account = logins[4] + logins[1]
						}
						me.userLogin(logins[0], account, logins[2], logins[3], logins[4], 'Y', function() {
							try {
								if (APP.config.app.platform == 'android') {
									if (logins[0] && logins[0] == 'mobile' && navigator && navigator.jpush && navigator.jpush.setAliasAndTags) {
										navigator.jpush.setAliasAndTags(function() {}, function() {}, logins[1], [logins[4]]);
									}
								} else {
									if (logins[0] && logins[0] == 'mobile' && navigator && navigator.jpushmanager && navigator.jpushmanager.jpushSetTagAlias) {
										var option = {
											tags: logins[4],
											alias: logins[1]
										};
										navigator.jpushmanager.jpushSetTagAlias(function(arg) {}, function(err) {}, option);
									}
								}
							} catch (e) {}
							me.getUserInfo(logins[1], logins[3], function() {
								MODULE.getModule('tyshIndexPage') && MODULE.getModule('tyshIndexPage').refresh();
                                if(isSwitch){APP.page.changePage('main/index')};
							}, function() {
								MODULE.getModule('tyshIndexPage') && MODULE.getModule('tyshIndexPage').refresh();
                                if(isSwitch){APP.page.changePage('main/index')};
							}, true, "auto");
						}, function(data) {
							APP.ui.ui('default.tip', {
								content: data.TSR_MSG,
								callback: function() {
									APP.page.changePage('common/login', {
										loginType: 'mobile'
									});
								}
							});
						}, true, "auto");
					}

				} catch (e) {}

			}
		},
		/**
		 * 处理流量通知栏相关
		 * @param {Object} actionType 'open'[/'close'] 默认'open'
		 */
		handleFlowNoti: function(actionType) {
			return; //关闭安卓流量提示框 杨飞宇2018 0629
			actionType = actionType ? actionType : 'open';
			if (actionType == 'open') {

				navigator.flowNotificationWidget && navigator.flowNotificationWidget.changepage2over(function(arg) {}, function(arg) {}, {}); //更新mainActivity 为可跳转直达页面状态
				navigator.flowNotificationWidget && navigator.flowNotificationWidget.openFlowNoti(function(arg) {}, function(arg) {}, {
					phoneNum: APP.main.getData('loginNumber'),
					areaCode: APP.main.getData('cityCode'),
					ztVersion: APP.config.app.version,
					token: APP.main.getData('token')
				});
			} else {
				navigator.flowNotificationWidget && navigator.flowNotificationWidget.closeFlowNoti(function(arg) {}, function(arg) {}, {});
			}
		},
		initFlowWidget: function() {
			try { //桌面流量插件处理
				var floatDesktop = APP.underly.util.floatDesktop;
				if (APP.main.getData('loginStatus') != 0 && APP.main.getFamily() == '2') {
					APP.interf.invoke({
						//                        server: "http://221.228.39.215:12000/ZtFlowOrder/jszt",
						url: "/flow/flowDisplay/showFlowDisplay",
						param: APP.tool.param.get().add("phoneNum", APP.main.getData('loginNumber'))
							.add("type", "1").add("platForm", "android").add("version", APP.config.app.version).value(),
						type: 'flow',
						showLoading: false,
						showError: false,
						success: function(result) {
							try {
								var resultConfig = JSON.parse(result.CONFIG),
									interf = APP.interf,
									main = APP.main;
								interf.init();
								resultConfig.param = APP.tool.param.get().add('accNbr', main.getData('loginNumber')).add('family', '2').add('areaCode', main.getData('cityCode')).add('actionCode', 'fy005').value() + interf.commonParam;
								resultConfig.isFromInterface = true;
								floatDesktop.change(resultConfig, function() {}, function() {});
							} catch (ee) {}
						},
						fail: function(result) {},
						error: function(result) {}
					});
				} else {
					floatDesktop.destory();
				}
			} catch (exForWidget) {}
		},
		bbChangePage: function(id, type) { //宽带跳转
			var me = this;
			var param = {
				prodOfferId: id,
				areaCode: me.getData('shopCityCode')
			};
			if (!type) {
				type = '101';
			}
			/*recommendTpye值代表的宽带类型：
			 1.单宽带：101
			 2.宽带+路由器：102
			 3.宽带+itv+路由器：103
			 4.宽带+itv：104
			 5.宽带+天翼套餐：105
			 6.宽带+ifree：106
			 7.宽带+嗨卡：108*/
			var url = 'tyshBroadband/tyshBroadbandDetail';
			if (type == '101' || type == '102' || type == '103' || type == '104') {
				url = 'tyshBroadband/tyshBroadbandDetail';
			} else if (type == '105') {
				url = 'mallBroadbandE9/bdE9Detail';
			} else if (type == '106' || type == '108') {
				url = 'mallBroadbandIfree/tyshBroadbandDetail';
			}
			if (APP.config.app.platform == 'iphone' || APP.config.app.platform == 'android') {
				APP.page.changePage('http://wapjs.189.cn/tysh/pages/' + url + '.html', {
					param: param
				});
			} else {
				APP.page.changePage(url, {
					param: param
				});
			}
		},
		uploadUserInfo: function() { //上报用户信息
			if (typeof device == 'undefined') {
				return;
			}
			var me = this;
			var config = APP.config;
			var str = APP.config._getRandomStr(),
				userId = str == undefined ? "" : str;
			var userPhoneNum = me.getData('loginNumber') == undefined ? "" : me.getData('loginNumber');
			var userImsi = device.imsi == undefined ? "" : device.imsi;
			var userImei = device.meid == undefined ? "" : device.meid;
			var userPushId = config.app.name + "_" + userId == undefined ? "" : config.app.name + "_" + userId;
			var userAreaCode = me.getLocalData('areaCode') == undefined ? "" : me.getLocalData('areaCode');
			var userPhoneSysStr = device.platform == undefined ? "" : device.platform;
			var userPhoneSysType = "";
			if (userPhoneSysStr.toLowerCase() == "android") {
				userPhoneSysType = "1";
			} else if (userPhoneSysStr.toLowerCase() == "iphone") {
				userPhoneSysType = "2";
			} else if (userPhoneSysStr.toLowerCase() == "ipad") {
				userPhoneSysType = "3";
			}
			var userPhoneBrand = device.brand == undefined ? "" : device.brand;
			var userPhoneType = device.name == undefined ? "" : device.name;
			var params = APP.tool.param.get();
			var channelcode = device.channelCode == undefined ? "" : device.channelCode;
			me.updateLocalData('channelCode', channelcode);
			params.add('userId', 'userId').add('userPhoneNum', userPhoneNum).add('userImsi', userImsi).add('userImei', userImei).add('userPushId', userPushId).add('userAreaCode', userAreaCode).add('userPhoneSysType', userPhoneSysType).add('userPhoneBrand', userPhoneBrand).add('userPhoneType', userPhoneType).add('channelCode', channelcode);
			APP.interf.invoke({
				url: '/rest/uploadUserInfo',
				type: 'old',
				actionCode: 'gx001',
				param: params.value(),
				success: function() {
					me.updateLocalData('uploadUserInfo310', 1);
				},
				showLoading: false,
				showError: false
			});
		},
		uploadUseInfoToUms: function() { //上报给西桥//西桥逻辑代码删除20170906

		},
		getRealNameContent: function() { //实名提示文字 //20161219删除，不使用
			var msg = this.getLocalData('realNameContentTip');
			if (msg == null || msg == '') {
				msg = '<p style="text-align:left">根据相关法律法规和监管要求，所有未实名登记或身份信息不全的用户必须进行补登记。您目前还不是实名用户，请于2016年12月31日前携带本机号码（手机用户请携带uim卡）、有效身份证件原件到号码归属地的中国电信指定营业厅办理补登记手续 。逾期未补登的，将依据法律法规及相关主管部门要求对号码进行停机处理，详询10000号！</p>';
				this.updateLocalData('realNameContentTip', msg);
			}
			return msg;
		},
		// 唤起天翼云盘
		// 掌厅记录下面信息
		// 手机号，区号，登录类型（手机（服务密码、免密、短信、微信））
		openTyCloud: function(opt) {
			var me = this;
			var loginStatus = me.getData('loginStatus');
			if (loginStatus == '0') {
				// 未登录
				opt.fail && opt.fail({
					message: '未登录'
				});
				APP.page.changePage('common/login');
			} else {
				var loginNumber = me.getData('loginNumber');
				var areaCode = me.getLocalData('areaCode');
				var loginType = me.getData('loginType');
				var loginHistory = me.getLocalData('loginHistory');
				if (opt.loginNumber) {
					mobile = opt.loginNumber;
				}
				if (opt.areaCode) {
					areaCode = opt.areaCode;
				}
				if (opt.loginType) {
					loginType = opt.loginType;
				}
				if (loginHistory && loginHistory.mobile) {
					for (var i = 0, len = loginHistory.mobile.length; i < len; i++) {
						if (loginNumber == loginHistory.mobile[i].account) {
							loginType = loginHistory.mobile[i].type;
						}
					}
				}
				var PathCode = 'otherlogin-00014';
				var params = APP.tool.param.get();
				params.add('loginNun', loginNumber);
				params.add('account', loginNumber + '@189.cn');
				params.add('areaCode', areaCode);
				params.add('loginType', loginType);
				var paramsV = params.value();

				function successFun(result) {
					if (result.accessToken) {
						function logFun(res, type) {
							var msg = 'navigator.TyCloudDiskPlugin.openCloudDisk回调error，出参：';
							if (type == 'success') {
								msg = 'navigator.TyCloudDiskPlugin.openCloudDisk回调success，出参：';
							}
							// console.log(msg + JSON.stringify(res));
						}
						var nvOpt = {
							para: JSON.stringify(result),
							success: function(res) {
								logFun(res, 'success');
							},
							error: function(res) {
								logFun(res, 'error');
							}
						};
						if (opt.success) {
							nvOpt.success = function(res) {
								logFun(res, 'success');
								opt.success(res);
							};
						}
						if (opt.fail) {
							nvOpt.error = function(res) {
								logFun(res, 'error');
								opt.fail(res);
							};
						}
						navigator.TyCloudDiskPlugin && navigator.TyCloudDiskPlugin.openCloudDisk(nvOpt);
					} else {
						failFun(result, '1');
					}
				}

				function failFun(result, type) {
					var message = '/otherlogin/noPswdloginByYunPan调用fail';
					// var msg = '/otherlogin/noPswdloginByYunPan调用fail，出参：';
					if (type && type == '1') {
						message = '/otherlogin/noPswdloginByYunPan出参无accessToken';
						msg = '/otherlogin/noPswdloginByYunPan出参无accessToken';
					}
					if (opt.fail) {
						opt.fail({
							message: message,
							result: result
						});
					} else {
						// console.log(msg + JSON.stringify(result));
					}
				}

				function errorFun(result) {
					if (opt.error) {
						opt.error({
							message: '/otherlogin/noPswdloginByYunPan调用error',
							result: result
						});
					} else {
						// var msg = '/otherlogin/noPswdloginByYunPan调用error，出参：';
						// console.log(msg + JSON.stringify(result));
					}
				}
				var invokeOpt = {
					url: '/otherlogin/noPswdloginByYunPan',
					type: 'ztlogin',
					pathCode: PathCode,
					param: paramsV,
					showLoading: false,
					showError: false,
					success: function(result) {
						successFun(result);
					},
					fail: function(result) {
						failFun(result);
					},
					error: function(result) {
						errorFun(result);
					}
				};
				if (opt.server) {
					invokeOpt.server = opt.server;
				}
				APP.interf.invoke(invokeOpt);
			}
		},
		// 客户端支持沉默用户打开记录
		operateRecordJpush: function(opt) {
			var me = this;
			var registrationId = '';
			var deviceNbr = '';
			// 0 打开app时调的
			// 1 登录进来的
			var type = opt.type;
			if (device && device.uuid) {
				deviceNbr = device.uuid;
				navigator.jpush.getRegistrationID(function(arg) {
					registrationId = arg;
					var params = APP.tool.param.get();
					var PathCode = 'new-0010';
					params.add('PathCode', PathCode);
					params.add('registrationId', registrationId);
					params.add('deviceNbr', deviceNbr);
					params.add('type', type);
					var paramsV = params.value();
					var invokeOpt = {
						url: '/newQuery/userRecord',
						type: 'ztservice',
						pathCode: PathCode,
						param: paramsV,
						showLoading: false,
						showError: false,
						success: function(result) {
							opt.callback({
								TSR_RESULT: 0,
								TSR_MSG: '接口/newQuery/userRecord success回调' + JSON.stringify(result)
							});
						},
						fail: function(result) {
							opt.callback({
								TSR_RESULT: 3,
								TSR_MSG: '接口/newQuery/userRecord fail回调' + JSON.stringify(result)
							});
						},
						error: function(result) {
							opt.callback({
								TSR_RESULT: 4,
								TSR_MSG: '接口/newQuery/userRecord error回调' + JSON.stringify(result)
							});
						}
					};
					if (opt.server) {
						invokeOpt.server = opt.server;
					}
					APP.interf.invoke(invokeOpt);
				}, function(arg) {
					opt.callback({
						TSR_RESULT: 2,
						TSR_MSG: 'navigator.jpush.getRegistrationID失败回调' + JSON.stringify(arg)
					});
				});
			} else {
				APP.tools.log.log('device.uuid失败回调');
				APP.tools.log.log(JSON.stringify(device));
				opt.callback({
					TSR_RESULT: 1,
					TSR_MSG: 'device.uuid失败回调,device=' + JSON.stringify(device)
				});
			}
		},
		// 水滴图使用配置工具 20190712 gcf
		getFormParameterFun: function(module, common) {
			//引流到宽带分会场 by cj 1126 无需接口 start
			var params = APP.tool.param.get();
			var PathCode = 'config-00013';
			params.add('PathCode', PathCode);
			APP.interf.invoke({
				// server:'http://221.228.47.27:10080/zt-config',
				url: '/config/getFormParameter',
				pathCode: PathCode,
				type: 'ztconfig',
				param: params.value(),
				showLoading: true,
				showError: false,
				success: function(data) {
					var b = data.body[0];
					if (b && b.startTime && b.endTime) {
						var nowD = new Date().getTime();

						function handleDate(dateS) {
							dateS = dateS.replaceAll(/-/g, "/");
							if (dateS.indexOf('.') > -1) {
								dateS = dateS.split('.')[0];
							}
							return dateS;
						}
						var sT = new Date(handleDate(b.startTime)).getTime();
						var eT = new Date(handleDate(b.endTime)).getTime();
						if (nowD >= sT && nowD <= eT) {
							// 有效期内
							if (APP.main.getData("loginStatus") != 0) {
								// 登录状态，根据配置地市展示
								var areaCode = APP.main.getData('cityCode');
								if (b.areaCode && b.areaCode.indexOf(areaCode) > -1) {
									ylkd(data.body[0]);
								}
							} else {
								// 未登录状态，只展示全省的
								// 025,0510,0511,0512,0513,0514,0515,0516,0517,0518,0519,0523,0527,
								if (b.areaCode) {
									var cA = b.areaCode;
									var is025 = cA.indexOf('025') > -1;
									var is0510 = cA.indexOf('0510') > -1;
									var is0511 = cA.indexOf('0511') > -1;
									var is0512 = cA.indexOf('0512') > -1;
									var is0513 = cA.indexOf('0513') > -1;
									var is0514 = cA.indexOf('0514') > -1;
									var is0515 = cA.indexOf('0515') > -1;
									var is0516 = cA.indexOf('0516') > -1;
									var is0517 = cA.indexOf('0517') > -1;
									var is0518 = cA.indexOf('0518') > -1;
									var is0519 = cA.indexOf('0519') > -1;
									var is0523 = cA.indexOf('0523') > -1;
									var is0527 = cA.indexOf('0527') > -1;
									var isAll = is025 && is0510 && is0511 && is0512 && is0513 && is0514 && is0515 && is0516 && is0517 && is0518 && is0519 && is0523 && is0527;
									if (isAll) {
										ylkd(data.body[0]);
									}
								}
							}
						}
					}
				},
				fail: function(data) {
					// 
				},
				error: function(data) {
					// 
				}
			});

			function ylkd(configData) {
				common.page.find('div[domId=ylkdDiv]').remove();
				// var strBuilder = APP.tool.stringBuilder.get();
				var domJQ = APP.tool.dom.create();
				domJQ.append('<div domId="ylkdDiv" style="z-index: 0 !important;position: absolute !important;">');
				domJQ.append('<div  class="o3 k8 m1 " style="right:30%;bottom:46px;z-index:99">');
				domJQ.append('<img src="' + configData.imgUrl + '?name=' + Math.random() + '" class="k15 wobble">');
				domJQ.append('</div>').append('</div>').end(null);
				domJQ.getDom().insertAfter($("#tyshIndexPage div[data-role=content]"));
				var ylkdDiv = common.page.find('div[domId=ylkdDiv]');
				APP.main.onClick(ylkdDiv, function(target) {
					// 插码
					try {
						var trkObj = {
							"eVar12": "首页-水滴广告-" + configData.title
						};
						if (typeof insertCodeNew != 'undefined') {
							try {
								insertCodeNew(trkObj);
							} catch (e) {}
						}
					} catch (e) {}
					configData.url && APP.main.executeJsCode(configData.url);
				});
			}
			//引流到宽带分会场 by cj 1126 无需接口 end
		},
		// ztmall.go189.cn 取消域名映射 20190822 gcf
		getFixUrl: function(url) {
			url = url.replaceAll('221.228.39.58:10000/tysh', 'wapjs.189.cn/tysh');
			url = url.replaceAll('221.228.39.58:10000/three', 'wapjs.189.cn/three');
			url = url.replaceAll('221.228.39.58:10000/ztthree', 'wapjs.189.cn/ztthree');
			url = url.replaceAll('221.228.39.33', 'wapjs.189.cn');
			url = url.replaceAll('61.160.137.140:8082', 'wapjs.189.cn');
			url = url.replaceAll('221.228.39.227', 'wapjs.189.cn');
			url = url.replaceAll('221.228.39.34', 'wapjs.189.cn');
			url = url.replaceAll('61.160.137.141', 'wapjs.189.cn');
			url = url.replaceAll('221.228.39.58', 'wapjs.189.cn');
			url = url.replaceAll('61.160.137.140', 'wapjs.189.cn');
			url = url.replaceAll('202.102.111.142', 'wapjs.189.cn');
			url = url.replaceAll('202.102.111.141', 'wapjs.189.cn');
			url = url.replaceAll('202.102.116.186', 'wapjs.189.cn');
			url = url.replaceAll('61.160.137.68', 'wapjs.189.cn');
			// 20190822 ztmall.go189.cn 取消域名映射
			url = url.replaceAll('ztmall.go189.cn', 'wapjs.189.cn');
			return url;
		},
        loginOffline:function(opt) {
            var me = APP.main;
            var app = APP.config.app;
            var tools = APP.tool;
            var paramInit = tools.param.get();
            var PathCode = 'login-00005';

            paramInit.add('PathCode', PathCode);
            paramInit.add('areaCode', me.getData('cityCode'));
            paramInit.add('ztInterSource', app.ztInterSource);
            paramInit.add('uucToken', me.getData('token'));
            paramInit.add('appVersion', app.version);
            APP.interf.invoke({
                url: '/login/offline',
                param: paramInit.value(),
                pathCode: PathCode,
                type: 'ztlogin',
                success: function (data) {
                    opt.success && opt.success();
                },
                fail: function (data) {
                    opt.fail && opt.fail(data);
                },
                error: function (data) {
                    opt.error && opt.error(data);
                }
            });
        }
	};

	var globalApp = new MAIN();

	module.exports = globalApp;
});