/**
 * 方法功能定义 export APP_METHODS
 */
;APPBASE.define('module',function(require, exports, module){
	var tools = require('tool');

	//方法对象
	var MODULES = function(){
		this.pageshows = {}; //pageshow 方法
		this.methods = {}; //普通方法
		this.modules = {};  //模块
		this.rewriteMethods = {};  //重写方法
		this.interfaceMethods = {}; //接口方法
	};

	//方法定义
	MODULES.prototype = {
		init:function(){
			$.mobile.page.prototype.options.domCache = true;
	        $.mobile.defaultPageTransition = "none";
	        $.mobile.allowCrossDomainPages = true;
	        $.mobile.linkBindingEnabled = false;
	        $.mobile.keepNative = 'select, input, textarea';
		},
		registerPageShow:function(id,pageshow,force){//注册pageshow
			if(force){
				this.pageshows[id] = pageshow;
			}
			if(tools.validate.isNotNull(id,pageshow)){
				this.pageshows[id] = pageshow;
			}
		},
		getPageShow:function(id){
			return this.pageshows[id];
		},
		addModule:function(module){
			var validate = tools.validate;
			if(validate.isNotNull(module)){
				var moduleId = module.id;
				if(validate.isNull(moduleId)){
					// console.log('模块添加失败,未设置模块id!');
				}
				var moduleOld = this.modules[moduleId];
				if(validate.isNotNull(moduleOld)){
					return;
				}
				var rewriteModule = this.rewriteMethod[moduleId];
				for(var key in rewriteModule){
					module[key] = rewriteModule[key];
				}
				this.modules[moduleId] = module;
                if(moduleId.indexOf("_video")>=0){
                    if(this.videomodules){
                        this.videomodules.push(moduleId);
                    }else{
                        this.videomodules=[];
                        this.videomodules.push(moduleId);
                    }

                }
				var pageshow = module.pageshow;
				if(validate.isNotNull(pageshow)){
					this.registerPageShow(moduleId,pageshow);
					//jquery mobile
					$(document).on("pageshow",'#' + moduleId,function(e,ui){
						MAIN.pageshow(e,{toPage:$(e.currentTarget)});
					});
					if(validate.isNotNull(module.pagecreate)){
						$(document).on("pagecreate",'#' + moduleId,function(e,ui){
							MAIN.pagecreate(e,{toPage:$(e.currentTarget)});
							
						});
					}else{
						$(document).on("pagecreate",'#' + moduleId,function(e,ui){
							MAIN.commonPagecreate(e,{toPage:$(e.currentTarget)});
						});
					}
				}
				var log = tools.log;
				log.log('模块添加成功,id[' + moduleId + ']');
				return this.modules[moduleId];
			}
			else{
				return {init:function(){}};
			}
		},
		getModule:function(moduleId){
			return this.modules[moduleId];
		},
		rewriteMethod:function(moduleId,methodName,newFunc){//覆盖方法
			if(this.rewriteMethod[moduleId] == null || this.rewriteMethod[moduleId] == ''){
				this.rewriteMethod[moduleId] = {};
			}
			this.rewriteMethod[moduleId][methodName] = newFunc;
			if(this.getModule(moduleId)){
				var module = this.getModule(moduleId);
				module[methodName] = newFunc;
				if(methodName == 'pageshow'){
					this.registerPageShow(moduleId,module.pageshow,true);
				}
			}
		},
		unRegisterMethod:function(method){//卸载方法

		},
		invoke:function(key){//调用

		},
		_getFuncName:function(func){
			var funcName = String(func) ;
       		return funcName.replace(/^function(\s|\n)+(.+)\((.|\n)+$/,'$2');
		},
		_getKey:function(key){
			return key.replace(/[_]/g,'');
		}
	};

	var modules = new MODULES();
	modules.init();
	module.exports = modules;
});