/**
 * @author Grahor
 * 应用页面对象定义
 */
;
APPBASE.define('page', function(require, exports, module) {

	var PAGES_LOCAL_DATA = "PAGES_LOCAL_DATA"; //页面存储对象键

	var tools = require('tool');
	var main = require('main');
	var config = require('config');

	//页面对象
	var PAGES = function() {
		this.contextPath = '../'; //'file:///C:/Users/lenvov/Desktop/jqm/jqm/pages/';   //页面环境路径
		this.pageContainer = 'loadBodyPage'; //页面容器id
		this.pages = { //页面地址信息对象
			main: {}
		}; //页面配置
		this.excludePages = {
			'mallNewNumInPage': true, //靓号提交
			'broadbandSelects': true, //号码选择
			'mallBroadbandIfreeConfirm': true,
			'flowflowDetail': true, //流量详情
			'packagepackageUsedInfo': true, //清单查询
			'bhRechargercBankIndex': true, //充值首页
			'businessHallpackageTheRemaining': true, //套餐使用情况       
			'bhBusinessbusinessLobby': true, //业务大厅页面
			'businessHallindex': true, //营业厅
			'bhBusinessbusinessDetail': true, //业务大厅订购详情页面
			// 'mineDatamineDataMyInfo':true, //密码修改
			'minechangePassowrdverify': true, //密码修改页面
			'mallindex': true, //探索首页
			'bhBusinessywMyBusiness': true, //我的业务
			'bhFlowindex': true, //流量首页
			'mineuser_Product_List': true //个人中心
		}; //跳转页面跳远程定义
		this.suffix = '.html'; //页面后缀
		this.defaultTransition = 'slide'; //页面跳转默认过渡
	};

	PAGES.prototype = {
		init: function(option) { //页面模块初始化
			var localData = tools.localData;
			var validate = tools.validate;
			if (validate.isNotNull(localData.get(PAGES_LOCAL_DATA))) {
				this.pages = JSON.parse(localData.get(PAGES_LOCAL_DATA));
				//tools.log.log('页面模块地址信息记录**************' + localData.get(PAGES_LOCAL_DATA));
			} else {
				if (validate.isNotNull(option.pages)) {
					this.addPages(option.pages);
				}
			}
			if (validate.isNotNull(option)) {
				if (validate.isNotNull(option.contextPath)) {
					this.contextPath = option.contextPath;
				}
				if (validate.isNotNull(option.pageContainer)) {
					this.pageContainer = option.pageContainer;
				}
				if (validate.isNotNull(option.suffix)) {
					this.suffix = option.suffix;
				}
				if (validate.isNotNull(option.defaultTransition)) {
					this.defaultTransition = option.defaultTransition;
				}
			}
			var href = window.location.href;
			var index = href.indexOf('pages/');
			var lastIndex = href.indexOf('.html');
			var url = href.substring(index + 6, lastIndex);
			this.prevPageUrl = url;
			if (url.indexOf('/load') >= 0) {
				return;
			}
			main.updateData('loginedUrl', this.prevPageUrl);
		},
		addPage: function(page, batch) { //添加页面对象
			if (typeof page == 'object') {
				//alert(JSON.stringify(this.pages));
				var path = page.path;
				var replacePath = page.replacePath;
				var transition = path.transition;
				var cache = path.cache;
				var page;
				if (path.indexOf('http://') >= 0 || path.indexOf('https://') >= 0) { //远程页面地址，则不进行记录
					var page = {
						path: path
					};
					if (transition && $.trim(transition) != '') {
						page['transition'] = transition;
					} else {
						page['transition'] = this.defaultTransition;
					}
					if (cache == null || cache == undefined) {
						cache = true;
					}
					page['cache'] = cache;
					return page;
				}
				if (replacePath != null && $.trim(replacePath) != '') {
					page = this.getPage(path);
					page['path'] = replacePath;
				} else {
					page = this.getPage(path);
					page['path'] = path;
				}
				if (transition && $.trim(transition) != '') {
					page['transition'] = transition;
				} else {
					page['transition'] = this.defaultTransition;
				}
				if (cache == null || cache == undefined) {
					cache = true;
				}
				page['cache'] = cache;
				if (!batch) {
					tools.localData.put(PAGES_LOCAL_DATA, this.pages);
				}
				return page;
			}
			return null;
		},
		addPages: function(pages) { //批量添加页面对象
			var addPageInner = this.addPage;
			var validate = tools.validate;
			if (validate.isArray(pages)) {
				var len = pages.length;
				for (var i = 0; i < len; i++) {
					addPageInner(pages[i], true);
				}
				tools.localData.put(PAGES_LOCAL_DATA, this.pages);
			}
		},
		removePage: function(page) { //移除页面

		},
		getPage: function(path, fromChange) { //获取页面对象信息
			var pageObj = this.pages;
			if (path.indexOf('/') >= 0) {
				var paths = path.split('/');
				for (var i = 0; i < paths.length; i++) {

					if (!pageObj[paths[i]] && !fromChange) {
						pageObj[paths[i]] = {};
					}
					pageObj = pageObj[paths[i]];
				}
				return pageObj;
			} else {
				if (!pageObj[path] && !fromChange) {
					pageObj[path] = {};
				}
				return pageObj[path];
			}
		},
		getPagePath: function(url, option) { //获取页面跳转信息
			var page = this.getPage(url);
			var validate = APP.tool.validate;
			if (validate.isNull(page) || !validate.hasProperties(page)) {
				if (validate.isNotNull(option) && validate.isNotNull(option.transition)) {
					page = this.addPage({
						path: url,
						transition: option.transition
					});
				} else {
					page = this.addPage({
						path: url
					});
				}
			}
			var path = page.path;
			if (path.indexOf('http://') >= 0 || path.indexOf('https://') >= 0) {
				if (path.lastIndexOf('.html') == -1) {
					page['url'] = path + this.suffix;
				} else {
					page['url'] = path;
				}
			} else {
				page['url'] = this.contextPath + path + this.suffix;
			}
			return page;
		},

		changePage: function(url, option) {
			if (url.indexOf('url=') == 0) {
				url = url.split('url=')[1];
			}
			var _a = 'https://';
			window.randomP = window.randomP || parseInt(1000000 * Math.random());
			if (!window.tyshServerAndroid313Loaded) {
				var random = 100000 * Math.random();
				if(!!APP.main.getLocalData('simplerAPP') && APP.main.getLocalData('simplerAPP') != 'false'){
                    APP.config.serverJsUrl = handleDomainContent('http://wapjs.189.cn/serverJS/android_simple.js');
                }
				appLoader.addJsFile({
					url: APP.config.serverJsUrl + '?callback=' + random,
					loaded: function() {}
				}, $('head:first'));
				appLoader.addJsFile({
					url: APP.config.wxbindJsUrl + '?callback=' + random,
					loaded: function() {}
				});
			}
			url = APP.main.getFixUrl(url);
			var main = APP.main,
				tools = APP.tool,
				config = APP.config,
				href = main.getLocationHref();
			if (href.indexOf("#%20") > -1) {
				href = href.replace("#%20", "#");
			}
			if (href.indexOf('#') >= 0 && (href.indexOf('http://', href.indexOf('#')) >= 0 || href.indexOf(_a, href.indexOf('#')) >= 0)) {
				var prefix = href.split('#')[1],
					subPrefix = '';
				if (url.indexOf('/') >= 0) {
					subPrefix = url.split('/')[0];
				}
				//一致性页面，长时间未登录，弹框点击回到main/index
				if (prefix.indexOf('businessHall/packageTheRemaining') < 0) {
					if (subPrefix != '' && prefix.indexOf(subPrefix) >= 0) {
						prefix = prefix.substring(0, prefix.indexOf(subPrefix));
						url = prefix + url + (url.indexOf('.html') >= 0 ? '' : '.html');
						main.fromWAPPage = true;
					}
				}
			}
			var page = this.getPagePath(url),
				validate = tools.validate;
			if (validate.isNull(page)) {
				APP.ui.ui('default.alert', {
					content: '页面地址异常！'
				});
				return;
			}
			if (validate.isNull(option)) {
				option = {};
			}
			var transition = option.transition;
			if (validate.isNull(transition)) {
				transition = 'slide';
			}
			if (option.noRefresh == null) {
				main.noRefresh = false;
			} else {
				main.noRefresh = option.noRefresh;
			}
			main.param = option.param;
			if (href.indexOf(url) >= 0) {
				if (config.platform == 'WAP') {
					var newUrl = href.indexOf('#') >= 0 ? href.split('#')[0] : href;
					window.history.replaceState("", "", newUrl);
					$(window).trigger("hashchange", null, {
						newUrl: newUrl,
						oldUrl: ""
					});
					return;
				}
			}
			this.prevPageUrl = url;
			if (url.indexOf('common/idUpload') >= 0) {
				page.url = 'http://wapjs.189.cn/tysh/pages/' + url + '.html';
			}
			if (APP.page.excludePages && APP.page.excludePages[url.replace(/\//g, '')]) {
				page.url = 'http://wapjs.189.cn/three/pages/' + url + '.html';
			}
			if (url.indexOf('http://') == -1 && url.indexOf(_a) == -1 && (url.match('common/payBank') || url.match('common/packagepayType') ||
					url.match('plugins/') || url.match('newEPhone/') ||
					url.match('newPrettyNumber/') || url.match('stores/') ||
					url.match('storesMallpackage/'))) { //掌厅五期新卖场
				page.url = 'http://wapjs.189.cn/market/' + url + '.html';
			}
			//个人中心修改
			if (url.indexOf('http://') == -1 && url.indexOf(_a) == -1 && (url.match('six_settings/') || url.match('six_userCenter') ||
					url.match('six_serviceHall/six_')) && !url.match('six_serviceHall/six_serviceHallIndex')) {
				page.url = 'http://wapjs.189.cn/personal/' + url + '.html';
			}
			//积分商城入口修改
			if (url.indexOf('mine/integralArea') >= 0) {
				page.url = 'http://wapjs.189.cn/three/pages/jfscNew/jfscMain.html';
			}

			//简化版首页
            if ((!!APP.main.getLocalData('simplerAPP') && APP.main.getLocalData('simplerAPP') != 'false')) {
                if(url.indexOf('main/index') >= 0){
                	page.url = page.url.replace('main/index','main/simpleIndex');
                }
                if(url.indexOf('six_userCent/userCenterIndexS') >= 0){
                	page.url = page.url.replace('six_userCent/userCenterIndexS','six_userCent/simpleUserCenter');
                }
                
            }
			if (page.url.indexOf('http://') >= 0 || page.url.indexOf(_a) >= 0) {
				if (window.location.href.indexOf(url.replace('../', '')) == -1) { //防止探索页面转圈的 lxc
					APP.ui.ui('default.loading');
				}
			}

			//静态资源迁移千万级环境
			//静态资源迁移千万级环境
			if (page.url.indexOf('221.228.39.58:10000') > -1) {
				page.url = page.url.replace('221.228.39.58:10000', 'wapjs.189.cn');
			} else if (page.url.indexOf('app3.api.go189.cn:10000') > -1) {
				page.url = page.url.replace('app3.api.go189.cn:10000', 'wapjs.189.cn');
			} else if (page.url.indexOf('app3.api.go189.cn') > -1) {
				page.url = page.url.replace('app3.api.go189.cn', 'wapjs.189.cn');
			} else if (page.url.indexOf('221.228.39.58') > -1) {
				page.url = page.url.replace('221.228.39.58', 'wapjs.189.cn');
			} else if (page.url.indexOf('ztmall.go189.cn') > -1) {
				page.url = page.url.replace('ztmall.go189.cn', 'wapjs.189.cn');
			}
			page.url = handleDomainContent(page.url);
			if (config.platform == 'WAP') {
				$.mobile.changePage(page.url + (page.url.indexOf('?') >= 0 ? '&' : '?') + 'ztInterSource=' + config.app.ztInterSource + '&platform=wap&callback=' + tools.util.getRandomString());
			} else {
				var exceptionLists = exceptionLists ? exceptionLists : ["jfscNew/jfscMain", "businessHall/packageTheRemaining", "bhInquiry/billQueryIndex", "mine/feeAndTrafficInformation",
					"bhFlow/", "familyGroup2/index", "bhBusiness", "package/packageUsedInfo", "bhRechangeChenDetail/index", "six_userCenter/sfamilyIndex",
					"bhBusiness/internationalBusinessList", "familyCloud/coloringRing"
				];
				if (!window.vvid) { //网周插码记录 vid
					try {
						navigator.InsertCode.getIdentify(function(arg) {
							window.vvid = arg;
							/*weixin登录屏蔽需鉴权网页入口，都跳入绑定start*/
							var curLoginType = APP.main.getData("loginType")
							if (config.platform == 'APP' && curLoginType == "weixin") {

								var isBind = false;
								for (var i = 0; i < exceptionLists.length; i++) {
									if (page.url.indexOf(exceptionLists[i]) != -1) {
										isBind = true;
										$.mobile.changePage("http://wapjs.189.cn/mall/pages/common/wxbindAccount.html?vid=" + window.vvid);
										break;
									}
								}
								if (isBind) return;
							}

							
							/*weixin登录屏蔽需鉴权网页入口，都跳入绑定end*/

							try{
								if(page.url.indexOf("http") === 0){
									if(navigator.network.connection.type === 'none'){
										APP.ui.ui('default.alert', {
											content: '网络连接失败，请检查网络设置',
											callback: function () {}
										});
										hideLoginWaitCurr();
										return;
									}    
								} 
							}catch(e){}
							
							if (page.url.match("http://") || page.url.match(_a)) {
								$.mobile.changePage(page.url + (page.url.indexOf('?') >= 0 ? '&' : '?') + "callback=" + window.randomP + "&vid=" + window.vvid);
							} else {
								if (page.url.match('main/index') || page.url.match('main/simpleIndex')) {
									$.mobile.changePage(page.url);
								} else {
									$.mobile.changePage(page.url + "?vid=" + window.vvid);
								}
							}
						}, function(arg) {
						});
					} catch (e) {}
				} else {
					/*weixin登录屏蔽需鉴权网页入口，都跳入绑定start*/
					var curLoginType = APP.main.getData("loginType")
					if (config.platform == 'APP' && curLoginType == "weixin") {
						var isBind = false;
						for (var i = 0; i < exceptionLists.length; i++) {
							if (page.url.indexOf(exceptionLists[i]) != -1) {
								isBind = true;
								$.mobile.changePage("http://wapjs.189.cn/mall/pages/common/wxbindAccount.html?vid=" + window.vvid);
								break;
							}
						}
						if (isBind) return;
					}

					/*weixin登录屏蔽需鉴权网页入口，都跳入绑定end*/
					try{
						if(page.url.indexOf("http") === 0){
							if(navigator.network.connection.type === 'none'){
								APP.ui.ui('default.alert', {
									content: '网络连接失败，请检查网络设置',
									callback: function () {}
								});
								hideLoginWaitCurr();
								return;
							}    
						} 
					}catch(e){}

					if (page.url.match("http://") || page.url.match(_a)) {
						$.mobile.changePage(page.url + (page.url.indexOf('?') >= 0 ? '&' : '?') + "callback=" + window.randomP + "&vid=" + window.vvid);
					} else {
						if (page.url.match('main/index') || page.url.match('main/simpleIndex')) {
							$.mobile.changePage(page.url);
						} else {
							$.mobile.changePage(page.url + "?vid=" + window.vvid);
						}
					}
				}
			}
		}
	};

	var pagesTool = new PAGES();

	module.exports = pagesTool;
});