/**
 * 第三方应用封装
 * @author Grahor
 */
;APPBASE.define('thirdParty',function(require, exports, module){
    var tool = require('tool');
    var config = require('config');
    var interf = require('interface');
    var underly = require('underly');
    var moduleTool = require('module');
    var page = require('page');

    /**
     * 第三方应用
     */
    var THIRDPARTY = function () {
        this.contextPath = null;
        this.payOrder = null;
        this.payTypeInfo = {};
        this.payGeneratorSucc = false; //生成支付链接是否成功
        this.paySuccess = false; //是否支付成功
        this.browserWindow = null; //浏览器窗口
    };

	THIRDPARTY.prototype = {
		init:function(){
            var that = this;
            if (config.platform == 'APP') {
                this.contextPath = '../';
            } else {
                this.contextPath = '../';
            }
			this.payTypes = {
				common:[
				    {name:'微信支付',id:'weixin',icon:'../../resources/images/pay/03.png',desc:'支持微信5.0及以上版本使用',point:'',bankType:'weixin',enable:true},
					{name:'支付宝',id:'zfb',icon:'../../resources/images/pay/02.png',desc:'推荐支付宝用户使用',point:'',bankType:'zfb',enable:true},
				    {name:'银行卡支付',id:'bank',icon:'../../resources/images/pay/04.png',desc:'支持银行卡快捷支付',point:'',bankType:'bank',enable:true},
					{name:'翼支付',id:'yzf',icon:'../../resources/images/pay/01.png',desc:'翼支付账户专享',point:'',bankType:'yzf',enable:true}
				],
				common5:[
				    {name:'微信支付',id:'weixin',icon:'../../resources/images/pay/03.png',desc:'支持微信5.0及以上版本使用',point:'',bankType:'weixin5',enable:true},
					{name:'支付宝',id:'zfb',icon:'../../resources/images/pay/02.png',desc:'推荐支付宝用户使用',point:'',bankType:'zfb',enable:true},
				    {name:'银行卡支付',id:'bank',icon:'../../resources/images/pay/04.png',desc:'支持银行卡快捷支付',point:'',bankType:'bank',enable:true},
					{name:'翼支付',id:'yzf',icon:'../../resources/images/pay/01.png',desc:'翼支付账户专享',point:'',bankType:'yzf',enable:true}
				],
				banks:[
					{name:'中国建设银行',id:'ccb',icon:'../../resources/images/pay/jianhang.png',desc:'推荐使用，支付快捷',point:'',bankType:'ccb',enable:true},
					{name:'中国工商银行',id:'icbc',icon:'../../resources/images/pay/gonghang.png',desc:'推荐使用，支付快捷',point:'',bankType:'zfb',enable:true},
					{name:'中国招商银行',id:'zcb',icon:'../../resources/images/pay/zhaoshang.png',desc:'推荐使用，支付快捷',point:'',bankType:'zfb',enable:true},
					{name:'中国银行',id:'zb',icon:'../../resources/images/pay/zhonghang.png',desc:'推荐使用，支付快捷',point:'',bankType:'zfb',enable:false},
					{name:'中国邮政',id:'yz',icon:'../../resources/images/pay/youzheng.png',desc:'推荐使用，支付快捷',point:'',bankType:'zfb',enable:false},
					{name:'中国农业银行',id:'abc',icon:'../../resources/images/pay/nonghang.png',desc:'推荐使用，支付快捷',point:'',bankType:'zfb',enable:false}
				],
				remainFee:[
				  {name:'话费余额',id:'remainFee',icon:'../../resources/images/pay/01.png',desc:'',point:'',bankType:'remainFee',enable:true},
				]
			}
            this.payTypeInfo['recharge'] = {//充值类
                url: '/rest/epaygetString',
                actionCode: 'zf001',
                type: 'old',
                bank: {
                    zfb: 'ALIPAY',
                    yzf: 'EPAYACC',
                    ccb: 'CCB',
                    def: '104'
                },
                params: function (order) {//生成参数
                    var param = APP.tool.param.get();
                    var json = order;
                    var userPhoneNum = APP.main.getData('loginNumber');
                    param.add('accNbr',json.areaCode + json.accNbr);
                    param.add('userPhoneNum',userPhoneNum);
                    param.add('orderType',11);
                    param.add('ordeRseq',"");
                    param.add('fee',json.payAmount + '00');
                    param.add('merchantUrl','http://61.160.137.141/backPay.action');
                    param.add('returnUrl','http://202.102.111.142:80/serverBackPay.action');
                    param.add('fundsType',json.mergetPay);
                    param.add('productType',json.productType);
                    param.add('areaCode',json.areaCode);
                    param.add('payType',1);
                    param.add('bankid',this.bank[order.bankType]);
                    if(json.orderCode == 'KDXY0110'){
                        param.add('orderCode',json.orderCode);
                        param.add('orderId',json.orderId);
                    }
                    return param.value();
                },
                generationPayStr: function (data) {//支付链接生成成功回调
                    that.payGeneratorSucc = true;
                    var epaygetString = "http://202.102.116.186:7001/NetPay/ePayAction.do?RequestValue=" + data.encyPayCode;
                    if (config.platform == 'WAP') {
                        that.browserWindow.location = epaygetString;
                        return;
                    } else {
                        underly.openBrowser(epaygetString, '在线支付', function (arg) {
                        }, function () {
                        });
                    }
                }
            };
			this.payTypeInfo['oldMall'] = {//商城（旧）
				url:'/stores/prettynumpay',
				actionCode:'lh005',
				type:'old',
				bank:{
					zfb:'104',
					yzf:'101',
					ccb:'103',
					def:'104'
				},
				params:function(order){//生成参数
					var param = tool.param.get();
                    var json = order;
                    param.add('orderNumber',json.orderNumber);
                    param.add('payAmount',json.payAmount);
                    param.add('showUrl',config.server.NORMAL_OLD+"/storesEpay.action");
                    param.add('areaCode',json.areaCode);
                    param.add('bankid',this.bank[order.bankType]);
                    return param.value();
				},
				generationPayStr:function(data){//支付链接生成成功回调
					var epaygetString = data.payUrl;
     				if(config.platform == 'WAP'){
                        that.browserWindow.location = epaygetString;
                  	  	return;
                    } else{
     					underly.openBrowser(epaygetString,'在线支付',function(arg){},function(){});
     				}
				}
			};
			this.payTypeInfo['mall'] = {//商城（新）
				url:'/mall/orderOf/getOrderOf',
				actionCode:'three_of_001',
				type:'mall',
				bank:{
					zfb:'104',
					yzf:'101',
					ccb:'103',
					def:'104'
				},
				params:function(order){//生成参数
                    var param = tool.param.get();
                    var json = order;
                    param.add('orderNumber',json.orderNumber);
                    param.add('payAmount',json.payAmount);
                    param.add('showUrl',config.server.NORMAL_OLD+"/storesEpayNew.action");
                    param.add('returnUrl','');
                    param.add('areaCode',json.areaCode);
                    param.add('bankId',this.bank[order.bankType]);
                    return param.value();
				},
				generationPayStr:function(data){//支付链接生成成功回调
					var epaygetString = data.root.body.payUrl;
     				if(config.platform == 'WAP'){
     					if(underly.browser().weixin()||
							underly.browser().yixin()||
							underly.browser().qq()||
							underly.browser().uc()){
     						window.location.href=epaygetString;
     						return;
     					}else{
	                        that.browserWindow.location = epaygetString;
	                  	  	return;
     					}
                    } else{
     					underly.openBrowser(epaygetString,'在线支付',function(arg){},function(){});
     				}
				}
			};
			this.payTypeInfo['mall5'] = {//商城（新）五期改版王琳
				url:'/pay/wap',
				actionCode:'mall5pay',
				type:'pay',
				bank:{
					zfb:'104',
					yzf:'101',
					ccb:'103',
					def:'104'
				},
				params:function(order){//生成参数
					var param = tool.param.get();
                    var json = order;
                    param.add('orderId',json.orderNumber);
                    param.add('payAmount',parseInt(json.payAmount * 100)+ '');
                    param.add('returnUrl',config.server.NORMAL_OLD+"/storesEpayNew.action");//写死了，最后确定是那个地址，目前先写死
                    param.add('areaCode',json.areaCode);
                    param.add('bankId',this.bank[order.bankType]);
                    param.add('payType','2');//应该是1或 2 
                    return param.value();
				},
				generationPayStr:function(data){//支付链接生成成功回调
					var epaygetString = data.item.payUrl;
     				if(config.platform == 'WAP'){
     					if(underly.browser().weixin()||
							underly.browser().yixin()||
							underly.browser().qq()||
							underly.browser().uc()){
     						window.location.href=epaygetString;
     						return;
     					}else{
	                        that.browserWindow.location = epaygetString;
	                  	  	return;
     					}
                    } else{
     					underly.openBrowser(epaygetString,'在线支付',function(arg){},function(){});
     				}
				}
			};
			this.payTypeInfo['commonFail'] = function(data){//失败

			};
		},
        loadPayTypeDiv: function (option) {//加载公用支付方式
            var me = this;
            me.payOrder = null;
            var url = this.contextPath + 'common/payType.html';
            var payPageId = 'commonPayType';
            if(option.mall5){
            	url = handleDomainContent('http://wapjs.189.cn/market/common/packagepayType.html');
            	payPageId = 'commonPayType5';
            }
            $.ajax({
                url: url,//'http://180.100.253.199:8080/tysh/pages/common/payType.html',//url:this.contextPath + 'common/payType.html',
                type: 'get',
                dataType: 'html',
                async: true,
                data: {nowT: (new Date()).getTime()},
                beforeSend: function () {
                }
            }).done(function (html) {
                option.parent && option.parent.empty().append(html);
                me.payOrder = option.order;
                moduleTool.getModule(payPageId).init(option.parent, APP, option.exclude);
            }).fail(function (data) {
                me.payOrder = null;
            }).always(function (data) {
            });
        },
        pay: function () {//lxc  支付身份证屏蔽修改
        	var validate = APP.tool.validate,config = APP.config,underly = APP.underly,interf = APP.interf;
    		var me = this;
    		var ui = APP.ui;
    		var order = me.payOrder;
    		if(validate.isNull(order) || validate.isNull(order.type)){
    			return;
    		}
    		var orderInfo = this.payTypeInfo[order.type];
    		if(order.bankType == 'weixin'){
    			me.weixinPay();
    			return;
    		}
    		if(order.bankType == 'weixin5'){//卖场五期新的支付 王琳
				me.weixinPay5();
				return;
			}
    		if(order.payType == 'bank'){
    			APP.page.changePage('common/payBank');
    			return;
    		}
    		ui.show('common.payLoading');
    		setTimeout(function(){
    			interf.invoke({
    				url:orderInfo.url,
    				param:orderInfo.params(order),
    				actionCode:orderInfo.actionCode,
    				type:orderInfo.type,
    				showLoading:false,
    				showDailog:false,
    				before:function(){
    					var changeZtinterSource = APP.main.getData("hideWeiXinYzf");
    					if(changeZtinterSource == "1"){
    						if(APP.config.app.ztInterSource == "android"){
    							APP.config.app.ztInterSource = "200208";
    						}else if(APP.config.app.ztInterSource == "iphone"){
    							APP.config.app.ztInterSource = "200209";
    						}
    					}
    					var jftaskStatus = APP.main.getData('jftaskStatus'); //积分签到做任务的渠道
    				 	if(jftaskStatus){
    				 		APP.config.app.ztInterSource="100007";	    	
    				 	}  
    					if(config.platform == 'WAP'){
    						if(underly.isBrowserCanBlank()){
    							me.browserWindow = window.open('','_blank');
    						}
    						else{
    							me.browserWindow = window;
    						}
    					}
    					else{
    						me.browserWindow = null;
    					}
    				},
    				success:function(data){
    					if(APP.config.app.ztInterSource == "200208"){
    						APP.config.app.ztInterSource = "android";
    					}else if(APP.config.app.ztInterSource == "200209"){
    						APP.config.app.ztInterSource = "iphone";
    					}
    					if(data.item && data.item.requestSeq){
    						me.payOrder.requestSeq = data.item.requestSeq;
    					}
    					APP.config.app.ztInterSource= window.curPlatform;	//恢复渠道
    					ui.hide('common.payLoading');
    					if(me.payOrder.payCallback5 && me.payOrder.payCallback5.success){
    						me.payOrder.payCallback5.success && me.payOrder.payCallback5.success(data);
                        }
    					orderInfo.generationPayStr && orderInfo.generationPayStr(data);
    				},
    				fail:function(data){
    					if(APP.config.app.ztInterSource == "200208"){
    						APP.config.app.ztInterSource = "android";
    					}else if(APP.config.app.ztInterSource == "200209"){
    						APP.config.app.ztInterSource = "iphone";
    					} 
    					APP.config.app.ztInterSource= window.curPlatform;	//恢复渠道
    					ui.hide('common.payLoading');
    					if(data.TSR_RESULT == '151202'){
    						 APP.ui.ui('default.alert',{content:data.TSR_MSG});
    						 return;
    					}
    					if(orderInfo.fail){
    						orderInfo.fail(data);
    					}
    					else{
    						me.payTypeInfo.commonFail && me.payTypeInfo.commonFail(data);
    					}
    					if(me.payOrder.payCallback5 && me.payOrder.payCallback5.fail){
    						me.payOrder.payCallback5.fail && me.payOrder.payCallback5.fail(data);
                        }
    				},
    				error:function(data){
    					if(APP.config.app.ztInterSource == "200208"){
    						APP.config.app.ztInterSource = "android";
    					}else if(APP.config.app.ztInterSource == "200209"){
    						APP.config.app.ztInterSource = "iphone";
    					} 
    					APP.config.app.ztInterSource= window.curPlatform;	//恢复渠道
    					ui.hide('common.payLoading');
    					if(me.payOrder.payCallback5 && me.payOrder.payCallback5.fail){
    						me.payOrder.payCallback5.fail && me.payOrder.payCallback5.fail(data);
                        }
    				}
    			});
    		},1000);
        },
        weixinPay: function () {
    	    var me = APP.thirdParty, order = me.payOrder, ui = APP.ui, config = APP.config;
	        var url = "/mall/wxPay/sendWxPayReq", actionCode = "41001", type = "mall", params = '';
	        var param = APP.tool.param.get(), json = order, userPhoneNum = APP.main.getData('loginNumber');
	        var params = '';
	        if(config.platform == 'WAP'){
	            params = 'orderNumber=' + order.orderNumber + ';';
	            param.add('tradeType','WAP');
	            param.add('appidTag',1);
	        }else{
	            params = 'orderNumber=' + order.orderNumber + ';';
	            param.add('tradeType','APP');
	            param.add('appidTag',3);
	        }
	        url = "/mall/wxPay/sendWxPayReq2";
	        actionCode = "41005";
	        type = "mall";
	        if(order.weixinType == '1'){
	             param.add('accNbr',json.areaCode + json.accNbr);
	             param.add('userPhoneNum',userPhoneNum);
	             param.add('orderType',11);
	             param.add('ordeRseq',"");
	             param.add('fee',json.payAmount + '00');
	             param.add('fundsType',json.mergetPay);
	             param.add('productType',json.productType);
	             param.add('areaCode',json.areaCode);
	             if(json.orderCode == 'KDXY0110'){
	                param.add('orderTypeXy',json.orderCode);
	                param.add('orderNum',json.orderId);
	             }
	             params = param.value();
	             url = "/rest/wxPayGetString";
	             actionCode = "weixinchongzhi";
	             type = "old";
	             addUmsEvent('APP_rcBankConfirmPage_wxRequest');
	        }else{//zhangll 卖场
	            param.add('orderType',12);
	            params = param.value()+params;
	            addUmsEvent('APP_mallConfirmPage_wxRequest');
	        }
	        var jftaskStatus = APP.main.getData('jftaskStatus'); //积分签到做任务的渠道
	        if(jftaskStatus){
	            APP.config.app.ztInterSource="100007";          
	        }  
	        ui.show('common.payLoading');
	        setTimeout(function () {
	            APP.interf.invoke({
	                url: url, param: params, actionCode: actionCode,//server:window.interfServer,
	                type: type, showLoading: false, showDailog: false,
	                success: function (data) {
	                    APP.config.app.ztInterSource= window.curPlatform;   //恢复渠道
	                    ui.hide('common.payLoading');
	                    if(me.payOrder.payCallback5 && me.payOrder.payCallback5.success){
    						me.payOrder.payCallback5.success && me.payOrder.payCallback5.success(data);
                        }
	                    if (order.weixinType == '1') {  //lxc  充值单独用到
	                        if (APP.underly.browser().weixin()) {
	                            var wxPayUrl  = "accNbr="+ json.areaCode + json.accNbr+"&orderType=11&ordeRseq=&fee="+json.payAmount + '00'+"&fundsType="+json.mergetPay+"&productType="+json.productType+"&areaCode="+json.areaCode;
	                              if(json.orderCode == 'KDXY0110'){
	                                  var wxPayUrl  = "accNbr="+ json.areaCode + json.accNbr+"&orderType=11&ordeRseq=&fee="+json.payAmount + '00'+"&fundsType="+json.mergetPay+"&productType="+json.productType+"&areaCode="+json.areaCode+"&orderTypeXy="+json.orderCode+"&orderNum="+json.orderId;
	                              }
	                              var openUrl = 'http://wapjs.189.cn/wxyyt_1/pay3/cz.do?'+wxPayUrl; 
	                             APP.underly.openBrowser(openUrl,'在线支付',function(arg){},function(){});
	                        } else {
	                            if (config.platform == 'WAP') {
	                                var wxPayUrl = 'appid=' + data.result.appid + '&noncestr=' + data.result.noncestr + '&package=WAP' + '&prepayid=' + data.result.prepayid + '&sign=' + data.result.sign + '&timestamp=' + data.result.timestamp;
	                                wxPayUrl = escape(wxPayUrl)
	                                var openUrl = 'weixin://wap/pay?' + wxPayUrl;
	                                APP.underly.openBrowser(openUrl, '在线支付', function (arg) { }, function () { });
	                            } else {
	                                data.result.code_url = data.result.codeUrl; //接口参数不一致 生成二维码时WAP端要注意
	                                me.invokeWeixinPay(data.result);
	                            }
	                        }
	                    }else{ //zhangll  卖场
	                        if(APP.underly.browser().weixin()){//never used  in app
	                             var wxPayUrl  = "orderNumber="+order.orderNumber+"&orderType=12&tradeType=JSAPI&appidTag=1";
	                             var openUrl = 'http://js.189.cn/imall/pay3/zf.do?'+wxPayUrl; //卖场支付跳转
	                             APP.underly.openBrowser(openUrl,'在线支付',function(arg){},function(){});
	                        }else{
	                            if(config.platform == 'WAP'){
	                                   var wxPayUrl  =  'appid='+data.result.appid+'&noncestr='+data.result.noncestr+'&package=WAP'+'&prepayid='+data.result.prepayid+'&sign='+data.result.sign+'&timestamp='+data.result.timestamp;
	                                   wxPayUrl = escape(wxPayUrl)
	                                   var openUrl = 'weixin://wap/pay?'+wxPayUrl;
	                                   APP.underly.openBrowser(openUrl,'在线支付',function(arg){},function(){});
	                            }else{
	                                data.result.code_url = data.result.codeUrl; //接口参数不一致 生成二维码时WAP端要注意
	                                me.invokeWeixinPay(data.result);
	                            }
	                        }
	                    }
	                },
	                fail: function (data) {
	                    APP.config.app.ztInterSource= window.curPlatform;   //恢复渠道
	                    ui.hide('common.payLoading');
	                    if(data.TSR_RESULT=="102001" || data.TSR_RESULT=="151202"){
	                      ui.ui('default.alert',{content:data.TSR_MSG});
	                    }else{
	                      ui.ui('default.alert',{content:'哎呀，网络开了小差，麻烦您再试一次。'});
	                    }
	                    if(me.payOrder.payCallback5 && me.payOrder.payCallback5.fail){
    						me.payOrder.payCallback5.fail && me.payOrder.payCallback5.fail(data);
                        }
	                },
	                error: function (data) {
	                    APP.config.app.ztInterSource= window.curPlatform;   //恢复渠道
	                    ui.hide('common.payLoading');
	                    ui.ui('default.alert', {content: '亲，网络不给力！'});
	                    if(me.payOrder.payCallback5 && me.payOrder.payCallback5.fail){
    						me.payOrder.payCallback5.fail && me.payOrder.payCallback5.fail(data);
                        }
	                }
	            });
	        }, 1000);
        },
        weixinPay5:function () {//五期卖场改造 王琳
            var me = APP.thirdParty, order = me.payOrder, ui = APP.ui, config = APP.config;
            var url = "/pay/wxPay", actionCode = "41001", type = "pay", params = '';
            var param = APP.tool.param.get(), json = order;
            var params = '';
            if(config.platform == 'WAP'){
                param.add('tradeType','WAP');
                param.add('appid',1);
            }else{
                param.add('tradeType','APP');
                param.add('appid',3);
            }
            url = "/pay/wxPay";
            actionCode = "41005";
            type = "pay";
            param.add('orderId',json.orderNumber);
            param.add('payAmount',parseInt(json.payAmount * 100)+ '');
            param.add('returnUrl',config.server.NORMAL_OLD+"/storesEpayNew.action");//写死了，最后确定是那个地址，目前先写死
            param.add('areaCode',json.areaCode);
            param.add('bankId','41');//微信是41
            param.add('payType','9');//微信是9
            if(json.description && json.description != ''){
                var description = json.description;
                if(description.length>45){
                    description = description.substr(0,44);
                }
                param.add('description',description);//可以传可以不传，但是不能传空值，目前先随便写死描述
            }
            ui.show('common.payLoading');
            setTimeout(function () {
                APP.interf.invoke({
                    url: url,
                    type: type,
                    param: param.value(),
                    actionCode: actionCode,//server:window.interfServer,
                    showLoading: false,
                    showDailog: false,
                    success: function (data) {
                        APP.config.app.ztInterSource= window.curPlatform;   //恢复渠道
                        ui.hide('common.payLoading');
                        if(me.payOrder.payCallback5 && me.payOrder.payCallback5.success){
                            me.payOrder.payCallback5.success && me.payOrder.payCallback5.success(data);
                        }
                        if(data.item && data.item.requestSeq){
                            json.requestSeq = data.item.requestSeq;
                        }
                        if(APP.underly.browser().weixin()){//never used  in app
                            var wxPayUrl  = "orderNumber="+order.orderNumber+"&orderType=12&tradeType=JSAPI&appidTag=1";
                            var openUrl = 'http://js.189.cn/imall/pay3/zf.do?'+wxPayUrl; //卖场支付跳转
                            APP.underly.openBrowser(openUrl,'在线支付',function(arg){},function(){});
                        }else{
                            if(config.platform == 'WAP'){
                                var wxPayUrl  =  'appid='+data.item.requestSeq+'&noncestr='+data.item.noncestr+'&package=WAP'+'&prepayid='+data.item.prepayid+'&sign='+data.item.sign+'&timestamp='+data.item.timestamp;
                                wxPayUrl = escape(wxPayUrl)
                                var openUrl = 'weixin://wap/pay?'+wxPayUrl;
                                APP.underly.openBrowser(openUrl,'在线支付',function(arg){},function(){});
                            }else{
                                data.item.code_url = data.item.codeUrl; //接口参数不一致 生成二维码时WAP端要注意
                                me.invokeWeixinPay5(data.item);
                            }
                        }
                    },
                    fail: function (data) {
                        APP.config.app.ztInterSource= window.curPlatform;   //恢复渠道
                        ui.hide('common.payLoading');
                        if(data.TSR_RESULT=="102001" || data.TSR_RESULT=="151202"){
                            ui.ui('default.alert',{content:data.TSR_MSG});
                        }else{
                            ui.ui('default.alert',{content:'哎呀，网络开了小差，麻烦您再试一次。'});
                        }
                        if(me.payOrder.payCallback5 && me.payOrder.payCallback5.fail){
                            me.payOrder.payCallback5.fail && me.payOrder.payCallback5.fail(data);
                        }
                    },
                    error: function (data) {
                        APP.config.app.ztInterSource= window.curPlatform;   //恢复渠道
                        ui.hide('common.payLoading');
                        ui.ui('default.alert', {content: '亲，网络不给力！'});
                        if(me.payOrder.payCallback5 && me.payOrder.payCallback5.fail){
                            me.payOrder.payCallback5.fail && me.payOrder.payCallback5.fail(data);
                        }
                    }
                });
            }, 1000);
	    },
        invokeWeixinPay: function (data) {
            var me = APP.thirdParty, order = me.payOrder, ui = APP.ui, config = APP.config;
            var page = APP.page, payCallback = order.payCallback;
            if (config.platform == 'WAP') {//wap平台 二维码扫描支付
                page.changePage('common/weixinCodePay', {
                    param: {
                        offerName: order.offerName,
                        payOrderNumber: order.orderNumber,
                        payData: data
                    }
                });
            } else {
                if (config.app.platform == 'android') {//安卓平台
                    var param = {
                        appId: data.appid,
                        partnerId: data.partnerid,
                        prepayId: data.prepayid,
                        packageValue: data.package,
                        nonceStr: data.noncestr,
                        timeStamp: data.timestamp,
                        sign: data.sign
                    };
                    //navigator.weixinPayPlugin.pay(weixinpaySuccess, weixinpayError, param);
                    navigator.weixinPay.pay({
            			appid: param.appId,
            			partnerid: param.partnerId,
            			prepayid: param.prepayId,
                        package: param.packageValue,
                        noncestr: param.nonceStr,
                        timestamp: param.timeStamp,
                        sign: param.sign,
                        success:function(code,msg){
                        	if (code == 0) {
                                if (payCallback && payCallback.success) {
                                    payCallback.success && payCallback.success({result: msg, order: order, payData: data});
                                } else {
                                    if (order.weixinType == '1') {  //lxc 微信充值就弹个成功
                                        if (msg == '' || msg == 'null') {
                                        	msg = '支付成功！';
                                        }
                                        ui.ui('default.alert', {content: msg});
                                    } else {
                                        page.changePage('common/paySuccess', {
                                            param: {result: msg, order: order, payData: data}
                                        });
                                    }
                                }
                            } else {
                                if (msg == '' || msg == 'null') {
                                	msg = '支付成功！';
                                }
                                ui.ui('default.alert', {content: msg});
                            }
                        },
                        error:function(code,msg){
                            if (payCallback && payCallback.fail) {
                                payCallback.fail({result: msg, order: order, payData: data});
                            } else {
                                if (order.weixinType == '1') {  //lxc 微信充值统计失败数据
                                    if (msg == "用户取消") {
                                        addUmsEvent('APP_rcBankConfirmPage_wxCancel');
                                    } else {
                                        addUmsEvent('APP_rcBankConfirmPage_wxFail');
                                    }
                                }
                                if (msg == '' || msg == 'null') {
                                	msg = '支付失败！';
                                }
                                ui.ui('default.alert', {content: msg});
                            }
                        }
            		});
                }
            }
        },
        invokeWeixinPay5: function (data) {
            var me = APP.thirdParty, order = me.payOrder, ui = APP.ui, config = APP.config;
            var page = APP.page, payCallback = order.payCallback;
            if (config.platform == 'WAP') {//wap平台 二维码扫描支付
                page.changePage('common/weixinCodePay', {
                    param: {
                        offerName: order.offerName,
                        payOrderNumber: order.orderNumber,
                        payData: data
                    }
                });
            } else {
                if (config.app.platform == 'android') {//安卓平台
                    var param = {
                        appId: data.appid,
                        partnerId: data.partnerid,
                        prepayId: data.prepayid,
                        packageValue: data.package,
                        nonceStr: data.noncestr,
                        timeStamp: data.timestamp,
                        sign: data.sign
                    };
                    //navigator.weixinPayPlugin.pay(weixinpaySuccess, weixinpayError, param);
                    navigator.weixinPay.pay({
            			appid: param.appId,
            			partnerid: param.partnerId,
            			prepayid: param.prepayId,
                        package: param.packageValue,
                        noncestr: param.nonceStr,
                        timestamp: param.timeStamp,
                        sign: param.sign,
                        success:function(code,msg){
                        	if (code == 0) {
                                if (payCallback && payCallback.success) {
                                    payCallback.success && payCallback.success({result: msg, order: order, payData: data});
                                } else {
                                    if (order.weixinType == '1') {  //lxc 微信充值就弹个成功
                                        if (msg == '' || msg == 'null') {
                                        	msg = '支付成功！';
                                        }
                                    } else {
                                        page.changePage('common/paySuccess', {
                                            param: {result: msg, order: order, payData: data}
                                        });
                                    }
                                }
                            } else {
                                if (msg == '' || msg == 'null') {
                                	msg = '支付成功！';
                                }
                            }
                        },
                        error:function(code,msg){
                            if (payCallback && payCallback.fail) {
                                payCallback.fail({result: msg, order: order, payData: data});
                            } else {
                                if (order.weixinType == '1') {  //lxc 微信充值统计失败数据
                                    if (msg == "用户取消") {
                                        addUmsEvent('APP_rcBankConfirmPage_wxCancel');
                                    } else {
                                        addUmsEvent('APP_rcBankConfirmPage_wxFail');
                                    }
                                }
                                if (msg == '' || msg == 'null') {
                                	msg = '支付失败！';
                                }
                            }
                        }
            		});
                }
            }
        }
	};

	var thirdParty = new THIRDPARTY();

	module.exports = thirdParty;
});