/**
 * @author Grahor
 * 应用工具对象 export APP_TOOLS
 */
String.prototype.replaceAll = function(s1,s2) { 
    return this.replace(new RegExp(s1,"gm"),s2); 
}
function PresentAccountInfo() {
    this.num = "";		//当前帐户号码
    this.numType = "";	//当前帐户类型
}
;APPBASE.define('tool',function(require, exports, module){
	
	var	appTools;//工具对象
	var LOCALDATA,
	SESSIONDATA,
	VALIDATE,
	STRINGBUILDER,
	UTILS,
	PARAM,
	FORMAT,
	LOG,
	STATISTICS,
	DOM;
	
	//工具对象
	var TOOLS = function(){
		this.localData = null; //本地数据对象
		this.sessionData = null; //会话级数据对象
		this.validate = null; //验证对象
		this.stringBuilder = null; //字符串操作对象
		this.util = null; //辅助对象
		this.param = null; //参数对象
		this.format = null; //格式对象
		this.log = null;//日志对象
		this.statistics = null; //统计对象
		this.dom = null; //dom对象
		this.mapList = null; //对象map集合管理
	};

	TOOLS.prototype = {
		init:function(option){
			var localData = new LOCALDATA();
			var sessionData = new SESSIONDATA();
			var validate = new VALIDATE();
			var strBuilder = new STRINGBUILDER();
			var util = new UTILS();
			var param = new PARAM();
			var format = new FORMAT();
			var log = new LOG();
			var statistics = new STATISTICS();
			var dom = new DOM();
			var mapList = new MAPLIST();
			
			this.localData = localData; //初始化本地数据对象
			this.sessionData = sessionData; //初始化会话级数据对象
			this.validate = validate; //初始化验证对象
			this.stringBuilder = strBuilder; //初始化字符串操作对象
			this.util = util; //初始化辅助对象
			this.param = param; //初始化参数对象
			this.format = format; //初始化格式对象
			this.log = log; //初始日志对象
			this.statistics = statistics;
			this.dom = dom; //dom对象
			this.mapList = mapList;
			
			if(validate.isNotNull(option)){
				localData.init(option.localData);
				sessionData.init(option.sessionData);
				validate.init(option.validate);
				strBuilder.init(option.strBuilder);
				util.init(option.util);
				param.init(option.param);
				format.init(option.format);
				log.init(option.log);
				statistics.init(option.statistics);
				dom.init(option.dom);
				mapList.init(option.mapList);
			}
			else{
				localData.init();
				sessionData.init();
				validate.init();
				strBuilder.init();
				util.init();
				param.init();
				format.init();
				log.init();
				statistics.init();
				dom.init();
				mapList.init();
			}
			
		},
		newInstance:function(){
			var obj = new TOOLS();
			obj.init();
			return obj;
		}
	};
	
	function encryptStr(str, pwd) {//加密字符串
		  if(pwd == null || pwd.length <= 0) {
		    //alert("Please enter a password with which to encrypt the message.");
		    return null;
		  }
		  var prand = "";
		  for(var i=0; i<pwd.length; i++) {
		    prand += pwd.charCodeAt(i).toString();
		  }
		  var sPos = Math.floor(prand.length / 5);
		  var mult = parseInt(prand.charAt(sPos) + prand.charAt(sPos*2) + prand.charAt(sPos*3) + prand.charAt(sPos*4) + prand.charAt(sPos*5));
		  var incr = Math.ceil(pwd.length / 2);
		  var modu = Math.pow(2, 31) - 1;
		  if(mult < 2) {
		    //alert("Algorithm cannot find a suitable hash. Please choose a different password. \nPossible considerations are to choose a more complex or longer password.");
		    return null;
		  }
		  var salt = Math.round(Math.random() * 1000000000) % 100000000;
		  prand += salt;
		  while(prand.length > 10) {
		    prand = (parseInt(prand.substring(0, 10)) + parseInt(prand.substring(10, prand.length))).toString();
		  }
		  prand = (mult * prand + incr) % modu;
		  var enc_chr = "";
		  var enc_str = "";
		  for(var i=0; i<str.length; i++) {
		    enc_chr = parseInt(str.charCodeAt(i) ^ Math.floor((prand / modu) * 255));
		    if(enc_chr < 16) {
		      enc_str += "0" + enc_chr.toString(16);
		    } else enc_str += enc_chr.toString(16);
		    prand = (mult * prand + incr) % modu;
		  }
		  salt = salt.toString(16);
		  while(salt.length < 8)salt = "0" + salt;
		  enc_str += salt;
		  return enc_str;
	}

	function decryptStr(str, pwd) {//解密字符串
		  if(str == null || str.length < 8) {
		    //alert("A salt value could not be extracted from the encrypted message because it's length is too short. The message cannot be decrypted.");
		    return;
		  }
		  if(pwd == null || pwd.length <= 0) {
		    //alert("Please enter a password with which to decrypt the message.");
		    return;
		  }
		  var prand = "";
		  for(var i=0; i<pwd.length; i++) {
		    prand += pwd.charCodeAt(i).toString();
		  }
		  var sPos = Math.floor(prand.length / 5);
		  var mult = parseInt(prand.charAt(sPos) + prand.charAt(sPos*2) + prand.charAt(sPos*3) + prand.charAt(sPos*4) + prand.charAt(sPos*5));
		  var incr = Math.round(pwd.length / 2);
		  var modu = Math.pow(2, 31) - 1;
		  var salt = parseInt(str.substring(str.length - 8, str.length), 16);
		  str = str.substring(0, str.length - 8);
		  prand += salt;
		  while(prand.length > 10) {
		    prand = (parseInt(prand.substring(0, 10)) + parseInt(prand.substring(10, prand.length))).toString();
		  }
		  prand = (mult * prand + incr) % modu;
		  var enc_chr = "";
		  var enc_str = "";
		  for(var i=0; i<str.length; i+=2) {
		    enc_chr = parseInt(parseInt(str.substring(i, i+2), 16) ^ Math.floor((prand / modu) * 255));
		    enc_str += String.fromCharCode(enc_chr);
		    prand = (mult * prand + incr) % modu;
		  }
		  return enc_str;
	}

	//验证对象
	VALIDATE = function(){
		this.errorMsg = {
			//isNull:
		};
		this.nbrRex = /^1(73|77|80|81|89|33|53|99|91)\d{8}$/;
	};

	VALIDATE.prototype = {
		init:function(option){

		},
		isNull:function(obj,error){
			if(typeof obj == 'undefined'){
				return true;
			}
			if(this.isArray(obj)){
				for(var i = 0; i < obj.length; i++){
					if(this.isNull(obj[i])){
						return true;
					}
				}
				return false;
			}
			if(obj == null || $.trim(obj) == '' || $.trim(obj) == 'null' || $.trim(obj) == 'undefined'){
				return true;
			}
			return false;
		},
		isNotNull:function(obj,error){
			return !this.isNull(obj);
		},
		hasProperties:function(obj){
			if(typeof obj==='object'){
				for(var key in obj){
					return true;
				}
			}
			return false;
		},
		isArray:function(obj,error){//是否为数组
			return obj && typeof obj === 'object' && Array == obj.constructor;
		},
		isFunction:function(obj,error){
			return obj && typeof obj === 'function';
		},
		isString:function(obj,error){//是否为字符串
			return obj && typeof obj === 'string';
		},
		isNumber:function(obj,error){//是否为数字
			return obj && typeof obj === 'number';
		},
		isMobile:function(mobile,error){//判断是否是手机号码 
			if(this.isNull(mobile,error)){
				return false;
			}
			return /^1[3|4|5|6|7|8|9]\d{9}$/.test(mobile);
		},
		isMobileCDMAOld : function(mobile,error){//判断是否为电信号码		
		    /** 
		     * @this APP.tool.validate 
		     * @property {function} isNull 检验手机号是否为空
		     */
		    var self = this;
		    if(self.isNull(mobile,error)){
		        return false;
		    }
		    var result = self.nbrRex.test(mobile);

		    if(result){
		        return true
		    } else {
		        var num = mobile.toString().substring(0,5);
		        return num === '10649' && mobile.toString().length === 13
		    } 
		},
		isMobileCDMA:function(mobile,error){//判断是否为电信号码
			try{
                if(APP.tool.validate[mobile+'isCDMA'] !== undefined){
                    console.warn('isMobileCDMA-cache-hit',performance.now(),mobile,APP.tool.validate[mobile+'isCDMA'])
                    return APP.tool.validate[mobile+'isCDMA']
                }
            }catch(e){}
			/** 
		     * @this APP.tool.validate 
		     * @property {function} isNull 检验手机号是否为空
		     */
		    var self = this;
		    if(self.isNull(mobile,error)){
		        return false;
		    }
		    var num = mobile.toString().substring(0,5);
		    if(num === '10649' && mobile.toString().length === 13){
		        return true
		    }
		    /** 
		     * @var {string} serverUrl 服务器地址
		     * @var {string} serverUrl 判断结果
		     */
		    var serverUrl = handleDomainContent('http://wapjs.189.cn');
		    var isCDMA;
		    
		    /** 
		     * @var {string} param 接口入参 
		     * @var {boolean} isAsync 是否异步加载（此处只能用同步 
		     * @var {number} timeout 超时时间（毫秒）
		     */
		    var param = "PathCode=user-00015;accNbr="+mobile;
		    var isAsync = false;
		    var timeout = 2000;

		        /**
		     * @description ajaxOption
		     * ajax调用参数
		     * @property {boolean} async 同步加载            
		     * @property {number} timeout 超时时间
		     */ 
		    var ajaxOption = {
		        url: serverUrl + "/zt-service/welcome",
		        type: "POST",
		        dataType: "json",
		        // 
		        async : isAsync,
		        // 超时2秒
		        timeout: timeout,
		        success: function(data) {
		            /**
		             * @description 接口可能出参
		             * @readonly
		             * @enum {string}
		             *  0      -- 电信号码
		             *  1      -- 异网号码
		             *  70001  -- 企信接口限流，提示“网络开小差，请稍后重试”
		             */
		            if(data && data.TSR_RESULT){
		                if(data.TSR_RESULT === "0"){
		                    isCDMA = true;
		                }else if(data.TSR_RESULT === "1"){
		                    isCDMA = false;
		                }else if(data.TSR_RESULT === "70001"){
		                    APP.ui.ui('default.alert',{ content: "网络开小差，请稍后重试" })
		                    isCDMA = false;
		                }else{
		                        /**
		                     * @description 
		                     * 其他情况走原号段判断逻辑
		                     */
		                    isCDMA = self.isMobileCDMAOld(mobile,error);
		                }
		            }else{
		                    /**
		                 * @description 
		                 * 其他情况走原号段判断逻辑
		                 */
		                isCDMA = self.isMobileCDMAOld(mobile,error);
					}
					APP.tool.validate[mobile+'isCDMA'] = isCDMA
					console.warn('isMobileCDMA-end',performance.now())
		        },
		        error: function(data) {
		            /**
		             * @description 
		             * 接口失败走原号段判断逻辑
		             */
		            isCDMA = self.isMobileCDMAOld(mobile,error);
		        },
		    }
		        /**
		     * @description
		     * @ignore
		     * 本方法为同步方法，此处需用wap厅加密方法ztEncrptyUtil，天翼生活使用前必须先加载app.rsa.min.js。天翼生活Cordova方法为异步方法，在此处无法使用。
		     */
		    try{
		        var RSAresult = ztEncrptyUtil.encode(param); 
		    }catch(e){
		        if(typeof error === 'function'){
		            error();
		        }
		        isCDMA = false;
		    }

		    /**
		     * @description ajaxOption
		     * ajax调用参数
		     * @property {object} data 接口入参  
		     */ 
			ajaxOption.data =  {"para": RSAresult}
			console.info('isMobileCDMA-begin',performance.now(),mobile)
		    $.ajax(ajaxOption);

		    return isCDMA
		},
		isBroadband:function(broadband,error){
			if(this.isNull(broadband,error)){
				return false;
			}
			return /^[\w|\d]{10,20}$/.test(broadband);
		},
		isPhone:function(phone,error){
			 var me = APP.tool.validate;
	            if (me.isNull(phone, error)) {
	                return false;
	            }
	            return /^\d{8,12}$/.test(phone);
		},
		isEmail:function(email){
			if (email) {
				return /^([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+@([a-zA-Z0-9]+[_|\_|\.]?)*[a-zA-Z0-9]+\.[a-zA-Z]{2,3}$/.test(email);
			}
			return false;
		},
		isVisible:function(obj){//是否可见
			if(this.isNull(obj[0])){
				return false;
			}
		    if(obj.tagName){
		    	 return obj.style.display != "none";
		    }
		    else{
		    	return obj[0].style.display != "none";
		    }
		}
	};

	//本地数据存储
	LOCALDATA = function(){
	};

	LOCALDATA.prototype = {
		init:function(option){//初始化本地数据
			if(!this._isEnabled()){
				return;
			}
		},
		_isEnabled:function(){//本地存储是否支持
			if(typeof localStorage != 'undefined'){
				return true;
			}
			return false;
		},
		put:function(key,value,expireSeconds){//key:键 value:值 expireSeconds:失效秒数
			if(!this._isEnabled()){
				return;
			}
			var validate = appTools.validate;
			if(validate.isNull(key,value)){
				return;
			}
			if(validate.isNotNull(expireSeconds)){
				window.localStorage.setItem(key + 'EXPIRETIME',(new Date()).getTime() + expireSeconds *1000);
			}else{
				window.localStorage.setItem(key + 'EXPIRETIME',"");
			}
			if(!validate.isString(value)){
				try{
					value = JSON.stringify(value);
				}catch(e){
				}
			}
			window.localStorage.setItem(key,value);
		},
		get:function(key){//获取值
			if(!this._isEnabled()){
				return null;
			}
			var validate = appTools.validate;
			if(validate.isNull(key)){
				return null;
			}
			if(validate.isNotNull(window.localStorage.getItem(key + 'EXPIRETIME'))){
				var time = parseFloat(window.localStorage.getItem(key + 'EXPIRETIME'));
				if((new Date()).getTime() < time){
					return window.localStorage.getItem(key);
				}
				window.localStorage.setItem(key,"");
				return null;
			}
			return window.localStorage.getItem(key);
		},
		remove:function(key){//删除本地数据
			if(!this._isEnabled()){
				return null;
			}
			if(appTools.validate.isNull(key)){
				return null;
			}
			var value = this.get(key);
			window.localStorage.setItem(key,null);
			window.localStorage.setItem(key + 'EXPIRETIME',null);
			return value;
		}
	};

	//会话级数据存储
	SESSIONDATA = function(){
	};

	SESSIONDATA.prototype = {
		init:function(option){//初始化会话数据
			if(!this._isEnabled()){
				return;
			}
		},
		_isEnabled:function(){//会话存储是否支持
			if(typeof sessionStorage != 'undefined'){
				return true;
			}
			return false;
		},
		put:function(key,value,expireSeconds){//key:键 value:值 expireSeconds:失效秒数
			if(!this._isEnabled()){
				return;
			}
			var validate = appTools.validate;
			if(validate.isNull(key,value)){
				return;
			}
			if(validate.isNotNull(expireSeconds)){
				window.sessionStorage.setItem(key + 'EXPIRETIME',(new Date()).getTime() + expireSeconds);
			}
			if(!validate.isString(value)){
				try{
					value = JSON.stringify(value);
				}catch(e){
				}
			}
			window.sessionStorage.setItem(key,value);
		},
		get:function(key){//获取值
			if(!this._isEnabled()){
				return null;
			}
			var validate = appTools.validate;
			if(validate.isNull(key)){
				return null;
			}
			if(validate.isNotNull(window.sessionStorage.getItem(key + 'EXPIRETIME'))){
				var time = parseFloat(window.sessionStorage.getItem(key + 'EXPIRETIME'));
				if((new Date()).getTime() < time){
					return window.sessionStorage.getItem(key);
				}
				return null;
			}
			return window.sessionStorage.getItem(key);
		},
		remove:function(key){//删除会话数据
			if(!this._isEnabled()){
				return null;
			}
			if(appTools.validate.isNull(key)){
				return null;
			}
			var value = this.get(key);
			window.sessionStorage.setItem(key,null);
			window.sessionStorage.setItem(key + 'EXPIRETIME',null);
			return value;
		}
	};

	/**
	 * 字符串操作对象
	 */
	STRINGBUILDER = function(){
		this.builder = [];
		this.size = 0;
	};

	STRINGBUILDER.prototype = {
		init:function(option){
			
		},
		newInstance:function(){
			return new STRINGBUILDER();
		},
		get:function(){
			return this.newInstance();
		},
		clear:function(){
			this.builder = [];
			this.size = 0;
			return this;
		},
		append:function(str){
			this.builder.push(str);
			return this;
		},
		toString:function(spliter){
			if(appTools.validate.isNull(spliter)){
				spliter = '';
			}
			return this.builder.join(spliter);
		}
	};

	/**
	 * 帮助对象
	 */
	UTILS = function(){
		this.uuidChars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');
		this.encryptKey = '13579ACEGIKNPRTVXZacegiknprtvxz'; //加密键
	}

	UTILS.prototype = {
		init:function(option){
			
		},
		uuid:function(){
		    var chars = this.uuidChars, uuid = [], i;
		    var radix = radix || chars.length;
			var r;
			uuid[8] = uuid[13] = uuid[18] = uuid[23] = '-';
			uuid[14] = '4';
			for (i = 0; i < 36; i++) {
				if (!uuid[i]) {
				  r = 0 | Math.random()*16;
				  uuid[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r];
				}
			}
    		return uuid.join('').replace(/[-]/g,'');
		},
		isEffectiveTime:function(date1Str,date2Str){//是否是有效时间
			var validate = appTools.validate;
			if(validate.isNull(date1Str) && validate.isNull(date2Str)){
				return false;
			}
			if(validate.isNotNull(date1Str) && validate.isNotNull(date2Str)){
				var bDate = new Date(date1Str.replace(/[-]/g, '/'));
			    var eDate = new Date(date2Str.replace(/[-]/g, '/'));
			    var nDate = new Date();
			    if (nDate.getTime() > bDate.getTime() && nDate.getTime() < eDate.getTime()) {
			        return true;
			    }
			    return false;
			}
			else if(validate.isNotNull(date1Str)){
				var bDate = new Date(date1Str.replace(/[-]/g, '/'));
			    var nDate = new Date();
			    if (nDate.getTime() > bDate.getTime()){
			        return true;
			    }
			    return false;
			}
			else if(validate.isNotNull(date2Str)){
			    var eDate = new Date(date2Str.replace(/[-]/g, '/'));
			    var nDate = new Date();
			    if(nDate.getTime() < eDate.getTime()){
			        return true;
			    }
			    return false;
			}
			return true;
		},
		encrypt:function(str){//加密
			if(appTools.validate.isNull(str)){
				return "";
			}
			return encryptStr(str,this.encryptKey);
		},
		decrypt:function(str){
			if(appTools.validate.isNull(str)){
				return "";
			}
			return decryptStr(str,this.encryptKey);
		},
		getCleanUrl:function(str,suffix){
			var validate = appTools.validate;
			if(validate.isNull(str)){
				return '';
			}
			if(validate.isNull(suffix)){
				suffix = '.html';
			}
			if(/\#/.test(str)){
				return str.substring(str.lastIndexOf('#') + 2,str.lastIndexOf(suffix) + suffix.length);
			}
			return str.substring(0,str.lastIndexOf(suffix) + suffix.length);
		},
		getSystemTime:function(){//获取系统时间
			return new Date();
		},
		getRandomString:function(){//获取随机数
 			var localData = appTools.localData;
 			var validate = appTools.validate;
 			var uuid = localData.get('ranUUID');
 			if(validate.isNull(uuid)){
				if(device){
					var userImsi = validate.isNull(device.imsi) ? "" : device.imsi;
	 				var userImei = validate.isNull(device.meid) ? "" : device.meid;
	 				var ranStr = parseInt(1000000 * Math.random());
	 				uuid = userImsi + userImei + ranStr;
				}else{
					var ranStr = parseInt(1000000 * Math.random());
	 				uuid = ranStr;
				}
 				uuid = uuid.toLowerCase();
 				localData.put('ranUUID',uuid);
 			}
 			return uuid;
 		},
		generateShortLink:function(longUrl,success,fail){//生成短连接
			$.ajax({
				url:'http://api.t.sina.com.cn/short_url/shorten.json?source=3833962837&url_long=' + escape(longUrl),
				type:'get',
				dataType:'json',
				success:function(data){
					if(data && data[0]){
						success && success(data[0].url_short);
					}else{
						fail && fail(longUrl);
					}
				},
				error:function(){
					fail && fail(longUrl);
				}
				
			});
		}
	};
	
	utilsTool = new UTILS();
	
	/**
	 * 参数对象帮助
	 */
	PARAM = function(){
		this.builder = null; //参数构造器
		this.spliter = ';'; //分隔符
	};
	
	PARAM.prototype = {
		init:function(option){
			
		},
		get:function(split){//获取一个新的param实例
			var param = new PARAM();
			param.builder = new STRINGBUILDER();
			if(appTools.validate.isNull(split)){
				param.spliter = ';';
			}
			else{
				param.spliter = split;
			}
			return param;
		},
		add:function(key,value){//添加参数键值
			this.builder.append(key).append('=').append(value).append(this.spliter);
			return this;
		},
		remove:function(key){
			param.builder.remove(key);
			return this;
		},
		value:function(split){
			if(appTools.validate.isNull(split)){
				split = '';
			}
			var value = this.builder.toString(split);
			this.builder = null;
			this.spliter = null;
			return value;
		},
		urlParam:function(){//url参数解析
			var href = window.location.href;
			if(href.indexOf('#') >= 0){
				href = href.substring(href.indexOf('#') + 1);
			}
			if(href.indexOf('?') >= 0){
				href = href.substring(href.indexOf('?') + 1);
				var param = {};
				var array = href.split('&');
				var len = array.length;
				var keyValue;
				for(var i = 0; i < len; i++){
					keyValue = this._getKeyValue(array[i]);
					param[keyValue[0]] = keyValue[1];
				}
				return param;
			}else{
				return null;
			}
		},
		_getKeyValue:function(str,split){
			if(!split){
				split = '=';
			}
			if(str.indexOf(split) >= 0){
				return str.split(split);
			}else{
				return [str,''];
			}
		}
	};
	
	//格式对象
	FORMAT = function(){
		this.week = {
			0:'日',
			1:'一',
			2:'二',
			3:'三',
			4:'四',
			5:'五',
			6:'六'	
		};
		this.defaultFormatSplit = ' ';
		this.formatType = {
			normal:'4 4 4',//普通
			mobile:'3 4 4',//手机
			phone:'4 4 4',//固话
			broadband:'4 4 4',//宽带
			flow:'3 4 4',//流量
			ID:'3 3 4'//身份证
		}
	};
	
	//格式化对象方法定义
	FORMAT.prototype = {
		init:function(option){
			
		},
		formatDate:function(format,date){//格式化日期
			var validate = appTools.validate;
			if(validate.isNull(format)){
				format = 'yyyy-MM-dd';
			}
			if(validate.isNull(date)){
				date = new Date();
			}
			var year = date.getFullYear();
            var month = date.getMonth() + 1;
            var dated = date.getDate();
            var hh = date.getHours();
            var mi = date.getMinutes();
            var se = date.getSeconds();
            var day = date.getDay();
            return format.replace(/[y|Y]{4}/g, year).replace(/[m|M]{2}/g, this._format10(month)).replace(/[d|D]{2}/g, this._format10(dated)).replace(/[h|H]{2}/g, this._format10(hh)).replace(/[m|M]{1}[i|I]{1}/g, this._format10(mi)).replace(/[s|S]{2}/g, this._format10(se)).replace(/[W|w]{2}/g, this.formatWeek(day));
		},
		stringToDate:function(str){
			try{
				var date = new Date(str.replace(/[-]/g, '/'));
				return date;
			}catch(e){
				return null;
			}
		},
		formatWeek:function(day,prefix){
			var validate = appTools.validate;
			if(validate.isNull(day)){
				day = 0;
			}
			if(validate.isNull(prefix)){
				prefix = '星期';
			}
			return prefix + this.week[day];
		},
		_format10:function(num){
			if(num < 10){
				return '0' + num;
			}
			return num;
		},
		getRealValueFormat:function(str,split){
			if(!str){
		        return "";
		    }
			if(!split){
				split = '\\s';
			}
		    if(str.indexOf('（') >= 0){
		    	str = str.substring(0, str.indexOf('（'));
		    }
		    if(str.match(split)){
		        return str.replace(new RegExp(split,'g'), '');
		    }
		    return str;
		},
		formatNumber:function(type,str,format,split,cycle){//type:格式化类型  str:待格式化字符串  format:格式化形式  cycle:是否循环
			if(type){
				format = this.formatType[type];
			}
			if(!format){
				format = this.formatType['normal'];
			}
			if(!split){
				split = ' ';
			}
			var strArry = [];
			str = this.getRealValueFormat(str);
			
	        var tArrs = format.split(split);
	        var specialChar = 0;
	        var startPos = 0;
	        var startCat = parseInt(tArrs[startPos]);
	        var len = str.length;
	        for(var i = 0; i < len; i++){
	        	if(i == startCat){
	        		strArry.push(split);
	        		if(startPos < tArrs.length - 1){
	        			startPos++;
	        		}
	        		startCat += parseInt(tArrs[startPos]);
	        		
	        	}
	        	strArry.push(str[i]);
	        }
	        return strArry.join('');
		},
		_format:function(str,format,split,cycle){
			//var reg = new Rg
			return str.replace(/[\w|\d]{}/,'');
		},
		formatStar:function(str,start,end,starsLen){//格式化显示*
			var validate = appTools.validate;
			if(validate.isNull(str)){
				return '';
			}
			var len = str.length;
			if(start <= 0 || end <=0 || start > len || end > len || start > end){
				return str;
			}
			var starLen = end - start + 1;
			var substr = str.substr(start-1,starLen);
			var stars = '';
			if(starsLen){
				starLen = starsLen;
			}
			for(var i = 0; i < starLen; i++){
				stars += '*';
			}
			
			return str.replace(substr,stars);
		},
		formatMoney:function(str){
			if(!isNaN(str)){
				str += '';
			}
			if(str.indexOf('.') >= 0){
				return str;
			}
			return str + '.00';
		},
		formatTitle:function(str,len){//格式化标题
			if(!str){
				return '';
			}
			if(len == null){
				len = 7;
			}
			if(str.length > 7){
				return str.substring(0,7) + '..';
			}else{
				return str;
			}
			
		},
		formatString:function(str,len){
			if(!str){
				return '';
			}
			if(len == null){
				len = 2;
			}
			return str.substring(0,2);
		},
		formatInt:function(str){
			if(!str){
				return '';
			}
			str += '';
			if(str.indexOf('.') >= 0){
				return str.substring(0,str.indexOf('.'));
			}
			return str;
		}
	};
	
	LOG = function(){//日志对象
		this.logLevel = 1; //日志级别 1:log 2:debug 3:info 4:error
		this.enabled = false;//打印日志 
	};
	LOG.prototype = {
		init:function(option){//初始化
			var validate = appTools.validate;
			if(validate.isNull(option)){
				return;
			}
			var level = option.level;
			var enabled = option.enabled;
			var validate = appTools.validate;
			if(validate.isNotNull(level)){
				this.logLevel = level;
			}
			else{
				this.logLevel = 1;
			}
			if(validate.isNotNull(enabled)){
				this.enabled = enabled;
			}
			else{
				this.enabled = true;
			}
		},
		log:function(str){//输出日志
			if(!this.enabled){
				return;
			}
			var level = this.logLevel;
			if(level == 1){
				console.log(str);
			}else if(level == 2){
				console.debug(str);
			}else if(level == 3){
				console.info(str);
			}else if(level == 4){
				console.error(str);
			}
		}
	};
	
	/**
	 * 统计数据对象
	 */
	STATISTICS = function(){
		
	}
	
	STATISTICS.prototype = {
		init:function(){//初始化
			
		},
		insertCode:function(data){//插码
			
		}
	};
	
	appTools = new TOOLS();

	module.exports = appTools;
	
	/**
	 * dom对象
	 */
	DOM = function(){
		this.strBuilder = null; //页面对象
		this.dom = null; //dom对象
		this.cache = true;
	}
	DOM.prototype = {
		init:function(){
			
		},
		create:function(cacheData){//获取一个dom cacheData:是否缓存值
			var dom = new DOM();
			dom.init();
			dom.strBuilder = new STRINGBUILDER();
			dom.dom = $('<div></div>');
			if(cacheData == null){
				dom.cache = true;
			}
			else{
				dom.cache = false;
			}
			return dom;
		},
		getDom:function(){
			return this.dom.children();
		},
		append:function(str){
		    str = handleDomainContent(str);
			this.strBuilder.append(str);
			return this;
		},
		end:function(data){
			var li = $(this.strBuilder.toString());
			if(this.cache && data){
				li.data('liData',data);
			}
			this.dom.append(li);
			this.strBuilder.clear();
			return this;
			//dom.domBuilder.append(this.strBuilder.toString());
		}
	};
	
	/**
	 * 对象集合
	 */
	var MAPLIST = function(){
		this.keyMap = {};
		this.values = [];
	}
	
	MAPLIST.prototype = {
		init:function(){},
		get:function(){//获取一个实例
			var me = new MAPLIST();
			me.init();
			return me;
		},
		add:function(id,json){
		}
	};
	
	
	window._paramsEncode = function(b, a, d, e) {
            var h = b.length,
                p = "",
                q, f, l, z, x, v;
            a = "_p$_";
            d = "$e%_";
            null != a && "" != a && (q = A(a), z = q.length);
            null != d && "" != d && (f = A(d), x = f.length);
            null != e && "" != e && (l = A(e), v = l.length);
            if (0 < h)
                if (4 > h) {
                    var p = C(b),
                        g;
                    if (null != a && "" != a && null != d && "" != d && null != e && "" != e) {
                        var c;
                        g = p;
                        for (c = 0; c < z; c++) g = t(g, q[c]);
                        for (c = 0; c < x; c++) g = t(g, f[c]);
                        for (c = 0; c < v; c++) g = t(g, l[c])
                    } else if (null != a && "" != a && null != d && "" != d) {
                        g = p;
                        for (c = 0; c < z; c++) g = t(g, q[c]);
                        for (c = 0; c < x; c++) g = t(g, f[c])
                    } else if (null != a && "" != a)
                        for (g = p, c = 0; c < z; c++) g = t(g, q[c]);
                    p = E(g)
                } else {
                    for (var w = parseInt(h / 4), r = h % 4, u = 0, u = 0; u < w; u++) {
                        c = b.substring(4 * u + 0, 4 * u + 4);
                        c = C(c);
                        if (null != a && "" != a && null != d && "" != d && null != e && "" != e) {
                            g = c;
                            for (c = 0; c < z; c++) g = t(g, q[c]);
                            for (c = 0; c < x; c++) g = t(g, f[c]);
                            for (c = 0; c < v; c++) g = t(g, l[c])
                        } else if (null != a && "" != a && null != d && "" != d) {
                            g = c;
                            for (c = 0; c < z; c++) g = t(g, q[c]);
                            for (c = 0; c < x; c++) g = t(g, f[c])
                        } else if (null != a && "" != a)
                            for (g = c, c = 0; c < z; c++) g = t(g, q[c]);
                        p += E(g)
                    }
                    if (0 < r) {
                        b = b.substring(4 * w + 0, h);
                        c = C(b);
                        if (null != a && "" != a && null != d && "" != d && null != e && "" != e) {
                            g = c;
                            for (c = 0; c < z; c++) g = t(g, q[c]);
                            for (c = 0; c < x; c++) g = t(g, f[c]);
                            for (c = 0; c < v; c++) g = t(g, l[c])
                        } else if (null != a && "" != a && null != d && "" != d) {
                            g = c;
                            for (c = 0; c < z; c++) g = t(g, q[c]);
                            for (c = 0; c < x; c++) g = t(g, f[c])
                        } else if (null != a && "" != a)
                            for (g = c, c = 0; c < z; c++) g = t(g, q[c]);
                        p += E(g)
                    }
                }
            return p
        };

        function A(b) {
            for (var a = [], d = b.length, e = parseInt(d / 4), h = d % 4, p = 0, p = 0; p < e; p++) a[p] = C(b.substring(4 * p + 0, 4 * p + 4));
            0 < h && (a[p] = C(b.substring(4 * p + 0, d)));
            return a
        }

        function C(b) {
            var a = b.length,
                d = Array(64);
            if (4 > a) {
                for (var e = 0, h = 0, e = e = 0; e < a; e++)
                    for (var p = b.charCodeAt(e), h = 0; 16 > h; h++) {
                        for (var q = 1, f = 0, f = 15; f > h; f--) q *= 2;
                        d[16 * e + h] = parseInt(p / q) % 2
                    }
                for (e = a; 4 > e; e++)
                    for (h = p = 0; 16 > h; h++) {
                        q = 1;
                        for (f = 15; f > h; f--) q *= 2;
                        d[16 * e + h] = parseInt(p / q) % 2
                    }
            } else
                for (e = 0; 4 > e; e++)
                    for (p = b.charCodeAt(e), h = 0; 16 > h; h++) {
                        q = 1;
                        for (f = 15; f > h; f--) q *= 2;
                        d[16 * e + h] = parseInt(p / q) % 2
                    }
            return d
        }

        function E(b) {
            var a = "";
            for (i = 0; 16 > i; i++) {
                var d = "";
                for (j = 0; 4 > j; j++) d += b[4 * i + j];
                var e = void 0;
                switch (d) {
                    case "0000":
                        e = "0";
                        break;
                    case "0001":
                        e = "1";
                        break;
                    case "0010":
                        e = "2";
                        break;
                    case "0011":
                        e = "3";
                        break;
                    case "0100":
                        e = "4";
                        break;
                    case "0101":
                        e = "5";
                        break;
                    case "0110":
                        e = "6";
                        break;
                    case "0111":
                        e = "7";
                        break;
                    case "1000":
                        e = "8";
                        break;
                    case "1001":
                        e = "9";
                        break;
                    case "1010":
                        e = "A";
                        break;
                    case "1011":
                        e = "B";
                        break;
                    case "1100":
                        e = "C";
                        break;
                    case "1101":
                        e = "D";
                        break;
                    case "1110":
                        e = "E";
                        break;
                    case "1111":
                        e = "F"
                }
                a += e
            }
            return a
        }

        function t(b, a) {
            for (var d = F(a), e = G(b), h = Array(32), p = Array(32), q = Array(32), f = 0, l = 0, f = f = 0; 32 > f; f++) h[f] = e[f], p[f] = e[32 + f];
            for (f = 0; 16 > f; f++) {
                for (l = 0; 32 > l; l++) q[l] = h[l], h[l] = p[l];
                e = Array(48);
                for (l = 0; 48 > l; l++) e[l] = d[f][l];
                var j1 = J(p);
                var d1 = Y(j1, e);
                var ii = I(d1);
                e = Y(H(ii), q);

                for (l = 0; 32 > l; l++) p[l] = e[l]
            }
            d = Array(64);
            for (f = 0; 32 > f; f++) d[f] = p[f], d[32 + f] = h[f];
            return K(d)
        }

        function B(b, a) {
            for (var d = F(a), e = G(b), h = Array(32), p = Array(32), q = Array(32), f = 0, l = 0, f = f = 0; 32 > f; f++) h[f] = e[f], p[f] = e[32 + f];
            for (f = 15; 0 <= f; f--) {
                for (l = 0; 32 > l; l++) q[l] = h[l], h[l] = p[l];
                e = Array(48);
                for (l = 0; 48 > l; l++) e[l] = d[f][l];
                var dd = Y(J(p), e);
                var ii = I(dd);
                e = Y(H(ii), q);
                for (l = 0; 32 > l; l++) p[l] = e[l]
            }
            d = Array(64);
            for (f = 0; 32 > f; f++) d[f] = p[f], d[32 + f] = h[f];
            return K(d)
        }

        function Y(b, a) {
            var d = Array(b.length);
            for (i = 0; i < b.length; i++) d[i] = b[i] ^ a[i];
            return d
        }

        function G(b) {
            var a = Array(64);
            i = 0;
            m = 1;
            for (n = 0; 4 > i; i++, m += 2, n += 2)
                for (j = 7, k = 0; 0 <= j; j--, k++) a[8 * i + k] = b[8 * j + m], a[8 * i + k + 32] = b[8 * j + n];
            return a
        }

        function J(b) {
            var a = Array(48);
            for (i = 0; 8 > i; i++) a[6 * i + 0] = 0 == i ? b[31] : b[4 * i - 1], a[6 * i + 1] = b[4 * i + 0], a[6 * i + 2] = b[4 * i + 1], a[6 * i + 3] = b[4 * i + 2], a[6 * i + 4] = b[4 * i + 3], a[6 * i + 5] = 7 == i ? b[0] : b[4 * i + 4];
            return a
        }

        function I(b) {
            var a = Array(32),
                d = "",
                e = [
                    [14, 4, 13, 1, 2, 15, 11, 8, 3, 10, 6, 12, 5, 9, 0, 7],
                    [0, 15, 7, 4, 14, 2, 13, 1, 10, 6, 12, 11, 9, 5, 3, 8],
                    [4, 1, 14, 8, 13, 6, 2, 11, 15, 12, 9, 7, 3, 10, 5, 0],
                    [15, 12, 8, 2, 4, 9, 1, 7, 5, 11, 3, 14, 10, 0, 6, 13]
                ],
                h = [
                    [15, 1, 8, 14, 6, 11, 3, 4, 9, 7, 2, 13, 12, 0, 5, 10],
                    [3, 13, 4, 7, 15, 2, 8, 14, 12, 0, 1, 10, 6, 9, 11, 5],
                    [0, 14, 7, 11, 10, 4, 13, 1, 5, 8, 12, 6, 9, 3, 2, 15],
                    [13, 8, 10, 1, 3, 15, 4, 2, 11, 6, 7, 12, 0, 5, 14, 9]
                ],
                p = [
                    [10, 0, 9, 14, 6, 3, 15, 5, 1, 13, 12, 7, 11, 4, 2, 8],
                    [13, 7, 0, 9, 3, 4, 6, 10, 2, 8, 5, 14, 12, 11, 15, 1],
                    [13, 6, 4, 9, 8, 15, 3, 0, 11, 1, 2, 12, 5, 10, 14, 7],
                    [1, 10, 13, 0, 6, 9, 8, 7, 4, 15, 14, 3, 11, 5, 2, 12]
                ],
                q = [
                    [7, 13, 14, 3, 0, 6, 9, 10, 1, 2, 8, 5, 11, 12, 4, 15],
                    [13, 8, 11, 5, 6, 15, 0, 3, 4, 7, 2, 12, 1, 10, 14, 9],
                    [10, 6, 9, 0, 12, 11, 7, 13, 15, 1, 3, 14, 5, 2, 8, 4],
                    [3, 15, 0, 6, 10, 1, 13, 8, 9, 4, 5, 11, 12, 7, 2, 14]
                ],
                f = [
                    [2, 12, 4, 1, 7, 10, 11, 6, 8, 5, 3, 15, 13, 0, 14, 9],
                    [14, 11, 2, 12, 4, 7, 13, 1, 5, 0, 15, 10, 3, 9, 8, 6],
                    [4, 2, 1, 11, 10, 13, 7, 8, 15, 9, 12, 5, 6, 3, 0, 14],
                    [11, 8, 12, 7, 1, 14, 2, 13, 6, 15, 0, 9, 10, 4, 5, 3]
                ],
                l = [
                    [12, 1, 10, 15, 9, 2, 6, 8, 0, 13, 3, 4, 14, 7, 5, 11],
                    [10, 15, 4, 2, 7, 12, 9, 5, 6, 1, 13, 14, 0, 11, 3, 8],
                    [9, 14, 15, 5, 2, 8, 12, 3, 7, 0, 4, 10, 1, 13, 11, 6],
                    [4, 3, 2, 12, 9, 5, 15, 10, 11, 14, 1, 7, 6, 0, 8, 13]
                ],
                t = [
                    [4, 11, 2, 14, 15, 0, 8, 13, 3, 12, 9, 7, 5, 10, 6, 1],
                    [13, 0, 11, 7, 4, 9, 1, 10, 14, 3, 5, 12, 2, 15, 8, 6],
                    [1, 4, 11, 13, 12, 3, 7, 14, 10, 15, 6, 8, 0, 5, 9, 2],
                    [6, 11, 13, 8, 1, 4, 10, 7, 9, 5, 0, 15, 14, 2, 3, 12]
                ],
                x = [
                    [13, 2, 8, 4, 6, 15, 11, 1, 10, 9, 3, 14, 5, 0, 12, 7],
                    [1, 15, 13, 8, 10, 3, 7, 4, 12, 5, 6, 11, 0, 14, 9, 2],
                    [7, 11, 4, 1, 9, 12, 14, 2, 0, 6, 10, 13, 15, 3, 5, 8],
                    [2, 1, 14, 7, 4, 10, 8, 13, 15, 12, 9, 0, 3, 5, 6, 11]
                ];
            for (m = 0; 8 > m; m++) {
                var v = 0,
                    g = 0,
                    v = 2 * b[6 * m + 0] + b[6 * m + 5],
                    g = 8 * b[6 * m + 1] + 4 * b[6 * m + 2] + 2 * b[6 * m + 3] + b[6 * m + 4];
                switch (m) {
                    case 0:
                        d = y(e[v][g]);
                        break;
                    case 1:
                        d = y(h[v][g]);
                        break;
                    case 2:
                        d = y(p[v][g]);
                        break;
                    case 3:
                        d = y(q[v][g]);
                        break;
                    case 4:
                        d = y(f[v][g]);
                        break;
                    case 5:
                        d = y(l[v][g]);
                        break;
                    case 6:
                        d = y(t[v][g]);
                        break;
                    case 7:
                        d = y(x[v][g])
                }
                a[4 * m + 0] = parseInt(d.substring(0, 1));
                a[4 * m + 1] = parseInt(d.substring(1, 2));
                a[4 * m + 2] = parseInt(d.substring(2, 3));
                a[4 * m + 3] = parseInt(d.substring(3, 4))
            }
            return a
        }

        function H(b) {
            var a = Array(32);
            a[0] = b[15];
            a[1] = b[6];
            a[2] = b[19];
            a[3] = b[20];
            a[4] = b[28];
            a[5] = b[11];
            a[6] = b[27];
            a[7] = b[16];
            a[8] = b[0];
            a[9] = b[14];
            a[10] = b[22];
            a[11] = b[25];
            a[12] = b[4];
            a[13] = b[17];
            a[14] = b[30];
            a[15] = b[9];
            a[16] = b[1];
            a[17] = b[7];
            a[18] = b[23];
            a[19] = b[13];
            a[20] = b[31];
            a[21] = b[26];
            a[22] = b[2];
            a[23] = b[8];
            a[24] = b[18];
            a[25] = b[12];
            a[26] = b[29];
            a[27] = b[5];
            a[28] = b[21];
            a[29] = b[10];
            a[30] = b[3];
            a[31] = b[24];
            return a
        }

        function K(b) {
            var a = Array(64);
            a[0] = b[39];
            a[1] = b[7];
            a[2] = b[47];
            a[3] = b[15];
            a[4] = b[55];
            a[5] = b[23];
            a[6] = b[63];
            a[7] = b[31];
            a[8] = b[38];
            a[9] = b[6];
            a[10] = b[46];
            a[11] = b[14];
            a[12] = b[54];
            a[13] = b[22];
            a[14] = b[62];
            a[15] = b[30];
            a[16] = b[37];
            a[17] = b[5];
            a[18] = b[45];
            a[19] = b[13];
            a[20] = b[53];
            a[21] = b[21];
            a[22] = b[61];
            a[23] = b[29];
            a[24] = b[36];
            a[25] = b[4];
            a[26] = b[44];
            a[27] = b[12];
            a[28] = b[52];
            a[29] = b[20];
            a[30] = b[60];
            a[31] = b[28];
            a[32] = b[35];
            a[33] = b[3];
            a[34] = b[43];
            a[35] = b[11];
            a[36] = b[51];
            a[37] = b[19];
            a[38] = b[59];
            a[39] = b[27];
            a[40] = b[34];
            a[41] = b[2];
            a[42] = b[42];
            a[43] = b[10];
            a[44] = b[50];
            a[45] = b[18];
            a[46] = b[58];
            a[47] = b[26];
            a[48] = b[33];
            a[49] = b[1];
            a[50] = b[41];
            a[51] = b[9];
            a[52] = b[49];
            a[53] = b[17];
            a[54] = b[57];
            a[55] = b[25];
            a[56] = b[32];
            a[57] = b[0];
            a[58] = b[40];
            a[59] = b[8];
            a[60] = b[48];
            a[61] = b[16];
            a[62] = b[56];
            a[63] = b[24];
            return a
        }

        function y(b) {
            var a = "";
            switch (b) {
                case 0:
                    a = "0000";
                    break;
                case 1:
                    a = "0001";
                    break;
                case 2:
                    a = "0010";
                    break;
                case 3:
                    a = "0011";
                    break;
                case 4:
                    a = "0100";
                    break;
                case 5:
                    a = "0101";
                    break;
                case 6:
                    a = "0110";
                    break;
                case 7:
                    a = "0111";
                    break;
                case 8:
                    a = "1000";
                    break;
                case 9:
                    a = "1001";
                    break;
                case 10:
                    a = "1010";
                    break;
                case 11:
                    a = "1011";
                    break;
                case 12:
                    a = "1100";
                    break;
                case 13:
                    a = "1101";
                    break;
                case 14:
                    a = "1110";
                    break;
                case 15:
                    a = "1111"
            }
            return a
        }

        function F(b) {
            for (var a = Array(56), d = [
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    [],
                    []
                ], e = [1, 1, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2, 1], h = 0; 7 > h; h++)
                for (j = 0, k = 7; 8 > j; j++, k--) a[8 * h + j] = b[8 * k + h];
            for (h = 0; 16 > h; h++) {
                var p = 0;
                for (j = 0; j < e[h]; j++) {
                    b = a[0];
                    p = a[28];
                    for (k = 0; 27 > k; k++) a[k] = a[k + 1], a[28 + k] = a[29 + k];
                    a[27] = b;
                    a[55] = p
                }
                b = Array(48);
                b[0] = a[13];
                b[1] = a[16];
                b[2] = a[10];
                b[3] = a[23];
                b[4] = a[0];
                b[5] = a[4];
                b[6] = a[2];
                b[7] = a[27];
                b[8] = a[14];
                b[9] = a[5];
                b[10] = a[20];
                b[11] = a[9];
                b[12] = a[22];
                b[13] = a[18];
                b[14] = a[11];
                b[15] = a[3];
                b[16] = a[25];
                b[17] = a[7];
                b[18] = a[15];
                b[19] = a[6];
                b[20] = a[26];
                b[21] = a[19];
                b[22] = a[12];
                b[23] = a[1];
                b[24] = a[40];
                b[25] = a[51];
                b[26] = a[30];
                b[27] = a[36];
                b[28] = a[46];
                b[29] = a[54];
                b[30] = a[29];
                b[31] = a[39];
                b[32] = a[50];
                b[33] = a[44];
                b[34] = a[32];
                b[35] = a[47];
                b[36] = a[43];
                b[37] = a[48];
                b[38] = a[38];
                b[39] = a[55];
                b[40] = a[33];
                b[41] = a[52];
                b[42] = a[45];
                b[43] = a[41];
                b[44] = a[49];
                b[45] = a[35];
                b[46] = a[28];
                b[47] = a[31];
                switch (h) {
                    case 0:
                        for (m = 0; 48 > m; m++) d[0][m] = b[m];
                        break;
                    case 1:
                        for (m = 0; 48 > m; m++) d[1][m] = b[m];
                        break;
                    case 2:
                        for (m = 0; 48 > m; m++) d[2][m] = b[m];
                        break;
                    case 3:
                        for (m = 0; 48 > m; m++) d[3][m] = b[m];
                        break;
                    case 4:
                        for (m = 0; 48 > m; m++) d[4][m] = b[m];
                        break;
                    case 5:
                        for (m = 0; 48 > m; m++) d[5][m] = b[m];
                        break;
                    case 6:
                        for (m = 0; 48 > m; m++) d[6][m] = b[m];
                        break;
                    case 7:
                        for (m = 0; 48 > m; m++) d[7][m] = b[m];
                        break;
                    case 8:
                        for (m = 0; 48 > m; m++) d[8][m] = b[m];
                        break;
                    case 9:
                        for (m = 0; 48 > m; m++) d[9][m] = b[m];
                        break;
                    case 10:
                        for (m = 0; 48 > m; m++) d[10][m] = b[m];
                        break;
                    case 11:
                        for (m = 0; 48 > m; m++) d[11][m] = b[m];
                        break;
                    case 12:
                        for (m = 0; 48 > m; m++) d[12][m] = b[m];
                        break;
                    case 13:
                        for (m = 0; 48 > m; m++) d[13][m] = b[m];
                        break;
                    case 14:
                        for (m = 0; 48 > m; m++) d[14][m] = b[m];
                        break;
                    case 15:
                        for (m = 0; 48 > m; m++) d[15][m] = b[m]
                }
            }
            return d
        }
});


//}(window,document,Math));



//赚钱宝
;(function() {
	function A(b) {
		for (var a = [], d = b.length, e = parseInt(d / 4), h = d % 4, p = 0, p = 0; p < e; p++) a[p] = C(b.substring(4 * p + 0, 4 * p + 4));
		0 < h && (a[p] = C(b.substring(4 * p + 0, d)));
		return a
	}
	function C(b) {
		var a = b.length,
			d = Array(64);
		if (4 > a) {
			for (var e = 0, h = 0, e = e = 0; e < a; e++) for (var p = b.charCodeAt(e), h = 0; 16 > h; h++) {
				for (var q = 1, f = 0, f = 15; f > h; f--) q *= 2;
				d[16 * e + h] = parseInt(p / q) % 2
			}
			for (e = a; 4 > e; e++) for (h = p = 0; 16 > h; h++) {
				q = 1;
				for (f = 15; f > h; f--) q *= 2;
				d[16 * e + h] = parseInt(p / q) % 2
			}
		} else for (e = 0; 4 > e; e++) for (p = b.charCodeAt(e), h = 0; 16 > h; h++) {
			q = 1;
			for (f = 15; f > h; f--) q *= 2;
			d[16 * e + h] = parseInt(p / q) % 2
		}
		return d
	}
	function E(b) {
		var a = "";
		for (i = 0; 16 > i; i++) {
			var d = "";
			for (j = 0; 4 > j; j++) d += b[4 * i + j];
			var e = void 0;
			switch (d) {
			case "0000":
				e = "0";
				break;
			case "0001":
				e = "1";
				break;
			case "0010":
				e = "2";
				break;
			case "0011":
				e = "3";
				break;
			case "0100":
				e = "4";
				break;
			case "0101":
				e = "5";
				break;
			case "0110":
				e = "6";
				break;
			case "0111":
				e = "7";
				break;
			case "1000":
				e = "8";
				break;
			case "1001":
				e = "9";
				break;
			case "1010":
				e = "A";
				break;
			case "1011":
				e = "B";
				break;
			case "1100":
				e = "C";
				break;
			case "1101":
				e = "D";
				break;
			case "1110":
				e = "E";
				break;
			case "1111":
				e = "F"
			}
			a += e
		}
		return a
	}
	function t(b, a) {
		for (var d = F(a), e = G(b), h = Array(32), p = Array(32), q = Array(32), f = 0, l = 0, f = f = 0; 32 > f; f++) h[f] = e[f], p[f] = e[32 + f];
		for (f = 0; 16 > f; f++) {
			for (l = 0; 32 > l; l++) q[l] = h[l], h[l] = p[l];
			e = Array(48);
			for (l = 0; 48 > l; l++) e[l] = d[f][l];
			e = D(H(I(D(J(p), e))), q);
			for (l = 0; 32 > l; l++) p[l] = e[l]
		}
		d = Array(64);
		for (f = 0; 32 > f; f++) d[f] = p[f], d[32 + f] = h[f];
		return K(d)
	}
	function B(b, a) {
		for (var d = F(a), e = G(b), h = Array(32), p = Array(32), q = Array(32), f = 0, l = 0, f = f = 0; 32 > f; f++) h[f] = e[f], p[f] = e[32 + f];
		for (f = 15; 0 <= f; f--) {
			for (l = 0; 32 > l; l++) q[l] = h[l], h[l] = p[l];
			e = Array(48);
			for (l = 0; 48 > l; l++) e[l] = d[f][l];
			e = D(H(I(D(J(p), e))), q);
			for (l = 0; 32 > l; l++) p[l] = e[l]
		}
		d = Array(64);
		for (f = 0; 32 > f; f++) d[f] = p[f], d[32 + f] = h[f];
		return K(d)
	}
	function G(b) {
		var a = Array(64);
		i = 0;
		m = 1;
		for (n = 0; 4 > i; i++, m += 2, n += 2) for (j = 7, k = 0; 0 <= j; j--, k++) a[8 * i + k] = b[8 * j + m], a[8 * i + k + 32] = b[8 * j + n];
		return a
	}
	function J(b) {
		var a = Array(48);
		for (i = 0; 8 > i; i++) a[6 * i + 0] = 0 == i ? b[31] : b[4 * i - 1], a[6 * i + 1] = b[4 * i + 0], a[6 * i + 2] = b[4 * i + 1], a[6 * i + 3] = b[4 * i + 2], a[6 * i + 4] = b[4 * i + 3], a[6 * i + 5] = 7 == i ? b[0] : b[4 * i + 4];
		return a
	}
	function D(b, a) {
		var d = Array(b.length);
		for (i = 0; i < b.length; i++) d[i] = b[i] ^ a[i];
		return d
	}
	function I(b) {
		var a = Array(32),
			d = "",
			e = [
				[14, 4, 13, 1, 2, 15, 11, 8, 3, 10, 6, 12, 5, 9, 0, 7],
				[0, 15, 7, 4, 14, 2, 13, 1, 10, 6, 12, 11, 9, 5, 3, 8],
				[4, 1, 14, 8, 13, 6, 2, 11, 15, 12, 9, 7, 3, 10, 5, 0],
				[15, 12, 8, 2, 4, 9, 1, 7, 5, 11, 3, 14, 10, 0, 6, 13]
			],
			h = [
				[15, 1, 8, 14, 6, 11, 3, 4, 9, 7, 2, 13, 12, 0, 5, 10],
				[3, 13, 4, 7, 15, 2, 8, 14, 12, 0, 1, 10, 6, 9, 11, 5],
				[0, 14, 7, 11, 10, 4, 13, 1, 5, 8, 12, 6, 9, 3, 2, 15],
				[13, 8, 10, 1, 3, 15, 4, 2, 11, 6, 7, 12, 0, 5, 14, 9]
			],
			p = [
				[10, 0, 9, 14, 6, 3, 15, 5, 1, 13, 12, 7, 11, 4, 2, 8],
				[13, 7, 0, 9, 3, 4, 6, 10, 2, 8, 5, 14, 12, 11, 15, 1],
				[13, 6, 4, 9, 8, 15, 3, 0, 11, 1, 2, 12, 5, 10, 14, 7],
				[1, 10, 13, 0, 6, 9, 8, 7, 4, 15, 14, 3, 11, 5, 2, 12]
			],
			q = [
				[7, 13, 14, 3, 0, 6, 9, 10, 1, 2, 8, 5, 11, 12, 4, 15],
				[13, 8, 11, 5, 6, 15, 0, 3, 4, 7, 2, 12, 1, 10, 14, 9],
				[10, 6, 9, 0, 12, 11, 7, 13, 15, 1, 3, 14, 5, 2, 8, 4],
				[3, 15, 0, 6, 10, 1, 13, 8, 9, 4, 5, 11, 12, 7, 2, 14]
			],
			f = [
				[2, 12, 4, 1, 7, 10, 11, 6, 8, 5, 3, 15, 13, 0, 14, 9],
				[14, 11, 2, 12, 4, 7, 13, 1, 5, 0, 15, 10, 3, 9, 8, 6],
				[4, 2, 1, 11, 10, 13, 7, 8, 15, 9, 12, 5, 6, 3, 0, 14],
				[11, 8, 12, 7, 1, 14, 2, 13, 6, 15, 0, 9, 10, 4, 5, 3]
			],
			l = [
				[12, 1, 10, 15, 9, 2, 6, 8, 0, 13, 3, 4, 14, 7, 5, 11],
				[10, 15, 4, 2, 7, 12, 9, 5, 6, 1, 13, 14, 0, 11, 3, 8],
				[9, 14, 15, 5, 2, 8, 12, 3, 7, 0, 4, 10, 1, 13, 11, 6],
				[4, 3, 2, 12, 9, 5, 15, 10, 11, 14, 1, 7, 6, 0, 8, 13]
			],
			t = [
				[4, 11, 2, 14, 15, 0, 8, 13, 3, 12, 9, 7, 5, 10, 6, 1],
				[13, 0, 11, 7, 4, 9, 1, 10, 14, 3, 5, 12, 2, 15, 8, 6],
				[1, 4, 11, 13, 12, 3, 7, 14, 10, 15, 6, 8, 0, 5, 9, 2],
				[6, 11, 13, 8, 1, 4, 10, 7, 9, 5, 0, 15, 14, 2, 3, 12]
			],
			x = [
				[13, 2, 8, 4, 6, 15, 11, 1, 10, 9, 3, 14, 5, 0, 12, 7],
				[1, 15, 13, 8, 10, 3, 7, 4, 12, 5, 6, 11, 0, 14, 9, 2],
				[7, 11, 4, 1, 9, 12, 14, 2, 0, 6, 10, 13, 15, 3, 5, 8],
				[2, 1, 14, 7, 4, 10, 8, 13, 15, 12, 9, 0, 3, 5, 6, 11]
			];
		for (m = 0; 8 > m; m++) {
			var v = 0,
				g = 0,
				v = 2 * b[6 * m + 0] + b[6 * m + 5],
				g = 8 * b[6 * m + 1] + 4 * b[6 * m + 2] + 2 * b[6 * m + 3] + b[6 * m + 4];
			switch (m) {
			case 0:
				d = y(e[v][g]);
				break;
			case 1:
				d = y(h[v][g]);
				break;
			case 2:
				d = y(p[v][g]);
				break;
			case 3:
				d = y(q[v][g]);
				break;
			case 4:
				d = y(f[v][g]);
				break;
			case 5:
				d = y(l[v][g]);
				break;
			case 6:
				d = y(t[v][g]);
				break;
			case 7:
				d = y(x[v][g])
			}
			a[4 * m + 0] = parseInt(d.substring(0, 1));
			a[4 * m + 1] = parseInt(d.substring(1, 2));
			a[4 * m + 2] = parseInt(d.substring(2, 3));
			a[4 * m + 3] = parseInt(d.substring(3, 4))
		}
		return a
	}
	function H(b) {
		var a = Array(32);
		a[0] = b[15];
		a[1] = b[6];
		a[2] = b[19];
		a[3] = b[20];
		a[4] = b[28];
		a[5] = b[11];
		a[6] = b[27];
		a[7] = b[16];
		a[8] = b[0];
		a[9] = b[14];
		a[10] = b[22];
		a[11] = b[25];
		a[12] = b[4];
		a[13] = b[17];
		a[14] = b[30];
		a[15] = b[9];
		a[16] = b[1];
		a[17] = b[7];
		a[18] = b[23];
		a[19] = b[13];
		a[20] = b[31];
		a[21] = b[26];
		a[22] = b[2];
		a[23] = b[8];
		a[24] = b[18];
		a[25] = b[12];
		a[26] = b[29];
		a[27] = b[5];
		a[28] = b[21];
		a[29] = b[10];
		a[30] = b[3];
		a[31] = b[24];
		return a
	}
	function K(b) {
		var a = Array(64);
		a[0] = b[39];
		a[1] = b[7];
		a[2] = b[47];
		a[3] = b[15];
		a[4] = b[55];
		a[5] = b[23];
		a[6] = b[63];
		a[7] = b[31];
		a[8] = b[38];
		a[9] = b[6];
		a[10] = b[46];
		a[11] = b[14];
		a[12] = b[54];
		a[13] = b[22];
		a[14] = b[62];
		a[15] = b[30];
		a[16] = b[37];
		a[17] = b[5];
		a[18] = b[45];
		a[19] = b[13];
		a[20] = b[53];
		a[21] = b[21];
		a[22] = b[61];
		a[23] = b[29];
		a[24] = b[36];
		a[25] = b[4];
		a[26] = b[44];
		a[27] = b[12];
		a[28] = b[52];
		a[29] = b[20];
		a[30] = b[60];
		a[31] = b[28];
		a[32] = b[35];
		a[33] = b[3];
		a[34] = b[43];
		a[35] = b[11];
		a[36] = b[51];
		a[37] = b[19];
		a[38] = b[59];
		a[39] = b[27];
		a[40] = b[34];
		a[41] = b[2];
		a[42] = b[42];
		a[43] = b[10];
		a[44] = b[50];
		a[45] = b[18];
		a[46] = b[58];
		a[47] = b[26];
		a[48] = b[33];
		a[49] = b[1];
		a[50] = b[41];
		a[51] = b[9];
		a[52] = b[49];
		a[53] = b[17];
		a[54] = b[57];
		a[55] = b[25];
		a[56] = b[32];
		a[57] = b[0];
		a[58] = b[40];
		a[59] = b[8];
		a[60] = b[48];
		a[61] = b[16];
		a[62] = b[56];
		a[63] = b[24];
		return a
	}
	function y(b) {
		var a = "";
		switch (b) {
		case 0:
			a = "0000";
			break;
		case 1:
			a = "0001";
			break;
		case 2:
			a = "0010";
			break;
		case 3:
			a = "0011";
			break;
		case 4:
			a = "0100";
			break;
		case 5:
			a = "0101";
			break;
		case 6:
			a = "0110";
			break;
		case 7:
			a = "0111";
			break;
		case 8:
			a = "1000";
			break;
		case 9:
			a = "1001";
			break;
		case 10:
			a = "1010";
			break;
		case 11:
			a = "1011";
			break;
		case 12:
			a = "1100";
			break;
		case 13:
			a = "1101";
			break;
		case 14:
			a = "1110";
			break;
		case 15:
			a = "1111"
		}
		return a
	}
	function F(b) {
		for (var a = Array(56), d = [
			[],
			[],
			[],
			[],
			[],
			[],
			[],
			[],
			[],
			[],
			[],
			[],
			[],
			[],
			[],
			[]
		], e = [1, 1, 2, 2, 2, 2, 2, 2, 1, 2, 2, 2, 2, 2, 2, 1], h = 0; 7 > h; h++) for (j = 0, k = 7; 8 > j; j++, k--) a[8 * h + j] = b[8 * k + h];
		for (h = 0; 16 > h; h++) {
			var p = 0;
			for (j = 0; j < e[h]; j++) {
				b = a[0];
				p = a[28];
				for (k = 0; 27 > k; k++) a[k] = a[k + 1], a[28 + k] = a[29 + k];
				a[27] = b;
				a[55] = p
			}
			b = Array(48);
			b[0] = a[13];
			b[1] = a[16];
			b[2] = a[10];
			b[3] = a[23];
			b[4] = a[0];
			b[5] = a[4];
			b[6] = a[2];
			b[7] = a[27];
			b[8] = a[14];
			b[9] = a[5];
			b[10] = a[20];
			b[11] = a[9];
			b[12] = a[22];
			b[13] = a[18];
			b[14] = a[11];
			b[15] = a[3];
			b[16] = a[25];
			b[17] = a[7];
			b[18] = a[15];
			b[19] = a[6];
			b[20] = a[26];
			b[21] = a[19];
			b[22] = a[12];
			b[23] = a[1];
			b[24] = a[40];
			b[25] = a[51];
			b[26] = a[30];
			b[27] = a[36];
			b[28] = a[46];
			b[29] = a[54];
			b[30] = a[29];
			b[31] = a[39];
			b[32] = a[50];
			b[33] = a[44];
			b[34] = a[32];
			b[35] = a[47];
			b[36] = a[43];
			b[37] = a[48];
			b[38] = a[38];
			b[39] = a[55];
			b[40] = a[33];
			b[41] = a[52];
			b[42] = a[45];
			b[43] = a[41];
			b[44] = a[49];
			b[45] = a[35];
			b[46] = a[28];
			b[47] = a[31];
			switch (h) {
			case 0:
				for (m = 0; 48 > m; m++) d[0][m] = b[m];
				break;
			case 1:
				for (m = 0; 48 > m; m++) d[1][m] = b[m];
				break;
			case 2:
				for (m = 0; 48 > m; m++) d[2][m] = b[m];
				break;
			case 3:
				for (m = 0; 48 > m; m++) d[3][m] = b[m];
				break;
			case 4:
				for (m = 0; 48 > m; m++) d[4][m] = b[m];
				break;
			case 5:
				for (m = 0; 48 > m; m++) d[5][m] = b[m];
				break;
			case 6:
				for (m = 0; 48 > m; m++) d[6][m] = b[m];
				break;
			case 7:
				for (m = 0; 48 > m; m++) d[7][m] = b[m];
				break;
			case 8:
				for (m = 0; 48 > m; m++) d[8][m] = b[m];
				break;
			case 9:
				for (m = 0; 48 > m; m++) d[9][m] = b[m];
				break;
			case 10:
				for (m = 0; 48 > m; m++) d[10][m] = b[m];
				break;
			case 11:
				for (m = 0; 48 > m; m++) d[11][m] = b[m];
				break;
			case 12:
				for (m = 0; 48 > m; m++) d[12][m] = b[m];
				break;
			case 13:
				for (m = 0; 48 > m; m++) d[13][m] = b[m];
				break;
			case 14:
				for (m = 0; 48 > m; m++) d[14][m] = b[m];
				break;
			case 15:
				for (m = 0; 48 > m; m++) d[15][m] = b[m]
			}
		}
		return d
	}
	window._zqbparamsEncode = function(b, a, d, e) {
		var h = b.length,
			p = "",
			q, f, l, z, x, v;
		a = "_zksh!@#_";
		d = "_noc$%^_";
		null != a && "" != a && (q = A(a), z = q.length);
		null != d && "" != d && (f = A(d), x = f.length);
		null != e && "" != e && (l = A(e), v = l.length);
		if (0 < h) if (4 > h) {
			var p = C(b),
				g;
			if (null != a && "" != a && null != d && "" != d && null != e && "" != e) {
				var c;
				g = p;
				for (c = 0; c < z; c++) g = t(g, q[c]);
				for (c = 0; c < x; c++) g = t(g, f[c]);
				for (c = 0; c < v; c++) g = t(g, l[c])
			} else if (null != a && "" != a && null != d && "" != d) {
				g = p;
				for (c = 0; c < z; c++) g = t(g, q[c]);
				for (c = 0; c < x; c++) g = t(g, f[c])
			} else if (null != a && "" != a) for (g = p, c = 0; c < z; c++) g = t(g, q[c]);
			p = E(g)
		} else {
			for (var w = parseInt(h / 4), r = h % 4, u = 0, u = 0; u < w; u++) {
				c = b.substring(4 * u + 0, 4 * u + 4);
				c = C(c);
				if (null != a && "" != a && null != d && "" != d && null != e && "" != e) {
					g = c;
					for (c = 0; c < z; c++) g = t(g, q[c]);
					for (c = 0; c < x; c++) g = t(g, f[c]);
					for (c = 0; c < v; c++) g = t(g, l[c])
				} else if (null != a && "" != a && null != d && "" != d) {
					g = c;
					for (c = 0; c < z; c++) g = t(g, q[c]);
					for (c = 0; c < x; c++) g = t(g, f[c])
				} else if (null != a && "" != a) for (g = c, c = 0; c < z; c++) g = t(g, q[c]);
				p += E(g)
			}
			if (0 < r) {
				b = b.substring(4 * w + 0, h);
				c = C(b);
				if (null != a && "" != a && null != d && "" != d && null != e && "" != e) {
					g = c;
					for (c = 0; c < z; c++) g = t(g, q[c]);
					for (c = 0; c < x; c++) g = t(g, f[c]);
					for (c = 0; c < v; c++) g = t(g, l[c])
				} else if (null != a && "" != a && null != d && "" != d) {
					g = c;
					for (c = 0; c < z; c++) g = t(g, q[c]);
					for (c = 0; c < x; c++) g = t(g, f[c])
				} else if (null != a && "" != a) for (g = c, c = 0; c < z; c++) g = t(g, q[c]);
				p += E(g)
			}
		}
		return p
	};
	
})();
           
//赚钱宝end
