/**
 * @autor Grahor
 * ui模块 exports ui
 */
;APPBASE.define('ui',function(require, exports, module){
	var tool = require('tool');
	var main = require('main');
	var page = require('page');
	var validate = tool.validate;
	
	//ui对象模块
	var UI = function(){
		this.uis = {};	//uis
		this.loadPage = 'loadBodyPage';
		this.currentUIShow = '';
	};
	
	//ui对象方法定义
	UI.prototype = {
		init:function(){
		},
		getUID:function(name){
			return name.replace(/[.]/g,'').toUpperCase();
			//return tool.util.encrypt(name);
		},
		add:function(name,ui){//添加ui
			var log = tool.log;
			var validate = tool.validate;
			if(validate.isNull(name)){
				return;
			}
			var uiObj;
			if(name.indexOf('.') >= 0){
				var keys = name.split('.');
				uiObj = this.uis;
				for(var i = 0; i < keys.length; i++){
					if(validate.isNull(uiObj[keys[i]])){
						uiObj[keys[i]] = {};
					}
					uiObj = uiObj[keys[i]];
				}
			}
			else{
				uiObj = this.uis[name];
			}
			if(validate.isNull(uiObj) || "{}" == JSON.stringify(uiObj)){
				uiObj.uiFunc = ui;
				log.log('ui添加成功，name[' + name + ']！');
			}
			else{
				log.log('ui添加失败，name[' + name + ']已存在！');
			}
		},
		replace:function(name,ui){//重写ui
			var log = tool.log;
			var validate = tool.validate;
			var uiObj;
			if(name.indexOf('.') >= 0){
				var keys = name.split('.');
				uiObj = this.uis;
				var key;
				var len = keys.length;
				for(var i = 0; i < len; i++){
					key = keys[i];
					if(validate.isNull(uiObj[key])){
						uiObj[key] = {};
					}
					uiObj = uiObj[key];
				}
			}
			else{
				uiObj = {};
				this.uis[name] = uiObj;
			}
			uiObj.uiFunc = ui;
			log.log('重写ui成功，name[' + name + ']！');
		},
		ui:function(name,data,data1){//调用ui
			$('div.ui-page-active').find('input').blur();
			var validate = tool.validate;
			if(validate.isFunction(data)){
				this.addUi(name,data);
				data = data1;
			}
			var func = this.uis[name];
			if(name.indexOf('.') >= 0){
				var keys = name.split('.');
				var uiObj = this.uis;
				var key,len = keys.length;
				for(var i = 0; i < len; i++){
					key = keys[i];
					if(i < len - 1){
						uiObj = uiObj[key];
					}
					else{
						if(validate.isNull(uiObj[key])){
							func = null;
						}
						else{
							func = uiObj[key].uiFunc;
						}
					}
				}
			}
			if(validate.isNotNull(func)){
				this.currentUIShow = name;
				return func(data,this.getUID(name));
			}
		},
		getActivePage:function(){
			return $('#' + page.pageContainer).pagecontainer('getActivePage');
		},
		addUIDOM:function(obj){
			$('#' + page.pageContainer).append(obj);//$('#' + page.pageContainer).find('div[data-role=content]').append(obj);
		},
		show:function(name,data){
			$('div.ui-page-active').find('input').blur();
			this.ui(name,data);
			var uid = this.getUID(name);
			this.currentUIShow = name;
			$('#' + uid).show();
		},
		hide:function(name){
			var uid = this.getUID(name);
			this.currentUIShow = '';
			$("#" + uid).hide();
		},
		alertList:function(title,list,key,curValue,callback){//通用弹框列表
			this.ui('common.alertList',{title:title,list:list,callback:callback,key:key,curValue:curValue});
		},
		behaviorCode:function(option,uiName){			
		    var main = APP.main;
		    var ui = APP.ui;
		    var tool = APP.tool;
		    var id = ui.getUID(uiName);
		    var div = $('#' + id);
		    var validate = tool.validate;
		    var maxT = 72;//高度最大值
		    var minT = 13;//高度最小值
		    var rangeT = maxT - minT;//高度范围
		    this.flag = true;//验证标记
		    this.checkCode = "";//已选择的文字
		    this.threeCode = "";//需要选择的文字
		    this.fiveCode = "";//全部文字
		    //验证方法
		    var isRight = function(){
		        flag = true;
		        for(var i = 0;i < threeCode.length;i++){
		            if(checkCode.indexOf(threeCode.charAt(i)) < 0 ){
		                flag = false
		                break;
		            }
		        }
		        return flag;
		    }
		    //加载全部文字
		    var loadLI = function(){
		        var str = "";
		        for(var i = 0;i < fiveCode.length;i++){
		            var maxL = (i+1)*17 -3;
		            var minL = i*17 + 4;
		            var left = parseInt(Math.random() * (maxL - minL) + minL);
		            var top = parseInt(Math.random() * (rangeT) + minT); //四舍五入
		            var rotate = parseInt(Math.random()*100);
		            str+='<li class="o2 weight c4" style="top:'+top+'%;left:'+left+'%;">';
		            str+='  <div class="o1">';
		            str+='      <span class="c4" style="font-size:1.7em;color:#171717;transform:rotate(-'+rotate+'deg);">'+fiveCode.charAt(i)+'</span>';
		            str+='      <img src="'+ handleDomainContent("http://wapjs.189.cn/tysh/pages/common/images/loginPitch.png") +'" class="o2 k17 c1" style="top:27%;left:10%;">';
		            str+='  </div>';    
		            str+='</li>';
		        }
		        return str
		    }
		    //加载需要点击文字
		    var loadCheckDiv = function(){
		        var str = '<span style="font-size:0.95em;color:#666;">请点击</span>';
		        for(var i = 0;i < threeCode.length;i++){
		            str+='<span class="weight threeCode" style="font-size:0.95em;color:#3d4245;">“'+threeCode.charAt(i)+'”</span>';
		        }
		        str+='<span style="font-size:0.95em;color:#666;">完成验证</span>';
		        return str
		    }
		    var loadDiv = function(){
		        var domJQ = tool.dom.create();
		        domJQ.append('<div id="').append(id).append('" class="blackBg" style="z-index:9;">');
		        domJQ.append('  <div class="k16 h1 white o1 l1 l5 l10 l14" style="margin:40% auto 0">');
		        domJQ.append('      <div class="m1 b1 checkDiv">');
		        //domJQ.append(loadcheckDiv());
		        domJQ.append('      </div>');
		        domJQ.append('      <div class="o1 d1 h2 r1">');
		        domJQ.append('          <img src="'+ handleDomainContent("http://wapjs.189.cn/tysh/pages/common/images/loginyzImg.png") +'" class="k20">');
		        domJQ.append('          <div class="o2 l24 p1 p4 c4 m3 k3 refresh" style="z-index:10;">');
		        domJQ.append('              <img src="'+ handleDomainContent("http://wapjs.189.cn/tysh/pages/common/images/loginBreak.png") +'" class="k15">');
		        domJQ.append('          </div>');
		        domJQ.append('          <ul class="o2 p1 p2 p3 p4" style="z-index:9;">');
		        //domJQ.append(loadLI());
		        domJQ.append('          </ul>');
		        domJQ.append('      </div>');
		        domJQ.append('  </div>');
		        domJQ.append('  <div class="m1 d2 colse">');
		        domJQ.append('      <img src="'+ handleDomainContent("http://wapjs.189.cn/tysh/pages/common/images/loginClosed.png") +'" style="width:13%;">');
		        domJQ.append('  </div>');
		        domJQ.append('</div>').end();
		        div = domJQ.getDom();
		        ui.addUIDOM(div);
		    }
		    if (validate.isNull(div[0])) {
		        loadDiv();
		    }else{
		        var tList = div.find(".threeCode");
		        for(var i = 0; i<tList.length;  i++){
		            $(tList[i]).html('')
		        }
		        
		        var liList = div.find("li");
		        for(var i = 0; i<liList.length;  i++){
		            $(liList[i]).find("span").html('');
		        }
		    }
		    main.onClick(div.find(".colse"),function(e){
		        ui.hide(uiName,option);
		    });
		    main.onClick(div.find(".refresh"),function(e){
		        getCode(option.accNbr);
		    });
		    main.onListClick(div.find("ul"),function(targrt,tagName){
		        if(tagName == "li"){
		            var cImg = $(div.find("ul")).find(".c1");
		            if(cImg.length == 2) return;
		            if(cImg.length >= 3){
		                var img = $(targrt).find("img");
		                if($(img).hasClass("c1")){
		                    $(img).removeClass("c1");
		                    checkCode += $(targrt).find("span").html();
		                }else{
		                    $(img).addClass("c1");
		                    var temp = $(targrt).find("span").html();
		                    checkCode = checkCode.replace(temp,"");
		                }
		            }
		            cImg = $(div.find("ul")).find(".c1");
		            if(cImg.length == 2){
		                if(isRight()){
		                    option.success && option.success({code:"0",checkCode:checkCode,content:""});
		                }else{
		                    getCode(option.accNbr);
		                    option.fail && option.fail({code:"0",checkCode:checkCode,content:"验证失败"});
		                }
		            }
		        }
		    },"li");
		    //获取图形验证码
		    var getCode = function (accNbr){
		        var interf  = APP.interf;
		        var main = APP.main;
		        var ui  = APP.ui;
		        var tool =  APP.tool;
		        var params = tool.param; 
		        var paramInit = params.get(); 
		        paramInit.add("accNbr",accNbr); 
		        paramInit.add("PathCode","login-000010");
		        div.find(".k17").addClass("c1");
		        interf.invoke({ 
		            url:"/welcome",
		            param:paramInit.value(),
		            type:'ztlogin',
		            pathCode:"login-000010",
		            actionCode:'dt001',
		            success:function(data){ 
		                checkCode = "";
		                threeCode = data.threeCode;
		                fiveCode = data.fiveCode;
		                $(div.find("ul")).html(loadLI());
		                $(div.find(".checkDiv")).html(loadCheckDiv());
		            },fail:function(data){
		                // 

		            },error:function(data){
		                // 
		            }
		        });
		    }
		    getCode(option.accNbr);
		}
	};
	
	var ui = new UI();
	
	module.exports = ui;
	
});

