/**
 * 应用系统（操作底层）相关js
 */
(function () {
    window.supportTouch = "ontouchstart" in window;
    START_EV = window.supportTouch ? "touchstart" : "mousedown";
    MOVE_EV = window.supportTouch ? "touchmove" : "mousemove";
    END_EV = window.supportTouch ? "touchend" : "mouseup";
})();
var tt = false;
$.fn.addEventListener = function (eventType, handler, args, tscallback, tecallback) {
    if (eventType == "quickClick") {
        this.each(function () {
            this.addEventListener(START_EV, domQuickClickTS);
        });
    }
    this.each(function () {
        $(this).data(eventType, [handler, args, tscallback, tecallback]);
    });
}

function domQuickClickTS(e) {
    if (!$(e.currentTarget).data("quickClick")) {
        return;
    }
    var tscallback = $(e.currentTarget).data("quickClick")[2];
    if (tscallback)
        tscallback.call(window, e.currentTarget, e.target);

    e.currentTarget.addEventListener(END_EV, domQuickClickTE);

    var point = window.supportTouch ? e.touches[0] : e;
    $(e.currentTarget).data("startY", point.clientY);
    $(e.currentTarget).data("startX", point.clientX);
    $(e.currentTarget).data("startTime", new Date());
    //e.preventDefault();
    return;
}

function domQuickClickTE(e) {
    if (!$(e.currentTarget).data("quickClick")) {
        return;
    }
    var tecallback = $(e.currentTarget).data("quickClick")[3];
    if (tecallback)
        tecallback.call(window, e.currentTarget, e.target);
    e.currentTarget.removeEventListener(END_EV, domQuickClickTE);
    var touchStartY = $(e.currentTarget).data("startY"), touchStartX = $(e.currentTarget).data("startX");
    var point = window.supportTouch ? e.changedTouches[0] : e;
    var startTime = $(e.currentTarget).data("startTime"), endTime = new Date();
    if (Math.abs(point.clientX - touchStartX) < 10 && Math.abs(point.clientY - touchStartY) < 10) {
        if (endTime.getTime() - startTime.getTime() > 500)
            return;
        var eventTarget = e.currentTarget;
        if ($(eventTarget).data("quickClick")) {
            var event = createEvent(e, "quickClick");
            event.currentTarget = eventTarget;
            var args = $(eventTarget).data("quickClick")[1];
            if (args) {
                $(eventTarget).data("quickClick")[0].apply(window, [event].concat(args));
            } else {
                $(eventTarget).data("quickClick")[0].call(window, event);
            }
            if (!event.propagation)
                e.stopPropagation();
        }
    }
    //e.preventDefault();
    return;
}

function createEvent(e, type) {
    var point = window.supportTouch ? e.changedTouches[0] : e, event = {};
    event.type = type;
    event.target = e.target;
    event.clientX = point.clientX;
    event.clientY = point.clientY;
    event.propagation = true;
    event.stopPropagation = function () {
        event.propagation = false;
    }
    return event;
}

$.fn.removeEventListener = function (eventType) {
    this.removeData(eventType);
}

;
APPBASE.define('underly', function (require, exports, module) {
    var tool = require('tool'), config = require('config'), ui = require('ui');
    var underly;//底层对象
    var share; //分享对象
    var contact; //通讯录对象
    var record; //历史记录对象
    var floatDesktop;//悬浮框对象

    var UNDERLY = function () {
        this.device = null; //设备信息对象
        this.downloadCache = null; //下载缓存进程
        this.browserUserAgent = ''; //浏览器引擎
        this.util = {
            share: null, //分享对象
            contact: null, //通讯录对象
            record: null, //历史记录对象
            floatDesktop: null, //悬浮框对象
            idUploader: null //id上传
        }
    };

    UNDERLY.prototype = {
        init: function () {//初始化
            var validate = tool.validate;
            if (validate.isNotNull(navigator) && validate.isNotNull(navigator.userAgent)) {
                this.browserUserAgent = navigator.userAgent;
            } else {
                this.browserUserAgent = null;
            }
            setTimeout(function () {
                share && share.init();
                // contact && contact.init();
                record && record.init();
                floatDesktop && floatDesktop.init();
                idUploader && idUploader.init();
            }, 1000);
            this.util.share = share;
            this.util.contact = contact;
            this.util.record = record;
            this.util.floatDesktop = floatDesktop;
            this.util.idUploader = idUploader;
        },
        browser: function () {//获取浏览器引擎
            var userAgent = this.browserUserAgent;
            if (tool.validate.isNotNull(userAgent)) {
                userAgent = userAgent.toLowerCase();
            } else {
                userAgent = '';
            }
            return {
                weixin: function () {
                    return userAgent.match(/MicroMessenger/i) == 'micromessenger';
                },
                yixin: function () {
                    return userAgent.match(/yixin/i) == 'yixin';
                },
                qq: function () {
                    return userAgent.match(/QQ/i) == 'qq';
                },
                uc: function () {
                    return userAgent.match(/ucbrowser/i) == 'ucbrowser';
                }
            };
        },
        isBrowserCanBlank: function () {
            var browser = this.browser();
            if (browser.weixin() || browser.qq() || browser.uc() || browser.yixin()) {
                return false;
            }
            return true;
        },
        openBrowser: function (url, title, succ, fail,backjs,isNotShowTitle) {
            url = handleDomainContent(url);
            if(url.indexOf("www.go189.cn")>-1){
                APP.page.changePage("http://wapjs.189.cn/tysh/pages/xiaxian/xaixian_ty.html")
                return;
            }
            if (APP.config.platform == 'APP') {
                navigator.browser.open({
                    url:url,
                    title:title,
                    backjs:backjs,
                    isNotShowTitle:isNotShowTitle,
                    startLoad:function(){
                    },
                    loading:function(progress){
                    },
                    finishLoad:function(){
                    },
                    close:function(){
                    },
                    errorLoad:function(){
                    },
                    success:function(){
                        succ && succ();
                    },
                    error:function(){
                        fail && fail();
                    }
                 }); 
            } else {
                if (this.isBrowserCanBlank()) {
                    window.open(url, '_blank');
                } else {
                    window.location.href = url;
                }
            }
        },
        openApp: function (option) {

        },
        insertCode: function (id, name) {//西桥逻辑代码删除20170906
             
        },
        appScan: function () {//扫码
            if (config.platform == 'APP') {
                var me = this;
                if (config.app.platform == "iphone") {
                    if (parseFloat(window.device.version) >= 7.0) {
                        var scannerOptions = {descText: "将二维码放入框内，即可自动扫描", errorMsgText: "您取消了哦", btnText: "取 消"};
                        navigator.ztmybarcodeplugin.openScanner(function (arg) {
                            me._scanHandler1(arg);
                        }, function (arg) {
                            ui.ui('default.alert', {title: '扫描结果', content: '未扫描到信息！'});
                        }, scannerOptions);
                    } else if (navigator.ktestclass) {
                        navigator.ktestclass.callzebrascan(function (arg) {
                            me._scanHandler1(arg);
                        }, function (arg) {
                            ui.ui('default.alert', {title: '扫描结果', content: '未扫描到信息！'});
                        });
                    }
                } else {
                    if (navigator.qrcode.scan) {
                        navigator.qrcode.scan(function (arg) {
                          
                            me._scanHandler1(arg);
                        }, function (arg) {
                         
                         //   ui.ui('default.alert', {title: '扫描结果', content: arg?arg:'未扫描到信息！'});
                        });
                    }
                }
            }
        },
        //欠费查询提示框，字段展示修改
        _scanHandler1: function (arg) {
            var page = APP.page;
            if (arg.indexOf("http://") == 0 || arg.indexOf("https://") == 0) {
                if(arg.match('wapjs.189.cn/realname')||  arg.match('wapjs.189.cn/smzhjh') || arg.match('wapjs.189.cn/tysh/pages/realNameActivate/realNameIndex.html')){
                    page.changePage('http://wapjs.189.cn/tysh/pages/realNameActivate/realNameIndex.html');
                    return;
                }else if(arg.match('wapjs.189.cn/jd_realname')){
                    page.changePage('http://wapjs.189.cn/tysh/pages/realNameActivate/realNameIndex_jd.html');
                    return;
                }else if(arg.match('wapjs.189.cn/sn_realname')){
                    page.changePage('http://wapjs.189.cn/tysh/pages/realNameActivate/realNameIndex_sn.html');
                    return;
                }else if(arg.match('http://wapjs.189.cn/jzitv')){
                    page.changePage('http://wapjs.189.cn/mall/pages/KD_itvOrderNew/itvIndex.html');
                    return;
                }else if (arg.match('192.168.') || arg.match('221.228.39') || arg.match('180.100.223')|| arg.match('180.100.222') || arg.match('ztmall.go189')||arg.match('o2o.telecomjs.com')||arg.match('wapjs.189.cn') ||arg.match('221.228.47') ||arg.match('10.1.140') ||arg.match('10.1.143') ||arg.match("61.160.137.199")) {
                    if (arg.indexOf('oldPlatformPage') >= 0) {
                        if (typeof ztChangePage != 'undefined') {
                            ztChangePage(arg);
                        } else {
                            page.changePage(arg);
                        }
                    } else {
                        page.changePage(arg);
                    }
                    return;
                } else{
                    this.openBrowser(arg, '天翼生活');
                }
            } else if (arg.indexOf("../") == 0) {
                if (typeof ztChangePage != 'undefined') {
                    ztChangePage(arg);
                } else {
                    page.changePage(arg);
                }
            } else {
                if (/^\d{1,20}$/.test(arg)) {
                 //   this.openBrowser('http://search.anccnet.com/searchResult2.aspx?keyword=' + arg, '天翼生活');
                     ui.ui('default.alert', {title: '扫描结果', content: arg});
                } else {
                    ui.ui('default.alert', {title: '扫描结果', content: arg});
                }
            }
    },
        isAppInstalled: function (option) {
            if (config.platform == 'APP') {
                if (config.app.platform == 'iphone') {//iphone

                } else {//android
                    if (navigator.deviceUtil) {
                    	navigator.deviceUtil.isInstalled(option.name,function(){
                			 option.success && option.success();
                		},function(){
                			 option.fail && option.fail();
                		});
                    }
                }
            }
            return false;
        },
        installApp: function (option) {

        },
        upload: function (option) {

        },
        share: function (option) {//分享
            share.share(option);
        },
        thirdLogin: function (type, success, fail) {//第三方登录
            if (type == "1") {//微信
                this._thirdLoginWeixin(success, fail);
            } else if (type == '2') {//qq
                this._thirdLoginQQ(success, fail);
            } else if (type == '3') {//天翼
                this._thirdLoginSurfing(success, fail);
            }

        },
        _thirdLoginWeixin: function (success, fail) {//微信登录
            if (config.platform == 'APP') {
                if (config.app.platform == 'iphone') {
                    navigator.weixinsharing.isInstalled(function (ergsss) {
                        var reqState = new Date().getTime();
                        var oLoginOption = {
                            state: reqState + '_TYSH',
                            scope: 'snsapi_userinfo',
                            errorMsgWidthNoInstalled: '未安装微信'
                        };
                        navigator.weixinLoginPlugin.login(function (result) {
                            try {
                                var result = JSON.parse(result);
                                success && success(result);
                            } catch (e) {
                                fail && fail({state: "0", loginEntity: '', userInfo: ''});
                            }
                        }, function (code,result) {
                            try {
                                fail && fail(code,result);
                            } catch (e) {
                                fail && fail({state: "0", loginEntity: '', userInfo: ''});
                            }
                        }, oLoginOption);
                    }, function (ergsss) {
                        ui.ui('default.alert', {content: eval(ergsss).msg});
                    });
                } else {
                	navigator.deviceUtil.isInstalled("com.tencent.mm",function(){
                		navigator.weixinLogin.login({
                			success:function(code,msg){
                				 try {
                                     //msg = JSON.parse(msg);
                                     success && success(msg);
                                 } catch (e) {
                                     fail && fail({state: "0", loginEntity: '', userInfo: ''});
                                 }
                			},
                			error:function(code,msg){
                				try {
                                    //msg = JSON.parse(msg);
                                    fail && fail(msg);
                                } catch (e) {
                                    fail && fail({state: "0", loginEntity: '', userInfo: ''});
                                }
                			}
                    	});
            		},function(){
            			ui.ui("default.alert", {content: "请先下载安装微信客户端"});
            		});
                }
            }
        },
        _thirdLoginQQ: function (success, fail) {//qq登录
            if (config.platform == 'APP') {
                if (config.app.platform == 'iphone') {
                    //navigator.qqLoginPlugin.login();
                } else {
                    underly.isAppInstalled({
                        success: function (arg) {
                        }, fail: function (arg) {
                            ui.ui("default.alert", {content: "请先下载安装QQ客户端"});
                        }, name: "com.tencent.mobileqq"
                    });
                    //navigator.qqLoginPlugin.login(function(result){success && success(JSON.parse(result));},function(result){error && error(JSON.parse(result));});
                }
            } else {
            }
        },
        _thirdLoginSurfing: function (success, fail) {//天翼登录
            if (config.platform == 'APP') {
                if (config.app.platform == 'iphone') {
                    navigator.surfingLoginPlugin.login(function (result) {
                        try {
                            result = JSON.parse(result);
                            if (result) {
                                result.userInfo.headimgurl = result.userInfo.userIconUrl;
                                if (result.userInfo.sex == '0') {
                                    result.userInfo.sex = '1';
                                } else {
                                    result.userInfo.sex = '0';
                                }
                            }
                            success && success(result);
                        } catch (e) {
                            fail && fail({state: "0", loginEntity: '', userInfo: ''});
                        }
                    }, function (result) {
                        try {
                            result = JSON.parse(result);
                            fail && fail(JSON.parse(result));
                        } catch (e) {
                            fail && fail({state: "0", loginEntity: '', userInfo: ''});
                        }
                    });
                } else {
                	navigator.surfingLogin.login({
            			success:function(code,msg){
            				try {
            					msg = JSON.parse(msg);
                              if (msg) {
                                  msg.userInfo.headimgurl = msg.userInfo.userIconUrl;
                                  if (msg.userInfo.sex == '0') {
                                      msg.userInfo.sex = '1';
                                  } else {
                                      msg.userInfo.sex = '0';
                                  }
                              }
                              success && success(msg);
                          } catch (e) {
                              fail && fail({state: "0", loginEntity: '', userInfo: ''});
                          }
            			},
            			error:function(code,msg){
            				try {
                              fail && fail(JSON.parse(msg));
                          } catch (e) {
                              fail && fail({state: "0", loginEntity: '', userInfo: ''});
                          }
            			}
            		});
                }
            } else {
            }
        },
        download: function (option) {
            var fileTransfer = new FileTransfer(), downloadId = 'DL' + tool.util.uuid(), uri = encodeURI(option.url);
            fileTransfer.onprogress = function (progressEvent) {
                if (progressEvent.lengthComputable) {
                } else {
                }
            };//js端回调下载传进度
            fileTransfer.download(
                uri, filePath,
                function (entry) {
                    option.succ && option.succ(entry);
                },
                function (error) {
                    option.fail && option.fail(error);
                }
            );
        },
        exitApp: function () {//退出app
            navigator.app.exitApp();
        }
    };

    /**
     * 分享 start
     */
    //分享类型定义
    var ZtShareType = {
        yixin: {
            haoyou: "YX_01",//易信好友
            pengyouquan: "YX_02"//易信朋友圈
        },
        weixin: {
            haoyou: "WX_01",//微信好友
            pengyouquan: "WX_02"//微信朋友圈
        },
        qq: {
            haoyou: "QQ_01",//qq好友
            qzone: "QQ_02"//qq空间分享
        },
        sina: "SA_01",//新浪微博
        message: "MG_01"//短信
    };

    /**
     * 天翼生活分享帮助类
     */
    function ZtShareHelper() {
        this.title = '';          //分享标题
        this.content = '';        //分享内容
        this.url = '';           //分享链接
        this.imgUrl = '';         //分享图片
        this.shareType = '';      //分享类型
        this.imageType = '';    //分享的图片类型：0二进制  1本地图片地址
        this.shareFuncMap = {};    //分享方法
        this.successMsg = '分享成功！';     //分享成功提示语
        this.errorMsg = '分享失败！';       //分享失败提示语
        this.succ = null;              //分享成功回调
        this.fail = null;              //分享失败回调
        this.shareAppList = [
            {
                name: '微信好友',
                icon: '../../resources/images/common/share/weixin_haoyou.png',
                shareType: 'WX_01',
                platform: 'app',
                enable: true
            },
            {
                name: '微信朋友圈',
                icon: '../../resources/images/common/share/weixin_pengyou.png',
                shareType: 'WX_02',
                platform: 'app',
                enable: true
            },
            {
                name: '易信好友',
                icon: '../../resources/images/common/share/yixin_haoyou.png',
                shareType: 'YX_01',
                platform: 'app',
                enable: true
            },
            {
                name: '易信朋友圈',
                icon: '../../resources/images/common/share/yixin_pengyou.png',
                shareType: 'YX_02',
                platform: 'app',
                enable: true
            },
            {
                name: 'QQ好友',
                icon: '../../resources/images/common/share/qq.png',
                shareType: 'QQ_01',
                platform: 'app',
                enable: true
            },
            {
                name: 'QQ空间',
                icon: '../../resources/images/common/share/qzone.png',
                shareType: 'QQ_02',
                platform: 'app',
                enable: true
            },
            {
                name: '新浪微博',
                icon: '../../resources/images/common/share/sina.png',
                shareType: 'SA_01',
                platform: 'app',
                enable: true
            },
            {
                name: '信息',
                icon: '../../resources/images/common/share/message.png',
                shareType: 'MG_01',
                platform: 'app',
                enable: true
            }
        ];//分享列表
        this.shareWapList = [
            {
                name: '易信朋友圈',
                icon: '../../resources/images/common/share/yxpengyouquan.png',
                shareType: 'YX_02',
                platform: 'wap',
                enable: true
            },
            {
                name: 'QQ空间',
                icon: '../../resources/images/common/share/qzone.png',
                shareType: 'QQ_02',
                platform: 'wap',
                enable: true
            },
            {
                name: '新浪微博',
                icon: '../../resources/images/common/share/weibo.png',
                shareType: 'SA_01',
                platform: 'wap',
                enable: true
            },
            {
                name: '腾讯微博',
                icon: '../../resources/images/common/share/tengxunweibo.png',
                shareType: 'TW_01',
                platform: 'wap',
                enable: true
            },
        ];//分享wap列表
        this.defaultInfo = {
            content: "天翼生活，吃喝玩乐游购娱从此开始。折扣购流量，充值送话费、不用排队买电影票……掌中搞定。赶快下载吧。http://wapjs.189.cn/khd",
            url: "http://wapjs.189.cn/khd",
            imgUrl: "http://wapjs.189.cn/three/resources/images/logo.png",
            title: "天翼生活",
            success: function () {
                showConfirm("提示", "分享成功！", null);
            },
            fail: function () {
                showConfirm("提示", "分享失败！", null);
            }
        };//分享默认信息
        this.defaultWapInfo = {
            content: "天翼生活，吃喝玩乐游购娱从此开始。折扣购流量，充值送话费、不用排队买电影票……掌中搞定。赶快下载吧。http://wapjs.189.cn/khd",
            url: "http://wapjs.189.cn/khd",
            imgUrl: "http://wapjs.189.cn/three/resources/images/logo.png",
            title: "天翼生活",
            success: function () {
                showConfirm("提示", "分享成功！", null);
            },
            fail: function () {
                showConfirm("提示", "分享失败！", null);
            }
        };//分享默认信息
        this.initial = {};        //初始化信息
        this.initCount = 10;//最多初始化10次
    }

    /**
     * 分享方法定义
     */
    ZtShareHelper.prototype = {
        init: function () {
            /*if (config.platform == 'APP') {
                var validate = tool.validate, O = this;
                this.initCount--;
                if (this.initCount < 0) {
                    return;
                }
                if (!O.initial.weixin && config.app.platform != "iphone") {
                    if (validate.isNull(plugins.sharing.WeixinSharing)) {
                        //O.init();
                        return;
                    }
                    plugins.sharing.WeixinSharing.register(
                        function (data) {
                            O.initial.weixin = true;
                        }, function (error) {
                            O.initial.weixin = false;
                        },
                        "wx36d572b4ee1512ac"  //应用在微信开发平台上申请获得到的APP ID
                    );
                }

                if (!O.initial.yixin && config.app.platform != "iphone" && !window.registerYixinShareAppIdInit) {
                    if (validate.isNull(plugins.sharing.YixinSharing)) {
                        return;
                    }
                    plugins.sharing.YixinSharing.register(
                        function (data) {
                            O.initial.yixin = true;
                        }, function (error) {
                            O.initial.yixin = false;
                        },
                        "yx05f56a43778642639d9437775b425819"
                    );
                }
            } else {
                document.removeEventListener('WeixinJSBridgeReady');
                var me = this;
                document.addEventListener('WeixinJSBridgeReady', function onBridgeReady(obj) {
                    return function () {
                        // 发送给好友
                        if (typeof WeixinJSBridge == 'undefined') {
                            return;
                        }
                        WeixinJSBridge.on('menu:share:appmessage', function (argv) {
                            obj.wapWeixinShare('app');
                        });
                        // 分享到朋友圈
                        WeixinJSBridge.on('menu:share:timeline', function (argv) {
                            obj.wapWeixinShare('friend');
                        });
                        // 分享到微博
                        WeixinJSBridge.on('menu:share:weibo', function (argv) {
                            obj.wapWeixinShare('weibo');
                        });
                    }
                }(me), false);
            }*/
        	if(!window.tyzsShareHelper){
        		window.tyzsShareHelper = {}
        	}
        	window.tyzsShareHelper.share = function(data){
        		APP.underly.share(data);
        	}
        },
        wapWeixinShare: function (type) {
            if (typeof WeixinJSBridge == 'undefined') {
                return;
            }
            var O = this;
            if (type == 'app') {
                WeixinJSBridge.invoke('sendAppMessage', {
                    "appid": '',
                    "img_url": O.imgUrl,
                    "img_width": "640",
                    "img_height": "640",
                    "link": O.targetUrl,
                    "desc": O.content,
                    "title": O.title
                }, function (res) {
                    _report('send_msg', res.err_msg);
                })
            } else if (type == 'friend') {
                WeixinJSBridge.invoke('shareTimeline', {
                    "img_url": O.imgUrl,
                    "img_width": "640",
                    "img_height": "640",
                    "link": O.targetUrl,
                    "desc": O.content,
                    "title": O.title
                }, function (res) {
                    _report('timeline', res.err_msg);
                });
            } else if (type == 'weibo') {
                WeixinJSBridge.invoke('shareWeibo', {
                    "content": O.content,
                    "url": O.targetUrl
                }, function (res) {
                    _report('weibo', res.err_msg);
                });
            }
        },
        _init: function (json) {//初始化
            var defaultShareData = JSON.parse(handleDomainContent(JSON.stringify(this.defaultInfo)));
            if (config.platform == 'WAP') {
                defaultShareData = JSON.parse(handleDomainContent(JSON.stringify(this.defaultWapInfo)));
            }
            this.title = json.title ? json.title : defaultShareData.title;
            this.content = json.content ? json.content : defaultShareData.content;
            this.url = json.url ? json.url : defaultShareData.url;
            this.imgUrl = json.imgUrl ? json.imgUrl : defaultShareData.imgUrl;
            this.shareType = json.shareType ? json.shareType : defaultShareData.shareType;
            this.imageType = json.imageType ? json.imageType : defaultShareData.imageType;
            this.succ = json.success ? json.success : defaultShareData.success;
            this.fail = json.fail ? json.fail : defaultShareData.fail;
        },
        share: function (json) {//分享
            var jsonStr = handleDomainContent(JSON.stringify(json));
            json = JSON.parse(jsonStr);
            console.log('share == '+JSON.stringify(json))
            this._init(json);
            if (tool.validate.isNull(this.shareType) && this.shareType.length > 2) {
                return;
            }
            switch (this.shareType.substring(0, 2)) {
                case "YX":
                    this._shareToYixin(this.shareType);
                    break;
                case "WX":
                    this._shareToWeixin(this.shareType);
                    break;
                case "QQ":
                    this._shareToQQ(this.shareType);
                    break;
                case "SA":
                    this._shareToSina(this.shareType);
                    break;
                case "MG":
                    this._shareToMessage(this.shareType);
                    break;
                case "TW":
                    this._shareToTengXunWeibo(this.shareType);
                    break;
            }
        },
        _shareToWeixinApp: function (type) {//分享到微信app        	
            var O = this;
            if (!this.initial.weixin) {
                O.init();
            }
            if (config.app.platform == 'iphone') { 
               navigator.deviceUtil.isInstalled('com.tencent.mm',
                    function () {
                        var shareType = "";
                        var options = "";
                        if (type == 'WX_01') {
                            shareType = WeixinShareScene.Session;
                        }else if (type == 'WX_02') {
                            shareType = WeixinShareScene.Timeline;
                        }else if(type == 'WX_Image_01'){  //微信好友-分享大图片
                            navigator.WeixinShare.share(WeixinShareScene.SESSION,WeixinShareType.IMAGE,{
                                title:O.title,
                                image:O.imgUrl,
                                imageType:O.imageType,
                                success:function(code,msg){
                                     O.succ && O.succ({msg: msg});
                                },
                                error:function(code,msg){
                                    O.fail && O.fail({error: msg});
                                }
                            }); 
                            return;
                        }else if(type == 'WX_Image_02'){  ////微信朋友圈-分享大图片
                            navigator.WeixinShare.share(WeixinShareScene.TIMELINE,WeixinShareType.IMAGE,{
                                title:O.title,
                                image:O.imgUrl,
                                imageType:O.imageType,
                                success:function(code,msg){
                                     O.succ && O.succ({msg: msg});
                                },
                                error:function(code,msg){
                                    O.fail && O.fail({error: msg});
                                }
                            }); 
                            return;
                        }
                        navigator.weixinShare.share(shareType,WeixinShareType.PAGE,{//改过
	            			title:O.title,
	            			description:O.content,
	            			image:O.imgUrl,
	            			link:O.url,
	            			success:function(code,msg){
	            				 O.succ && O.succ({msg: msg});
	            			},
	            			error:function(code,msg){
	            				O.fail && O.fail({error: msg});
	            			}
            			}); 
                    }, function () {
                        ui.ui("default.alert", {content: eval(isInstalledArg).msg});
                    }
                );

            } else {
            	navigator.deviceUtil.isInstalled("com.tencent.mm",function(){
    				var shareType = '';
                	if (type == 'WX_01') {
                		shareType = WeixinShareScene.Session;
                	}else if (type == 'WX_02'){
                        shareType = WeixinShareScene.Timeline;
                    }else if(type == 'WX_Image_01'){  //微信好友-分享大图片
                        // console.log('underly:WX_Image_01');
                        navigator.weixinShare.share(WeixinShareScene.Session,WeixinShareType.IMAGE,{//改过
                            title:O.title,
                            image:O.imgUrl,
                            imageType:O.imageType,
                            success:function(code,msg){
                                 // console.log('underly-suc:WX_Image_01');
                                 O.succ && O.succ({msg: msg});
                            },
                            error:function(code,msg){
                                O.fail && O.fail({error: msg});
                            }
                        }); 
                        return;
                    }else if(type == 'WX_Image_02'){  ////微信朋友圈-分享大图片
                        // console.log('underly:WX_Image_02');
                        navigator.weixinShare.share(WeixinShareScene.Timeline,WeixinShareType.IMAGE,{//改过
                            title:O.title,
                            image:O.imgUrl,
                            imageType:O.imageType,
                            success:function(code,msg){
                                // console.log('underly-suc:WX_Image_02');
                                 O.succ && O.succ({msg: msg});
                            },
                            error:function(code,msg){
                                O.fail && O.fail({error: msg});
                            }
                        }); 
                        return;
                    }                           	
                    navigator.weixinShare.share(shareType,WeixinShareType.PAGE,{//改过
            			title:O.title,
            			description:O.content,
            			image:O.imgUrl,
            			link: O.url,                    	
            			success:function(code,msg){
            				O.succ && O.succ({msg: msg});
            			},
            			error:function(code,msg){
            				O.fail && O.fail({error: msg});	            				 
            		   }
                    });
        		},function(){
        			ui.ui("default.alert", {content: "请先下载安装微信客户端"});
        		});
            }
        },
        _shareToWeixinWap: function (type) {//分享到微信wap

        },
        _shareToWeixin: function (type) {//分享到微信
            if (config.platform == 'WAP') {
                this._shareToWeixinWap(type);
            } else {
                this._shareToWeixinApp(type);
            }
        },
        _shareToYixinApp: function (type) {//分享到易信app
            var O = this;
            if (!this.initial.yixin) {
                O.init();
            }
            if (config.app.platform == 'iphone') {            
                navigator.yixinsharing.isInstalled(
                    function (isInstalledArg) {
                        var sharetype;
                        if (type == "YX_01") {
                            sharetype = YixinShareScene.Session;
                        } else {
                            sharetype = YixinShareScene.Timeline;
                        }
                        navigator.yixinShare.share(sharetype,YixinShareType.PAGE,{
	            			title:O.title,
	            			description: O.content,
	            			image:O.imgUrl,
	            			link:O.url,
	            			success:function(code,msg){
	            				O.succ && O.succ({msg: msg});
	            			},
	            			error:function(code,msg){
	            				O.fail && O.fail({error: msg});
	            			}
	            		}); 
                    }, function (isInstalledArg) {
                        ui.ui("default.alert", {content: eval(isInstalledArg).msg});
                    }
                );
            } else {
            	navigator.deviceUtil.isInstalled("im.yixin",function(){
            		var sharetype;
                    if (type == "YX_01") {
                        sharetype = YixinShareScene.Session;
                    } else {
                        sharetype = YixinShareScene.Timeline;
                    }                    
       			  	navigator.yixinShare.share(sharetype,YixinShareType.PAGE,{
            			title:O.title,
            			description: O.content,
            			image:O.imgUrl,
            			link:O.url,	            			
            			success:function(code,msg){
            				O.succ && O.succ({msg: msg});
            			},
            			error:function(code,msg){
            				O.fail && O.fail({error: msg});
            			}
	            	});
        		},function(){
        			ui.ui("default.alert", {content: "请先下载安装易信客户端"});
        		});
            }
        },
        _shareToYixinWap: function (type) {//分享到易信wap
            if (type == 'YX_02') {
                var me = this, appkey = "yxbbd0e8b3dce64e02bab42437becc4384", type = "webpage", title = this.title;
                var desc = this.content, userdesc = this.content, pic = this.imgUrl, url = this.url;
                var uri = "http://open.yixin.im/share?appkey=" + appkey + "&type=" + type + "&title=" + title + "&desc=" + desc + "&userdesc=" + userdesc + "&pic=" + pic + "&url=" + url;
                window.open(uri);
                setTimeout(function () {
                    ui.ui("default.confirm", {
                        content: '是否分享成功？', confirm: function () {
                            me.succ && me.succ({msg: '分享成功'});
                        }, cancel: function () {
                            me.fail && me.fail({msg: '分享失败'});
                        }, confirmBtn: '是', cancel: '否'
                    });
                }, 2000);

            }
        },
        _shareToYixin: function (type) {//分享到易信
            if (config.platform == 'WAP') {
                this._shareToYixinWap(type);
            } else {
                this._shareToYixinApp(type);
            }
        },
        _shareToQQApp: function (type) {//qq分享app
            var O = this;
            if (config.app.platform == 'android') {
            	navigator.deviceUtil.isInstalled("com.tencent.mobileqq",function(){
            		if(type == 'QQ_01'){
	            		navigator.qqShare.share(QQShareScene.QQ, QQShareType.QQ_IMAGE_TEXT, {
	            			title:O.title,
	            			description:O.content,
	            			image:O.imgUrl,
	            			link:O.url,
	            			success:function(msg){
	            				 O.succ && O.succ({msg: msg});
	            			},
	            			error:function(msg){
	            				 O.fail && O.fail({error: msg});
	            			}
	            		});
            		}else if(type == 'QQ_02'){
            			navigator.qqShare.share(QQShareScene.QZone, QQShareType.QZone_IMAGE_TEXT, {
                			title: O.title,
                			description:O.content, 
                			image:O.imgUrl,
                			link: O.url,
                			success:function(msg){
                				O.succ && O.succ({msg: msg});
                			},
                			error:function(msg){
                				O.fail && O.fail({error: msg});
                			}
                		}); 
            		}else if(type == 'QQ_Image_01'){  //QQ好友-分享大图片
                        // console.log('underly:QQ_Image_01');
                        navigator.qqShare.share(QQShareScene.QQ, QQShareType.QQ_IMAGE, {
                            title:O.title,
                            image:O.imgUrl,
                            success:function(code,msg){
                                // console.log('underly-suc:QQ_Image_01');
                                 O.succ && O.succ({msg: msg});
                            },
                            error:function(code,msg){
                                O.fail && O.fail({error: msg});
                            }
                        }); 
                        return;
                    }
        		},function(){
        			ui.ui("default.alert", {content: "请先下载安装QQ客户端"});
        		});
            } else {
                navigator.qqsharing.isInstalled(
                    function (isInstalledArg) {
                        var options = {"title": O.title, "content": O.content, "url": O.url, "imageUrl": O.imgUrl};
                        if (type == 'QQ_01') {
                            navigator.qqsharing.sendURLToQQ(function (arg) {
                                O.succ && O.succ({msg: arg});
                            }, function (arg) {
                                O.fail && O.fail({error: arg});
                            }, options);
                        } else if (type == 'QQ_02') {
                            navigator.qqsharing.sendURLToQZone(function (arg) {
                                O.succ && O.succ({msg: arg});
                            }, function (arg) {
                                O.fail && O.fail({error: arg});
                            }, options);
                        }else if(type == 'QQ_Image_01'){  //QQ好友-分享大图片
                            navigator.QQShare.share(QQShareScene.SESSION, QQShareType.IMAGE, {
                                title:O.title,
                                image:O.imgUrl,
                                imageType:O.imageType,
                                success:function(code,msg){
                                     O.succ && O.succ({msg: msg});
                                },
                                error:function(code,msg){
                                    O.fail && O.fail({error: msg});
                                }
                            }); 
                            return;
                        }
                    }, function (isInstalledArg) {
                        ui.ui("default.alert", {content: eval(isInstalledArg).msg});
                    }
                );

            }
        },
        _shareToQQWap: function (type) {//qq分享wap
            if (type == 'QQ_02') {
                var me = this, summary = this.content;//分享的文本内容
                var url = this.url, pic = this.imgUrl;//分享的网页 //分享的图片
                var uri = "http://sns.qzone.qq.com/cgi-bin/qzshare/cgi_qzshare_onekey?summary=" + summary + "&url=" + url + "&pic=" + pic;
                window.open(uri);
                setTimeout(function () {
                    ui.ui("default.confirm", {
                        content: '是否分享成功？', confirm: function () {
                            me.succ && me.succ({msg: '分享成功'});
                        }, cancel: function () {
                            me.fail && me.fail({msg: '分享失败'});
                        }, confirmBtn: '是', cancelBtn: '否'
                    });
                }, 2000);
            }
        },
        _shareToQQ: function (type) {//qq分享
            if (config.platform == 'WAP') {
                this._shareToQQWap(type);
            } else {
                this._shareToQQApp(type);
            }
        },
        _shareToSinaWap: function () {//新浪微博分享wap
            var me = this, textStr = this.content, identStr = 1000000 * Math.random();
            textStr = encodeURI(textStr).replace(new RegExp("%", "gm"), "ZZZZZ");
            var uri = "https://api.weibo.com/oauth2/authorize?client_id=3833962837&display=mobile&redirect_uri=http://202.102.111.141/sinaCallBack.action&state=sina|" + identStr + ",," + textStr;
            window.open(uri);
            setTimeout(function () {
                ui.ui("default.confirm", {
                    content: '是否分享成功？', confirm: function () {
                        me.succ && me.succ({msg: '分享成功'});
                    }, cancel: function () {
                        me.fail && me.fail({msg: '分享失败'});
                    }, confirmBtn: '是', cancelBtn: '否'
                });
            }, 2000);
        },
        _shareToSinaApp: function () {//新浪微博分享app
            var O = this, randomStr = tool.util.getRandomString();
            var textStrs = encodeURI(this.content).replace(new RegExp("%", "gm"), "ZZZZZ");
            var param = "state=sina|" + randomStr + ",," + textStrs;
            APP.interf.invoke({
                url: '/stores/sendWeibo', param: param, server: 'http://202.102.111.141/jszt',
                success: function (data) {
                    loginWeiboFunc();
                },
                fail: function (data) {
                    if (data.TSR_RESULT == "10001") {
                        loginWeiboFunc();
                    } else {
                        O.fail && O.fail({error: data.TSR_MSG});
                    }
                }
            });
            function loginWeiboFunc() {
                var textStr = O.content;
                textStr = encodeURI(textStr).replaceAll("%", "ZZZZZ");
                var href = "https://api.weibo.com/oauth2/authorize?client_id=3833962837&display=mobile&redirect_uri=http://202.102.111.141/sinaCallBack.action&state=sina|" + randomStr + ",," + textStr;
                var title = "绑定新浪微博账号";
                underly.openBrowser(href, title);

                setTimeout(function () {
                    ui.ui('default.confirm', {
                        content: '分享成功了？', confirm: function () {
                            O.succ && O.succ({msg: "分享成功"});
                        }, cancel: function () {
                            O.fail && O.fail({error: "分享失败"});
                        }, confirmBtn: '是', cancelBtn: '否'
                    });
                }, 3000);
            }
        },
        _shareToSina: function () {//新浪微博分享
            if (config.platform == 'WAP') {
                this._shareToSinaWap();
            } else {
                this._shareToSinaApp();
            }
        },
        _shareToTengXunWeiboWap: function (type) {//分享到腾讯微博wap
            if (type == 'TW_01') {
                var me = this;
                var title = this.title;//微博内容
                var url = this.url;//分享的地址
                var pic = this.imgUrl;//缩略图
                var uri = "http://v.t.qq.com/share/share.php?title=" + title + "&url=" + url + "&pic=" + pic;
                window.open(uri);
                setTimeout(function () {
                    ui.ui("default.confirm", {
                        content: '是否分享成功？', confirm: function () {
                            me.succ && me.succ({msg: '分享成功'});
                        }, cancel: function () {
                            me.fail && me.fail({msg: '分享失败'});
                        }, confirmBtn: '是', cancelBtn: '否'
                    });
                }, 2000);
            }
        },
        _shareToTengXunWeiboApp: function (type) {//分享到腾讯微博app
            if (type == 'TW_01') {

            }
        },
        _shareToTengXunWeibo: function (type) {//分享到腾讯微博
            var me = this;
            if (config.platform == 'WAP') {
                this._shareToTengXunWeiboWap(type);
            } else {
                this._shareToTengXunWeiboApp(type);
            }
            setTimeout(function () {
                ui.ui("default.confirm", {
                    content: '是否分享成功？', confirm: function () {
                        me.succ && me.succ({msg: '分享成功'});
                    }, cancel: function () {
                        me.fail && me.fail({msg: '分享失败'});
                    }, confirmBtn: '是', cancelBtn: '否'
                });
            }, 2000);

        },
        _shareToMessage: function () {//短信分享
            if (typeof ztChangePage != 'undefined') {
                window.shareFromSelfDefined = true;
                window.shortMsgContentStr = this.content;
//                ztChangePage('http://zy.go189.cn:10080/ympz/wdty-dxfx/index.html');
                ztChangePage('http://61.160.137.140:8082/ympz/wdty-dxfx/index.html');
            }
        }
    }

    share = new ZtShareHelper();
    /** 分享 end */

    /**
     * 通讯录对象
     */
    var Contacts = function () {
        this.contacts = [];
        this.keys = {};
        this.hasInit = false;
        this.initScroll = false;
    };

    Contacts.prototype = {
        init: function () { //初始化通讯录
           if (!this._enabled()) {
                return;
           }
            this.reset();
            var options = new ContactFindOptions();
            options.filter = "";
            options.multiple = true;
            var fields = ["displayName", "name", "phoneNumbers"];
            navigator.contacts.find(fields, this._contactSucc, this._contactFail, options);
        },
        _enabled: function () {
            if (config.platform == 'WAP') {
                return false;
            }
            return true;
        },
        _contactSucc: function (contacts) {
            if (!contact._enabled()) {
                return;
            }
            try{
            var me = contact;
            me.reset();
            for (var i = 0; contacts[i]; i++) {
                if (contacts[i].phoneNumbers && contacts[i].phoneNumbers.length) {
                    for (var j = 0; contacts[i].phoneNumbers[j]; j++) {
                        me.addKey(contacts[i].phoneNumbers[j].value.replace(/[-]/g, "").replace("+86", "").replace(/\s/g, ""));
                        if (config.app.platform == "iphone") {
                            me.addContact({
                                number: contacts[i].phoneNumbers[j].value.replace(/[-]/g, "").replace("+86", "").replace(/\s/g, ""),
                                type: contacts[i].phoneNumbers[j].type,
                                name: contacts[i].name.formatted
                            });
                        } else {
                            me.addContact({
                                number: contacts[i].phoneNumbers[j].value.replace(/[-]/g, "").replace("+86", "").replace(/\s/g, ""),
                                type: contacts[i].phoneNumbers[j].type,
                                name: contacts[i].displayName
                            });
                        }
                    }
                }
            }
            }catch(e){}
        },
        _contactFail: function () {
            if (!this._enabled()) {
                return;
            }
        },
        reset: function () { //重置
            this.contacts = [];
            this.keys = {};
            this.hasInit = false;
        },
        isInitContacts: function () { //是否需要初始化
            if (this.contacts.length > 0) {
                this.hasInit = true;
                return true;
            }
            return this.hasInit;
        },
        addContact: function (json) {
            this.contacts.push(json);
        },
        getContacts: function () {
            return this.contacts;
        },
        addKey: function (number) { //添加关键字
            this.addKeyRule(number, 2);
            this.addKeyRule(number, 3);
            this.addKeyRule(number, 4);
            this.addKeyRule(number, 5);
            this.addKeyRule(number, 6);
            this.addKeyRule(number, 7);
            this.addKeyRule(number, 8);
            this.addKeyRule(number, 9);
            this.addKeyRule(number, 10);
            this.addKeyRule(number, 11);
            this.addKeyRule(number, 8, 2);
            this.addKeyRule(number, 8, 3);
            this.addKeyRule(number, 8, 4);
            this.addKeyRule(number, 4, 2);
            this.addKeyRule(number, 4, 3);
            this.addKeyRule(number, 4, 4);
        },
        addKeyRule: function (number, index, endIndex) {
            var indexStr = '';
            if (endIndex) {
                indexStr = this.keys[number.substr(index - 1, endIndex)];
            } else {
                indexStr = this.keys[number.substring(0, index)];
            }
            if (indexStr && indexStr.indexOf(this.contacts.length + "") >= 0) {//indexStr.match(this.contacts.length + "")) {
                return;
            }
            if (!indexStr) {
                indexStr = this.contacts.length + "";
            } else {
                indexStr += ',' + this.contacts.length;
            }
            if (endIndex) {
                this.keys[number.substr(index - 1, endIndex)] = indexStr;
            } else {
                this.keys[number.substring(0, index)] = indexStr;
            }
        },
        matchContacts: function (number, func) {//匹配通讯录
            if (!this._enabled()) {
                return;
            }
            if (this.contacts.length == 0) {
                this.init();
            }
            var indexStr = this.keys[number];
            if (!indexStr || $.trim(indexStr) == '') {
                return [];
            }
            var array = indexStr.split(','), indexList = array.sort(), list = [];
            for (var i = 0; i < indexList.length; i++) {
                indexList[i].noDel = true;
                list.push(this.contacts[indexList[i]]);
            }
            return list;
        },
        invoke: function (succ, fail) {//调取通讯录
            if (!this._enabled()) {
                fail && fail('暂不支持wap');
                return;
            }
          if (config.app.platform == 'iphone') { //iphone 通讯录获取
                var option = new ContactFindOptions();
                option.fields = ["id", "phoneNumbers"];
                navigator.contacts.chooseContact(function (id) {
                    var options = new ContactFindOptions();
                    options.filter = id + "";
                    var fields = ["id", "displayName", "name", "phoneNumbers"];
                    options.multiple = true;
                    navigator.contacts.find(fields, function (contacts) {
                        for (var i = 0; i < contacts.length; i++) {
                            var contact = contacts[i];
                            if (contact.id == id) {
                                var contactObj = {};
                                if (contact.name && contact.name.formatted) {
                                    contactObj['name'] = contact.name.formatted;
                                }
                                if (contact.phoneNumbers) {
                                    for (var j = 0; j < contact.phoneNumbers.length; j++) {
                                        if (contact.phoneNumbers[j].type == "mobile" && !isNull(contact.phoneNumbers[j].value)) {
                                            if (!isNull(contact.phoneNumbers[j].value)) {
                                                contactObj['number'] = contact.phoneNumbers[j].value.replace(/[-]/g, "").replace("+86", "").replace(/\s/g, "");
                                            }
                                            succ && succ(contactObj);
                                            break;
                                        } else if (contact.phoneNumbers[j].type == "other" && !isNull(contact.phoneNumbers[j].value)) {
                                            if (!isNull(contact.phoneNumbers[j].value)) {
                                                contactObj['number'] = contact.phoneNumbers[j].value.replace(/[-]/g, "").replace("+86", "").replace(/\s/g, "");
                                            }
                                            succ && succ(contactObj);
                                            break;
                                        }
                                    }
                                }
                                break;
                            }
                        }
                    }, function (error) {
                        fail && fail(error);
                    }, options);
                }, option);
            } else { //android 通讯录获取
            	navigator.contacts.pickContact(function(contact){
                
            		var contactObj = {};
            		var data = {};
            		if (contact.selectedNum) {
                        contactObj['number'] = contact.selectedNum.replace(/[-]/g, "").replace("+86", "").replace(/\s/g, "");
                       
                         contactObj['name'] = contact.displayName;

                         
                        succ && succ(contactObj);
 
                       }
            		
            		data.number = contactObj['number'];
        		},
               
                  function (error) {
              
                    fail && fail(error);
                    }
                   
                );

         }
      
    } 

};
  
    contact = new Contacts();

    /**
     * 历史记录
     */
    function RRecord() {
        this.records = {};
        this.orderBy = 0; // 0:时间排序 1：号码排序， 2：姓名排序
        this.currentRecord = {}; //当前选择的记录
    }

    RRecord.prototype = {
        init: function (obj) { //初始化充值记录数据库
            this.reset();
            if (obj) {
                this.records = obj;
                return;
            }
            if (window.localStorage.RRecordLOCAL) {
                try {
                    this.init(JSON.parse(window.localStorage.rechargeRecord));
                } catch (e) {
                    this.records = {};
                }
            } else {
                this.records = {};
            }
        },
        reset: function () {
            this.records = {};
            this.indexMap = {};
            this.orderBy = 0; // 0:时间排序 1：号码排序， 2：姓名排序
            this.recordsType = {};
            this.currentRecord = {}; //当前选择的记录
        },
        addRecord: function (json) { //添加充值记录
            if (this.hasRecord(json)) {
                this.deleteRecord(json);
            }
            this.getRecord(json.pageId, json.typeId).unshift(json);
            window.localStorage.RRecordLOCAL = this.toJSONStr();
        },
        hasRecord: function (json) { //判断是否存在该记录
            if (typeof json == 'string') {
                return false;
            }
            var list = this.getRecord(json.pageId, json.typeId), len = list.length;
            if (list) {
                for (var i = 0; i < len; i++) {
                    if (list[i].key == json.key) {
                        return true;
                    }
                }
            }
            return false;
        },
        deleteRecord: function (json) { //删除该记录
            if (!json || !json.pageId || !json.typeId || !json.index) {
                return;
            }
            var index = json.index;
            this.getRecord(json.pageId, json.typeId).splice(index, 1);
            window.localStorage.RRecordLOCAL = this.toJSONStr();
        },
        getRecord: function (pageId, typeId) { //根据类型获取对应记录（比较网银充值和充值卡充值）
            if (!pageId || !typeId) {
                return [];
            }
            var data = this.records[pageId];
            if (data) {
                return data[typeId]
            }
            return [];
        },
        toJSONStr: function () { //转换为JSON字符串
            return JSON.stringify(this.records);
        },
        getRecords: function (pageId, typeId, number) {
            var list = this.getRecord(pageId, typeId);
            var arr = [];
            var len = list.length;
            var util = tool.util;
            if (len > 0) {
                len > 5 ? 5 : len;
                for (var i = 0; i < len; i++) {
                    list[i].key = util.uuid();
                    list[i].index = i;
                    arr.push(list[i]);
                }
            }
            return arr;
        },
        hasRecords: function (pageId, typeId) { //是否存在该记录
            return this.getRecord(pageId, typeId).length > 0;
        },
        addCurrentRecord: function (json) { //设置当前选择的记录
            if (json)
                this.currentRecord = json;
        },
        delCurrentRecord: function () { //删除当前选择的记录
            if (this.currentRecord) {
                this.currentRecord = null;
            }
        },
        getCurrentRecord: function () { //获取当前选择 的记录
            if (this.currentRecord) {
                return this.currentRecord;
            }
            return {};
        }
    };

    record = new RRecord();

    var FLOATDESKTOP = function () {
        this.enabled = false;
    }//悬浮框对象

    FLOATDESKTOP.prototype = {
        init: function (refresh) {
            if (config.platform == 'APP' && config.app.platform == 'android') {
                this.enabled = true;
            } else {
                this.enabled = false;
            }
            if (this.enabled) {
            }
        },
        _enabled: function () {
            return this.enabled;
        },
        get: function (succ, fail) {//获取悬浮框信息
            if (!this._enabled()) {
                fail && fail();
                return;
            }
            navigator.desktopWidget.get(function (data) {
                succ && succ(data);
            }, function (data) {
                fail && fail(data);
            });
        },
        show: function (data) {//显示 暂时无用
            if (!this._enabled()) {
                return;
            }
            var app = APP, main = app.main, loginStatus = main.getData('loginStatus');
            if (loginStatus != 0) {
                loginStatus = 1;
            } else {
                loginStatus = 0;
            }
            navigator.desktopWidget.show(function () {
            }, function () {
            }, {
                type: 1, phoneNum: main.getData('loginNumber'), token: main.getData('token'), alpha: data.alpha,
                enable: 1, login: loginStatus, show: 1, showType: data.showType, interfaceType: data.interfaceType, params: data.param
            });
        },
        destory: function () {//销毁悬浮窗，比如注销时
            if (!this._enabled()) {
                return;
            }
            navigator.desktopWidget.hide(function () { }, function () { }, {type: 1});
        },
        change: function (data, succ, fail) {//更新
            if (!this._enabled()) {
                return;
            }
            var app = APP, main = app.main, loginStatus = main.getData('loginStatus'), me = this;
            if (data.isFromInterface) {//来自打开app时从接口读取来的配置信息，需同步至本地数据库
                me.changeLocalDB(data, succ, fail);
            } else {//页面操作，用户手动配置，需更新接口和本地
                var temp = data.param;
                data.params = '';
                data.param = '';
                APP.interf.invoke({
//                    server: "http://221.228.39.215:12000/ZtFlowOrder/jszt",
                    url: "/flow/flowDisplay/insertFlowDisplay",
                    param: APP.tool.param.get()
                        .add("phoneNum", main.getData('loginNumber')).add("type", "1").add("platForm", "android")
                        .add("version", APP.config.app.version).add("config", JSON.stringify(data))
                        .add("showType", data.showType).add("interFaceType", data.interfaceType).value(),
                    type: 'flow', showLoading: false, showError: false,
                    success: function (result) {
                        data.param = temp;
                        me.changeLocalDB(data, succ, fail);
                    }
                });
            }
        },
        changeLocalDB: function (data, succ, fail) {//同步本地数据库信息
            var app = APP, main = app.main, loginStatus = main.getData('loginStatus');
            navigator.desktopWidget.update(function () {
                succ && succ();
            }, function () {
                fail && fail();
            }, {
                type: 1, phoneNum: main.getData('loginNumber'), token: main.getData('token'),
                enable: data.enable, login: 1, show: data.show, showType: data.showType,
                interfaceType: data.interfaceType, params: data.param, alpha: data.alpha
            });
        }
    };

    floatDesktop = new FLOATDESKTOP();

    /**
     * 身份证上传帮助类
     */
    var IdUploadHelper = function () {
        this.counter = 0;    //计数器
        this.totalPic = 0;  //总上传数
        this.uploadUrl = 'http://221.228.39.58:10000/tysh/filePhoto/upload.do';// 'http://202.102.111.147:8990/nmall/uploadImg/receiveData'; 'http://180.100.253.129:8080/ztjklj/jszt/stores/uploadRealNamePicture';
        this.uploadUrlWebBase64 = config.server.WAP_PATH + '/file/imgUpload.do';
        this.uploadUrlWeb = config.server.WAP_PATH + '/filePhoto/upload.do';//'http://js.189.cn/nmall/uploadImg/receiveData';//'http://202.102.111.147:8990/nmall/uploadImg/receiveData';
        this.queryUrl = 'http://js.189.cn/nmall/uploadImg/checkUserInfo';//'http://202.102.111.147:8990/nmall/uploadImg/queryImgInfo';
        this.queryUrlWeb = config.server.WAP_PATH + '/finePhoto/query.do';//'http://202.102.111.147:8990/nmall/uploadImg/queryImgInfo';
        this.updateIdAddressUrl = 'http://js.189.cn/nmall/uploadImg/updateRealName'; //'http://202.102.111.147:8990/nmall/uploadImg/updateRealName';
        this.updateIdAddressUrlWeb = config.server.WAP_PATH + '/filePhoto/updateinfo';
    };

    IdUploadHelper.prototype = {
        init: function () {

        },
        getPicture: function (type, obj, succ, fail) {//获取照片 type(1:拍照，2:图库), succ成功回调  fail失败回调
            var option = {
                destinationType: Camera.DestinationType.FILE_URI,
                quality: 100,
                sourceType: Camera.PictureSourceType.CAMERA
            };
            if (type == '1') {
                option.sourceType = Camera.PictureSourceType.CAMERA;
                option.targetWidth = 965;
                option.targetHeight = 660;
            }
            else if (type == '2') {
                option.sourceType = Camera.PictureSourceType.SAVEDPHOTOALBUM;
            }
            navigator.camera.getPicture(function (path) {

                if(path.startsWith("file://")){
                     obj.find('img').attr('src', path.replace("file://","http://androidimg"));
                }else
                    obj.find('img').attr('src', path);
                obj.data('imgPath', path);
                succ && succ(path);
            }, function (message) {
                obj.data('imgPath', null);
                fail && fail(message);
            }, option);
        },
        upload: function (idCard, address, file1, file2, file3, succ, fail, uploading, jsonData) {
            if (config.platform == 'WAP') {
                this._uploadWeb(idCard, address, file1, file2, file3, succ, fail, uploading, jsonData);
            } else {
                var succCount = 0, me = this;
                UI.show('default.loading');
                setTimeout(function () {
                    me._uploadAPP(idCard, address, file1, file2, file3, function (data) {
                        succCount++;
                        if (succCount == 3) {
                            UI.hide('default.loading');
                            succ && succ(data);
                        } else {
                            fail && fail();
                        }
                    }, function () {
                        UI.hide('default.loading');
                        fail && fail();
                    }, uploading, jsonData);
                }, 500);
            }
        },
        _uploadAPP: function (idCard, address, file1, file2, file3, succ, fail, uploading, jsonData) {
            if (file1) {
                this._upload('file1', file1, idCard, address, succ, fail, uploading, jsonData);
            }
            if (file2) {
                this._upload('file2', file2, idCard, address, succ, fail, uploading, jsonData);
            }
            if (file3) {
                this._upload('file3', file3, idCard, address, succ, fail, uploading, jsonData);
            }
        },
        _upload: function (key, fileURI, idCard, address, succ, fail, uploading, jsonData) {//上传图片 imgPath图片路径 succ成功回调 fail失败回调 uploading上传中回调
            var options = new FileUploadOptions();
            options.fileKey = key;
            options.fileName = fileURI.substr(fileURI.lastIndexOf('/') + 1);
            options.mimeType = "multipart/form-data";
            options.chunkedMode = false;
            var params = new Object();
            if (window.curPlatform == 'iphone') {
                params.headers = {'headerParam': 'headerValue'};
            }
            params.idCard = idCard;
            params.cardAddress = address;
            options.params = params;
            var ft = new FileTransfer();
            if (uploading) {
                ft.onprogress = function (progressEvent) {
                    if (progressEvent.lengthComputable) {
                        uploading(progressEvent.loaded, progressEvent.total);
                    } else {

                    }
                };
            }

            ft.upload(fileURI, encodeURI(this.uploadUrl), function (r) {
                var data = JSON.parse(r.response);
                if (data.result || data.result == 'true') {
                    succ && succ(data);
                } else {
                    fail && fail(data);
                }
            }, function (error) {
                fail && fail(error.code);
            }, options);
        },
        _uploadWeb: function (idCard, address, file1, file2, file3, succ, fail, uploading, jsonData) {
            var xhr = new XMLHttpRequest(), fd = new FormData();
            if (file1 && file1.files && file1.files[0]) {
                fd.append('file1', file1.files[0]);
            } else {
                fd.append('file1', file1);
            }
            if (file2 && file2.files && file2.files[0]) {
                fd.append('file2', file2.files[0]);
            } else {
                fd.append('file2', file2);
            }
            if (file3 && file2.files && file3.files[0]) {
                fd.append('file3', file3.files[0]);
            } else {
                fd.append('file3', file3);
            }
            fd.append("idCard", idCard);
            fd.append("cardAddress", address);

            xhr.upload.addEventListener("progress", function () {
                uploading && uploading();
            }, false);
            xhr.addEventListener("load", function (evt) {
                UI.hide('default.loading');
                if (evt.target.responseText) {
                    var data = JSON.parse(evt.target.responseText);
                    if (data.result || data.result == 'true') {
                        succ && succ(data.TSR_MSG, true);
                    } else {
                        succ && succ(data.TSR_MSG, false);
                    }
                } else {
                    fail && fail(data.TSR_MSG);
                }
            }, false);
            xhr.addEventListener("error", function (msg) {
                UI.hide('default.loading');
                fail && fail();
            }, false);
            xhr.addEventListener("abort", function () {
                UI.hide('default.loading');
            }, false);
            if (jsonData && jsonData.base64) {
                xhr.open("POST", this.uploadUrlWebBase64, true);
            } else {
                xhr.open("POST", this.uploadUrlWeb, true);
            }
            UI.ui('default.loading');
            xhr.send(fd);
        },
        isIdUpload: function (idCard, succ, fail, uploading, notShow) {
            var xhr = new XMLHttpRequest(), fd = new FormData(), me = this;
            fd.append("idCard", idCard);
            xhr.upload.addEventListener("progress", function () {
                uploading && uploading();
            }, false);
            xhr.addEventListener("load", function (evt) {
                me.idUploadHandle(evt.target.responseText, succ, fail);
            }, false);
            xhr.addEventListener("error", function (msg) {
                me.idUploadHandle(msg, succ, fail)
            }, false);
            xhr.addEventListener("abort", function () {
            }, false);
            if (config.platform == 'WAP') {
                xhr.open("POST", this.queryUrlWeb, true);
            } else {
                xhr.open("POST", this.queryUrl, true);
            }
            xhr.send(fd);
        },
        idUploadHandle: function (msg, succ, fail) {
            var msg = JSON.parse(msg);
            if (!isNull(JSON.stringify(msg)) && msg.flag == false) {//msg.flag=false不需要上传
                try {
                    succ && succ();
                } catch (e) {
                }
            } else if (msg.flag == true) {//msg.flag=true需要上传
                fail && fail();
            } else {
                fail && fail();
            }
        },
        updateIdAddress: function (data, succ, fail) {//更新身份证地址信息
            var xhr = new XMLHttpRequest(), fd = new FormData();
            fd.append("idCard", data.idCard);
            fd.append("cardAddress", data.address);
            xhr.upload.addEventListener("progress", function () { }, false);
            xhr.addEventListener("load", function (evt) { succ && succ(evt.target.responseText); }, false);
            xhr.addEventListener("error", function (msg) { fail && fail(); }, false);
            xhr.addEventListener("abort", function () { }, false);
            xhr.open("POST", this.updateIdAddressUrl, true);
            xhr.send(fd);
        }
    };
    var idUploader = new IdUploadHelper();

    underly = new UNDERLY();

    module.exports = underly;
});
