(function () {
    var $, Calendar, DAYS, DateRangePicker, MONTHS, TEMPLATE = [];
    var common, main;
    $ = jQuery;
    DAYS = ['日', '一', '二', '三', '四', '五', '六'];
    MONTHS = ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'];

    TEMPLATE.push('<div class="l24 chooseDate_dateTie m1">');
    TEMPLATE.push('   <span class="drp-arrow a1 icon-rechargeRecoredLeftBtn k2 grayFont6"></span>');
    TEMPLATE.push('   <p class="a1 blueFont i5 k14"></p>');
    TEMPLATE.push('   <span class="drp-arrow a1 icon-rechargeRecordRightBtn k2 grayFont6"></span>');
    TEMPLATE.push('</div>');
    TEMPLATE.push('<div class="k20 b1 datePicker_l10 m1 datePicker_l14 chooseDate_weekDay">');
    TEMPLATE.push('   <p class="a1 datePicker_g7 blueFont">日</p>');
    TEMPLATE.push('   <p class="a1 datePicker_g7">一</p>');
    TEMPLATE.push('   <p class="a1 datePicker_g7">二</p>');
    TEMPLATE.push('   <p class="a1 datePicker_g7">三</p>');
    TEMPLATE.push('   <p class="a1 datePicker_g7">四</p>');
    TEMPLATE.push('   <p class="a1 datePicker_g7">五</p>');
    TEMPLATE.push('   <p class="a1 datePicker_g7 blueFont">六</p>');
    TEMPLATE.push('</div>');
    TEMPLATE.push('<div class="drp-days">');
    TEMPLATE.push('</div>');

    DateRangePicker = (function () {
        function DateRangePicker($div, _common) {
            common = _common;
            main = common.app.main;
            this.$dateRangePicker = $(TEMPLATE.join(''));
            //this.initBindings();//初始化点击事件
            $div.append(this.$dateRangePicker);
            this.calendar = new Calendar(this, $div, new Date());
            this.draw();//绘制天
        }

        DateRangePicker.prototype.initBindings = function () {
            //main.onClick(this.$dateRangePicker, function (evt) {
            //    return evt.stopPropagation();
            //});
        };

        DateRangePicker.prototype.formatDate = function (d) {
            return "" + (d.getFullYear().toString().substr(2, 2)) + "/" + (d.getMonth() + 1) + "/" + (d.getDate());
        };

        DateRangePicker.prototype.getDateRange = function () {
            return this.calendar.getDateRange();
        };

        DateRangePicker.prototype.draw = function () {
            this.calendar.draw();
        };
        return DateRangePicker;
    })();

    Calendar = (function () {
        function Calendar(dateRangePicker, $calendar, date) {
            var self;
            this.dateRangePicker = dateRangePicker;
            this.$calendar = $calendar;
            this.date = date;
            self = this;
            this.date.setHours(0, 0, 0, 0);
            this.dateRange = {};
            this._visibleMonth = this.month();
            this._visibleYear = this.year();
            this.$title = this.$calendar.find('.chooseDate_dateTie p');
            this.$leftBut = this.$calendar.find('.chooseDate_dateTie .icon-rechargeRecoredLeftBtn');
            this.$rightBut = this.$calendar.find('.chooseDate_dateTie .icon-rechargeRecordRightBtn');
            this.$days = this.$calendar.find('.drp-days');
            main.onClick($calendar.find('.drp-arrow'),function(e){
                if ($(e.target).hasClass('icon-rechargeRecordRightBtn')) {
                    if (!$(e.target).hasClass('grayFont')) {
                        self.showNextMonth();
                    }
                } else {
                    self.showPreviousMonth();
                }
                return false;
            });
        }

        Calendar.prototype.showPreviousMonth = function () {
            if (this._visibleMonth === 1) {
                this._visibleMonth = 12;
                this._visibleYear -= 1;
            } else {
                this._visibleMonth -= 1;
            }
            return this.draw();
        };

        Calendar.prototype.showNextMonth = function () {
            if (this._visibleMonth === 12) {
                this._visibleMonth = 1;
                this._visibleYear += 1;
            } else {
                this._visibleMonth += 1;
            }
            return this.draw();
        };

        Calendar.prototype.setDay = function (day) {
            this.setDate(this.visibleYear(), this.visibleMonth(), day);
        };

        Calendar.prototype.setDate = function (year, month, day) {
            this.date = new Date(year, month - 1, day);
            return this.dateRangePicker.draw();
        };

        Calendar.prototype.draw = function () {
            this.$title.html(this.visibleYear() + "年" + (this.nameOfMonth(this.visibleMonth())) + " ");
            var nowDate = new Date();
            if (this.visibleYear() == nowDate.getFullYear() && this.visibleMonth() == nowDate.getMonth() + 1) {
                this.$rightBut.addClass('grayFont').removeClass('grayFont6');
            } else {
                this.$rightBut.removeClass('grayFont').addClass('grayFont6');
            }
            this.clearDateTrack();
            this.drawDays();
            common.scroll.refresh();
        };

        Calendar.prototype.drawDays = function () {
            var firstDayOfMonth, i, lastDayOfMonth, self, lineNum;
            var lastMonthLastDayNum;//上个月多少天
            self = this;
            this.$days.empty();
            firstDayOfMonth = this.firstDayOfMonth(this.visibleMonth(), this.visibleYear());//获取1号是星期几
            lastDayOfMonth = this.daysInMonth(this.visibleMonth(), this.visibleYear());
            lastMonthLastDayNum = this.lastDaysInLastMonth(this.visibleMonth(), this.visibleYear());
            lineNum = Math.ceil((lastDayOfMonth + (firstDayOfMonth - 1)) / 7);
            var daysHtml = [];
            var countDay = 0;
            for (i = 0; i < lineNum; i++) {
                daysHtml.push('<div data-linenum="'+i+'" class="k20 b1 datePicker_l10 m1 datePicker_l14 datePicker_white">');
                if (i == 0) {//绘制第一行
                    for (var m = firstDayOfMonth - 2; m >= 0; m--) {//1号以前
                        daysHtml.push('<div class="a1 datePicker_g7 grayFont5">' + (lastMonthLastDayNum - m) + '</div>');
                    }
                    for (var m = 1, n = 7 - firstDayOfMonth + 1; m <= n; m++) {
                        daysHtml.push('<div class="a1 datePicker_g7">' + m + '</div>');
                        countDay = m + 1;
                    }
                } else if (i == lineNum - 1) {
                    var lastNum = 0;
                    for (var m = 0; m < 7 && countDay <= lastDayOfMonth; m++) {//最后一行，下月前
                        daysHtml.push('<div class="a1 datePicker_g7">' + countDay + '</div>');
                        countDay++;
                        lastNum++;
                    }
                    for (var m = 1, n = 7 - lastNum; m <= n; m++) {//下个月
                        daysHtml.push('<div class="a1 datePicker_g7 grayFont5">' + m + '</div>');
                    }
                } else {
                    for (var m = 0; m < 7; m++) {
                        daysHtml.push('<div class="a1 datePicker_g7">' + countDay + '</div>');
                        countDay++;
                    }
                }
                daysHtml.push('</div><div class="j1 k20"></div>');
            }
            this.$days.append($(daysHtml.join('')));
            this.$days.find('.datePicker_white').find('div:first, div:last').each(function (i, v) {
                if (!$(v).hasClass('grayFont5')) {
                    $(v).addClass('blueFont');
                }
            });
            main.onListClick(this.$calendar, function(target){
                var day;
                if ($(target).hasClass('grayFont5')) {
                    return false;
                }
                day = parseInt($(target).text(), 10);
                if (isNaN(day)) {
                    return false;
                }
                self.drawSelect($(target));
            }, '.drp-days .datePicker_g7');
        };

        Calendar.prototype.getDateRange = function () {
            return [this.year(), this.month(), this.day()].join('/');
        };

        Calendar.prototype.month = function () {
            return this.date.getMonth() + 1;
        };

        Calendar.prototype.day = function () {
            return this.date.getDate();
        };

        Calendar.prototype.dayOfWeek = function () {
            return this.date.getDay() + 1;
        };

        Calendar.prototype.year = function () {
            return this.date.getFullYear();
        };

        Calendar.prototype.visibleMonth = function () {
            return this._visibleMonth;
        };

        Calendar.prototype.visibleYear = function () {
            return this._visibleYear;
        };

        Calendar.prototype.nameOfMonth = function (month) {
            return MONTHS[month - 1];
        };

        Calendar.prototype.firstDayOfMonth = function (month, year) {
            return new Date(year, month - 1, 1).getDay() + 1;
        };

        Calendar.prototype.daysInMonth = function (month, year) {
            month || (month = this.visibleMonth());
            year || (year = this.visibleYear());
            return new Date(year, month, 0).getDate();
        };
        Calendar.prototype.lastDaysInLastMonth = function (month, year) {
            var lastDay = new Date(new Date(year, month - 1, 1).getTime() - 1000 * 60 * 60 * 24);
            return lastDay.getDate();
        };
        Calendar.prototype.clearSelect = function () {
            this.$days.find('.chooseDate_getIt').each(function (i, v) {
                var dayNum = $(v).find("span:last").html();
                $(v).removeClass('chooseDate_getIt').html(dayNum);
            });
            this.clearDateTrack();
        };
        Calendar.prototype.clearDateTrack = function () {
            this.$calendar.find('.dateTrack').remove();
        };
        Calendar.prototype.drawDateTrack = function () {//绘制轨迹
            var start = this.$days.find('.chooseDate_getIt:first');
            var end = this.$days.find('.chooseDate_getIt:last');
            var startLineLastNum,endLineFirstNum;
            if(start.parent().find('div:last').hasClass('chooseDate_getIt')){
                startLineLastNum = start.find('span:last').html();
            } else {
                startLineLastNum = start.parent().find('div:last').html();
            }
            if(end.parent().find('div:first').hasClass('chooseDate_getIt')){
                endLineFirstNum = end.find('span:last').html();
            } else {
                endLineFirstNum = end.parent().find('div:first').html();
            }
            startLineLastNum = Number(startLineLastNum);
            endLineFirstNum = Number(endLineFirstNum);
            var haflW = start[0].offsetWidth / 2;
            var h = start[0].offsetHeight;
            var startPoint = this.getXYFromDom(start, haflW);
            if (start.parent().data('linenum') == end.parent().data('linenum')) {//同行
                var w = end.position().left + haflW + 1;
                var info = this.getDateTrackDom(startPoint.x, startPoint.y, h, w);
                var $dateTrack = info.dom;
                this.$calendar.append($dateTrack);
                $dateTrack.animate({width: info.width}, 333);
            } else {
                var allTime = 100;
                //处理第一行
                var w = start.parent()[0].offsetWidth;
                var info = this.getDateTrackDom(startPoint.x, startPoint.y, h, w);
                this.$calendar.append(info.dom);
                info.dom.animate({width: info.width}, allTime);
                //处理中间行
                var nextLine = start.parent().next().next();
                while (startLineLastNum + 1 != endLineFirstNum) {
                    var _info = this.getDateTrackDom(0, nextLine.find('div:first').position().top, h, nextLine[0].offsetWidth);
                    var $dom = _info.dom;
                    var domWidth = _info.width;
                    this.$calendar.append($dom);
                    (function ($dom, domWidth, allTime) {
                        setTimeout(function () {
                            $dom.animate({width: domWidth}, 100);
                        }, allTime);
                    })($dom, domWidth, allTime);
                    allTime += allTime;
                    nextLine = nextLine.next().next();
                    startLineLastNum += 7;
                }
                //处理最后一行
                var endPoint = this.getXYFromDom(end, haflW);
                var _info_ = this.getDateTrackDom(0, endPoint.y, h, endPoint.x);
                var $dom1 = _info_.dom;
                var domWidth1 = _info_.width;
                this.$calendar.append($dom1);
                setTimeout(function () {
                    $dom1.animate({width: domWidth1}, 100);
                }, allTime);
                //var _dayNum = this.$days.find('.chooseDate_getIt:first').find('span:last').html();
                //var lineNum = (endLineFirstNum - startLineLastNum + 1)/7;
            }
        };
        Calendar.prototype.getDateTrackDom = function (x, y, h, w) {
            var $dateTrack = $('<div class="dateTrack" style="top:' + y + 'px;left:' + x + 'px;height:' + h + 'px"></div>');
            return {dom: $dateTrack, width: w - x};
        },
            Calendar.prototype.getXYFromDom = function (aim, haflW) {
                return {x: aim.position().left + haflW, y: aim.position().top};
            },
            Calendar.prototype.drawSelect = function (aim) {
                var sels = this.$days.find('.chooseDate_getIt');
                if (sels.length == 0) {
                    this.drawSelectOne(aim, true);
                } else if (sels.length == 1) {
                    var day = Number(sels.find("span:last").html());
                    var day_num = Number(aim.html());
                    if (day_num < day) {
                        this.drawSelectOne(aim, true);
                        sels.find('span:first').html('结束');
                    } else if (day_num > day) {
                        this.drawSelectOne(aim);
                    }
                    this.drawDateTrack();
                } else {
                    this.clearSelect();
                    this.drawSelectOne(aim, true);
                }
            };
        Calendar.prototype.drawSelectOne = function (aim, isStart) {
            var dayNum = aim.html();
            aim.addClass('chooseDate_getIt').html('<span>' + (isStart ? '开始' : '结束') + '</span><span>' + dayNum + '</span>');
        };
        Calendar.prototype.getDateRange = function (aim, isStart) {
            var sels = this.$days.find('.chooseDate_getIt');
            var dr;
            if (sels.length == 2) {
                dr = {};
                var startDayNum = this.$days.find('.chooseDate_getIt:first').find("span:last").html();
                var endDayNum = this.$days.find('.chooseDate_getIt:last').find("span:last").html();
                dr.startDate = new Date(this.visibleYear(), this.visibleMonth() - 1, startDayNum);
                dr.endDate = new Date(this.visibleYear(), this.visibleMonth() - 1, endDayNum);
            }
            return dr;
        };
        return Calendar;
    })();

    $.fn.dateRangePicker = function (common) {
        return new DateRangePicker(this, common);
    };

}).call(this);
