/**
 * @author Grahor
 * 初始化导入js文件
 */
(function (window, document, Math) {
    //js加载对象
    LOADER = function () {
        this.cssFiles = []; //css文件列表
        this.jsFiles = []; //js文件列表
        this.currentTime = 0;
    };

    //方法执行
    LOADER.prototype = {
        init: function () {//加载
            var currentTime = (new Date()).getTime();
            this.currentTime = currentTime;
            for (var i = 0; i < this.cssFiles.length; i++) {
                if (this.cssFiles[i].sync == null || this.cssFiles[i].sync == undefined || this.cssFiles[i].sync) {
                	if(this.cssFiles[i].id){
                		document.write('<link id="' + this.cssFiles[i].id + '" rel="stylesheet" type="text/css" href="' + this.cssFiles[i].url + '?_t=' + this.currentTime + '" />');
                	}else{
                		document.write('<link rel="stylesheet" type="text/css" href="' + this.cssFiles[i].url + '?_t=' + this.currentTime + '" />');
                	}
                } else {
                    var css = document.createElement("link");
                    css.href = data.url;
                    css.rel = "stylesheet";
                    css.type = "text/css";
                    document.head.appendChild(css);
                }
            }
            var jsBuilder = [];
            for (var i = 0; i < this.jsFiles.length; i++) {
                if (this.jsFiles[i].sync == null || this.jsFiles[i].sync == undefined || this.jsFiles[i].sync) {
                	jsBuilder.push('<script type="text/javascript" src="' + this.jsFiles[i].url + '?_t=' + this.currentTime +  '"></script>');
                    //document.write('<script type="text/javascript" src="' + this.jsFiles[i].url +  '"></script>');
                } else {
                    var oScript = document.createElement("script");
                    oScript.type = "text/javascript";
                    oScript.src = this.jsFiles[i].url;
                    document.head.appendChild(oScript);
                }
            }
            if(jsBuilder.length > 0){
            	document.write(jsBuilder.join(''));
            }
            
        },
        initBase: function () {

        },
        clear: function () {
            this.jsClear();
            this.cssClear();
        },
        jsClear: function () {//清除js文件列表
            this.jsFiles = [];
        },
        cssClear: function () {//清除css文件列表
            this.cssFiles = [];
        },
        addJsFile: function (data, parent) {//添加js文件 {url:'../../resources/main.js',sync:false} sync默认是同步加载
            if (parent) {
                if (data.before) {
                    if (!data.before()) {
                        return;
                    }
                }
                var oScript = document.createElement("script");
                oScript.type = "text/javascript";
                oScript.src = data.url + '?_t=' + this.currentTime;
                if (typeof $ == 'undefined') {
                    parent = document.head;
                    parent.appendChild(oScript);
                } else if (typeof parent == 'string') {
                    $(parent)[0].appendChild(oScript);
                } else {
                    parent[0].appendChild(oScript);
                }
                oScript.onload = oScript.onreadystatechange = function (data) {
                    return function () {
                        data.loaded && data.loaded();
                    };
                }(data);
            } else {
                this.jsFiles.push(data);
            }
        },
        addCssFile: function (data, parent) {//添加css文件
            if (parent) {
                var css = document.createElement("link");
                css.href = data.url + '?_t=' + this.currentTime;
                css.rel = "stylesheet";
                css.type = "text/css";
                if (typeof $ == 'undefined') {
                    parent = document.head;
                    parent.appendChild(css);
                } else if (typeof parent == 'string') {
                    $(parent)[0].appendChild(css);
                } else {
                    parent[0].appendChild(css);
                }
                css.addEventListener('load', function(){
                	return function(){
                        if (data.loaded) {
                            data.loaded && data.loaded();
                        }
                    }
                }(data), false); 
            } else {
                this.cssFiles.push(data);
            }
        }
    };

    var loader = new LOADER(); //加载对象
    loader.clear();
    loader.cssFiles = [
  	    {url: '../../resources/css/jquery.mobile-1.4.5.min.css'},
  	    {url: '../../resources/css/framework.css'},
  	    {url: '../../resources/css/loading.css'},
  	    {url: '../../resources/css/app.public.css'},
  	    {url: '../../resources/css/app.module.css'},
  	    {url: '../../resources/css/fonts.css'},
  	    {url: '../../resources/css/fontStyle.css'},
  	    {url:'../../resources/css/ty-fontStyle.css'},
  	    {url:'../../resources/css/style.app.css'},
  	    {url:'../../resources/css/swiper.css'},
  	    {url:'../../resources/css/appstore.css'},
  	    {url:'../../resources/css/compatible.low.css'}
  	];
   loader.jsFiles = [
        // min
 	    {url:'../../resources/js/jquery-2.1.0.min.js'},             
 	    {url:'../../resources/js/jquery.mobile-1.4.5.min.js'},             
 	    {url:'../../resources/cordova.js'},
        // not-min
        {url:'../../resources/js/ipv6.js'},
 	    {url:'../../resources/js/app/app.base.js'},             
 	    {url:'../../resources/js/app/app.config.js'},             
 	    {url:'../../resources/js/app/app.tool.js'},             
 	    {url:'../../resources/js/app/app.module.js'},             
 	    {url:'../../resources/js/app/app.framework.js'},             
 	    {url:'../../resources/js/app/app.underly.js'},             
 	    {url:'../../resources/js/app/app.interface.js'},             
 	    {url:'../../resources/js/app/app.third.party.js'},             
 	    {url:'../../resources/js/app/app.page.js'},             
 	    {url:'../../resources/js/app/app.ui.js'},             
 	    {url:'../../resources/js/app/app.ui.default.js'},             
 	    {url:'../../resources/js/app/app.widgets.js'},             
 	    {url:'../../resources/js/app/app.widget.mall.js'},             
 	    {url:'../../resources/js/app/app.main.js'},             
 	    {url:'../../resources/js/app/app.init.js'},             
 	    {url:'../../resources/js/datePicker.js'},             
 	    {url:'../../resources/js/qrcode.js'},             
 	    {url:'../../resources/js/fixcode.js'}, 
 	    {url:'../../resources/js/compatible.low.js'}, 
 	    {url:'../../resources/js/swiper.js'},
 	    {url:'../../resources/js/mui.min.js'},
 	    {url:'../../resources/js/picker.js'},
 	    {url:'../../resources/js/city.data.js'},
 	    // {url:'../../resources/js/d3.min.js'},
 	    // {url:'../../resources/js/radialProgress.js'},
 	    // {url:'../../resources/js/echarts.min.js'},
        // {url:'../../resources/js/s_code.js'},
        {url:'../../resources/js/app/app.rsa.min.js'}
 	];
    
    loader.init();
    window.appLoader = loader;

}(window, document, Math));
