function radialProgress(parent,width1,height1,outerRadius1,innerRadius1,innerRadius2) {
    var _data=null,
        _duration= 1000,
        _selection,
        _margin = {top:0, right:0, bottom:30, left:0},
        __width = width1,
        __height = height1,
        _diameter,
        _label="",
        _fontSize=10;


    var _mouseClick;

    var _value= 0,
        _minValue = 0,
        _maxValue = 100;

    var  _currentArc= 0, _currentArc2= 0, _currentValue=0;

    var _arc = d3.svg.arc()
        .startAngle(0 * (Math.PI/180)); //just radians

    var _arc2 = d3.svg.arc()
        .startAngle(0 * (Math.PI/180))
        .endAngle(0); //just radians


    _selection=d3.select(parent);


    function component() {

        _selection.each(function (data) {

            // Select the svg element, if it exists.
            var svg = d3.select(this).selectAll("svg").data([data]);

            var enter = svg.enter().append("svg").attr("class","radial-svg").append("g");

            measure();

            svg.attr("width", __width)
                .attr("height", __height);


            var background = enter.append("g").attr("class","component")
                .attr("cursor","pointer")
                .on("click",onMouseClick);


            _arc.endAngle(360 * (Math.PI/180))

            background.append("rect")
                .attr("class","background")
                .attr("width", _width)
                .attr("height", _height);

            background.append("path")
                .attr("transform", "translate(" + _width/2 + "," + _width/2 + ")")
                .attr("d", _arc);

            background.append("text")
                .attr("class", "label")
                .attr("transform", "translate(" + _width/2 + "," + (_width + _fontSize) + ")")
                .text(_label);
           var g = svg.select("g")
                .attr("transform", "translate(" + _margin.left + "," + _margin.top + ")");


            _arc.endAngle(_currentArc);
            enter.append("g").attr("class", "arcs");
            var path = svg.select(".arcs").selectAll(".arc").data(data);
            path.enter().append("path")
                .attr("class","arc")
                .attr("transform", "translate(" + _width/2 + "," + _width/2 + ")")
                .attr("d", _arc);

            //Another path in case we exceed 100%
            var path2 = svg.select(".arcs").selectAll(".arc2").data(data);
            path2.enter().append("path")
                .attr("class","arc2")
                .attr("transform", "translate(" + _width/2 + "," + _width/2 + ")")
                .attr("d", _arc2)
                .attr("stroke-width","5");


            enter.append("g").attr("class", "labels");
            var label = svg.select(".labels").selectAll(".label").data(data);
            label.enter().append("text")
                .attr("class","label")
                .attr("y",_width/2+_fontSize/3)
                .attr("x",_width/2)
                .attr("cursor","pointer")
                .attr("width",_width)
                // .attr("x",(3*_fontSize/2))
                .text(function (d) { return Math.round((_value-_minValue)/(_maxValue-_minValue)*100) + "%" })
                .style("font-size",_fontSize+"px")
                .on("click",onMouseClick);

            path.exit().transition().duration(500).attr("x",1000).remove();

            layout(svg);

            function layout(svg) {

                var ratio=(_value-_minValue)/(_maxValue-_minValue);
                var endAngle=Math.min(360*ratio,360);
                endAngle=endAngle * Math.PI/180;

                path.datum(endAngle);
                path.transition().duration(_duration)
                    .attrTween("d", arcTween);

                if (ratio > 1) {
                    path2.datum(Math.min(360*(ratio-1),360) * Math.PI/180);
                    path2.transition().delay(_duration).duration(_duration)
                        .attrTween("d", arcTween2);
                }

                label.datum(Math.round(ratio*100));
                label.transition().duration(_duration)
                    .tween("text",labelTween);

            }

        });

        function onMouseClick(d) {
            if (typeof _mouseClick == "function") {
                _mouseClick.call();
            }
        }
    }

    function labelTween(a) {
        var i = d3.interpolate(_currentValue, a);
        _currentValue = i(0);

        return function(t) {
            _currentValue = i(t);
            this.textContent = Math.round(i(t)) + "%";
        }
    }

    function arcTween(a) {
        var i = d3.interpolate(_currentArc, a);

        return function(t) {
            _currentArc=i(t);
            return _arc.endAngle(i(t))();
        };
    }

    function arcTween2(a) {
        var i = d3.interpolate(_currentArc2, a);

        return function(t) {
            return _arc2.endAngle(i(t))();
        };
    }


    function measure() {
        _width=_diameter - _margin.right - _margin.left - _margin.top - _margin.bottom;
        _height=_width;
        _fontSize=_width*.2;
        _arc.outerRadius(_width/2 );
        _arc.innerRadius(_width/2 * .95);
        _arc2.outerRadius(_width/2 * outerRadius1 );
        _arc2.innerRadius(_width/2 * innerRadius1  - (_width/2 * innerRadius2));
    }


    component.render = function() {
        measure();
        component();
        return component;
    }

    component.value = function (_) {
        if (!arguments.length) return _value;
        _value = [_];
        _selection.datum([_value]);
        return component;
    }


    component.margin = function(_) {
        if (!arguments.length) return _margin;
        _margin = _;
        return component;
    };

    component.diameter = function(_) {
        if (!arguments.length) return _diameter
        _diameter =  _;
        return component;
    };

    component.minValue = function(_) {
        if (!arguments.length) return _minValue;
        _minValue = _;
        return component;
    };

    component.maxValue = function(_) {
        if (!arguments.length) return _maxValue;
        _maxValue = _;
        return component;
    };

    component.label = function(_) {
        if (!arguments.length) return _label;
        _label = _;
        return component;
    };

    component._duration = function(_) {
        if (!arguments.length) return _duration;
        _duration = _;
        return component;
    };

    component.onClick = function (_) {
        if (!arguments.length) return _mouseClick;
        _mouseClick=_;
        return component;
    }

    return component;

}



function radialProgress01(parent, opt) {
    var _data01=null,
        _duration01= 1000,
        _selection01,
        _margin01 = {top:0, right:0, bottom:30, left:0},
        __width01 = 220,
        __height01 = 220,
        _diameter01,
        _fontSize01=10,
        _component = 'component', _arcStr = 'arc';
        if(opt){
            if(opt.component){
                _component = opt.component;
            }
            if(opt.arc){
                _arcStr = opt.arc;
            }
        }

    var _mouseClick01;

    var _value01= 0,
        _value2= 0,
        _minValue01 = 0,
        _maxValue01 = 100;

    var  _currentArc01= 0, _currentArc2= 0, _currentValue01=0;

    var _arc01 = d3.svg.arc()
        .startAngle(0 * (Math.PI/180)); //just radians

    var _arc2 = d3.svg.arc()
        .startAngle(0 * (Math.PI/180))
        .endAngle(0); //just radians


    _selection01=d3.select(parent);


    function component01() {

        _selection01.each(function (data) {

            // Select the svg element, if it exists.
            var svg = d3.select(this).selectAll("svg").data([data]);

            var enter = svg.enter().append("svg").attr("class","radial-svg").append("g");

            measure01();

            svg.attr("width", __width01)
                .attr("height", __height01);


            var background = enter.append("g").attr("class",_component)
                .attr("cursor","pointer")
                .on("click",onMouseClick01);


            _arc01.endAngle(360 * (Math.PI/180))

            background.append("rect")
                .attr("class","background")
                .attr("width", _width)
                .attr("height", _height);

            background.append("path")
                .attr("transform", "translate(" + _width/2 + "," + _width/2 + ")")
                .attr("d", _arc01);

           var g = svg.select("g")
                .attr("transform", "translate(" + _margin01.left + "," + _margin01.top + ")");


            _arc01.endAngle(_currentArc01);
            enter.append("g").attr("class", "arcs");
            var path = svg.select(".arcs").selectAll("." + _arcStr).data(data);
            path.enter().append("path")
                .attr("class",_arcStr)
                .attr("transform", "translate(" + _width/2 + "," + _width/2 + ")")
                .attr("d", _arc01);

            //Another path in case we exceed 100%
            var path2 = svg.select(".arcs").selectAll(".arc2").data(data);
            path2.enter().append("path")
                .attr("class","arc2")
                .attr("transform", "translate(" + _width/2 + "," + _width/2 + ")")
                .attr("d", _arc2)
                .attr("stroke-width","5");

            path.exit().transition().duration(500).attr("x",1000).remove();

            layout01(svg);

            function layout01(svg) {

                var ratio=(_value01-_minValue01)/(_maxValue01-_minValue01),
                    ratio2=(_value2-_minValue01)/(_maxValue01-_minValue01);
                var endAngle=Math.min(360*ratio,360),
                    endAngle2=Math.min(360*ratio2,360);
                endAngle=endAngle * Math.PI/180;
                endAngle2=endAngle2 * Math.PI/180;

                path.datum(endAngle);
                path.transition().duration(_duration01)
                    .attrTween("d", arcTween01);

                path2.datum(endAngle2);
                path2.transition().duration(_duration01)
                    .attrTween("d", arcTween2);

            }

        });

        function onMouseClick01(d) {
            if (typeof _mouseClick01 == "function") {
                _mouseClick01.call();
            }
        }
    }


    function arcTween01(a) {
        var i = d3.interpolate(_currentArc01, a);

        return function(t) {
            _currentArc01=i(t);
            return _arc01.endAngle(i(t))();
        };
    }

    function arcTween2(a) {
        var i = d3.interpolate(_currentArc2, a);

        return function(t) {
            return _arc2.endAngle(i(t))();
        };
    }


    function measure01() {
        _width=_diameter01 - _margin01.right - _margin01.left - _margin01.top - _margin01.bottom;
        _height=_width;
        _fontSize01=_width*.2;
        _arc01.outerRadius(_width/2 );
        _arc01.innerRadius(_width/2 * .94);
        _arc2.outerRadius(_width/2 * .92);
        _arc2.innerRadius(_width/2 * 0.9  - (_width/2 * .04));
    }


    component01.render = function() {
        measure01();
        component01();
        return component01;
    }

    component01.value = function (_) {
        if (!arguments.length) return _value01;
        _value01 = [_];
        _selection01.datum([_value01]);
        return component01;
    }
    component01.value2 = function (_) {
        if (!arguments.length) return _value2;
        _value2 = [_];
        _selection01.datum([_value2]);
        return component01;
    }


    component01.margin = function(_) {
        if (!arguments.length) return _margin01;
        _margin01 = _;
        return component01;
    };

    component01.diameter = function(_) {
        if (!arguments.length) return _diameter01
        _diameter01 =  _;
        return component01;
    };

    component01.minValue = function(_) {
        if (!arguments.length) return _minValue01;
        _minValue01 = _;
        return component01;
    };

    component01.maxValue = function(_) {
        if (!arguments.length) return _maxValue01;
        _maxValue01 = _;
        return component01;
    };

    component01._duration01 = function(_) {
        if (!arguments.length) return _duration01;
        _duration01 = _;
        return component01;
    };

    return component01;

}

