cordova.define("ZhiBo", function(require, exports, module) {
	var exec = require('cordova/exec');

	/**
	 * 直播对象
	 */
	var ZhiBo = function(){
			/**
		 * 回调方法map
		 */
		this.callbackMap = {};

	}

	ZhiBo.prototype = {

           /**
			 * 是否为空
			 */
			isNull:function(obj){
				return obj == null || obj == '' || obj.toString() == '';
			},
			/**
			 * 根据请求data生成唯一的callbackId
			 */
			generateCallbackId:function(url){
				var str = url.replace(/[:|/|.]/g,'');
				if(str.length > 10){
					return str.substring(str.length - 10) + parseInt(Math.random() * 1000000);
				}
				return str + parseInt(Math.random() * 1000000);
			},
		/**
			 * 执行回调
			 */
			excuteCallback:function(callbackId,callbackName,data){
				if(this.callbackMap[callbackId] && this.callbackMap[callbackId][callbackName]){
					this.callbackMap[callbackId][callbackName](data);
				//	this.callbackMap[callbackId][callbackName] = null;
				}
			},
			/**
			 * 验证
			 */
			validate:function(option){
				if(this.isNull(option)){
					console.log('参数为空');
					return false;
				}
				
				/**
				 * 插件调用时的相关回调方法定义
				 */
				var callback = {
					share:option.share,
					purchase:option.purchase,
					
				};
                
   				//每次调用插件时清空 方法
				for(var key in this.callbackMap){
                     delete this.callbackMap[key];
                       }
				var callbackId = this.generateCallbackId(option.idSource);

				this.callbackMap[callbackId] = callback;
				option.callbackId = callbackId;
				return true;
			},

		/**
		 * 打开直播控件
		 */
		


        openZhiBoVC:function(option){
				if(!this.validate(option)){
					return;
				}
				var args = [option];
				exec(option.success,option.error,"ZhiBo","openZhiBoVC",args);
			}
      
	}

	module.exports = new ZhiBo();
});
