cordova.define("browser.Browser", function(require, exports, module) {
	var exec = require('cordova/exec');
	
	/**
	 * 浏览器对象
	 */
	var Browser = function(){
		/**
		 * 回调方法map
		 */
		this.callbackMap = {};
	}
	
	/**
	 * 浏览器对象方法定义
	 */
	Browser.prototype = {
			/**
			 * 是否为空
			 */
			isNull:function(obj){
				return obj == null || obj == '' || obj.toString() == '';
			},
			/**
			 * 根据请求url生成唯一的callbackId
			 */
			generateCallbackId:function(url){
				var str = url.replace(/[:|/|.]/g,'');
				if(str.length > 10){
					return str.substring(str.length - 10) + parseInt(Math.random() * 1000000);
				}
				return str + parseInt(Math.random() * 1000000);
			},
			/**
			 * 执行回调
			 */
			excuteCallback:function(callbackId,callbackName,data){
				if(this.callbackMap[callbackId] && this.callbackMap[callbackId][callbackName]){
					this.callbackMap[callbackId][callbackName](data);
					this.callbackMap[callbackId][callbackName] = null;
				}
			},
			/**
			 * 验证
			 */
			validate:function(option){
				if(this.isNull(option)){
					console.log('参数为空');
					return false;
				}
				if(this.isNull(option.url)){
					console.log('链接为空');
					return false;
				}
				/**
				 * 插件调用时的相关回调方法定义
				 */
				var callback = {
					startLoad:option.startLoad,
					loading:option.loading,
					finishLoad:option.finishLoad,
					close:option.close,
					errorLoad:option.errorLoad
				};
				var callbackId = this.generateCallbackId(option.url);
				this.callbackMap[callbackId] = callback;
				option.callbackId = callbackId;
				return true;
			},
			/**
			 * 打开浏览器
			 */
			open:function(option){
				if(!this.validate(option)){
					return;
				}
				var args = [option];
				exec(option.success,option.error,"Browser","open",args);
			},

			/*
			* 保存外部第三方app  scheme
			 */
			
			saveSchemes:function(option){
				
				
				exec(option.success,option.error,"Browser","saveSchemes",[option.args]);
			}
	}
	
	module.exports = new Browser();
});