var Jifen = function () {
	};
	
	/**
	 * 积分商城接口初始化
	 */
	Jifen.prototype.init = function(successCallback, errorCallback){
		cordova.exec(successCallback,errorCallback, "JifenPlugin", "init", []);		
	}
	
	/**
	 * 用户登录
	 * 
	 * @param account:用户帐号
     * @param typeCode:用户帐号类型
     * @param cityCode:用户地区代码
	 */
	Jifen.prototype.certification = function(account, typeCode, cityCode, successCallback, errorCallback){
		cordova.exec(successCallback,errorCallback, "JifenPlugin", "certification", [account, typeCode, cityCode]);		
	}

	/**
	 * 获取产品分类 
	 */
	Jifen.prototype.getCatefory = function(successCallback,errorCallback){
	    cordova.exec(successCallback,errorCallback, "JifenPlugin", "getCatefory", []);
	}
	
	/**
	 * 用户权限验证
	 * 
	 * @param account 用户帐号
	 * @param typeCode 用户帐号类型
	 * @param cityCode 用户地区代码
	 */
    Jifen.prototype.certification = function(account, typeCode, cityCode, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "certification", [account, typeCode, cityCode]);
    }
    
    /**
     * 根据分类获取商品列表
     * @param cateyID:分类编号
     * @param pageIndex:第几页
     * @param pageSize:每页记录最大记录数
     * @param type:分页类型(
     *             “1”:,兑换量
     *             “2”:, 上架时间
     *             “3”:,价格即积分值
     *             “4”:按点击量)
     * @param startPrice:开始积分价
     * @param endPrice:结束积分价 
     */
    Jifen.prototype.getGoodsListByCategory = function(cateyID, pageIndex, pageSize, type, startPrice, endPrice, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getGoodsListByCategory", [cateyID, pageIndex, pageSize, type, startPrice, endPrice]);
    }
    
    /**
     * 获取某个分类下的热销商品
     * 
     * @param categoryId 商品分类编号（如果为100，则表示全部商品中获取热销商品）
     * @param pageIndex 当前页数
     * @param pageSize  每页显示数
     */
    Jifen.prototype.getHotGoodsList = function(categoryId, pageIndex, pageSize, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getHotGoodsList", [categoryId, pageIndex, pageSize]);
    }
    
    /**
     * 获取商品详情
     * 
     * @param goodsId 商品编号
     */
    Jifen.prototype.getGoodsDetail = function(goodsId, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getGoodsDetail", [goodsId]);
    }
    
    /**
     * 提交订单
     * 
     * @param order 订单详情，json对象
     * {
     *     "userCode":"用户代码",
     *     "areacode":"区域代码",
     *     "loginType":"登录类型",
     *     "goodsID":"商品编号",
     *     "BSSID":"商品编号",
     *     "goodsCount":"商品数量",
     *     "deliveryId":"收货地址编码",
     *     "remark":"购买备注",
     *     "cent":"支付积分（必须大于0）",
     *     "cash":"支付现金"
     * }
     */
    Jifen.prototype.commitOrder = function(order, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "commitOrder", [order]);
    }
    
    /**
     * 取消订单
     * 
     * @param orderNum 订单号 
     */
    Jifen.prototype.cancelOrder = function(orderNum, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "cancelOrder", [orderNum]);
    }
    
    /**
     * 获取用户的订单
     * 
     * @param userCode:用户编号
     * @param pageIndex:第几页
     * @param pageSize:分页数(默认20)
     */
    Jifen.prototype.getOrder = function(userCode, pageIndex, pageSize, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getOrder", [userCode, pageIndex, pageSize]);
    }
    
    /**
     * 重新获取二次鉴权码
     * 
     */
    Jifen.prototype.regetDetermine = function(transID, userCode, loginType, userArea, successCallback,errorCallback){
    	cordova.exec(successCallback,errorCallback, "JifenPlugin", "regetDetermine", [transID, userCode, loginType, userArea]);
    }
    
    /**
     * 二次鉴权
     * 
     * @param orderNum:订单号
     * @pram determineCode:二次鉴权码
     */
    Jifen.prototype.secondDetermine = function(transID, userCode, loginType, userArea, orderNum, determineCode, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "secondDetermine", [transID, userCode, loginType, userArea, orderNum, determineCode]);
    }
    
    /**
     * 变更订单状态
     * 
     * @param orderNum:订单号
     */
    Jifen.prototype.updateOrderState = function(orderNum, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "updateOrderState", [orderNum]);
    }
    
    /**
     * 获取用户收货地址
     * 
     * @param userCode 用户编号
     */
    Jifen.prototype.getDeliveryAddress = function(userCode, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getDeliveryAddress", [userCode]);
    }
    
    /**
     * 新增用户的收货地址
     * 
     * @param address 收货地址详情，json对象
     * {
     *     "userCode":"用户编号",
     *     "toName":"收货人姓名",
     *     "sex":"性别",
     *     "areaCode":"地区代码",
     *     "address":"收货地址",
     *     "zipCode":"邮政编码",
     *     "telePhone":"固话号码",
     *     "phoneAreaCode":"固话区号",
     *     "subPhoneCode":"固话分机号",
     *     "mobile":"手机号码",
     *     "safeEmail":"安全邮箱",
     *     "isDefault":"是否默认地址"
     * }
     * 
     * 注意：
     *   1、	其中必填项为：UserCode:用户代码；ToName:收货人姓名；AreaCode:地区代码；Address：收货地址；ZipCode：邮政编码；Mobile：手机号码；
     *   2、Sex:性别：如不填，默认为男
     */
    Jifen.prototype.addDeliveryAddress = function(address, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "addDeliveryAddress", [address]);
    }
    
    /**
     * 新增用户的收货地址
    * 
    * @param address 收货地址详情，json对象
    * {
    *     "userCode":"用户编号",
    *     "toName":"收货人姓名",
    *     "sex":"性别",
    *     "areaCode":"地区代码",
    *     "address":"收货地址",
    *     "zipCode":"邮政编码",
    *     "telePhone":"固话号码",
    *     "phoneAreaCode":"固话区号",
    *     "subPhoneCode":"固话分机号",
    *     "mobile":"手机号码",
    *     "safeEmail":"安全邮箱",
    *     "isDefault":"是否默认地址",
    *     "deliveryId" : "需要修改的送货地址ID"
    * }
    * 
    * 注意：
    *   1、	其中必填项为：UserCode:用户代码；ToName:收货人姓名；AreaCode:地区代码；Address：收货地址；ZipCode：邮政编码；Mobile：手机号码；
    *   2、Sex:性别：如不填，默认为男
    */
    Jifen.prototype.modifyDeliveryAddress = function(address, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "modifyDeliveryAddress", [address]);
    }
    
    /**
     * 删除用户收货地址
     * 
     * @param deliveryID 编号
     * 
     */
    Jifen.prototype.deleteDeliveryAddress = function(deliveryID, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "deleteDeliveryAddress", [deliveryID]);
    }
    
    /**
     * 获取地区信息
     * 
     */
    Jifen.prototype.getAreaInfoList = function(successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getAreaInfoList", []);
    }
    
    /**
     * 搜索商品
     * 
     * @param keyword:搜索关键字
     * @param pageIndex:第几页
     * @param pageSize:每页记录最大记录数
     * @param StartCent:开始积分
     * @param EndCent:结束积分
     * 注意：开始积分和结束积分传递值必须同时为空或都不为空
     */
     Jifen.prototype.searchGoods = function(keyword, pageIndex, pageSize, startCent, endCent,successCallback, errorCallback){
     	if(!startCent || !endCent)
     		cordova.exec(successCallback,errorCallback, "JifenPlugin", "searchGoods", [keyword, pageIndex, pageSize]);
     	else
     		cordova.exec(successCallback,errorCallback, "JifenPlugin", "searchGoods", [keyword, pageIndex, pageSize, startCent, endCent]);
     }
    
    /**
     * 获取用户积分
     * 
     * @param userCode:用户帐号
     * @param loginType:用户帐号类型
     * @param userArea:用户地区代码
     * 
     */
    Jifen.prototype.getUserPoint = function(userCode, userArea, loginType, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getUserPoint", [userCode, userArea, loginType]);
    }
    
    /**
     * 获取活动列表
     * 
     * @param pageIndex:第几页
     * @param pageSize:每页记录最大记录数
     */
    Jifen.prototype.getActivityList = function(pageIndex, pageIndex, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getActivityList", [pageIndex, pageIndex]);
    }
    
    /**
     * 获取活动的商品列表
     * 
     * @param actId 活动编号
     * @param pageIndex:第几页
     * @param pageSize:每页记录最大记录数
     */
    Jifen.prototype.getActivityGoods = function(actId, pageIndex, pageIndex, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getActivityGoods", [actId, pageIndex, pageIndex]);
    }
    
    /**
     * 订单中商品是电信积分兑换话费
     * 
     * @param orderNum 订单号
     * @param userCode:手机号码
     * @param loginType:用户帐号类型
     * @param chargeType: 充值类型(1为其它手机号码，2为本机号码)
     */
    Jifen.prototype.redeemCalls = function(orderNum, userCode, loginType, chargeType, userArea, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "redeemCalls", [orderNum, userCode, loginType, chargeType, userArea]);
    }
    
    /**
     * 获取周排行
     * 
     * @param cateyId:分类编号(0-全部商品类型的排行，其他对应品类型的排行)
     * @param pageIndex:第几页
     * @param pageSize:每页记录最大记录数
     */
    Jifen.prototype.topByWeek = function(cateyId, pageIndex, pageSize, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "topByWeek", [cateyId, pageIndex, pageSize]);
    }
    
    /**
     * 电信业务兑换
     * 
     * @param orderNum:订单号
     * @param userCode:用户代码
     * @param userArea:区域代码
     * @param loginType:用户帐号类型
     */
    Jifen.prototype.businessExchange = function(orderNum, userCode, userArea, loginType, successCallback,errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "businessExchange", [orderNum, userCode, userArea, loginType]);
    }
    
    Jifen.prototype.getHotGoodsListByPoint = function(cateyId, pageIndex, pageSize, point, successCallback, errorCallback){
        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getHotGoodsListByPoint", [cateyId, pageIndex, pageSize, point]);
    }
    
    /**
	*	@function		add goods into userfavouritefolder
	*	@author			Ling Chenyang
	*	@time				2013-4-16 15:30
	*	@param			(string)userCode:用户代码
	*	@param			(string)userArea:用户地区
	*	@param			(string)loginType:登录类型
	*	@param			(string)goodsID:商品编号
	*	@param			(string)bssid:商品BSSID号
	**/
	Jifen.prototype.addUserFavorite = function(userCode, userArea, loginType, goodsID, bssid, successCallback,errorCallback){
	        cordova.exec(successCallback,errorCallback, "JifenPlugin", "addUserFavorite", [userCode, userArea, loginType, goodsID, bssid]);
	}
	
	/**
	*	@function		delete from userfavouritefolder by favouriteID
	*	@author			Ling Chenyang
	*	@time				2013-4-16 15:30
	*	@param			(string)favoreitesID:收藏编号
	**/
	Jifen.prototype.deleteUserFavorite = function(favoreitesID, successCallback,errorCallback){
	        cordova.exec(successCallback,errorCallback, "JifenPlugin", "deleteUserFavorite", [favoreitesID]);
	}
	
	/**
	*	@function		get the goods in the userfavouritefolder
	*	@author			Ling Chenyang
	*	@time				2013-4-16 15:30
	*	@param			(string)userCode: 用户代码
	*	@param			(string)UserArea:用户区域编号
	*	@param			(string)loginType:登录类型（“9”：手机）
	*	@param			(string)categoryID:分类编号(0为全部分类，1-9)
	*	@param			(string)pageIndex:页数
	*	@param			(string)pageSize:分页数目
	**/
	Jifen.prototype.getUserFavorite = function(userCode, UserArea, loginType, categoryID, pageIndex, pageSize, successCallback,errorCallback){
	        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getUserFavorite", [userCode, UserArea, loginType, categoryID, pageIndex, pageSize]);
	}
	
	/**
	*	@function		upload multiple real goods orders by customers already checked in
	*	@author			Ling Chenyang
	*	@time				2013-4-16 15:30
	*	@param			(string)userCode:用户代码
	*	@param			(string)userArea:区域代码
	*	@param			(string)loginType:登录类型(9：手机用户)
	*	@param			(string)deliveryId:收货地址编码（兑换流程为001传收货地址id,其他传0）
	*	@param			(string)remark:购买备注
	*	@param			(string)cent:支付积分（必须大于0）
	*	@param			(string)cash:支付现金
	*	@param			(array)list:商品信息
	*	@listform		[{
	*								"GoodsID":"",
	*								"BSSID":"",
	*								"GoodsCount":"",
	*							},{
	*								"GoodsID":"",
	*								"BSSID":"",
	*								"GoodsCount":"",
	*							}]
	*											GoodsID 商品编号
	*											BSSID:商品编号
	*											GoodsCount:商品数量
	*	@notes			注意：
	*							多个商品提交只能全部为001的商品
	*							兑换流程为
	*							002,、003、004、005、008一次只能购买一份；
	*							001、002、008：订单》鉴权》现金支付》更改状态
	*							（没有现金支付则到鉴权结束）
	*							003：订单》业务兑换
	*							004：订单》充话费
	*							005：订单》兑换流量卡
	*							只有001,需要DeliveryId
	**/
	Jifen.prototype.commitOrderForMultigoods = function(userCode, userArea, loginType, deliveryId, remark, cent, cash, list, successCallback,errorCallback){
	        cordova.exec(successCallback,errorCallback, "JifenPlugin", "commitOrderForMultigoods", [userCode, userArea, loginType, deliveryId, remark, cent, cash, list]);
	}
	
	/**
	*	@function		get the goods album information
	*	@author			Ling Chenyang
	*	@time				2013-4-16 15:30
	*	@param			(string)goodsID:商品编号
	**/
	Jifen.prototype.getGoodsAlbum = function(goodsID, successCallback,errorCallback){
	        cordova.exec(successCallback,errorCallback, "JifenPlugin", "getGoodsAlbum", [goodsID]);
	}
	
	var jifen = new Jifen();