cordova.define("jpush.JPush", function(require, exports, module) {
	var exec=require('cordova/exec');

	/**
	 * 加解密对象
	 */
	var JPush = function(){
		
	}

	/**
	 * JPush相关插件
	 * @callback module:JPush.successCallback  成功的回调
	 * @callback module:JPush.errorCallback 失败的回调
	 */
	JPush.prototype = {
		/**
		 * 初始化
		 */
		init:function(){
			if(window.JPUSH_PARAS != null){
				this.eventCallback(3,window.JPUSH_PARAS);
			}
		},

		/**
		 * 获取通知消息
		 */
		getNotification:function(successCallback,errorCallback){
			exec(successCallback,errorCallback,"JPush","getNotification");
		},
		/**
	     * 向JPush注册设备；设置分组、别名
	     * @param {Object} option
		 * @param {String} option.tags 设备分组
		 * @param {String} options.alias 设备别名
		 			{tags:window.cityCode,alias:window.loginNumber}
	     */
		setAliaAndTags:function(successCallback, errorCallback,option) {
	        // successCallback required
	        if (typeof successCallback !== "function") {
	            console.log("setAliaAndTags Error: successCallback is not a function");
	            return;
	        }

	        // errorCallback optional
	        if (errorCallback && (typeof errorCallback !== "function")) {
	            console.log("setAliaAndTags Error: errorCallback is not a function");
	            return;
	        }
	        // Get heading
	        exec(successCallback, errorCallback, "JPush", "setAliaAndTags",[option]);
	    },
	    setAliasAndTags:function(successCallback, errorCallback,alias,tags){//兼容以前
	    	exec(successCallback, errorCallback, "JPush", "setAliaAndTags",[{alias:alias,tags:tags}]);
	    },
	    /**
	     * 获取registrationID
	     *
	     */
	    getRegistrationID:function(successCallback, errorCallback) {
	        // successCallback required
	        if (typeof successCallback !== "function") {
	            console.log("getRegistrationID Error: successCallback is not a function");
	            return;
	        }
	        // errorCallback optional
	        if (errorCallback && (typeof errorCallback !== "function")) {
	            console.log("getRegistrationID Error: errorCallback is not a function");
	            return;
	        }
	        exec(successCallback, errorCallback, "JPush", "getRegistrationID",[]);
	    },
	    /**
	     * 获取设备推送token
	     */
	    getJPushToken:function(successCallback, errorCallback) {
	        // successCallback required
	        if (typeof successCallback !== "function") {
	            console.log("getJPushToken Error: successCallback is not a function");
	            return;
	        }

	        // errorCallback optional
	        if (errorCallback && (typeof errorCallback !== "function")) {
	            console.log("getJPushToken Error: errorCallback is not a function");
	            return;
	        }
	        exec(successCallback, errorCallback, "JPush", "getJPushToken",[]);
	    },
	    /**
	     * 调用失败回调
	     */
	    invokeError:function(action,msg){
	    	//出错统一处理
	    },
	    /**
	     * jpush推送事件统一处理
	     */
	    eventCallback:function(type,data){
	    	/*if(type == 'messageRecevice'){//接收到推送信息
	    	}else if(type == 'notificationOpen'){//点击了通知栏
	    	}else if(type == 'notificationRecevie'){//通知栏接收到了消息
	    		
	    	}*/
	    	if(data){
				var title = (data.extras && data.extras.title) ? data.extras.title : (data.title?data.title:"消息");
				if(title!="消息") {
                    var trkObj = {"eVar6": "JPUSH:" + title};
                    if (typeof trkObjDimention != 'undefined') {
                        try {
                            trkObjDimention(trkObj);
                        } catch (e) {
                        }
                    }
                }

               
	    		if(data.extras && data.extras.url && data.extras.url != ''){
                   
                  
	    		/*	if(data.extras.url.indexOf('http://221.228.39.58')>-1||data.extras.url.indexOf('http://wapjs.189.cn')>-1||(data.extras.url.indexOf('http://')!=0&&data.extras.url.indexOf('https://')!=0)){
	    			   
	    			   APP.page.changePage(data.extras.url);
                    }else{
                    	//navigator.browser.open({success:function(){},error:function(){},url:data.extras.url});
                    	APP.underly.openBrowser(data.extras.url);
                    }*/


                          if (data.extras.url.match("https://") || data.extras.url.match("http://"))//支持配置https 外部链接跳转
                        {


                          if (data.extras.url.match("221.228.39") || data.extras.url.match("wapjs.189.cn")) {
                                APP.page.changePage(data.extras.url);
                          } else {
                                APP.underly.openBrowser(data.extras.url, "天翼生活");//支持配置http 外部链接跳转
                          }
                        }
                        else {
                            APP.page.changePage(data.extras.url);//../跳转
                        }

	    			
	    		}


	    		if(data.extras && data.extras.js && data.extras.js != ''){
	    //			 console.log("wwww444"+data.extras.js);
	    			APP.main.executeJsCode(data.extras.js);
	    		}
	    	}
	    	window.JPUSH_PARAS = null;
	    }
	}
	module.exports = new JPush();
});