cordova.define("MeasureSpeed", function(require, exports, module) {
	var exec = require('cordova/exec');
	
	/**
	 * 网络测速对象
	 */
	var MeasureSpeed = function(){
		/**
		 * 回调方法map
		 */
		this.callbackMap = {};
	}
	
	/**
	 * 网络测速对象方法定义
	 */
	MeasureSpeed.prototype = {
			/**
			 * 是否为空
			 */
			isNull:function(obj){
				return obj == null || obj == '' || obj.toString() == '';
			},
			/**
			 * 生成唯一的callbackId
			 */
			generateCallbackId:function(){
				
				 
				return parseInt(Math.random() * 1000000) + parseInt(Math.random() * 1000000);
			},
			/**
			 * 执行回调
			 */
			excuteCallback:function(callbackId,callbackName,data){
				if(this.callbackMap[callbackId] && this.callbackMap[callbackId][callbackName]){
					this.callbackMap[callbackId][callbackName](data);
					
				}
			},
			/**
			 * 验证
			 */
			validate:function(option){
				
				/**
				 * 插件调用时的相关回调方法定义
				 */
				var callback = {
					toast:option.toast,
					measure:option.measure,
					compelte:option.compelte,
					failure:option.failure
					
				};
				var callbackId = this.generateCallbackId();
				this.callbackMap[callbackId] = callback;
				option.callbackId = callbackId;
				return true;
			},
			/**
			 * 开始测速
			 */
			startMeasure:function(option){
				if(!this.validate(option)){
					return;
				}
				var args = [option.callbackId];
				exec(option.success,option.error,"MeasureSpeed","startMeasure",args);
			},

			/*
			* 取消测速
			 */
			
			cancelMeasure:function(option){
				
				
				exec(option.success,option.error,"MeasureSpeed","cancelMeasure",[]);
				
			}
	}
	
	module.exports = new MeasureSpeed();
});