cordova.define("qq.QQShare", function(require, exports, module) {
	var exec = require('cordova/exec');
	var ShareType = require('qq.QQShareType');
	
	/**
	 * qq分享对象
	 */
	var QQShare = function(){
	}
	
	/**
	 * qq分享方法定义
	 */
	QQShare.prototype = {
			/**
			 * 是否为空
			 */
			isNull:function(obj){
				return obj == null || obj == '' || obj.toString() == '';
			},
			/**
			 * 验证视频类型参数
			 */
			_validateApp:function(option){
				if(!this._validateText(option)){
					return false;
				}
				return true;
			},
			/**
			 * 验证音乐类型参数
			 */
			_validateMusic:function(option){
				if(!this._validateText(option)){
					return false;
				}
				if(this.isNull(option.music)){
					return false;
				}
				return true;
			},
			/**
			 * 验证图片类型参数
			 */
			_validateImage:function(option){
				if(!this._validateImageText(option)){
					return false;
				}
				return true;
			},
			/**
			 * 验证文本类型参数
			 */
			_validateImageText:function(option){
				if(this.isNull(option)){
					return false;
				}
				if(this.isNull(option.title)){
					return false;
				}
				
				if(this.isNull(option.image)){
					return false;
				}
				
				return true;
			},
			/**
			 * 必填参数校验
			 */
			validate:function(type,option){
				var flag = false;
				switch(type){
					case ShareType.QQ_IMAGE_TEXT:
						flag = this._validateImageText(option);
						break;
					case ShareType.QQ_IMAGE:
						flag = this._validateImage(option);
						break;
					case ShareType.QQ_AUDIO:
						flag = this._validateMusic(option);
						break;
					case ShareType.QQ_APP:
						flag = this._validateApp(option);
						break;
				}
				return flag;
			},
			/**
			 * 将json参数转化成数组形式
			 */
			toArgs:function(scene,type,option){
				var args = [
					scene,
					type,
					option
				];
				return args;
			},
			/**
			 * 分享方法入口调用
			 * @param {WeinxShareScene} scene 分享的场景
			 * @param {WeixinShareType} type 分享类型
			 * @param {Object} option 分享参数
			 * @param {String} option.title 分享的标题
			 * @param {String} option.description 分享的描述
			 * @param {String} option.image 分享的图片
			 * @param {String} option.link 分享的链接
			 * @param {String} option.music 分享的音乐地址
			 * @param {Function} option.success 分享的成功回调
			 * @param {Function} option.error 分享的失败回调
			 */
			share:function(scene,type,option){
				if(!this.validate(type,option)){
					return;
				}
				exec(option.success,option.error,"QQShare","share",this.toArgs(scene,type,option));
			}
	}
	
	module.exports = new QQShare();
});