cordova.define("util.App", function(require, exports, module) {
	var exec = require('cordova/exec');
	/**
	 * 应用对象
	 */
	var App = function(){
		this.contextPath = null;
		this.welcomePath = null;
	}
	
	/**
	 * 应用对象方法
	 */
	App.prototype = {
		/**
		 * 初始化
		 */
		init:function(contextPath,loginType,areaCode,number,pushId){
			var me = this;
			if(loginType == null || loginType == ''){
				loginType = '2';
			}
			if(number == null || number == ''){
				number = '18900000000';
			}
			if(areaCode == null || areaCode == ''){
				areaCode = '025'
			}
			if(pushId == null || pushId == ''){
				pushId = 'jszt_100000';
			}
			me._initDatabases(function(){
				me.initCommon(contextPath,loginType,areaCode,number,pushId);
				me._initAdParam(contextPath,loginType,areaCode,number,pushId);
			});
		},
		_initDatabases:function(success){
			var db = window.sqlitePlugin.openDatabase({name:device.dbName,location: 2,createFromLocation: 1});
			db.transaction(function(tx) {
			    tx.executeSql('CREATE TABLE IF NOT EXISTS appstart_tbl(id,url,path,starttime,endtime)');
			    tx.executeSql('CREATE TABLE IF NOT EXISTS appadreq_tbl(id,url,param,loginType,areaCode,number,pushId)');
			    success && success();
			}, function(error) {
			}, function() {
			});
		},
		/**
		 * 初始化通用
		 */
		initCommon:function(contextPath,loginType,areaCode,number,pushId){
			var me = this;
			me.contextPath = contextPath;
			navigator.deviceUtil.getPath({
				type:0,
				success:function(path){
					me.welcomePath = path + '/welcome/';

					
					me._initWelcome(loginType,areaCode,number,pushId);
				},
				error:function(){
					me.welcomePath = '/ataaw/welcome/';
					me._initWelcome(loginType,areaCode,number,pushId);
				}
			});
		},
		/**
		 * 初始化开机画面
		 */
		_initWelcome:function(loginType,areaCode,number,pushId){
			var params = [];
			var me = this;
			var resolution = (window.screen.height/window.screen.width).toFixed(2);//手机分辨率保留2位
    		var systemType = APP.config.app.platform=='android'?'Android':'IOS';
			params.push('actionCode=jsztActionCode_flowbootAnimationshowBootAnimation');
			params.push('pushUserId=' + pushId);
			params.push('coachUser=;userLogAccNbrType=;userLogAccNbr=;userTokenAccNbrType=2');
			params.push('ztVersion=' + device.appVersion);
			params.push('ztInterSource=android');
			params.push('pubToken=');
			params.push('areaCode=' + areaCode);
			params.push('number=' + number);
			params.push('loginType=' + loginType);
			params.push('actionType=1');
			params.push('platform=android');
			params.push('PathCode=base-00004'); 
			params.push('resolution='+resolution);
			params.push('systemType='+systemType); 
            navigator.http.post({
                url: me.contextPath + '/flow/bootAnimation/showBootAnimation',
                //url:'http://221.228.47.27:10080/zt-app/flow/bootAnimation/showBootAnimation',
                data: { para: params.join(';')},
                success: function(data) {

                	var result = null;
                	try{
                		//console.error("开机画面wwwwww-----(url:" + me.contextPath + '/flow/bootAnimation/showBootAnimation' + ";params=" + params.join(';') + ")(response=" + data.data + ")");
                		if(typeof data.data == 'string'){
                			result = eval('(' + data.data + ')');
                		}else{
                			result = data.data;
                		}
                		if (result.TSR_CODE != 0 && result.TSR_CODE != '0') {
                        	me._errorWelcome(result);
                        } else {         
                        	
                        	me._successWelcome(result);
                        }

                        if(result.seturl && result.seturl!=""){//第三方插件配置数据
                        		var seturl = result.seturl;
                        		window.localStorage.setItem('seturl',seturl);
                        		navigator.browser.saveSchemes({success:function(arg){},error:function(arg){},args:seturl});
                        	}else{
                        		var seturl = window.localStorage.getItem('seturl',seturl);
                        		if(seturl && seturl!=""){
                        			navigator.browser.saveSchemes({success:function(arg){},error:function(arg){},args:seturl});
                        		}
                        	}
                	}catch(e){
                	}
                },
                error: function(msg) {
                	try{
	                	var seturl = window.localStorage.getItem('seturl',seturl);
	            		if(seturl && seturl!=""){
	            			navigator.browser.saveSchemes({success:function(arg){},error:function(arg){},args:seturl});
	            		}	
                	}catch(e){}
                	
                	me._errorWelcome(result);
                },
                complete: function(msg) {},
                charset: 0,
                newDes: 1
            });
		},
		/**
		 * 没有获取到开机画面
		 */
		_errorWelcome:function(result){
		},
		/**
		 * 成功获取可用的开机画面
		 */
		_successWelcome:function(result){
			var me = this;
			if(result){
				if(result instanceof Array){
					for(var i = 0; i < result.length; i++){
						me._successWelcome(result[i]);
					}
				}else if(typeof result == 'object'){
					me._downloadWelcome(result);
				}
			}
		},
		/**
		 * 下载图片
		 */
		_downloadWelcome:function(result){
			var url = result.downloadUrl;
			var me = this;
			var filename = '';
			var index = url.lastIndexOf('/');
			if(index >= 0){
				filename = url.substring(index + 1);
			}else{
				filename = 'splash.jpg';
			}
			var filePath = me.welcomePath + filename;
			
			var startDate = new Date();
			var endDate = new Date();
			startDate.setTime(result.startTime);
			endDate.setTime(result.endTime);
			
			result.startTime = startDate.getTime();
			result.endTime = endDate.getTime();

			
			navigator.http.download({
    			url:result.downloadUrl,
    			data:{},
    			filePath:filePath,
    			success:function(data){

                   

    				if(data && data.absolutedURL ){


    				var db = window.sqlitePlugin.openDatabase({name:device.dbName,location:'default'});
    				var params = [result.id,result.downloadUrl,data.absolutedURL,result.startTime,result.endTime];
                   
                    db.transaction(function(tx) {
                    	tx.executeSql("delete from appstart_tbl", null, function(tx, res) {
                    		tx.executeSql("insert into appstart_tbl(id,url,path,starttime,endtime) values(?,?,?,?,?)", params, function(tx, res) {
                            }, function(e) {});
                        }, function(e) {});
                    });
                }
    			},
    			error:function(msg){
    				//alert('error:' + msg);
    				console.log("_downloadWelcome error:"+msg);
    			},
    			complete:function(msg){
    				//alert('complete:' + msg)
    			},
    			downloading:function(data){
    				//console.error(data.downloaded + '---------' + data.total);
    			},
    			overwritten:false
    		});
		},
		hideFlash:function(success,error){
			navigator.splashscreen.hide();
			success && success();
		},
		_initAdParam:function(contextPath,loginType,areaCode,number,pushId){
			var params = [];
			var me = this;
			var resolution = (window.screen.height/window.screen.width).toFixed(2);//手机分辨率保留2位
    		var systemType = APP.config.app.platform=='android'?'Android':'IOS';
			params.push('actionCode=jsztActionCode_flowbootAnimationshowBootAnimation');
			params.push('pushUserId=' + pushId);
			params.push('coachUser=;userLogAccNbrType=;userLogAccNbr=;userTokenAccNbrType=2');
			params.push('ztVersion=' + device.appVersion);
			params.push('ztInterSource=android');
			params.push('pubToken=');
			params.push('areaCode=' + areaCode);
			params.push('number=' + number);
			params.push('loginType=' + loginType);
			params.push('actionType=2');
			params.push('PathCode=base-00004');
			params.push('resolution='+resolution);
			params.push('systemType='+systemType);
			var db = window.sqlitePlugin.openDatabase({name:device.dbName,location:'default'});
            db.transaction(function(tx) {
            	var paras = ['adId' + parseInt(Math.random() * 100000),contextPath + '/flow/bootAnimation/showBootAnimation',params.join(";"),loginType,areaCode,number,pushId];
            	tx.executeSql("delete from appadreq_tbl", null, function(tx, res) {
            		tx.executeSql("insert into appadreq_tbl(id,url,param,loginType,areaCode,number,pushId) values(?,?,?,?,?,?,?)", paras, function(tx, res) {
                    }, function(e) {});
                }, function(e) {});
            });
		},
		/**
		 * 添加快捷方式
		 */
		addShortcut:function(success,error){
			exec(success,error,"DeviceUtil","addShortcut",[]);
		},
		/**
		 * 添加快捷方式
		 */
		deleteShortcut:function(success,error){
			exec(success,error,"DeviceUtil","deleteShortcut",[]);
		},
		/**
		 *是否有快捷方式
		 */
		hasShortcut:function(success,error){
			exec(success,error,"DeviceUtil","hasShortcut",[]);
		},
		/**
		 * 退出程序
		 */
		exitApp:function(){
			exec(null,null,"DeviceUtil","exit",[]);
		},
		initAd:function(){
			window.cordovaIndexPageHasShow = true;
			if($('#cordovaAppAdLinkBtn')[0]){
				$('#cordovaAppAdLinkBtn')[0].style.zIndex = 'inherit';
				$('#cordovaAppAdLinkBtn').show();
			}
		}
	}
	
	module.exports = new App();
});