cordova.define("util.DeviceUtil", function(require, exports, module) {
	var exec = require('cordova/exec');
	
	/**
	 * 设备帮助对象
	 */
	var DeviceUtil = function(){
	}
	
	/**
	 * Http请求
	 */
	DeviceUtil.prototype = {
			/**
			 * 是否为空
			 */
			isNull:function(obj){
				return obj == null || obj == '' || obj.toString() == '';
			},
			/**
			 * 拨打电话
			 */
			dial:function(number,success,error){
				if(this.isNull(number)){
					return;
				}
				var args = [number];
				exec(success,error,"DeviceUtil","dial",args);
			},
			/**
			 * 拨打电话
			 */
			call:function(number,success,error){
				if(this.isNull(number)){
					return;
				}
				var args = [number];
				exec(success,error,"DeviceUtil","call",args);
			},
			/**
			 * 安装应用
			 */
			install:function(filePath,success,error){
				if(filePath == null || '' == filePath){
					console.log('filePath is null');
					return;
				}
				exec(success,error,"DeviceUtil","install",[filePath]);
			},
			/**
			 * 判断应用是否安装
			 */
			isInstalled:function(packageName,success,error){
				if(packageName == null || '' == packageName){
					console.log('packageName is null');
					return;
				}
				exec(success,error,"DeviceUtil","isInstalled",[packageName]);
			},
			/**
			 * 打开应用
			 */
			openApp:function(packageName,para,success,error){
				if(packageName == null || '' == packageName){
					console.log('packagename is null');
					return;
				}
				exec(success,error,"DeviceUtil","openApp",[packageName,para]);
			},
			/**
			 * 短信界面调起
			 */
			smsView:function(numbers,msg,success,error){
				if(numbers == null || '' == numbers){
					console.log('numbers is null');
					return;
				}
				if(msg == null || '' == msg){
					console.log('msg is null');
					return;
				}
				exec(success,error,"DeviceUtil","sendSMS",[numbers,msg]);
			},
			/**
			 * 发送短信
			 */
			sendSMS:function(numbers,msg,success,error){
				if(numbers == null || '' == numbers){
					console.log('numbers is null');
					return;
				}
				if(msg == null || '' == msg){
					console.log('msg is null');
					return;
				}
				exec(success,error,"DeviceUtil","sendSMS",[numbers,msg]);
			},
			/**
			 * 获取路径
			 */
			getPath:function(option){
				exec(option.success,option.error,"DeviceUtil","getPath",[option.type,option.dbName]);
			},

			/**
			 * 重启应用
			 */
			reStart:function(option){
				exec(option.success,option.error,"DeviceUtil","reStart",[]);
			},
			/**
			 * 获取ip地址
			 */
			getIp:function(option){
				exec(option.success,option.error,"DeviceUtil","getIp",[]);
			},
			/**
			 * 获取应用信息
			 */
			getApplicationInfo:function(name,success,error){
				exec(success,error,"DeviceUtil","getApplicationInfo",[name]);
			},
			getDevicesInfoPremission:function(success,error){
				exec(success,error,"DeviceUtil","getDevicesInfoPremission",[]);
			},

			getStoragePremission:function(success,error){
				exec(success,error,"DeviceUtil","getStoragePremission",[]);
			}
			
	}
	
	module.exports = new DeviceUtil();
});