/**
 * 摇一摇插件定义
 */
cordova.define("util.Shake", function(require, exports, module) {
	var exec = require('cordova/exec');
	
	/**
	 * 摇一摇对象
	 */
	var Shake = function(){
		this.callback = {};
	}
	
	/**
	 * 摇一摇对象方法定义
	 */
	Shake.prototype = {
			/**
			 * 打开摇一摇监听
			 * @param {Object} option 参数
			 * @param {Function} option.shakedSuccess 摇一摇成功回调
			 * @param {Function} option.shakedError 摇一摇失败回调
			 * @param {Function} option.success 打开成功回调
			 * @param {Function} option.error 打开失败回调
			 */
			start:function(option){
				/**
				 * 回调设置
				 */
				this.callback = {
					shakedSuccess:option.shakedSuccess,
					shakedError:option.shakedError
				};
				exec(option.success,option.error,"Shake","start",[option]);
			},
			/**
			 * 停止摇一摇
			 * @param {Function} success 停止成功回调
			 * @param {Function} error 停止失败回调
			 */
			stop:function(success,error){
				exec(success,error,"Shake","stop");
			},
			/**
			 * 回调
			 */
			executeCallback:function(type,msg){
				if(type == 0){
					this.callback.shakedSuccess(msg);
				}else{
					this.callback.shakedError(msg);
				}
			}
			
	}
	
	module.exports = new Shake();
});