/**
 * 微信登录插件定义
 */
cordova.define("weixin.WeixinLogin", function(require, exports, module) {
	var exec = require('cordova/exec');
	
	/**
	 * 微信登录对象
	 */
	var WeixinLogin = function(){
		/**
		 * 回调方法map
		 */
		this.callback = {};
	}
	
	/**
	 * 微信登录方法定义
	 */
	WeixinLogin.prototype = {
		/**
		 * 执行回调方法
		 */
		excuteCallback:function(errCode,errMsg){
			
			if(errCode == 0 || errCode == '0'){
					
				this.callback.success && this.callback.success(errCode,errMsg);
			}else{
				this.callback.error && this.callback.error(errCode,errMsg);
			}
		},
		/**
		 * @param {Object} option 参数
		 * @param {Function} option.success 成功回调
		 * @param {Function} option.error 失败回调
		 */
		login:function(option){
			this.callback = {
				success:option.success,
				error:option.error
			}
			exec(null,null,"WeixinLogin","login",[option]);
		},

		subscribe:function(success,error,option){
			this.callback = {
				success:success,
				error:error
			}
			exec(success,error,"WeixinLogin","subscribe",[option]);
		}
	}
	
	module.exports = new WeixinLogin();
});