/**
 * 桌面悬浮js定义
 */
cordova.define("widget.DesktopWidget", function(require, exports, module) {
	var exec = require('cordova/exec');
	
	/**
	 * 悬浮对象定义
	 */
	var DesktopWidget = function(){};
	
	/**
	 * 悬浮对象定义
	 */
	DesktopWidget.prototype._toArgs = function(option) {
	    var args = [];
	    if(!option){
	    	option = {};
	    }
		args.push(option.type);//类型1：悬浮框  2：通知栏
	    args.push(option.phoneNum);//手机号码
	    args.push(option.token);//登录授权token
	    args.push(option.enable);//是否启用 1：启用   0：未启用
	    args.push(option.login);//1:登录 0：未等到
	    args.push(option.show);//是否显示1：显示  0：隐藏
	    args.push(option.showType);//显示类型1：百分比显示   2：数字显示
	    args.push(option.interfaceType);//数据类型：1：剩余流量  2：已用流量
	    args.push(option.params);//请求参数（请求参数由用户传人，各渠道可能不一样）
	    args.push(option.alpha);//透明度
	    args.push(option.refresh);//刷新
	    return args;
	};

	//显示
	DesktopWidget.prototype.get = function (successCallback, errorCallback, option) {
	    exec(successCallback, errorCallback, "DesktopWidget", "get", this._toArgs(option));
	};
	//显示
	DesktopWidget.prototype.show = function (successCallback, errorCallback, option) {
	    exec(successCallback, errorCallback, "DesktopWidget", "show", this._toArgs(option));
	};
	//更新
	DesktopWidget.prototype.update = function (successCallback, errorCallback, option) {
	    exec(successCallback, errorCallback, "DesktopWidget", "update", this._toArgs(option));
	};
	//隐藏
	DesktopWidget.prototype.hide = function (successCallback, errorCallback, option) {
	    exec(successCallback, errorCallback, "DesktopWidget", "hide", this._toArgs(option));
	};

	module.exports = new DesktopWidget();
});