/**
 * wifi体检
 */
cordova.define("wifi.FreeFlowAppStore", function(require, exports, module) {
	var exec = require('cordova/exec');
	var javaClassName = "FreeFlowAppStore";
	
	var FreeFlowAppStorePlugin = function () {}, fp = FreeFlowAppStorePlugin.prototype;

	//打开app
	fp.openApp = function (successCallback, errorCallback, param) {
	    exec(successCallback, errorCallback, javaClassName, "openApp", [param.pn]);
	};
	//安装app
	fp.installApp = function (successCallback, errorCallback, param) {
	    exec(successCallback, errorCallback, javaClassName, "installApp", [param.appId]);
	};
	//开始未完成的下载
	fp.downloadContinue = function (successCallback, errorCallback) {
	    exec(successCallback, errorCallback, javaClassName, "downloadContinue", []);
	};
	//根据packagename获取本机app信息，包括下载信息
	fp.syncAppInfo = function (successCallback, errorCallback, param) {
	    exec(successCallback, errorCallback, javaClassName, "syncAppInfo", [param.pkg_vcs]);
	};
	//获取未完成下载列表
	fp.getAppUnDownloadedList = function (successCallback, errorCallback) {
	    exec(successCallback, errorCallback, javaClassName, "getAppUnDownloadedList", []);
	};
	//开始下载
	fp.downloadApp = function (successCallback, errorCallback, param) {
	    exec(successCallback, errorCallback, javaClassName, "downloadApp", [param.appId, param.appPackageName,param.logoUrl, param.version,
            param.versionCode,param.downloadTimes,param.downloadUrl,param.size ,param.appName]);
	};
	//暂停下载
	fp.pauseDownloadApp = function (successCallback, errorCallback, param) {
	    exec(successCallback, errorCallback, javaClassName, "pauseDownloadApp", [param.appId]);
	};
	//继续下载
	fp.continueDownloadApp = function (successCallback, errorCallback, param) {
	    exec(successCallback, errorCallback, javaClassName, "continueDownloadApp", [param.appId]);
	};
	//删除下载
	fp.deleteDownload = function (successCallback, errorCallback, param) {
	    exec(successCallback, errorCallback, javaClassName, "deleteDownload", [param.appId]);
	};
	//获取当前下载队列
	fp.getDownloadQueue = function (successCallback, errorCallback) {
	    exec(successCallback, errorCallback, javaClassName, "getDownloadQueue", []);
	};
	//获取已下载队列
	fp.getDownloadedList = function (successCallback, errorCallback) {
	    exec(successCallback, errorCallback, javaClassName, "getDownloadedList", []);
	};
	//获取本机非系统应用列表
	fp.getAllUserApp = function (successCallback, errorCallback) {
	    exec(successCallback, errorCallback, javaClassName, "getAllUserApp", []);
	};
	//不继续下载未完成列表
	fp.notDLContinue = function (successCallback, errorCallback) {
	    exec(successCallback, errorCallback, javaClassName, "notDLContinue", []);
	};
	//清除已下载完成列表
	fp.clearDownloaded = function (successCallback, errorCallback) {
	    exec(successCallback, errorCallback, javaClassName, "clearDownloaded", []);
	};
	//通知已进入应用管理页面
	fp.notiAppManger = function (successCallback, errorCallback, type) {
	    exec(successCallback, errorCallback, javaClassName, "notiAppManger", [type]);
	};

	module.exports = new FreeFlowAppStorePlugin();
});